package cn.redcdn.butelopensdk.constconfig;

import android.content.Context;
import cn.redcdn.commonutil.NetConnectHelper;

public class NetConfig {
  
  private class NetDetailType {
    public static final int NETTYPE_UNDEF = -1;// 网络未设置

    public static final int NETTYPE_WIRED = 0;// 有线网络

    public static final int NETTYPE_WIFI = 1;// 无线网络

    public static final int NETTYPE_4G = 2;// 4G网络

    public static final int NETTYPE_3G = 3;// 3G网络

    public static final int NETTYPE_10086_3G = 4;// 移动3G

    public static final int NETTYPE_10086_4G = 5;// 移动4G

    public static final int NETTYPE_10010_3G = 6;// 联通3G

    public static final int NETTYPE_10010_4G = 7;// 联通4G

    public static final int NETTYPE_189_3G = 8;// 电信3G

    public static final int NETTYPE_189_4G = 9;// 电信4G

    public static final int NETTYPE_10086_2G = 10;// 移动2G

    public static final int NETTYPE_10010_2G = 11;// 联通3G

    public static final int NETTYPE_189_2G = 12;// 电信2G
  }

  public static int getNetType(Context context) {
    int type;
    switch (NetConnectHelper.getNetWorkType(context)) {
      case NetConnectHelper.NETWORKTYPE_INVALID:// 无网络
        type = NetDetailType.NETTYPE_UNDEF;
        break;

      case NetConnectHelper.NETWORKTYPE_ETHERNET:// 有线网络
        type = NetDetailType.NETTYPE_WIRED;
        break;
      case NetConnectHelper.NETWORKTYPE_WIFI:// 无线网络
        type = NetDetailType.NETTYPE_WIFI;
        break;
      case NetConnectHelper.NETWORKTYPE_2G:// 2g網絡
        type = NetDetailType.NETTYPE_WIFI;
        break;
      case NetConnectHelper.NETWORKTYPE_3G:// 3G網絡
        type = NetDetailType.NETTYPE_3G;
      case NetConnectHelper.NETWORKTYPE_4G:// 4G網絡
        type = NetDetailType.NETTYPE_4G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_MOBILE_2G:// 移动2G
        type = NetDetailType.NETTYPE_10086_2G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_MOBILE_3G:// 移动3G
        type = NetDetailType.NETTYPE_10086_3G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_MOBILE_4G:// 移动4G
        type = NetDetailType.NETTYPE_10086_4G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_UNICOM_2G:// 联通2G
        type = NetDetailType.NETTYPE_10010_2G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_UNICOM_3G:// 联通3G
        type = NetDetailType.NETTYPE_10010_3G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_UNICOM_4G:// 联通4G
        type = NetDetailType.NETTYPE_10010_4G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_TELECOM_2G:// 电信2G
        type = NetDetailType.NETTYPE_189_2G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_TELECOM_3G:// 电信3G
        type = NetDetailType.NETTYPE_189_3G;
        break;
      case NetConnectHelper.NETWORKTYPE_CHINAE_TELECOM_4G:// 电信4G
        type = NetDetailType.NETTYPE_189_4G;
        break;
      default:
        type = NetDetailType.NETTYPE_UNDEF;
        break;
    }

    return type;
  }
}
