package cn.redcdn.butelopensdk.constconfig;

public class NotifyType {

	/* 会控相关 */
	/**
	 * 参与者加入会议
	 */
	public static final int PERSON_JOIN_MEETING = 0;

	/**
	 * 参与者退出会议
	 */
	public static final int PERSON_EXIT_MEETING = 1;

	/**
	 * 参与者申请发言
	 */
	public static final int PERSON_ASK_FOR_SPEAK = 2;

	/**
	 * 会议结束
	 */
	@Deprecated
	public static final int MEETING_FINISHED = 3;

	/**
	 * 被抢占：其他终端使用相同的视讯号加入会议时会收到被抢占命令
	 */
	public static final int BE_GRABED = 4;

	@Deprecated
	/**
	 * 之前由于媒体模块初始化是异步进行，所以需要此异步回调通知，现在不再需要
	 */
	public static final int START_MEETING_SUC = 5;

	@Deprecated
	/**
	 * 之前由于媒体模块初始化是异步进行，所以需要此异步回调通知，现在不再需要
	 */
	public static final int START_MEETING_FAIL = 6;

	/**
	 * 服务器通知收到-981：UI端显示网络异常Loading
	 */
	public static final int SERVICE_NOTICE_981 = 181;

	/**
	 * 处理异常成功，Object携带是否需要刷新数据。true:数据有变化，需要重新获取speakinfo重建数据；false:数据无变化，不需要刷新
	 */
	public static final int HANDLE_EXCEPTION_SUC = 7;

	/**
	 * 处理异常失败：多次重连失败，退出会议
	 */
	public static final int HANDLE_EXCEPTION_FAIL = 8;

	@Deprecated
	/**
	 * 插话人员增加
	 */
	public static final int EPISODE_ADD = 9;

	@Deprecated
	/**
	 * 插话人员减少
	 */
	public static final int EPISODE_REMOVE = 10;

	@Deprecated
	/**
	 * 停止插话
	 */
	public static final int EPISODE_STOP = 11;

	/**
	 * 服务器通知会议模式改变
	 */
	public static final int SERVER_NOTICE_MEETING_MODE_CHANGE = 12;

	/**
	 * 服务器通知参会方举手
	 */
	public static final int SERVER_NOTICE_USER_ASK_FOR_RAISE_HAND = 13;

	/**
	 * 服务器通知开启直播
	 */
	public static final int SERVER_NOTICE_LIVE = 14;

	/**
	 * 服务器通知加/解锁信息改变
	 */
	public static final int NOTIFY_LOCK_INFO = 15;

	public static final int PARTICIPANT_CHANGED = 16;

	/***
	 * 流媒体相关
	 */
	public static final int AUDIO_IN_DEVICE_INIT_FAILED = 17;

	public static final int AUDIO_OUT_DEVICE_INIT_FAILED = 18;

	public static final int CAMERA_OPEN_FAILED = 19;

	public static final int MIC_1_SPEAK_SUC = 20;

	public static final int MIC_1_SPEAK_FAIL = 21;

	public static final int MIC_1_STOP_SPEAK_SUC = 22;

	public static final int MIC_1_STOP_SPEAK_FAIL = 23;

	public static final int MIC_2_SPEAK_SUC = 24;

	public static final int MIC_2_SPEAK_FAIL = 25;

	public static final int MIC_2_STOP_SPEAK_SUC = 26;

	public static final int MIC_2_STOP_SPEAK_FAIL = 27;

	public static final int START_SPEAK = 28;

	public static final int STOP_SPEAK = 29;

	public static final int CHANGE_MODE = 30;

	public static final int SPEAKER_ON_LINE = 31;

	public static final int SPEAKER_OFF_LINE = 32;

	public static final int CHANGE_TO_VGA = 33;

	public static final int CHANGE_TO_QVGA = 34;

	public static final int MEDIAPLAY_REMOTE_NETWORK_POOR = 35;

	public static final int MEDIAPLAY_LOCAL_NETWORK_POOR = 36;

	public static final int MEDIAPLAY_ALL_NETWORK_POOR = 37;

	public static final int REMOTE_OPEN_MIC_CAMERA = 38;

	public static final int REMOTE_CLOSE_MIC_CAMERA = 39;

	public static final int OWN_CHANGE_VIDEOTOAUDIO_FAIL = 40;

	public static final int OWN_CHANGE_AUDIOTOVIDEO = 41;

	public static final int AUTO_SWITCH_TO_AUDIO = 42;

	public static final int GET_NET_INFO = 43;

	/**
	 * 开始屏幕分享，无相关Object信息
	 */
	public static final int START_SHARE_DOC = 44;

	/**
	 * 停止屏幕分享，无相关Object信息
	 */
	public static final int STOP_SHARE_DOC = 45;

	/**
	 * 通知屏幕分享名称改变。同时Object携带 String name 信息，标识改变后的名字
	 */
	public static final int SHARE_NAME_CHANGE = 46;

	/***
	 * 异常相关，UI端必须关注以下信息
	 */
	public static final int EXCEPTION = 47;

	public static final int MEETING_CONTEXT_INIT_FAILED = 48;

	public static final int OTHER_EXCEPTION = 49;

	public static final int ACCOUNT_CONTEXT_NOT_EXIST = 50;

	public static final int MANAGER_NOT_EXIST = 51;

	public static final int SERVER_WRONG = 52;

	public static final int RELEASE_SUC = 53;

	public static final int TOKEN_TIME_OUT = 54;

	/**
	 * 自己作为发言者开始屏幕分享，无相关 Object信息
	 */
	// public static final int START_SCREEN_SHAREING = 56;

	/**
	 * 自己作为发言者停止屏幕分享,无相关Object信息
	 */
	// public static final int STOP_SCREEN_SHAREING = 57;

	/**
	 * 服务器通知发言者开始屏幕分享，相关信息可通过 {@link Cmd} 获取：{"cmdID":8103,"meetingId":5,
	 * "accountId":"123","userName":"testName"}
	 */
	public static final int SERVER_NOTICE_START_SCREEN_SHAREING = 58;

	/**
	 * 服务器通知发言者停止屏幕分享，相关信息可通过 {@link Cmd} 获取：{"cmdID":8103,"meetingId":5,
	 * "accountId":"123","userName":"testName"}
	 */
	public static final int SERVER_NOTICE_STOP_SCREEN_SHAREING = 59;

	/**
	 * 服务器通知新主讲人产生，相关信息可通过 {@link Cmd}
	 * 获取：{"cmdID":8113,"meetingId":5,"accountId":"123","userName":"testName"}
	 */
	public static final int SERVER_NOTICE_NEW_MAIN_SPEAKER = 60;

	/**
	 * 服务器通知现有主讲人失效，相关信息可通过 {@link Cmd}
	 * 获取：{"cmdID":8115,"meetingId":5,"userName":"testName","accountId":"123"}
	 */
	public static final int SERVER_NOTICE_MAIN_SPEAKER_INVALID = 61;

	/**
	 * 服务器通知发言者发布流，ButelOpenSDK 会维护流信息，可通过 {@link Cmd} 获取到视讯号再去查找该发言者对应流
	 */
	public static final int SERVER_NOTICE_STREAM_PUBLISH = 62;

	/**
	 * 服务器通知发言者取消发布流，ButelOpenSDK 会维护流信息，可通过 {@link Cmd} 获取到视讯号再去查找该发言者对应流
	 */
	public static final int SERVER_NOTICE_STREAM_UNPUBLISH = 63;

	/**
	 * 发言者视频采集参数发生改变，ButelOpenSDK会更新对应SpeakerInfo信息。同时Object携带 String
	 * accountId信息。
	 */
	public static final int SPEAKER_VIDEO_PARAM_UPDATE = 64;

	/**
	 * 打开摄像头
	 */
	public static final int OPEN_CAMERA = 65;

	/**
	 * 关闭摄像头
	 */
	public static final int CLOSE_CAMERA = 66;

	/**
	 * 打开麦克风
	 */
	public static final int OPEN_MIC = 67;

	/**
	 * 关闭麦克风
	 */
	public static final int CLOSE_MIC = 68;

	/**
	 * 被踢出会议室，参会方收到该信息后需要主动退出会议。相关信息可通过 {@link Cmd}
	 * {" accountId ":”123”,"cmdID":8123,"meetingId":5 }
	 */
	public static final int BE_KICKED = 69;

	/**
	 * 信号强度更新。同时Object携带 int strength 强度信息.0~4,其中0表示没有获取到强度，1表示最强，4表示信号强度最弱
	 */
	public static final int SIGNAL_STRENGTH_UPDATE = 70;

	/**
	 * 自己打开扬声器
	 */
	public static final int OPEN_LOUNDSPEAKER = 71;

	/**
	 * 自己关闭扬声器
	 */
	public static final int CLOSE_LUNDSPEAKER = 72;

	/**
	 * 用户打开扬声器
	 */
	public static final int USER_OPEN_LOUNDSPEAKER = 73;

	/**
	 * 用户关闭扬声器
	 */
	public static final int USER_CLOSE_LUNDSPEAKER = 74;

	/**
	 * 服务器通知操作流（打开/关闭 摄像头/音频/文档）
	 */
	public static final int SERVER_NOTICE_OPERATE_STREAM = 75;

	/**
	 * 服务器通知主持人要求某人操作扬声器
	 */
	public static final int MASTER_OPERATE_USER_LOUDSPEAKER = 76;

	/**
	 * 主持人控制打开参会者扬声器成功
	 */
	public static final int MASTER_OPEN_USERLOUDSPEAKER_SUCCESS = 77;

	/**
	 * 主持人控制打开参会者扬声器失败
	 */
	public static final int MASTER_OPEN_USERLOUDSPEAKER_FAIL = 78;

	/**
	 * 主持人控制关闭参会者扬声器成功
	 */
	public static final int MASTER_CLOSE_USERLOUDSPEAKER_SUCCESS = 79;

	/**
	 * 主持人控制关闭参会者扬声器失败
	 */
	public static final int MASTER_CLOSE_USERLOUDSPEAKER_FAIL = 80;

	/**
	 * 主持人打开参会者摄像头
	 */
	public static final int MASTER_OPEN_USER_CAMERA = 81;

	/**
	 * 主持人关闭参会者摄像头
	 */
	public static final int MASTER_CLOSE_USER_CAMERA = 82;

	/**
	 * 主持人打开参会者麦克风
	 */
	public static final int MASTER_OPEN_USER_MIC = 83;

	/**
	 * 主持人关闭参会者麦克风
	 */
	public static final int MASTER_CLOSE_USER_MIC = 84;

	/**
	 * 占用cpu过载
	 */
	public static final int NOTIFY_CPU_OVERLOAD = 85;

	/**
	 * 网络信号
	 */
	public static final int NOTIFY_NET_STATUS = 86;

	/**
	 * 自适应关闭视频
	 */
	public static final int NOTIFY_VIDEO_CLOSE_ADAPT = 87;

	/**
	 * STP通知终端结束会议
	 */
	public static final int SERVER_NOTICE_END_MEETING = 88;

	/**
	 * 服务器通知终端会议开始录制
	 */
	public static final int SERVER_NOTICE_START_RECORDING = 89;

	/**
	 * 服务器通知终端会议停止录制
	 */
	public static final int SERVER_NOTICE_STOP_RECORDING = 90;

	/**
	 * 服务器通知会议开始直播
	 */
	public static final int SERVER_NOTICE_MEETING_START_LIVING = 91;

	/**
	 * 声音强度变化
	 */
	public static final int NOTIFY_VOLUME_UPDATE = 92;

	/**
	 * 查询pc状态结果
	 */
	public static final int NOTIFY_QUERY_STATE = 93;

	/**
	 * 服务器通知终端移交主持人权限
	 */
	public static final int SERVER_NOTICE_MASTERID_CHANGED = 94;

	/**
	 * 通知某条视频流开始渲染
	 */
	public static final int NOTIFY_VIDEO_START_RENDER = 95;

	/**
	 * surfaceview状态改变
	 */
	public static final int NOTIFY_SURFACEVIEW_STATE_CHANGE = 96;
	
	/**
	 * 关闭扬声器回调
	 */
	public static final int NOTIFY_USER_CLOSE_LOUDSPEAKER = 97;
	
	/**
	 * 开启共享回应
	 */
	public static final int NOTIFY_DATA_SHARE_RESPONSE = 98;

	/**
	 * 布局改变
	 */
	public static final int NOTIFY_LAYOUT_CHANGE = 99;

	/**
	 * 字幕广播
	 */
	public static final int NOTIFY_MEET_CAPTION = 100;

	/**
	 * 主题广播
	 */
	public static final int NOTIFY_MEET_THEME = 101;

	/**
	 * 会议聊天状态改变
	 */
	public static final int NOTIFY_MEETING_CHAT_STATE_CHANGE = 102;

	/**
	 * 收到会议聊天消息
	 */
	public static final int NOTIFY_RECEIVE_MEETING_CHAT_MESSAGE = 103;

	/**
	 * 通知终端开始轮询推流
	 */
	public static final int SERVER_NOTICE_START_POLL_AND_PUSH = 104;

	/**
	 * 通知终端停止轮询推流
	 */
	public static final int SERVER_NOTICE_STOP_POLL_AND_PUSH = 105;

	/**
	 * 主持人通知即将被轮询
	 */
	public static final int MASTER_WILL_START_POLL_AND_PUSH = 106;
}