package cn.redcdn.butelopensdk.constconfig;

public class RespModelStatusCode {
  public static final int SUCCESS = 0;
  public static final int TOKEN_TIME_OUT = -900;
  public static final int INVALID_MEETING_ID = -901;
  public static final int INVALID_ACCOUNT_ID = -902;
  public static final int MEETING_NOT_START = -903;
  public static final int PARTICIPANT_FULL = -904;
  public static final int INVALID_MIC_ID = -905;
  public static final int ALREADY_JOINED_MEETING = -906;
  public static final int MEETING_STOP = -907;
  public static final int AUTHORITY_WRONG = -908;
  public static final int ACCOUNT_IN_OTHER_MEETING = -909;
  public static final int INVALID_SPEAKER_ID = -910;
  public static final int MEETING_ALREADY_START = -911;
  public static final int INVALID_CMD = -912;
  public static final int PARAMS_WRONG = -913;
  public static final int MEETING_FINISHED = -914;
  public static final int MEETING_CONTEXT_INIT_FAILED = -915;
  public static final int ACCOUNT_CONTEXT_NOT_EXIST = -916;
  public static final int MANAGER_NOT_EXIST = -917;
  public static final int USER_LOG_OUT_OR_NOT_LOGIN = -918;
  public static final int JSON_CONTROL_FAILED = -919;
  public static final int MEMORY_ALLOCATE_FAILED = -920;
  public static final int IS_LEAVING = -921;
  public static final int IS_SPEAKING = -922;
  public static final int LOCAL_NET_WRONG = -980;
  public static final int SERVER_WRONG = -981;
  public static final int TIME_OUT = -982;
  public static final int OTHER_EXCEPTION = -999;
  public static final int MANAGER_JOIN_MEETING_ERROR = -923;
  public static final int TOPO_WRONG = -932;
  public static final int GIVE_MIC_FAILED = -933;
  public static final int LOCK_OR_UNLOCK_MEETING_FAILED = -934;
  public static final int MEETING_LOCKED = -935;

  public static String getDescriptionOfStatusCode(int statusCode) {
    String description = "";
    switch (statusCode) {
    case SUCCESS:
      description = "SUCCESS";
      break;
    case TOKEN_TIME_OUT:
      description = "Token不存在或已过期";
      break;
    case INVALID_MEETING_ID:
      description = "无效的会议Id";
      break;
    case INVALID_ACCOUNT_ID:
      description = "无效的账户Id";
      break;
    case PARTICIPANT_FULL:
      description = "会议方数达到上限";
      break;
    case INVALID_MIC_ID:
      description = "无效的会场Id";
      break;
    case ALREADY_JOINED_MEETING:
      description = "已经加入该会议";
      break;
    case MEETING_STOP:
      description = "会议已经停止";
      break;
    case AUTHORITY_WRONG:
      description = "权限不足";
      break;
    case ACCOUNT_IN_OTHER_MEETING:
      description = "已参加其他会议";
      break;
    case INVALID_SPEAKER_ID:
      description = "无效的发言者ID";
      break;
    case MEETING_ALREADY_START:
      description = "会议已经开始";
      break;
    case INVALID_CMD:
      description = "无效的命令";
      break;
    case MEETING_FINISHED:
      description = "会议已结束";
      break;
    case MEETING_CONTEXT_INIT_FAILED:
      description = "会议上下文初始化失败";
      break;
    case ACCOUNT_CONTEXT_NOT_EXIST:
      description = "账号对应的上下文不存在";
      break;
    case MANAGER_NOT_EXIST:
      description = "管理员不存在";
      break;
    case USER_LOG_OUT_OR_NOT_LOGIN:
      description = "用户未登录或已退出";
      break;
    case JSON_CONTROL_FAILED:
      description = "Json操作失败";
      break;
    case MEMORY_ALLOCATE_FAILED:
      description = "分配内存失败";
      break;
    case LOCAL_NET_WRONG:
      description = "本地网络错误";
      break;
    case SERVER_WRONG:
      description = "与服务器通信异常";
      break;
    case TIME_OUT:
      description = "超时回应";
      break;
    case OTHER_EXCEPTION:
      description = "其它错误";
      break;
    case IS_LEAVING:
      description = "用户处于暂离状态，无法发言";
      break;
    case IS_SPEAKING:
      description = "用户正在讲话，无法暂离";
      break;
    case MANAGER_JOIN_MEETING_ERROR:
      description = "您为该会议管理员，请在管理会议页面中选择该会议进入。";
      break;
    case PARAMS_WRONG:
      description = "参数错误";
      break;
    case TOPO_WRONG:
      description = "拓扑获取失败";
      break;
    default:
      break;
    }
    return description + "(code: " + statusCode + ")";
  }
}
