package cn.redcdn.butelopensdk.constconfig;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.log.CustomLog;

public class StreamInfo {
	private final static String TAG = StreamInfo.class.getName().toString();

	@Override
	public String toString() {
		return "StreamInfo [syncId=" + syncId + ", resourcesId=" + resourcesId
				+ ", mediaType=" + mediaType + ", streamId=" + streamId
				+ ",shareType=" + shareType + "]";
	}

	private int streamId = -1; // 初始值为-1，等到真正发布时才产生该值
	private int syncId; // 同步组 id 字段
	private int resourcesId;// 针对M1,android,iOS发布流时，音频流取值为resourceId取值为201，视频流取值为101，文档视频流取值为102；都为整形；
	private int mediaType; // 媒体类型
	private int shareType;// 共享类型
	private int codecId; // 编码ID
	private int codecType; // 编码类型

	public final static int RESOURCE_TYPE_VIDEO = 100; // 视频流类型
	public final static int RESOURCE_TYPE_DOC_VIDEO = 300; // 文档视频流类型
	public final static int RESOURCE_TYPE_AUDIO = 200; // 音频流类型
	public final static int RESOURCE_TYPE_DOC_AUDIO = 350; // 文档音频流类型

	public StreamInfo() {

	}

	public StreamInfo(int streamId, int resourcesId, int syncId, int mediaType) {
		setStreamId(streamId);
		setResourcesId(resourcesId);
		setSyncId(syncId);
		setMediaType(mediaType);
	}

	public StreamInfo(int streamId, int resourcesId, int syncId, int mediaType,
			int shareType) {
		setStreamId(streamId);
		setResourcesId(resourcesId);
		setSyncId(syncId);
		setMediaType(mediaType);
		setShareType(shareType);
	}

	public int getStreamId() {
		return streamId;
	}

	public void setStreamId(int streamId) {
		CustomLog.d(TAG, "setStreamId: " + streamId);
		this.streamId = streamId;
	}

	public int getSyncId() {
		return syncId;
	}

	public void setSyncId(int syncId) {
		CustomLog.d(TAG, "setSyncId: " + syncId);
		this.syncId = syncId;
	}

	public int getResourcesId() {
		return resourcesId;
	}

	public void setResourcesId(int resourcesId) {
		CustomLog.d(TAG, "setResourcesId: " + resourcesId);
		this.resourcesId = resourcesId;
	}

	public int getMediaType() {
		return this.mediaType;
	}

	public void setMediaType(int mediaType) {
		CustomLog.d(TAG, "setMediaType: " + mediaType);
		this.mediaType = mediaType;
	}

	public int getShareType() {
		return shareType;
	}

	public void setShareType(int shareType) {
		this.shareType = shareType;
	}

	public int getCodecId() {
		return codecId;
	}

	public void setCodecId(int codecId) {
		this.codecId = codecId;
	}

	public int getCodecType() {
		return codecType;
	}

	public void setCodecType(int codecType) {
		this.codecType = codecType;
	}
}
