package cn.redcdn.butelopensdk.vo;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.butelopensdk.constconfig.CmdId;
import cn.redcdn.butelopensdk.constconfig.CmdKey;
import cn.redcdn.butelopensdk.constconfig.MediaType;
import cn.redcdn.butelopensdk.constconfig.SpeakerInfo;
import cn.redcdn.log.CustomLog;

public class Cmd {
    private final static String TAG = Cmd.class.getName();
    private int cmdId;
    private int meetingId;
    private String userId;
    private String accountId;
    private int status;
    private int micId;
    private int meetingState;
    private int showMode;
    private int role;
    private int speakerAccountId;
    private String token;
    private String userName;
    private String partnerListStr;
    private int meetingPresenceId;
    private int connectedStatus;
    private String mic1UserName;
    private String mic2UserName;
    private String mic1UserId;
    private String mic2UserId;
    private int mediaPlayId;
    private int serverStatus;
    private int memberStatus;
    private int lockInfo;
    private int cmdFlag;
    private String origUserName;
    private JSONArray participators;

    private int liveStatus;

    private int operatorId;

    private int mic1CamStaus;
    private int mic2CamStaus;
    private String masterId;
    private String masterName;
    private int userType;
    private int meetingStyle;

    private JSONArray speakers;
    private JSONArray streams;
    private int camStatus;
    private int speakerType;
    private int screenShareInfo;

    private String liveName;

    private int streamOperatorType;

    private int newStreamOperatorType;

    public static final int STREAM_OPERATOR_TYPE_PUBLISH = 1;
    public static final int STREAM_OPERATOR_TYPE_UNPUBLISH = 2;

    private int resourceId; // 注意：STP 处使用的是 String类型
    private int mediaType;
    private String extraInfo; // 记录流相关信息
    private int type; // 操作状态 1.已打开 2.已关闭
    private int loudSpeakerStatus; // 1。开启状态 2.关闭状态

    private String recServerAddr;// 录制服务器地址
    private String fileAddress;// 录制文件地址
    private int isRecord;

    private int audience;// 观众

    private String data;
    private String targetId;
    private String fromId;

    private String oriMasterId;
    private String oriMasterName;
    private String newMasterId;
    private String newMasterName;

    private JSONArray results;

    private String fromUserId;
    private int messageId;
    private String msgData;
    private String touserId;

    private int speakersNum;
    private String cmdKey;
    private String cmdValue;

    private int meetingChatState;
    private long timestamp;

    private String pollParam;
    private int operateType;

    public JSONArray getSpeakers() {
        return speakers;
    }

    public void setSpeakers(JSONArray speakers) {
        this.speakers = speakers;
    }

    public JSONArray getStreams() {
        return streams;
    }

    public void setStreams(JSONArray streams) {
        this.streams = streams;
    }

    public int getCamStatus() {
        return camStatus;
    }

    public void setCamStatus(int camStatus) {
        this.camStatus = camStatus;
    }

    public int getSpeakerType() {
        return speakerType;
    }

    public void setSpeakerType(int speakerType) {
        this.speakerType = speakerType;
    }

    public int getScreenShareInfo() {
        return screenShareInfo;
    }

    public void setScreenShareInfo(int screenShareInfo) {
        this.screenShareInfo = screenShareInfo;
    }

    public String getLiveName() {
        return liveName;
    }

    public void setLiveName(String liveName) {
        this.liveName = liveName;
    }

    public int getStreamOperatorType() {
        return streamOperatorType;
    }

    public void setStreamOperatorType(int operatorType) {
        this.streamOperatorType = operatorType;
    }

    public int getNewStreamOperatorType() {
        return newStreamOperatorType;
    }

    public void setNewStreamOperatorType(int operatorType) {
        this.newStreamOperatorType = operatorType;
    }

    public String getMasterId() {
        return masterId;
    }

    public void setMasterId(String masterId) {
        this.masterId = masterId;
    }

    public String getMasterName() {
        return masterName;
    }

    public void setMasterName(String masterName) {
        this.masterName = masterName;
    }

    public int getUserType() {
        return userType;
    }

    public void setUserType(int userType) {
        this.userType = userType;
    }

    public int getMeetingStyle() {
        return meetingStyle;
    }

    public void setMeetingStyle(int meetingStyle) {
        this.meetingStyle = meetingStyle;
    }

    public int getRole() {
        return role;
    }

    public void setRole(int role) {
        this.role = role;
    }

    public int getSpeakerAccountId() {
        return speakerAccountId;
    }

    public void setSpeakerAccountId(int value) {
        this.speakerAccountId = value;
    }

    public String getPartnerListStr() {
        return partnerListStr;
    }

    public void setPartnerListStr(String partnerListStr) {
        this.partnerListStr = partnerListStr;
    }

    public int getCmdId() {
        return cmdId;
    }

    public void setCmdId(int cmdId) {
        this.cmdId = cmdId;
    }

    public int getMeetingId() {
        return meetingId;
    }

    public void setMeetingId(int meetingId) {
        this.meetingId = meetingId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String accountId) {
        this.userId = accountId;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    @Deprecated
    public int getMicId() {
        return micId;
    }

    @Deprecated
    public void setMicId(int micId) {
        this.micId = micId;
    }

    public int getMeetingState() {
        return meetingState;
    }

    public void setMeetingState(int meetingState) {
        this.meetingState = meetingState;
    }

    public int getShowMode() {
        return showMode;
    }

    public void setShowMode(int showMode) {
        this.showMode = showMode;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public void setUserName(String username) {
        this.userName = username;
    }

    public String getUserName() {
        return userName;
    }

    public int getMeetingPresenceId() {
        return meetingPresenceId;
    }

    public void setMeetingPresenceId(int meetingPresenceId) {
        this.meetingPresenceId = meetingPresenceId;
    }

    public int getConnectedStatus() {
        return connectedStatus;
    }

    public void setConnectedStatus(int connectedStatus) {
        this.connectedStatus = connectedStatus;
    }

    @Deprecated
    public String getMic1UserName() {
        return mic1UserName;
    }

    @Deprecated
    public void setMic1UserName(String mic1UserName) {
        this.mic1UserName = mic1UserName;
    }

    @Deprecated
    public String getMic2UserName() {
        return mic2UserName;
    }

    @Deprecated
    public void setMic2UserName(String mic2UserName) {
        this.mic2UserName = mic2UserName;
    }

    public int getMediaPlayId() {
        return mediaPlayId;
    }

    public void setMediaPlayId(int mediaPlayId) {
        this.mediaPlayId = mediaPlayId;
    }

    public int getServerStatus() {
        return serverStatus;
    }

    public void setServerStatus(int serverStatus) {
        this.serverStatus = serverStatus;
    }

    public String getMic1UserId() {
        return mic1UserId;
    }

    public void setMic1UserId(String mic1UserId) {
        this.mic1UserId = mic1UserId;
    }

    public String getMic2UserId() {
        return mic2UserId;
    }

    public void setMic2UserId(String mic2UserId) {
        this.mic2UserId = mic2UserId;
    }

    public void setMemberStatus(int status) {
        this.memberStatus = status;
    }

    public int getMemberStatus() {
        return this.memberStatus;
    }

    @Override
    public String toString() {
        String cmdName;
        switch (this.cmdId) {
            case CmdId.ASK_FOR_SPEAK:
                cmdName = "申请发言";
                break;
            case CmdId.ASK_FOR_SPEAK_RESP:
                cmdName = "申请发言回应";
                break;
            case CmdId.ASK_FOR_STOP_SPEAK:
                cmdName = "申请停止发言";
                break;
            case CmdId.ASK_FOR_STOP_SPEAK_RESP:
                cmdName = "申请停止发言回应";
                break;
            case CmdId.BE_GRABED:
                cmdName = "被抢占";
                break;
            case CmdId.EXCEPTION:
                cmdName = "981";
                break;
            case CmdId.EXIT_MEETING:
                cmdName = "退出会议";
                break;
            case CmdId.EXIT_MEETING_RESP:
                cmdName = "退出会议回应";
                break;
            case CmdId.JOIN_MEETING:
                cmdName = "加入会议";
                break;
            case CmdId.JOIN_MEETING_RESP:
                cmdName = "加入会议回应";
                break;
            case CmdId.REPORT_STATUS:
                cmdName = "汇报状态";
                break;
            case CmdId.REPORT_STATUS_RESP:
                cmdName = "汇报状态回应";
                break;
            case CmdId.SPEAKER_ON_LINE:
                cmdName = "新发言者产生";
                break;
            case CmdId.SPEAKER_OFF_LINE:
                cmdName = "发言者被取消";
                break;
            case CmdId.START_MEETING:
                cmdName = "开始会议";
                break;
            case CmdId.START_SPEAK:
                cmdName = "开始发言";
                break;
            case CmdId.STOP_SPEAK:
                cmdName = "停止发言";
                break;
            case CmdId.NEW_GET_PARTICIPATORS_RESP/* GET_PARTICIPATORS_RESP */:
                cmdName = "获取参会者列表回应";
                break;
            // case CmdId.GET_PARTICIPATORS_RESP:
            // cmdName = "获取参会者列表回应";
            // break;
            case CmdId.PERSON_ASK_FOR_SPEAK:
                cmdName = "有人申请发言";
                break;
            case CmdId.PERSON_JOIN_MEETING:
                cmdName = "有人加入会议";
                break;
            case CmdId.PERSON_EXIT_MEETING:
                cmdName = "有人退出会议";
                break;
            case CmdId.GIVE_MIC:
                cmdName = "传麦";
                break;
            case CmdId.GIVE_MIC_RESP:
                cmdName = "传麦回应";
                break;
            case CmdId.LOCK_MEETING:
                cmdName = "加|解锁";
                break;
            case CmdId.LOCK_MEETING_RESP:
                cmdName = "加|解锁回应";
                break;
            case CmdId.NOTIFY_LOCK_INFO:
                cmdName = "通知会议加锁信息";
                break;
            default:
                cmdName = "异常命令";
                break;
        }
        return cmdName;
    }

    public JSONArray getParticipators() {
        return participators;
    }

    public void setParticipators(JSONArray participators) {
        this.participators = participators;
    }

    public String getAccountId() {
        return accountId;
    }

    public void setAccountId(String accountId) {
        this.accountId = accountId;
    }

    public int getLockInfo() {
        return lockInfo;
    }

    public void setLockInfo(int lockInfo) {
        this.lockInfo = lockInfo;
    }

    public int getCmdFlag() {
        return cmdFlag;
    }

    public void setCmdFlag(int cmdFlag) {
        this.cmdFlag = cmdFlag;
    }

    public String getOrigUserName() {
        return origUserName;
    }

    public void setOrigUserName(String origUserName) {
        this.origUserName = origUserName;
    }

    public int getOperatorId() {
        return operatorId;
    }

    public void setOperatorId(int operatorId) {
        this.operatorId = operatorId;
    }

    public int getMic1CamStaus() {
        return mic1CamStaus;
    }

    public void setMic1CamStaus(int mic1CamStaus) {
        this.mic1CamStaus = mic1CamStaus;
    }

    public int getMic2CamStaus() {
        return mic2CamStaus;
    }

    public void setMic2CamStaus(int mic2CamStaus) {
        this.mic2CamStaus = mic2CamStaus;
    }

    public int getLiveStatus() {
        return liveStatus;
    }

    public void setLiveStatus(int liveStatus) {
        this.liveStatus = liveStatus;
    }

    public void setResourceId(int id) {
        this.resourceId = id;
    }

    public int getResourceId() {
        return this.resourceId;
    }

    public void setMediaType(int type) {
        this.mediaType = type;
    }

    /**
     * 获取MediaType
     *
     * @return {@link MediaType}
     */
    public int getMediaType() {
        return SpeakerInfo.ParseStpMediaTypeToSM(this.mediaType);
    }

    public void setExtraInfo(String extra) {
        this.extraInfo = extra;
    }

    public String getExtraInfo() {
        return extraInfo;
    }

    public void setType(int type) {
        this.type = type;
    }

    public int getType() {
        return type;
    }

    public void setLoudSpeakerStatus(int loudSpeakerStatus) {
        this.loudSpeakerStatus = loudSpeakerStatus;
    }

    public int getLoudSpeakerStatus() {
        return loudSpeakerStatus;
    }

    public void setRecServerAddr(String recServerAddr) {
        this.recServerAddr = recServerAddr;
    }

    public String getRecServerAddr() {
        return recServerAddr;
    }

    public void setFileAddress(String fileAddress) {
        this.fileAddress = fileAddress;
    }

    public String getFileAddress() {
        return fileAddress;
    }

    public void setIsRecord(int isRecord) {
        this.isRecord = isRecord;
    }

    public int getIsRecord() {
        return isRecord;
    }

    public void setAudience(int audience) {
        this.audience = audience;
    }

    public int getAudience() {
        return audience;
    }

    public void setData(String data) {
        this.data = data;
    }

    public String getData() {
        return data;
    }

    public void setTargetId(String targetId) {
        this.targetId = targetId;
    }

    public String getTargetId() {
        return targetId;
    }

    public void setFromId(String fromId) {
        this.fromId = fromId;
    }

    public String getFromId() {
        return fromId;
    }

    public String getOriMasterId() {
        return oriMasterId;
    }

    public void setOriMasterId(String oriMasterId) {
        this.oriMasterId = oriMasterId;
    }

    public String getOriMasterName() {
        return oriMasterName;
    }

    public void setOriMasterName(String oriMasterName) {
        this.oriMasterName = oriMasterName;
    }

    public String getNewMasterId() {
        return newMasterId;
    }

    public void setNewMasterId(String newMasterId) {
        this.newMasterId = newMasterId;
    }

    public String getNewMasterName() {
        return newMasterName;
    }

    public void setNewMasterName(String newMasterName) {
        this.newMasterName = newMasterName;
    }

    // {\"sygid\": 2,\"vdev\": {\"w\": 1024,\"h\": 768}
    public static int getSyncId(String extrainfo) {
        CustomLog.d(TAG, "Cmd::getSyncId() extraInfo: " + extrainfo);
        int syncId = -1;
        try {
            JSONObject extraJson = new JSONObject(extrainfo);
            syncId = extraJson.optInt(CmdKey.SYNC_ID);
        } catch (JSONException e) {
            CustomLog.e(TAG, "extrainfo format error!");
        }

        return syncId;
    }

    public static int getShareType(String extrainfo) {
        CustomLog.d(TAG, "Cmd::getShareType() extraInfo: " + extrainfo);
        int shareType = -1;
        try {
            JSONObject extraJson = new JSONObject(extrainfo);
            JSONObject paramJson = extraJson.optJSONObject(CmdKey.VIDEO_PARAM);
            if (paramJson != null) {
                shareType = paramJson.optInt(CmdKey.VIDEO_SHARETYPE);
            } else {
                CustomLog
                        .e(TAG,
                                "error! Cmd::getVideoParam() no vdev info in extrainfo.");
            }
        } catch (JSONException e) {
            CustomLog.e(TAG, "extrainfo format error!");
        }

        return shareType;
    }

    public static VideoParameter getVideoParam(String extrainfo) {
        CustomLog.d(TAG, "Cmd::getVideoParam() extraInfo: " + extrainfo);
        VideoParameter param = new VideoParameter();
        try {
            JSONObject extraJson = new JSONObject(extrainfo);
            JSONObject paramJson = extraJson.optJSONObject(CmdKey.VIDEO_PARAM);
            if (paramJson != null) {
                param.setCapHeight(paramJson.optInt(CmdKey.VIDEO_PARAM_HEIGHT));
                param.setCapWidth(paramJson.optInt(CmdKey.VIDEO_PARAM_WIDTH));
            } else {
                CustomLog
                        .e(TAG,
                                "error! Cmd::getVideoParam() no vdev info in extrainfo.");
            }

        } catch (JSONException e) {
            CustomLog.e(TAG, "extrainfo format error!");
        }

        return param;
    }

    public static String createExtraInfo(int syncId, int width, int height) {
        CustomLog.d(TAG, "Cmd::createExtraInfo() syncId: " + syncId
                + " width: " + width + " height: " + height);
        JSONObject result = new JSONObject();
        JSONObject paramJson = new JSONObject();
        try {
            paramJson.put(CmdKey.VIDEO_PARAM_WIDTH, width);
            paramJson.put(CmdKey.VIDEO_PARAM_HEIGHT, height);

            result.put(CmdKey.VIDEO_PARAM, paramJson);
            result.put(CmdKey.SYNC_ID, syncId);

        } catch (JSONException e) {
            CustomLog.e(TAG, "json 构造出错 : " + e.getMessage());
        }

        CustomLog.d(TAG, "Cmd::createExtraInfo() result: " + result.toString());
        return result.toString();
    }

    public static String createExtraInfo(int syncId, int width, int height,
                                         int shareType) {
        CustomLog.d(TAG, "Cmd::createExtraInfo() syncId: " + syncId
                + " width: " + width + " height: " + height);
        JSONObject result = new JSONObject();
        JSONObject paramJson = new JSONObject();
        try {
            paramJson.put(CmdKey.VIDEO_PARAM_WIDTH, width);
            paramJson.put(CmdKey.VIDEO_PARAM_HEIGHT, height);
            paramJson.put(CmdKey.VIDEO_SHARETYPE, shareType);

            result.put(CmdKey.VIDEO_PARAM, paramJson);
            result.put(CmdKey.SYNC_ID, syncId);

        } catch (JSONException e) {
            CustomLog.e(TAG, "json 构造出错 : " + e.getMessage());
        }

        CustomLog.d(TAG, "Cmd::createExtraInfo() result: " + result.toString());
        return result.toString();
    }

    public JSONArray getResults() {
        return results;
    }

    public void setResults(JSONArray results) {
        this.results = results;
    }

    public String getFromUserId() {
        return fromUserId;
    }

    public void setFromUserId(String fromUserId) {
        this.fromUserId = fromUserId;
    }

    public int getMessageId() {
        return messageId;
    }

    public void setMessageId(int messageId) {
        this.messageId = messageId;
    }

    public String getMsgData() {
        return msgData;
    }

    public void setMsgData(String msgData) {
        this.msgData = msgData;
    }

    public String getTouserId() {
        return touserId;
    }

    public void setTouserId(String touserId) {
        this.touserId = touserId;
    }

    public int getSpeakersNum() {
        return speakersNum;
    }

    public void setSpeakersNum(int speakersNum) {
        this.speakersNum = speakersNum;
    }

    public String getCmdKey() {
        return cmdKey;
    }

    public void setCmdKey(String cmdKey) {
        this.cmdKey = cmdKey;
    }

    public String getCmdValue() {
        return cmdValue;
    }

    public void setCmdValue(String cmdValue) {
        this.cmdValue = cmdValue;
    }

    public int getMeetingChatState() {
        return meetingChatState;
    }

    public void setMeetingChatState(int meetingChatState) {
        this.meetingChatState = meetingChatState;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

    public String getPollParam() {
        return pollParam;
    }

    public void setPollParam(String pollParam) {
        this.pollParam = pollParam;
    }

    public int getOperateType() {
        return operateType;
    }

    public void setOperateType(int operateType) {
        this.operateType = operateType;
    }
}