package cn.redcdn.datacenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.log.CustomLog;
import cn.redcdn.network.httprequest.PostTextHttp;

/**
 * AbstractBusinessDataDouble两个服务器同时发起http请求
 * 
 * @author Administrator
 *
 * @param <T>
 * 
 * 
 */

public class AbstractBusinessDataDoublePwd<T> {
	
	private String tag = getClass().getName();
	private String FirstServerUrl;//1服务器后台接口请求地址
	private String SecondServerUrl;//2服务器后台接口请求地址
	private PostTextHttp FirstHttpPost;
	private PostTextHttp SecondHttpPost;	
	private ServerStaus FirstServerStatus = ServerStaus.STATUS_NONE; //1服务器状态
	private ServerStaus SecondServerStatus = ServerStaus.STATUS_NONE; //2服务器状态
	private boolean HasOnSuccess = false; 
	private PwdStatus firstPwd = PwdStatus.STATUS_NONE;
	private PwdStatus secondPwd = PwdStatus.STATUS_NONE;
	private String requestUrl;
	
	private enum PwdStatus{
		STATUS_NONE, //初始状态
		STATUS_SUCCESS, //成功
		STATUS_FAILED //失败
	}
	
	private enum ServerStaus{
		STATUS_NONE, //初始状态
		STATUS_SUCCESS, //成功
		STATUS_FAILED //失败
	}
	
	public int exec(String FirstUrl,String SecondUrl, final String content){
		FirstServerUrl = FirstUrl;
		SecondServerUrl = SecondUrl;
		requestUrl = FirstUrl;
		int FirstServerReturn = FirstServerExec(FirstServerUrl,content);
		int SecondServerReturn = SecondServerExec(SecondServerUrl,content);
		
		if(FirstServerReturn<0&&SecondServerReturn<0){
			return -1000;
		}
		
		return 0;
		
	}
	
	/*
	 * 1服务器
	 */
	// -1: 表示无效的操作，当前操作正在执行;
	// -2: 表示无效的编码;
	protected int FirstServerExec(String url, final String content){
		
		if(null!=FirstHttpPost){
			return -1;
		}
		
		FirstHttpPost = new PostTextHttp() {
			
		@Override
		protected void onRequestFailed(int statusCode){
			FirstServerStatus = ServerStaus.STATUS_FAILED;
			
            if(SecondServerStatus == ServerStaus.STATUS_NONE){
            	return;
			}else if(SecondServerStatus == ServerStaus.STATUS_SUCCESS){
				return;
			}else if(SecondServerStatus == ServerStaus.STATUS_FAILED){

					ProcessFail(statusCode);
						  
			}
			
		}
		
		@Override
		protected void onRequestFinished(int statusCode, String responseContent){
			CustomLog.d(tag,"onRequestFinished1: "+responseContent);
			
			FirstServerStatus = ServerStaus.STATUS_SUCCESS;
			
			if(SecondServerStatus == ServerStaus.STATUS_NONE){
			CustomLog.d(tag,"FirstServerStatus == ServerStaus.STATUS_SUCCESS " 
			            +" & SecondServerStatus == ServerStaus.STATUS_NONE");
				ProcessSuccess(responseContent,1);
			}else if(SecondServerStatus == ServerStaus.STATUS_SUCCESS){
			CustomLog.d(tag,"FirstServerStatus == ServerStaus.STATUS_SUCCESS " 
			            +" & SecondServerStatus == ServerStaus.STATUS_SUCCESS");
				return;
			}else if(SecondServerStatus == ServerStaus.STATUS_FAILED){
			CustomLog.d(tag,"FirstServerStatus == ServerStaus.STATUS_SUCCESS "
			            +" & SecondServerStatus == ServerStaus.STATUS_FAILED");
				ProcessSuccess(responseContent,1);
			}

		}
			
		};
		
		FirstHttpPost.setURL(FirstServerUrl);
		return FirstHttpPost.postUrlEncodeContent(content);
		
	}

	/*
	 * 2服务器
	 */
	// -1: 表示无效的操作，当前操作正在执行;
	// -2: 表示无效的编码;
	protected int SecondServerExec(String url, final String content){
		
		if(null!=SecondHttpPost){
			return -1;
		}
		
		SecondHttpPost = new PostTextHttp() {
			
		@Override
		protected void onRequestFailed(int statusCode){
			SecondServerStatus = ServerStaus.STATUS_FAILED;
			
			if(FirstServerStatus == ServerStaus.STATUS_NONE){
				return;
			}else if(FirstServerStatus == ServerStaus.STATUS_SUCCESS){
				return;
			}else if(FirstServerStatus == ServerStaus.STATUS_FAILED){

					ProcessFail(statusCode);
				
			}
			
		}
		
		@Override
		protected void onRequestFinished(int statusCode, String responseContent){
			CustomLog.d(tag,"onRequestFinished2: "+responseContent);
			SecondServerStatus = ServerStaus.STATUS_SUCCESS;
			
			if(FirstServerStatus == ServerStaus.STATUS_NONE){
			CustomLog.d(tag,"SecondServerStatus == ServerStaus.STATUS_SUCCESS"
					    +" & FirstServerStatus == ServerStaus.STATUS_NONE");
				ProcessSuccess(responseContent,2);
			}else if(FirstServerStatus == ServerStaus.STATUS_SUCCESS){
			CustomLog.d(tag,"SecondServerStatus == ServerStaus.STATUS_SUCCESS"
					    +" & FirstServerStatus == ServerStaus.STATUS_SUCCESS");	
				return;
			}else if(FirstServerStatus == ServerStaus.STATUS_FAILED){
			CustomLog.d(tag,"SecondServerStatus == ServerStaus.STATUS_SUCCESS"
					    +" & FirstServerStatus == ServerStaus.STATUS_FAILED");	
				ProcessSuccess(responseContent,2);
			}
			
		}
			
		};
		SecondHttpPost.setURL(SecondServerUrl);
		return SecondHttpPost.postUrlEncodeContent(content);
	}
	
	 public void cancel() {
		    if (null == FirstHttpPost) {
		      return;
		    }else{
		    try {
			    FirstHttpPost.cancel();
			    FirstHttpPost = null;
		    }catch(Exception e) {
		    	CustomLog.e(tag,"first cancel:" + e.toString());
		    }

		    }
		    
		    if (null == SecondHttpPost) {
			  return;
			}else{
			try {
				SecondHttpPost.cancel();
				SecondHttpPost = null;
			}catch(Exception e) {
				CustomLog.e(tag,"second cancel:" +e.toString());
			}

			}

		  }

		  protected T parseContentBody(JSONObject jo)
		      throws InvalidateResponseException {
		    return null;
		  }

		  protected T parseContentBody(int headerValue, JSONObject jo)
		      throws InvalidateResponseException { 
		    return parseContentBody(jo);
		  }

		  protected Parser getParser() {
		    return null;
		  }

		  protected void onSuccess(T responseContent) {
			  HasOnSuccess = true;
			  CustomLog.d(tag,"onSuccess");
		  };
		  
		  // 返回HttpErrorCode、接口业务逻辑错误码、DataErrorCode
		  protected void onFail(int statusCode, String statusInfo) {
		    CustomLog.e(tag,"onFail, statusCode = "+ statusCode+" statusInfo = "+statusInfo+"requestUrl ="+requestUrl);
		  };
          
		  //处理onRequestFinished
		  protected void ProcessSuccess(String responseContent,int value) {
		        Parser parser = getParser();
		        if (null == parser) {
		          onFail(DataErrorCode.DATA_INVALIDATE_PARSER, DataErrorInfo.SERVICE_FAILED);
		          return;
		        }

		        parser.parse(responseContent);
		        if (parser.isOk()) {
		        	Object ob = null ;
		            try {
		              ob  = parseContentBody(parser.getHeaderValue(), parser.getBody());
		            } catch (InvalidateResponseException e) {
		              onFail(DataErrorCode.DATA_INVALIDATE_RESPONSE_FORMAT,DataErrorInfo.SERVICE_FAILED);
		              return;
		            } catch (ClassCastException e) {
		              onFail(DataErrorCode.CLASS_CAST_EXCEPTION,DataErrorInfo.SERVICE_FAILED);
		              return;
		            } catch (NumberFormatException e) {
		              onFail(DataErrorCode.NUMBER_FORMAT_EXCEPTION,DataErrorInfo.SERVICE_FAILED);
		              return;
		            }
//		            onSuccess((T)ob);
		            
		            if(HasOnSuccess){
		            	return;
		            }else{
			            
							try {
								if(parser.getBody().getInt("hasMeetingPwd")==1){	
									if(value==1){
										firstPwd =PwdStatus.STATUS_SUCCESS;
									}else if(value==2){
										secondPwd =PwdStatus.STATUS_SUCCESS;
									}
								}else{
									if(value==1){
										firstPwd =PwdStatus.STATUS_FAILED;
									}else if(value==2){
										secondPwd =PwdStatus.STATUS_FAILED;
									}														
								}
								
								if(value==1){
                                    if(firstPwd==PwdStatus.STATUS_SUCCESS){										
										onSuccess((T)ob);
										return;
									}else if(firstPwd==PwdStatus.STATUS_FAILED&&secondPwd==PwdStatus.STATUS_NONE){										
										if(SecondServerStatus == ServerStaus.STATUS_NONE||SecondServerStatus == ServerStaus.STATUS_FAILED){
											onSuccess((T)ob);
											return;
										}
									}
								}else if(value==2){
									if(secondPwd==PwdStatus.STATUS_SUCCESS){										
										onSuccess((T)ob);
										return;
									}else if(secondPwd==PwdStatus.STATUS_FAILED&&firstPwd==PwdStatus.STATUS_NONE){										
										if(FirstServerStatus == ServerStaus.STATUS_NONE||FirstServerStatus == ServerStaus.STATUS_FAILED){
											onSuccess((T)ob);
											return;
										}
									}
								}													
								
							} catch (JSONException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						
		            }

		            	
		        } else {
		            onFail(parser.getHeaderValue(), parser.getHeaderText());
		        }
			}
		  
		  //处理onRequestFailed
		  protected void ProcessFail(int statusCode) {
                onFail(statusCode,DataErrorInfo.NETWORK_FAILED);
			}
		  
}
