package cn.redcdn.datacenter.CapcthaCenter;

import android.text.TextUtils;

import org.json.JSONObject;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.CapcthaCenter.data.CaptchaInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;

/**
 * Created by gexy on 2019\9\26 0026.
 */

public class GetCaptcha extends AbstractBusinessDataBothSeq<CaptchaInfo> {

    /**
     * 获取验证码
     *
     * @return 0:成功 其他:失败
     */
    public int getCaptcha() {
        if (TextUtils.isEmpty(ConstConfig.Capctha_Slave_URL)) {
            return exec(ConstConfig.getCaptchaMasterUrl() + ConstConfig.CAPTCHA_GET_CAPTCHA,
                    "", "");
        }
        return exec(ConstConfig.getCaptchaMasterUrl() + ConstConfig.CAPTCHA_GET_CAPTCHA,
                ConstConfig.getCaptchaSlaveUrl() + ConstConfig.CAPTCHA_GET_CAPTCHA, "");
    }

    protected CaptchaInfo parseContentBody(JSONObject jo) {
        JSONObject json = jo.optJSONObject("data");
        CaptchaInfo captchaInfo = new CaptchaInfo();
        if (json != null) {
            captchaInfo.id = json.optString("id");
            captchaInfo.img = json.optString("img");
        }
        return captchaInfo;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
