package cn.redcdn.datacenter.FaceCompare;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by gexy on 2018\8\27 0027.
 */

public class FaceCompare extends MDSAbstractBusinessData<FaceCompareResult> {

    public void faceCompareInterface(String APIKey,String APISecret,String image1,String image2){

        String param = "";
        try {
//            String param = "api_key="+APIKey+"&api_secret="+APISecret+"&image_url1="+image1+"&image_url2="+image2;
            param = "api_key="+APIKey+"&api_secret="+APISecret+"&image_base64_1="+URLEncoder.encode(image1, "UTF-8")+"&image_base64_2="+URLEncoder.encode(image2, "UTF-8");
        } catch (UnsupportedEncodingException e) {

        }
        execFaceCompare(ConstConfig.getFaceCompareURL(),param);
    }


    protected FaceCompareResult parseContentBody(JSONObject jo) {
        FaceCompareResult faceCompareResult = new FaceCompareResult();
        if (jo != null) {
            faceCompareResult.requestId = jo.optString("request_id");
            faceCompareResult.confidence = (float) jo.optDouble("confidence");
            faceCompareResult.timeUsed = jo.optInt("time_used");
            faceCompareResult.imageId1 = jo.optString("image_id1");
            faceCompareResult.imageId2 = jo.optString("image_id2");
            JSONObject thresholds = jo.optJSONObject("thresholds");
            if (thresholds != null) {
                faceCompareResult.thresholds1e3 = (float) thresholds.optDouble("1e-3");
                faceCompareResult.thresholds1e4 = (float) thresholds.optDouble("1e-4");
                faceCompareResult.thresholds1e5 = (float) thresholds.optDouble("1e-5");
            }
        }
        return faceCompareResult;
    }

    protected Parser getParser(){
        return new FaceCompareParser();
    }
}
