package cn.redcdn.datacenter.FaceCompare;

/**
 * Created by gexy on 2018\8\27 0027.
 */

public class FaceCompareResult {
    //注：如果传入图片但图片中未检测到人脸，则无法进行比对，本字段不返回。
    public float confidence; //比对结果置信度,范围 [0,100]，小数点后3位有效数字，数字越大表示两个人脸越可能是同一个人。
    public String requestId; //用于区分每一次请求的唯一的字符串。

    //如果置信值低于“千分之一”阈值则不建议认为是同一个人；如果置信值超过“十万分之一”阈值，则是同一个人的几率非常高。
    //注：如果传入图片但图片中未检测到人脸，则无法进行比对，本字段不返回。
    public float thresholds1e3; //误识率为千分之一的置信度阈值；
    public float thresholds1e4; //误识率为万分之一的置信度阈值；
    public float thresholds1e5; //误识率为十万分之一的置信度阈值；

    public String imageId1; //通过 image_url1、image_file1 或 image_base64_1 传入的图片在系统中的标识。
    public String imageId2; //通过 image_url2、image_file2 或 image_base64_2 传入的图片在系统中的标识。

    public int timeUsed; //整个请求所花费的时间，单位为毫秒。

    public FaceCompareResult() {
        confidence = 0.0f;
        requestId = "";
        thresholds1e3 = 0.0f;
        thresholds1e4 = 0.0f;
        thresholds1e5 = 0.0f;
        imageId1 = "";
        imageId2 = "";
        timeUsed = 0;
    }

    public float getConfidence() {
        return confidence;
    }

    public void setConfidence(float confidence) {
        this.confidence = confidence;
    }

    public String getRequestId() {
        return requestId;
    }

    public void setRequestId(String requestId) {
        this.requestId = requestId;
    }

    public float getThresholds1e3() {
        return thresholds1e3;
    }

    public void setThresholds1e3(float thresholds1e3) {
        this.thresholds1e3 = thresholds1e3;
    }

    public float getThresholds1e4() {
        return thresholds1e4;
    }

    public void setThresholds1e4(float thresholds1e4) {
        this.thresholds1e4 = thresholds1e4;
    }

    public float getThresholds1e5() {
        return thresholds1e5;
    }

    public void setThresholds1e5(float thresholds1e5) {
        this.thresholds1e5 = thresholds1e5;
    }

    public String getImageId1() {
        return imageId1;
    }

    public void setImageId1(String imageId1) {
        this.imageId1 = imageId1;
    }

    public String getImageId2() {
        return imageId2;
    }

    public void setImageId2(String imageId2) {
        this.imageId2 = imageId2;
    }

    public int getTimeUsed() {
        return timeUsed;
    }

    public void setTimeUsed(int timeUsed) {
        this.timeUsed = timeUsed;
    }
}
