package cn.redcdn.datacenter.JasCenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JasCenter.data.InviteUserInfo;
import cn.redcdn.datacenter.JasCenter.data.UserInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\4\23 0023.
 */

public class GetInviteList extends MDSAbstractBusinessData<List<InviteUserInfo>> {
    private String TAG = "GetInviteList";

    public int getInviteList(String token) {
        CustomLog.d(TAG, "getInviteList token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
        } catch (Exception e) {
            return -3;
        }
        return exec(ConstConfig.getJasUrl() + ConstConfig.JAS_GET_INVITE_LIST, json.toString());
    }

    protected List<InviteUserInfo> parseContentBody(JSONObject jo) throws InvalidateResponseException {
        List<InviteUserInfo> inviteUserInfoList = new ArrayList<>();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " GetInviteList jo = null");
                throw new InvalidateResponseException();
            } else {
                JSONArray inviteUserInfoArr = jo.optJSONArray("data");
                if (inviteUserInfoArr != null) {
                    for (int i = 0;i< inviteUserInfoArr.length();i++) {
                        JSONObject inviteUserInfoObject = inviteUserInfoArr.getJSONObject(i);
                        if (inviteUserInfoObject != null) {
                            InviteUserInfo inviteUserInfo = new InviteUserInfo();

                            inviteUserInfo.name = inviteUserInfoObject.optString("name");
                            inviteUserInfo.mobile = inviteUserInfoObject.optString("mobile");
                            inviteUserInfo.state = inviteUserInfoObject.optString("state");

                            inviteUserInfoList.add(inviteUserInfo);
                        }
                    }
                }

            }
        } catch (Exception e) {
            CustomLog.e(TAG, "getUserInfo invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return inviteUserInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
