package cn.redcdn.datacenter.JasCenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JasCenter.data.UserInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\4\22 0022.
 */

public class GetUserInfo  extends MDSAbstractBusinessData<UserInfo> {
    private String TAG = "GetUserInfo";

    public int getUserInfo(String token) {
        CustomLog.d(TAG, "getUserInfo token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
        } catch (Exception e) {
            return -3;
        }
        return exec(ConstConfig.getJasUrl() + ConstConfig.JAS_GET_USER_INFO, json.toString());
    }

    protected UserInfo parseContentBody(JSONObject jo) throws InvalidateResponseException {
        UserInfo userInfo = new UserInfo();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " getUserInfo jo = null");
                throw new InvalidateResponseException();
            } else {
                JSONObject userInfoObject = jo.optJSONObject("data");
                if (userInfoObject != null) {
                    userInfo.setType(userInfoObject.optString("type"));
                    userInfo.setMobile(userInfoObject.optString("mobile"));
                    userInfo.setHeadThumUrl(userInfoObject.optString("headThumUrl"));
                    userInfo.setNube(userInfoObject.optString("nube"));
                    userInfo.setName(userInfoObject.optString("name"));
                    userInfo.setCompany(userInfoObject.optString("company"));
                    userInfo.setState(userInfoObject.optString("state"));
                    userInfo.setGuaranteeMode(userInfoObject.optString("guaranteeMode"));
                    userInfo.setGuarantorNube(userInfoObject.optString("guarantorNube"));
                    userInfo.setGuarantorName(userInfoObject.optString("guarantorName"));
                    userInfo.setGuarantorCompany(userInfoObject.optString("guarantorCompany"));
                    userInfo.setGuarantorMobile(userInfoObject.optString("guarantorMobile"));
                    userInfo.setGuarantorGroupId(userInfoObject.optString("guarantorGroupId"));
                    userInfo.setReason(userInfoObject.optString("reason"));
                    userInfo.setAuthSign(userInfoObject.optString("authSign"));
                    userInfo.setMonitorSign(userInfoObject.optString("monitorSign"));
                }
            }
        } catch (Exception e) {
            CustomLog.e(TAG, "getUserInfo invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return userInfo;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
