package cn.redcdn.datacenter.JasCenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JasCenter.data.UserInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\4\23 0023.
 */

public class SearchUserInfo extends MDSAbstractBusinessData<List<UserInfo>> {
    private String TAG = "SearchUserInfo";

    public int searchUserInfo(String token, List<String> mobiles) {
        CustomLog.d(TAG, "searchUserInfo token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            StringBuffer mobileBuffer = new StringBuffer();
            for (int i = 0; i < mobiles.size(); i++) {
                mobileBuffer.append(mobiles.get(i));
                if (i != mobiles.size() - 1) {
                    mobileBuffer.append(",");
                }
            }
            json.put("mobiles", mobileBuffer);
        } catch (Exception e) {
            return -3;
        }
        return exec(ConstConfig.getJasUrl() + ConstConfig.JAS_SEARCH_USER_INFO, json.toString());
    }

    public int searchUserInfo(String token, List<String> mobiles, List<String> nubes, String type) {
        CustomLog.d(TAG, "searchUserInfo token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            StringBuffer mobileBuffer = new StringBuffer();
            for (int i = 0; i < mobiles.size(); i++) {
                mobileBuffer.append(mobiles.get(i));
                if (i != mobiles.size() - 1) {
                    mobileBuffer.append(",");
                }
            }
            json.put("mobiles", mobileBuffer);
            StringBuffer nubeBuffer = new StringBuffer();
            for (int i = 0; i < nubes.size(); i++) {
                nubeBuffer.append(nubes.get(i));
                if (i != nubes.size() - 1) {
                    nubeBuffer.append(",");
                }
            }
            json.put("nubes", nubeBuffer);
            json.put("type", type);
        } catch (Exception e) {
            return -3;
        }
        return exec(ConstConfig.getJasUrl() + ConstConfig.JAS_SEARCH_USER_INFO, json.toString());
    }

    protected List<UserInfo> parseContentBody(JSONObject jo) throws InvalidateResponseException {
        List<UserInfo> userInfoList = new ArrayList<>();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " searchUserInfo jo = null");
                throw new InvalidateResponseException();
            } else {
                JSONArray userInfoArr = jo.optJSONArray("data");
                if (userInfoArr != null) {
                    for (int i = 0; i < userInfoArr.length(); i++) {
                        JSONObject userInfoObject = userInfoArr.getJSONObject(i);
                        if (userInfoObject != null) {
                            UserInfo userInfo = new UserInfo();

                            userInfo.setType(userInfoObject.optString("type"));
                            userInfo.setMobile(userInfoObject.optString("mobile"));
                            userInfo.setHeadThumUrl(userInfoObject.optString("headThumUrl"));
                            userInfo.setNube(userInfoObject.optString("nube"));
                            userInfo.setName(userInfoObject.optString("name"));
                            userInfo.setCompany(userInfoObject.optString("company"));
                            userInfo.setState(userInfoObject.optString("state"));
                            userInfo.setGuarantorNube(userInfoObject.optString("guarantorNube"));
                            userInfo.setGuarantorName(userInfoObject.optString("guarantorName"));
                            userInfo.setGuarantorCompany(userInfoObject.optString("guarantorCompany"));
                            userInfo.setGuarantorMobile(userInfoObject.optString("guarantorMobile"));
                            userInfo.setReason(userInfoObject.optString("reason"));
                            userInfo.setContactExistSign(userInfoObject.optString("contactExistSign"));

                            userInfoList.add(userInfo);
                        }
                    }
                }

            }
        } catch (Exception e) {
            CustomLog.e(TAG, "getUserInfo invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return userInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
