package cn.redcdn.datacenter.JecCenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\8\6 0006.
 */

public class DelPersonalContact extends MDSAbstractBusinessData<String> {
    private static final String TAG = "DelPersonalContact";

    /**
     * 删除个人通讯录
     *
     * @param token        token
     * @param contactNubes 多个视讯号时，用英文“,”隔开
     * @return 0:成功 其他:失败
     */
    public int delContact(String token, String contactNubes) {
        CustomLog.i(TAG, "delContact token = " + token + " contactNubes=" + contactNubes);

        if (token == null || token.equals("")) {
            CustomLog.e(TAG, "token为空");
            return -5;
        }
        try {
            JSONObject json = new JSONObject();
            json.put("token", token);
            json.put("contactNubes", contactNubes);

            return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_DEL_PERSONAL_CONTACT, json.toString());
        } catch (Exception e) {
            CustomLog.e(TAG, e.getMessage());
        }
        return -3;
    }

    protected String parseContentBody(JSONObject jo) {
        JSONObject json = jo.optJSONObject("data");
        if (json != null) {

        }
        return "";
    }

    protected Parser getParser() {
        return new MedicalParser();
    }

}