package cn.redcdn.datacenter.JecCenter;

import android.text.TextUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JecCenter.data.MeetingGroupInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.meetingmanage.GetMeetingInfo;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\9\5 0005.
 */

public class GetMeetingGroupList extends AbstractBusinessDataBothSeq<List<MeetingGroupInfo>> {
    private static final String TAG = "GetMeetingList";

    public int getMeetingGroupList(String token) {
        CustomLog.i(TAG, "GetMeetingGroupList token = " + token);

        if (token == null || token.equals("")) {
            CustomLog.e(TAG, "token为空");
            return -5;
        }
        try {
            JSONObject json = new JSONObject();
            json.put(ConstConfig.PARAM_TOKEN, token);
            if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
                exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_MEETING_GROUP_LIST, "", json.toString());
            }
            return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_MEETING_GROUP_LIST, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_MEETING_GROUP_LIST, json.toString());
        } catch (Exception e) {
            CustomLog.e(TAG, e.getMessage());
        }
        return -3;
    }

    protected List<MeetingGroupInfo> parseContentBody(JSONObject jo)
            throws InvalidateResponseException {
        try {
            if (jo == null) {
                CustomLog.e(TAG, "GetMeetingGroupList jo == null");
                throw new InvalidateResponseException();
            }
            JSONObject jsonObject = jo.optJSONObject("data");
            int count = jsonObject.optInt("count");
            CustomLog.d(TAG, "GetMeetingGroupList count=" + count);

            List<MeetingGroupInfo> meetingGroupInfoList = new ArrayList<MeetingGroupInfo>();

            JSONArray jary = jsonObject.optJSONArray("meetingList");
            if (jary != null) {
                for (int i = 0; i < jary.length(); i++) {
                    JSONObject obj = jary.getJSONObject(i);
                    if (obj != null) {
                        MeetingGroupInfo meetingGroupInfo = new MeetingGroupInfo();
                        meetingGroupInfo.groupName = obj.optString("groupName");
                        meetingGroupInfo.meetingCount = obj.optInt("meetingCount");
                        meetingGroupInfo.groupType = obj.optInt("groupType");
                        JSONArray meetingArray = obj.optJSONArray("groupMeetingList");
                        if (meetingArray != null) {
                            for (int k = 0; k < meetingArray.length(); k++) {
                                JSONObject meetingInfoObj = meetingArray.getJSONObject(k);
                                if (meetingInfoObj != null) {
                                    GetMeetingInfo meetingInfo = new GetMeetingInfo();
                                    ProcessInfo(meetingInfoObj, meetingInfo);
                                    meetingGroupInfo.addGroupMeetingInfo(meetingInfo);
                                }
                            }
                        }
                        meetingGroupInfoList.add(meetingGroupInfo);
                    }
                }
            }
            return meetingGroupInfoList;

        } catch (JSONException e) {
            CustomLog.e(TAG, " GetMeetingGroupList invalidate reponse");
            throw new InvalidateResponseException();
        }
    }

    private GetMeetingInfo ProcessInfo(JSONObject obj, GetMeetingInfo info) {
        info.meetingId = obj.optInt("meetingId");
        info.phoneId = obj.optString("phoneId");
        info.createTime = obj.optString("createTime");
        info.creatorName = obj.optString("creatorName");
        info.topic = obj.optString("topic");
        info.meetingType = obj.optInt("meetingType");
        info.hasMeetingPwd = obj.optInt("hasMeetingPwd");
        info.meetingHost = obj.optString("meetingHost");
        info.expectEndtime = obj.optString("expectEndtime");
        info.speakersNum = obj.optInt("speakersNum");
        info.fixedFlg = obj.optInt("fixedFlg");
        return info;
    }


    protected Parser getParser() {
        return new MedicalParser();
    }
}
