package cn.redcdn.datacenter.JecCenter;

import android.nfc.Tag;
import android.text.TextUtils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.meetingmanage.GetMeetingInfo;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\6\21 0021.
 */

public class GetMeetingList extends AbstractBusinessDataBothSeq<List<GetMeetingInfo>> {

    private static final String TAG = "GetMeetingList";

    public int getMeetingList(String token) {
        CustomLog.i(TAG, "getMeetingList token = " + token);

        if (token == null || token.equals("")) {
            CustomLog.e(TAG, "token为空");
            return -5;
        }
        try {
            JSONObject json = new JSONObject();
            json.put(ConstConfig.PARAM_TOKEN, token);
            if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
                exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_MEETING_LIST, "", json.toString());
            }
            return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_MEETING_LIST, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_MEETING_LIST, json.toString());
        } catch (Exception e) {
            CustomLog.e(TAG, e.getMessage());
        }
        return -3;
    }

    protected List<GetMeetingInfo> parseContentBody(JSONObject jo)
            throws InvalidateResponseException {
        try {
            if (jo == null) {
                CustomLog.e(TAG, "getMeetingList jo == null");
                throw new InvalidateResponseException();
            }
            JSONObject jsonObject = jo.optJSONObject("data");
            int count = jsonObject.optInt("count");
            CustomLog.d(TAG, "getMeetingList count=" + count);

            JSONArray jary = jsonObject.optJSONArray("meetingList");
            List<GetMeetingInfo> getMeetingInfoList = new ArrayList<GetMeetingInfo>();

            for (int i = 0; i < jary.length(); i++) {
                JSONObject obj = jary.getJSONObject(i);
                GetMeetingInfo info = new GetMeetingInfo();
                ProcessInfo(obj, info);
                getMeetingInfoList.add(info);
            }

            return getMeetingInfoList;

        } catch (JSONException e) {
            CustomLog.e(TAG, " getMeetingList invalidate reponse");
            throw new InvalidateResponseException();
        }
    }

    private GetMeetingInfo ProcessInfo(JSONObject obj, GetMeetingInfo info) {
        info.meetingId = obj.optInt("meetingId");
        info.phoneId = obj.optString("phoneId");
        info.createTime = obj.optString("createTime");
        info.creatorName = obj.optString("creatorName");
        info.topic = obj.optString("topic");
        info.meetingType = obj.optInt("meetingType");
        info.hasMeetingPwd = obj.optInt("hasMeetingPwd");
        info.meetingHost = obj.optString("meetingHost");
        info.expectEndtime = obj.optString("expectEndtime");
        info.speakersNum = obj.optInt("speakersNum");
        info.fixedFlg = obj.optInt("fixedFlg");
        return info;
    }


    protected Parser getParser() {
        return new MedicalParser();
    }
}
