package cn.redcdn.datacenter.JecCenter;

import android.text.TextUtils;

import org.json.JSONObject;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.JecCenter.data.OrgiInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;

/**
 * Created by gexy on 2019\2\19 0019.
 */

public class GetOrgiInfo extends AbstractBusinessDataBothSeq<OrgiInfo> {

    public int getOrgiInfo(String nube) {
        JSONObject json = new JSONObject();
        try {
            json.put("nube", nube);
        } catch (Exception e) {
            // TODO: handle exception
            return -3;
        }
        if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
            exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_ORGI_INFO, "", json.toString());
        }
        return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_ORGI_INFO, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_ORGI_INFO, json.toString());
    }

    protected OrgiInfo parseContentBody(JSONObject jo) {
        OrgiInfo orgiInfo = new OrgiInfo();
        JSONObject json = jo.optJSONObject("data");
        if (json != null) {
            orgiInfo.firstGroup = json.optString("firstGroup");
            orgiInfo.secondGroup = json.optString("secondGroup");
            orgiInfo.thirdGroup = json.optString("thirdGroup");
            orgiInfo.fourthGroup = json.optString("fourthGroup");
            orgiInfo.fiveGroup = json.optString("fiveGroup");
            orgiInfo.groupId = json.optString("groupId");
        }
        return orgiInfo;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
