package cn.redcdn.datacenter.JecCenter;

import android.text.TextUtils;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JecCenter.data.EnterpriseAllStructures;
import cn.redcdn.datacenter.JecCenter.data.Groups;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\4\23 0023.
 */

public class GetOuterEnterpriseStructureList extends AbstractBusinessDataBothSeq<EnterpriseAllStructures> {
    private String TAG = "GetOuterEnterpriseStructureList";

    public int getOuterStructureList(String token, String accountFlg) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("accountFlg", accountFlg);
        } catch (Exception e) {
            // TODO: handle exception
            return -3;
        }
        if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
            exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE, "", json.toString());
        }
        return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE, json.toString());
    }

    public int getOuterStructureListByGzip(String token, String accountFlg) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("accountFlg", accountFlg);
        } catch (Exception e) {
            // TODO: handle exception
            return -3;
        }
        if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
            exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE_BY_GZIP, "", json.toString());
        }
        return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE_BY_GZIP, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_OUTER_ENTERPRISE_STRUCTURE_BY_GZIP, json.toString());
    }

    protected EnterpriseAllStructures parseContentBody(JSONObject jo) throws InvalidateResponseException {
        EnterpriseAllStructures enterpriseAllStructures = new EnterpriseAllStructures();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " getOuterStructureList jo = null");
                throw new InvalidateResponseException();
            }
            JSONObject structureInfoObj = jo.optJSONObject("data");
            if (structureInfoObj != null) {
                enterpriseAllStructures.entName = structureInfoObj.optString("entName");

                List<Groups> groupsAllList = new ArrayList<>();
//                JSONArray allGroups = structureInfoObj.optJSONArray("allGroups");
//                if (allGroups != null) {
//                    List<Groups> groupsList = parseGroups(allGroups,true);
//                    if (groupsList != null && groupsList.size() > 0) {
//                        groupsAllList.addAll(groupsList);
//                    }
////                    groupsAllList.addAll(parseGroups(allGroups,true));
//                }
                JSONArray allContacts = structureInfoObj.optJSONArray("allContacts");
                if (allContacts != null) {
                    List<Groups> contactList = parseGroups(allContacts, false);
                    if (contactList != null && contactList.size() > 0) {
                        groupsAllList.addAll(contactList);
                    }
//                    groupsAllList.addAll(parseGroups(allContacts,false));
                }

                enterpriseAllStructures.allStructures = groupsAllList;
            }
        } catch (Exception e) {
            CustomLog.e(TAG, "getOuterStructureList invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return enterpriseAllStructures;
    }


    protected Parser getParser() {
        return new MedicalParser();
    }

    private List<Groups> parseGroups(JSONArray groupArr, boolean isGroup) {
        if (groupArr == null) {
            return null;
        }
        List<Groups> groupsList = new ArrayList<>();
        try {
            if (groupArr != null) {
                for (int i = 0; i < groupArr.length(); i++) {
                    JSONObject object = groupArr.optJSONObject(i);
                    if (object != null) {
                        Groups groups = new Groups();
                        groups.id = object.optString("id");
                        groups.name = object.optString("name");
                        groups.isGroup = isGroup;

                        JSONArray group2Arr = object.optJSONArray("groups");
                        if (group2Arr != null && group2Arr.length() > 0) {
                            groups.groups = parseGroups(group2Arr, isGroup);
                        }
                        groupsList.add(groups);
                    }
                }
            }
        } catch (Exception e) {
            CustomLog.d(TAG, "Exception e:" + e.toString());
        }
        return groupsList;
    }
}
