package cn.redcdn.datacenter.JecCenter;

import android.text.TextUtils;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.JecCenter.data.ContactInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\8\6 0006.
 */

public class GetPersonalContact extends AbstractBusinessDataBothSeq<List<ContactInfo>> {
    private static final String TAG = "GetPersonalContact";

    /**
     * 获取个人通讯录
     *
     * @param token token
     * @return 0:成功 其他:失败
     */
    public int getContact(String token) {
        CustomLog.i(TAG, "getContact token = " + token);

        if (token == null || token.equals("")) {
            CustomLog.e(TAG, "token为空");
            return -5;
        }
        try {
            JSONObject json = new JSONObject();
            json.put("token", token);
            if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
                exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_PERSONAL_CONTACT, "", json.toString());
            }
            return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_GET_PERSONAL_CONTACT, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_GET_PERSONAL_CONTACT, json.toString());
        } catch (Exception e) {
            CustomLog.e(TAG, e.getMessage());
        }
        return -3;
    }

    protected List<ContactInfo> parseContentBody(JSONObject jo) {
        List<ContactInfo> contactInfoList = new ArrayList<>();
        JSONArray jsonArray = jo.optJSONArray("data");
        if (jsonArray != null) {
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject contactObj = jsonArray.optJSONObject(i);
                if (contactObj != null) {
                    ContactInfo contactInfo = new ContactInfo();
                    contactInfo.nube = contactObj.optString("nube");
                    contactInfo.name = contactObj.optString("name");
                    contactInfo.mobile = contactObj.optString("mobile");
                    contactInfo.phone = contactObj.optString("phone");
                    contactInfo.business = contactObj.optString("business");
                    contactInfo.remarks = contactObj.optString("remarks");

                    contactInfoList.add(contactInfo);
                }
            }
        }
        return contactInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }

}

