package cn.redcdn.datacenter.JecCenter;

import android.text.TextUtils;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.JecCenter.data.JecUserInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\10\16 0016.
 */

public class SearchMobile extends AbstractBusinessDataBothSeq<List<JecUserInfo>> {
    private String TAG = "SearchMobile";

    public int searchMobile(String token, List<String> mobiles, List<String> nubes, String type) {
        CustomLog.d(TAG, "searchMobile token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            StringBuffer mobileBuffer = new StringBuffer();
            for (int i = 0; i < mobiles.size(); i++) {
                mobileBuffer.append(mobiles.get(i));
                if (i != mobiles.size() - 1) {
                    mobileBuffer.append(",");
                }
            }
            json.put("mobiles", mobileBuffer);
            StringBuffer nubeBuffer = new StringBuffer();
            for (int i = 0; i < nubes.size(); i++) {
                nubeBuffer.append(nubes.get(i));
                if (i != nubes.size() - 1) {
                    nubeBuffer.append(",");
                }
            }
            json.put("nubes", nubeBuffer);
            json.put("type", type);
        } catch (Exception e) {
            return -3;
        }
        if (TextUtils.isEmpty(ConstConfig.JEC_SLAVE_URL)) {
            exec(ConstConfig.getJecUrl() + ConstConfig.JEC_SEARCH_MOBILE, "", json.toString());
        }
        return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_SEARCH_MOBILE, ConstConfig.getJecSlaveUrl() + ConstConfig.JEC_SEARCH_MOBILE, json.toString());
    }

    protected List<JecUserInfo> parseContentBody(JSONObject jo) throws InvalidateResponseException {
        List<JecUserInfo> userInfoList = new ArrayList<>();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " searchMobile jo = null");
                throw new InvalidateResponseException();
            } else {
                JSONArray userInfoArr = jo.optJSONArray("data");
                if (userInfoArr != null) {
                    for (int i = 0; i < userInfoArr.length(); i++) {
                        JSONObject userInfoObject = userInfoArr.getJSONObject(i);
                        if (userInfoObject != null) {
                            JecUserInfo userInfo = new JecUserInfo();

                            userInfo.setMobile(userInfoObject.optString("mobile"));
                            userInfo.setHeadThumUrl(userInfoObject.optString("headThumUrl"));
                            userInfo.setNube(userInfoObject.optString("nube"));
                            userInfo.setName(userInfoObject.optString("name"));
                            userInfo.setCompany(userInfoObject.optString("company"));
                            userInfo.setContactExistSign(userInfoObject.optString("contactExistSign"));

                            userInfoList.add(userInfo);
                        }
                    }
                }

            }
        } catch (Exception e) {
            CustomLog.e(TAG, "searchMobile invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return userInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
