package cn.redcdn.datacenter.JecCenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\11\13 0013.
 */

public class SetAccount extends MDSAbstractBusinessData<String> {
    private static final String TAG = "SetAccount";

    /**
     * 设置用户信息（修改用户头像和昵称）
     *
     * @param token    token
     * @param headUrl  头像地址
     * @param nickName 用户昵称
     * @return 0:成功 其他:失败
     */
    public int setAccount(String token, String headUrl, String nickName) {
        CustomLog.i(TAG, "setAccount token = " + token + " headUrl=" + headUrl + " nickName=" + nickName);

        if (token == null || token.equals("")) {
            CustomLog.e(TAG, "token为空");
            return -5;
        }
        try {
            JSONObject json = new JSONObject();
            json.put("token", token);
            if (headUrl != null && headUrl.length() > 0) {
                json.put("headUrl", headUrl);
            }
            if (nickName != null && nickName.length() > 0) {
                json.put("nickName", nickName);
            }

            return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_SET_ACCOUNT, json.toString());
        } catch (Exception e) {
            CustomLog.e(TAG, e.getMessage());
        }
        return -3;
    }

    protected String parseContentBody(JSONObject jo) {
        JSONObject json = jo.optJSONObject("data");
        if (json != null) {

        }
        return "";
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
