package cn.redcdn.datacenter.JecCenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;

/**
 * Created by gexy on 2019\2\15 0015.
 */

public class SetContactInfo extends MDSAbstractBusinessData<String> {

    /**
     * 设置企业成员
     *
     * @param token       token
     * @param name        昵称
     * @param groupId     最后一级分组ID
     * @param firstGroup  一级组织
     * @param secondGroup 二级组织
     * @param thirdGroup  三级组织
     * @param accountFlg 账号标识 账号后台未导入则必填
     * @return 0:成功 其他:失败
     */
    public int setContactInfo(String token, String name, String groupId, String firstGroup, String secondGroup, String thirdGroup,
                              String fourthGroup, String fiveGroup, String accountFlg) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("name", name);
            json.put("groupId", groupId);
            json.put("firstGroup", firstGroup);
            json.put("secondGroup", secondGroup);
            json.put("thirdGroup", thirdGroup);
            json.put("fourthGroup", fourthGroup);
            json.put("fiveGroup", fiveGroup);
            json.put("accountFlg", accountFlg);
        } catch (Exception e) {
            // TODO: handle exception
            return -3;
        }
        return exec(ConstConfig.getJecUrl() + ConstConfig.JEC_SET_CONTACT_INFO, json.toString());
    }

    protected String parseContentBody(JSONObject jo) {
        JSONObject json = jo.optJSONObject("data");
        if (json != null) {

        }
        return "";
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
