package cn.redcdn.datacenter.OlsCenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.OlsCenter.data.RequestPacketInfo;
import cn.redcdn.datacenter.OlsCenter.data.ResponsePackageInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\4\24 0024.
 */

public class GetPackageInfo extends MDSAbstractBusinessData<List<ResponsePackageInfo>> {

    private String TAG = getClass().getName();

    public int getPackageInfo(List<RequestPacketInfo> requestPacketInfoList) {
        CustomLog.d(TAG, "getPackageInfo");
        JSONObject json = new JSONObject();
        try {
            JSONArray jsonArray = new JSONArray();
            for (int i = 0; i < requestPacketInfoList.size(); i++) {
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("name", requestPacketInfoList.get(i).getName());
                jsonObject.put("version", requestPacketInfoList.get(i).getVersion());

                jsonArray.put(jsonObject);
            }
            json.put("pakages", jsonArray);
        } catch (Exception e) {
            return -3;
        }
        return exec(ConstConfig.getOlsUrl() + ConstConfig.OLS_GET_PACKAGEINFO, json.toString());
    }

    protected List<ResponsePackageInfo> parseContentBody(JSONObject jo) throws InvalidateResponseException {
        List<ResponsePackageInfo> responsePackageInfoList = new ArrayList<>();
        try {
            if (jo == null) {
                CustomLog.e(TAG, " getPackageInfo jo = null");
                throw new InvalidateResponseException();
            } else {
                JSONArray packageInfoArr = jo.optJSONArray("data");
                if (packageInfoArr != null) {
                    for (int i = 0; i < packageInfoArr.length(); i++) {
                        JSONObject packageInfoObj = packageInfoArr.optJSONObject(i);
                        if (packageInfoObj != null) {
                            ResponsePackageInfo packageInfo = new ResponsePackageInfo();
                            packageInfo.upgradeFlg = packageInfoObj.optInt("upgradeFlg");
                            packageInfo.name = packageInfoObj.optString("name");
                            packageInfo.version = packageInfoObj.optString("version");
                            packageInfo.url = packageInfoObj.optString("url");
                            packageInfo.sha1 = packageInfoObj.optString("sha1");

                            responsePackageInfoList.add(packageInfo);
                        }
                    }
                }
            }
        } catch (Exception e) {
            CustomLog.e(TAG, "getPackageInfo invalidate reponse " + e.toString());
            throw new InvalidateResponseException();
        }
        return responsePackageInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
