package cn.redcdn.datacenter.cantacts;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.cantacts.data.ContanctsInfo;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public abstract class UploadContacts extends
		AbstractBusinessData<List<ContanctsInfo>> {
	private String tag = UploadContacts.class.getName();

	/**
	 * 上传联系人数据接口。上传失败的数据将重新返回给本地。 对应接口 《个人通讯录接口-批量操作》 4.1
	 * 
	 * @param contactInfo
	 *            联系人列表
	 * @param accessToken
	 *            Token
	 * @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常
	 */
	public int uploadContactsData(List<ContanctsInfo> contactInfo,
			String accessToken) {
		CustomLog.i(tag, "UploadContactsData");
		if(contactInfo == null){
		  CustomLog.e(tag, "contactInfo为空");
		  return -1;
		}
		JSONObject json = new JSONObject();
		JSONObject j = null;
		JSONArray jary = new JSONArray();
		for (int i = 0; i < contactInfo.size(); i++) {
			j = new JSONObject();
			try {
				j.put("contactId", contactInfo.get(i).contactId);
				j.put("timestamp", contactInfo.get(i).timestamp);
				j.put("isDeleted", contactInfo.get(i).isDeleted);
				j.put("name", contactInfo.get(i).name);
				j.put("firstName", contactInfo.get(i).firstName);
				j.put("nickName", contactInfo.get(i).nickName);

				JSONObject t1 = new JSONObject();
			  if(contactInfo.get(i).number != null){
			    t1.put("number", contactInfo.get(i).number);
        }
			  else t1.put("number","");
			  
			  if(contactInfo.get(i).contactUserId != null){
          t1.put("contactUserId", contactInfo.get(i).contactUserId);
        }
			  else t1.put("contactUserId","");
			  
			  if(contactInfo.get(i).trueNumber != null){
          t1.put("trueNumber", contactInfo.get(i).trueNumber);
        }
        else t1.put("trueNumber","");
			  
				JSONArray j1 = new JSONArray();
				j1.put(t1);
				JSONObject t2 = new JSONObject();
				t2.put("移动电话", j1);
				JSONArray j2 = new JSONArray();
				j2.put(t2);
				j.put("phones", j2);    // "phones"节点为数组

				
				JSONObject t3 = new JSONObject();
				if(contactInfo.get(i).nubeNumber != null){
				  t3.put("nubeNumber", contactInfo.get(i).nubeNumber);
				}
				else   t3.put("nubeNumber","");
				
        if(contactInfo.get(i).contactUserId != null){
          t3.put("contactUserId", contactInfo.get(i).contactUserId);
        }
        else  t3.put("contactUserId","");
        
				JSONArray j3 = new JSONArray();
				j3.put(t3);
				j.put("nubeInfos", j3);     // nubeInfo节点

				
				JSONArray j4 = new JSONArray();
				if(contactInfo.get(i).urls != null){
				  j4.put(contactInfo.get(i).urls);
				}
				else  j4.put("");
				JSONObject t4 = new JSONObject();
				t4.put("headUrl", j4);
				JSONArray j5 = new JSONArray();
				j5.put(t4);
				j.put("urls", j5);           // urls节点
                      
				JSONObject obj1 = new JSONObject();
				if (contactInfo.get(i).email != null) {
					obj1.put("email",contactInfo.get(i).email);
				}else obj1.put("email", "");
				if(contactInfo.get(i).contactUserId != null){
			          obj1.put("contactUserId", contactInfo.get(i).contactUserId);
			        }
			    else  obj1.put("contactUserId","");
				JSONArray arr1 = new JSONArray();
				arr1.put(obj1);
				JSONObject tm1 = new JSONObject();
				tm1.put("工作",arr1);
				JSONArray tm2 = new JSONArray();
				tm2.put(tm1);
				j.put("emails",tm2);      //emails节点
				
				JSONArray j6 = new JSONArray();
				j6.put(contactInfo.get(i).ServiceType);
				JSONObject t5 = new JSONObject();
				t5.put("ServiceType", j6);

			  JSONArray j7 = new JSONArray();
			  if(contactInfo.get(i).AppType != null){
			    j7.put(contactInfo.get(i).AppType);
			  }
			  else{ j7.put("");}
			  JSONObject t6 = new JSONObject();
			  t6.put("AppType", j7);

				JSONArray j8 = new JSONArray();
				j8.put(contactInfo.get(i).UserFrom);
				JSONObject t7 = new JSONObject();
				t7.put("UserFrom", j8);
				
				JSONArray arr2 = new JSONArray();
				arr2.put(contactInfo.get(i).accountType);
				JSONObject obj2 = new JSONObject();
				obj2.put("accountType", arr2);
				
				JSONArray arr3 = new JSONArray();
				arr3.put(contactInfo.get(i).workUnitType);
				JSONObject obj3 = new JSONObject();
				obj3.put("workUnitType", arr3);
				
				JSONArray arr4 = new JSONArray();
				if (arr4.put(contactInfo.get(i).workUnit)!=null) {
					arr4.put(contactInfo.get(i).workUnit);
				}else {arr4.put("");}
				JSONObject obj4 = new JSONObject();
				obj4.put("workUnit", arr4);
				
				JSONArray arr5 = new JSONArray();
				if (arr5.put(contactInfo.get(i).department)!=null) {
					arr5.put(contactInfo.get(i).department);
				} else {arr5.put("");}
				JSONObject obj5 = new JSONObject();
				obj5.put("department", arr5);
				
				JSONArray arr6 = new JSONArray();
				if (arr6.put(contactInfo.get(i).professional)!=null) {
					arr6.put(contactInfo.get(i).professional);
				}else{arr6.put("");}
				
				JSONObject obj6 = new JSONObject();
				obj6.put("professional", arr6);
				
				JSONArray arr7 = new JSONArray();
				arr7.put(contactInfo.get(i).officeTel);
				JSONObject obj7 = new JSONObject();
				obj7.put("officeTel", arr7);
				
				JSONArray arr8 = new JSONArray();
				arr8.put(contactInfo.get(i).saveToContactsTime);
				JSONObject obj8 = new JSONObject();
				obj8.put("saveToContactsTime", arr8);
				
				JSONArray arr10 = new JSONArray();
				arr10.put(contactInfo.get(i).userType);
				JSONObject obj9 = new JSONObject();
				obj9.put("userType", arr10);
				
				JSONArray arr11 = new JSONArray();
				arr11.put(contactInfo.get(i).model);
				JSONObject obj10 = new JSONObject();
				obj10.put("model", arr11);
				
				
				JSONArray j9 = new JSONArray();
				j9.put(t5);
				j9.put(t6);
				j9.put(t7);
				j9.put(obj2);
				j9.put(obj3);
				j9.put(obj4);
				j9.put(obj5);
				j9.put(obj6);
				j9.put(obj7);
				j9.put(obj8);
				if (ConstConfig.APP_TYPE == "jhy") {
					j9.put(obj9);
				}else if (ConstConfig.APP_TYPE == "zghy") {
					j9.put(obj10);
				}
				j.put("extendProperties", j9);  // 扩展属性

				jary.put(j);
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			  return -3;
			}
		}
		try {
			json.put(ConstConfig.CONTACTS, jary);
		} catch (JSONException e) {
			return -3;
		}
		//转义特殊字符   % --> %25
		String jsonString = java.net.URLEncoder.encode(json.toString());
		return exec(ConstConfig.getUploadContactsData(),
				ConstConfig.PARAM_USERCNTER_UPLOADCONTACTDATA + jsonString
						+ "&accessToken=" + accessToken);
	}

	/**
	 * 上传联系人的同步接口
	 */
	public List<ContanctsInfo> uploadContactsDataSync(List<ContanctsInfo> contactInfo,
      String accessToken) {
    CustomLog.i(tag, "UploadContactsData");
    if(contactInfo == null){
      CustomLog.e(tag, "contactInfo为空");
      return null;
    }
    JSONObject json = new JSONObject();
    JSONObject j = null;
    JSONArray jary = new JSONArray();
    for (int i = 0; i < contactInfo.size(); i++) {
      j = new JSONObject();
      try {
        j.put("contactId", contactInfo.get(i).contactId);
        j.put("timestamp", contactInfo.get(i).timestamp);
        j.put("isDeleted", contactInfo.get(i).isDeleted);
        j.put("name", contactInfo.get(i).name);
        j.put("firstName", contactInfo.get(i).firstName);
        j.put("nickName", contactInfo.get(i).nickName);

        JSONObject t1 = new JSONObject();
        if(contactInfo.get(i).number != null){
          t1.put("number", contactInfo.get(i).number);
        }
        else t1.put("number","");
        
        if(contactInfo.get(i).contactUserId != null){
          t1.put("contactUserId", contactInfo.get(i).contactUserId);
        }
        else t1.put("contactUserId","");
        
        if(contactInfo.get(i).trueNumber != null){
          t1.put("trueNumber", contactInfo.get(i).trueNumber);
        }
        else t1.put("trueNumber","");
        
        JSONArray j1 = new JSONArray();
        j1.put(t1);
        JSONObject t2 = new JSONObject();
        t2.put("移动电话", j1);
        JSONArray j2 = new JSONArray();
        j2.put(t2);
        j.put("phones", j2);    // "phones"节点为数组

        
        JSONObject t3 = new JSONObject();
        if(contactInfo.get(i).nubeNumber != null){
          t3.put("nubeNumber", contactInfo.get(i).nubeNumber);
        }
        else   t3.put("nubeNumber","");
        
        if(contactInfo.get(i).contactUserId != null){
          t3.put("contactUserId", contactInfo.get(i).contactUserId);
        }
        else  t3.put("contactUserId","");
        
        JSONArray j3 = new JSONArray();
        j3.put(t3);
        j.put("nubeInfos", j3);     // nubeInfo节点

        
        JSONArray j4 = new JSONArray();
        if(contactInfo.get(i).urls != null){
          j4.put(contactInfo.get(i).urls);
        }
        else  j4.put("");
        JSONObject t4 = new JSONObject();
        t4.put("headUrl", j4);
        JSONArray j5 = new JSONArray();
        j5.put(t4);
        j.put("urls", j5);           // urls节点

        JSONObject obj1 = new JSONObject();
		if (contactInfo.get(i).email != null) {
			obj1.put("email",contactInfo.get(i).email);
		}else obj1.put("email", "");
		if(contactInfo.get(i).contactUserId != null){
	          obj1.put("contactUserId", contactInfo.get(i).contactUserId);
	        }
	    else  obj1.put("contactUserId","");
		JSONArray arr1 = new JSONArray();
		arr1.put(obj1);
		JSONObject tm1 = new JSONObject();
		tm1.put("工作",arr1);
		JSONArray tm2 = new JSONArray();
		tm2.put(tm1);
		j.put("emails",tm2);      //emails节点 
        
        JSONArray j6 = new JSONArray();
        j6.put(contactInfo.get(i).ServiceType);
    
        JSONObject t5 = new JSONObject();
        t5.put("ServiceType", j6);

        JSONArray j7 = new JSONArray();
        if(contactInfo.get(i).AppType != null){
          j7.put(contactInfo.get(i).AppType);
        }
        else{ j7.put("");}
        JSONObject t6 = new JSONObject();
        t6.put("AppType", j7);

        JSONArray j8 = new JSONArray();
        j8.put(contactInfo.get(i).UserFrom);
        JSONObject t7 = new JSONObject();
        t7.put("UserFrom", j8);
        
        JSONArray arr2 = new JSONArray();
		arr2.put(contactInfo.get(i).accountType);
		JSONObject obj2 = new JSONObject();
		obj2.put("accountType", arr2);
		
		JSONArray arr3 = new JSONArray();
		arr3.put(contactInfo.get(i).workUnitType);
		JSONObject obj3 = new JSONObject();
		obj3.put("workUnitType", arr3);
		
		JSONArray arr4 = new JSONArray();
		arr4.put(contactInfo.get(i).workUnit);
		JSONObject obj4 = new JSONObject();
		obj4.put("workUnit", arr4);
		
		JSONArray arr5 = new JSONArray();
		arr5.put(contactInfo.get(i).department);
		JSONObject obj5 = new JSONObject();
		obj5.put("department", arr5);
		
		JSONArray arr6 = new JSONArray();
		arr6.put(contactInfo.get(i).professional);
		JSONObject obj6 = new JSONObject();
		obj6.put("professional", arr6);
		
		JSONArray arr7 = new JSONArray();
		arr7.put(contactInfo.get(i).officeTel);
		JSONObject obj7 = new JSONObject();
		obj7.put("officeTel", arr7);
		
		JSONArray arr8 = new JSONArray();
		arr8.put(contactInfo.get(i).saveToContactsTime);
		JSONObject obj8 = new JSONObject();
		obj8.put("saveToContactsTime", arr8);
		
		
		JSONArray arr10 = new JSONArray();
		arr10.put(contactInfo.get(i).userType);
		JSONObject obj9 = new JSONObject();
		obj9.put("userType", arr10);
		
		JSONArray arr11 = new JSONArray();
		arr11.put(contactInfo.get(i).model);
		JSONObject obj10 = new JSONObject();
		obj10.put("model", arr11);

		
		
		JSONArray j9 = new JSONArray();
		j9.put(t5);
		j9.put(t6);
		j9.put(t7);
		j9.put(obj2);
		j9.put(obj3);
		j9.put(obj4);
		j9.put(obj5);
		j9.put(obj6);
		j9.put(obj7);
		j9.put(obj8);
		if (ConstConfig.APP_TYPE == "jhy") {
			j9.put(obj9);
		}else if (ConstConfig.APP_TYPE == "zghy") {
			j9.put(obj10);
		}
		
		j.put("extendProperties", j9);  // 扩展属性
        jary.put(j);
      } catch (JSONException e) {
        // TODO Auto-generated catch block
        CustomLog.e(tag, e.toString());
        return null;
      }
    }
    try {
      json.put(ConstConfig.CONTACTS, jary);
    } catch (JSONException e) {
      CustomLog.e(tag, e.toString());
      return null;
    }
  //转义特殊字符   % --> %25
    String jsonString = java.net.URLEncoder.encode(json.toString());
    return execSync(ConstConfig.getUploadContactsData(),
        ConstConfig.PARAM_USERCNTER_UPLOADCONTACTDATA + jsonString
            + "&accessToken=" + accessToken);
  }
	
	
	
	
	protected List<ContanctsInfo> parseContentBody(JSONObject jo)
			throws InvalidateResponseException {
		try {
			if (jo == null) {
				CustomLog.e(tag, "uploadContactsData invalidate reponse");
				throw new InvalidateResponseException();
			}
			CustomLog.d("parseContentBody:", jo.toString());
			List<ContanctsInfo> mylist = new ArrayList<ContanctsInfo>();
			
			//为-1001
			 if(jo.getString("status").equals("-1001")){
	        CustomLog.e("上传失败", "错误码为 -1001");
	        ContanctsInfo coninfo = null;
	        try{
	          JSONArray jary = (JSONArray) jo.get("contacts");
	          for (int t = 0; t < jary.length(); t++){
	            coninfo = new ContanctsInfo();
	            coninfo.message = jo.getString("message");
	            coninfo.status = -1001;
	            mylist.add(coninfo);
	          }
	        }catch(ClassCastException e){
            CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
            throw new ClassCastException();
	        }
	      }
		    //为-1002
			 else if(jo.getString("status").equals("-1002")){
          CustomLog.e("上传失败", "错误码为 -1002");
          ContanctsInfo coninfo = null;
          try{
            JSONArray jary = (JSONArray) jo.get("contacts");
            for (int t = 0; t < jary.length(); t++){
              coninfo = new ContanctsInfo();
              coninfo.message = jo.getString("message");
              coninfo.status = -1002;
              mylist.add(coninfo);
            }
          }catch(ClassCastException e){
            CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
            throw new ClassCastException();
          }
         
        }
			// 为-1004
			 else	if(jo.getString("status").equals("-1004")){
			  CustomLog.e("上传失败", "错误码为 -1004");
			  ContanctsInfo coninfo = null;
			  try{
			    JSONArray jary = (JSONArray) jo.get("contacts");
	        for (int t = 0; t < jary.length(); t++){
	          coninfo = new ContanctsInfo();
	          coninfo.message = jo.getString("message");
	          coninfo.status = -1004;
	          mylist.add(coninfo);
	        }
			  }catch(ClassCastException e){
          CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
          throw new ClassCastException();
			  }
			}
			// 为-1003
			else if(jo.getString("status").equals("-1003")){
			  CustomLog.e("上传失败", "错误码为 -1003");
			  ContanctsInfo coninfo = null;
			  try{
			    JSONArray jary = (JSONArray) jo.get("contacts");
	        for (int t = 0; t < jary.length(); t++){
	          JSONObject contactObj = jary.getJSONObject(t);
	          coninfo = new ContanctsInfo();
	          coninfo.status = -1003;
	          coninfo.message = jo.getString("message");
	          if(contactObj.has("name")){
	            CustomLog.d("有name字段","有name字段");
	            coninfo.name = contactObj.getString("name");
	          }
	          if(contactObj.has("contactId")){
	            CustomLog.d("有contactId字段","有contactId字段");
	            coninfo.contactId = contactObj.getString("contactId");
	          }
	          if(contactObj.has("nickName")){
	            CustomLog.d("有nickName字段","有nickName字段");
	            coninfo.nickName = contactObj.getString("nickName");
	          }
	          if(contactObj.has("clientLineNumber")){
	            CustomLog.d("有clientLineNumber字段","有clientLineNumber字段");
	            coninfo.clientLineNumber = contactObj.getString("clientLineNumber");
	          }
	          if(contactObj.has("timestamp")){
	            CustomLog.d("有timestamp字段","有timestamp字段");
	            coninfo.timestamp = contactObj.getLong("timestamp");
	          }
	          if( contactObj.has("extendProperties")){
	            CustomLog.d("有extendProperties字段","有extendProperties字段");
	            JSONArray extendJarry = new JSONArray(contactObj.getString("extendProperties"));
	            JSONArray stJary = ((JSONObject)extendJarry.get(0)).getJSONArray("ServiceType");
	            coninfo.ServiceType = stJary.getInt(0);
	            JSONArray atJary = ((JSONObject)extendJarry.get(1)).getJSONArray("AppType");
	            coninfo.AppType = atJary.getString(0);
	            JSONArray ufJary = ((JSONObject)extendJarry.get(2)).getJSONArray("UserFrom");
	            coninfo.UserFrom = ufJary.getInt(0);
	         }else{
	           CustomLog.d("没有extendProperties字段","没有extendProperties字段");
	           coninfo.ServiceType = 1;
	           coninfo.AppType = "";
	           coninfo.UserFrom = 0;
	         }
	          if( contactObj.has("nubeInfos")){
	            CustomLog.d("有nubeInfos字段","有nubeInfos字段");
	            JSONArray nubeJarry = new JSONArray(contactObj.getString("nubeInfos"));
	            JSONObject nubeinfoobj = new JSONObject(nubeJarry.get(0).toString());
	            coninfo.contactUserId = nubeinfoobj.getString("contactUserId");
	            coninfo.nubeNumber = nubeinfoobj.getString("nubeNumber");
	          }else {
	            CustomLog.d("没有nubeInfos字段","没有nubeInfos字段");
	            coninfo.contactUserId = "";
	            coninfo.nubeNumber = "";
	          }
	          
	          if( contactObj.has("phones")){
	            CustomLog.d("有phones字段","有phones字段");
	            JSONArray phoneJarry =  new JSONArray(contactObj.getString("phones"));
	            JSONArray yddhJsrray =  new JSONArray(phoneJarry.getJSONObject(0).getString("移动电话"));
	            JSONObject tmpobj =  new JSONObject(yddhJsrray.getString(0));
	            if(tmpobj.has("contactUserId")){
	                coninfo.contactUserId = tmpobj.getString("contactUserId");
	            }
	            if(tmpobj.has("number")){
	              coninfo.number = tmpobj.getString("number");
	            }
	            if(tmpobj.has("trueNumber")){
	              coninfo.trueNumber = tmpobj.getString("trueNumber");
	            }
	          }  else{
	            CustomLog.d("没有phones","没有phones字段");
	            coninfo.contactUserId ="";
	            coninfo.number ="";
	            coninfo.trueNumber = "";
	          }
	          
	          if( contactObj.has("urls")){
	            CustomLog.d("有urls字段","有urls字段");
	            JSONArray urlJarry =  new JSONArray(contactObj.getString("urls"));
	            JSONObject urlobj = new JSONObject(urlJarry.getString(0));
	            JSONArray headarray = new JSONArray(urlobj.getString("headUrl"));
	            coninfo.urls = headarray.get(0).toString();
	          }  else {
	            CustomLog.d("没有urls字段","没有urls字段");
	            coninfo.urls = "";
	          }
	          mylist.add(coninfo);
	        }
			  }catch(ClassCastException e){
          CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
          throw new ClassCastException();
			  }
			}
	    else if(jo.getString("status").equals("-2002")){
        CustomLog.e("上传失败", "错误码为 -2002");
        ContanctsInfo coninfo = null;
        try{
          JSONArray jary = (JSONArray) jo.get("contacts");
          for (int t = 0; t < jary.length(); t++){
            coninfo = new ContanctsInfo();
            coninfo.message = jo.getString("message");
            coninfo.status = -2002;
            mylist.add(coninfo);
          }
        }catch(ClassCastException e){
          CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
          throw new ClassCastException();
        }
      }
			else if(jo.getString("status").equals("1")){
			  CustomLog.d("上传成功：","上传成功");
			  ContanctsInfo coninfo = null;
			  try{
		       JSONArray jary = (JSONArray) jo.get("contacts");
		        for (int t = 0; t < jary.length(); t++) {
		          JSONObject contactObj = jary.getJSONObject(t);
		          coninfo = new ContanctsInfo();
		           if (objExist("contactId", contactObj)) {
		              coninfo.contactId = contactObj.getString("contactId");
		            }
		           if (objExist("timestamp", contactObj)) {
		             coninfo.timestamp = contactObj.getLong("timestamp");
		           }
		           if (objExist("status", jo)) {
		            coninfo.status = jo.getInt("status");
		           }
		           if (objExist("message", jo)) {
		            coninfo.message = jo.getString("message");
		           }
		          mylist.add(coninfo);
		        }
			  }catch(ClassCastException e){
			    CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
			    throw new ClassCastException();
			  }
			}
			else{
			  CustomLog.e(tag, "上传失败，错误码未知");
        ContanctsInfo coninfo = null;
        try{
          JSONArray jary = (JSONArray) jo.get("contacts");
          for (int t = 0; t < jary.length(); t++){
            coninfo = new ContanctsInfo();
            coninfo.message = jo.getString("message");
            int tmp_status = 0;
            try{
             tmp_status = Integer.parseInt(jo.getString("status"));
            }catch(NumberFormatException e){
              CustomLog.e(tag, "UploadContactsData NumberFormatException :invalid passed to a string-to-number conversion method");
              throw new NumberFormatException();
            }
            coninfo.status = tmp_status;
            mylist.add(coninfo);
          }
        }catch(ClassCastException e){
          CustomLog.e(tag, "UploadContactsData ClassCastException :java.lang.String cannot be cast to org.json.JSONArray");
          throw new ClassCastException();
        }
			}
			//返回之前打印返回的内容 
			for(int t = 0; t<mylist.size();t++){
			  ContanctsInfo tconinfo =(ContanctsInfo)mylist.get(t);
//			  CustomLog.d("nubeNumber：",tconinfo.nubeNumber);
//			  CustomLog.d("clientLineNumber：",tconinfo.clientLineNumber);
//			  CustomLog.d("contactId：",tconinfo.contactId);
//			  CustomLog.d("timestamp：",tconinfo.timestamp+"");
	       CustomLog.d("message：",tconinfo.message);
	       CustomLog.d("status：",tconinfo.status+"");
			}
			 return mylist;
		}
		  catch (JSONException e) {
			CustomLog.e(tag, "UploadContactsData invalidate reponse");
			throw new InvalidateResponseException();
		}
	}

	protected Parser getParser() {
		return new ContactsParser();
	}

	 boolean objExist(String str, JSONObject contactObj) {
	    return contactObj.has(str);// 判断是否存在该属性，若存在，则返回Value
	 }

}
