package cn.redcdn.datacenter.cdnuploadimg;


import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.apache.http.entity.mime.content.ContentBody;
import org.apache.http.entity.mime.content.FileBody;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;

import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;


public abstract class CdnUploadImage extends MDSAbstractBusinessData<CdnUploadDataInfo> {

    public int uploadImage(File file, String token, String fileName, String uploadUrl) {

        String urlStr = "http://" + uploadUrl + "/fileupload?token=" + token;
        Map<String, ContentBody> bodys = new HashMap<String, ContentBody>();
        bodys.put("", new FileBody(file));
        return exeu(urlStr, bodys);
    }

    public int uploadImage(File file, String token, String fileName, String uploadUrl, int timeout) {

        String urlStr = "http://" + uploadUrl + "/fileupload?token=" + token;
        Map<String, ContentBody> bodys = new HashMap<String, ContentBody>();
        bodys.put("", new FileBody(file));
        return exeu(urlStr, bodys, timeout);
    }

    protected CdnUploadDataInfo parseContentBody(JSONObject jo) {
        System.out.println(jo.toString());
        CdnUploadDataInfo info = new CdnUploadDataInfo();
        if (jo != null) {
            try {
                info.filepath = jo.getString("filepath");
                info.cid = jo.getString("cid");
            } catch (JSONException e) {

                e.printStackTrace();
            }
        }
        return info;
    }

    protected Parser getParser() {
        return new CdnUploadImageParser();
    }

}
