package cn.redcdn.datacenter.collectcenter;


import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;



public abstract class AddCollectionItems extends AbstractBusinessData<JSONObject> {

	private String tag = AddCollectionItems.class.getName();
	
	public int addFavoriteItems(String nubeNumber,String id,String token,int type,DataBodyInfo info)
	{
		String data = "";
		if (type == 2) {
			//图片信息
			data = getImageData(nubeNumber, info);
		}
		if (type == 3) {
			//视频信息
			data = getVideoData(nubeNumber, info);
		}
		if (type == 7) {
			//音频信息
			data = getVoiceData(nubeNumber, info);
		}
		if (type == 21) {
			//文件信息
			data = getFileData(nubeNumber, info);
		}
		if (type == 8) {
			//文字信息
			data = getStringData(nubeNumber, info);	
		}
		if (type == 30) {
			//文章
			data = getArticleData(nubeNumber, info);
		}
		if (type == 31) {
			data = getCombineData(nubeNumber,info);
		}
		JSONObject json = new JSONObject();
		try {
			json.put("service", "addItem");
			json.put("nubeNumber", nubeNumber);
			json.put("id",id);
			json.put("token", token);
			json.put("data", data);
		} catch (Exception e) {
			// TODO: handle exception
		}
		String  paramStr = "service=addItem&nubeNumber="+nubeNumber+"&id="+id+"&token="+token+
				"&data="+data;
		return exec(ConstConfig.getFavoriteItemUrl(),paramStr);
	}
	
	//添加链接信息收藏
	public int addWebItems(String nubeNumber,String id,String token,String txt,WebDataInfo info)
	{
		String data = getWebData(nubeNumber, txt, info);
		String  paramStr = "service=addItem&nubeNumber="+nubeNumber+"&id="+id+"&token="+token+
				"&data="+data;
		return exec(ConstConfig.getFavoriteItemUrl(),paramStr);
	}
	
	protected JSONObject parseContentBody(JSONObject jo){
		if (jo == null) {
			CustomLog.d(tag, "AddCollectionItems parseContentBody jo == null");
		}
		return jo;
	}
	protected Parser getParser(){
		return new CollectionParser();
	}
	
	//转换成相应的信息
	private String getImageData(String nubeNumber,DataBodyInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type", 2);
			json.put("extinfo", "");
			tmpjson.put("localUrl", info.localUrl);
			tmpjson.put("duration", info.duration);
			tmpjson.put("photoHeight", info.photoHeight);
			tmpjson.put("compressPath", info.compressPath);
			tmpjson.put("photoWidth", info.photoWidh);
			tmpjson.put("remoteUrl", info.remoteUrl);
			tmpjson.put("thumbnailRemoteUrl", info.thumbnailRemoteUrl);
			tmpjson.put("size",info.size);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			tmpjson.put("GroupName", info.groupName);
			arr.put(0, tmpjson);
			json.put("body",arr);
						
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	private String getVideoData(String nubeNumber,DataBodyInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type",3);
			json.put("extinfo", "");
			tmpjson.put("localUrl", info.localUrl);
			tmpjson.put("duration", info.duration);
			tmpjson.put("compressPath", info.compressPath);
			tmpjson.put("remoteUrl", info.remoteUrl);
			tmpjson.put("thumbnailRemoteUrl", info.thumbnailRemoteUrl);
			tmpjson.put("size",info.size);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			tmpjson.put("GroupName", info.groupName);
			arr.put(0, tmpjson);
			json.put("body", arr);
			  
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	private String getVoiceData(String nubeNumber,DataBodyInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type", 7);
			json.put("extinfo", "");
			tmpjson.put("localUrl", info.localUrl);
			tmpjson.put("duration", info.duration);
			tmpjson.put("compressPath", info.compressPath);
			tmpjson.put("remoteUrl", info.remoteUrl);
			tmpjson.put("thumbnailRemoteUrl", info.thumbnailRemoteUrl);
			tmpjson.put("size",info.size);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			tmpjson.put("GroupName", info.groupName);
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	
	private String getFileData(String nubeNumber,DataBodyInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type", 21);
			json.put("extinfo", "");
			tmpjson.put("localUrl", info.localUrl);
			tmpjson.put("fileType", info.fileType);
			tmpjson.put("fileName", info.fileName);
			tmpjson.put("duration", info.duration);
			tmpjson.put("compressPath", info.compressPath);
			tmpjson.put("remoteUrl", info.remoteUrl);
			tmpjson.put("thumbnailRemoteUrl", info.thumbnailRemoteUrl);
			tmpjson.put("size",info.size);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	private String getStringData(String nubeNumber,DataBodyInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
           json.put("operatorNube", nubeNumber);
			json.put("type",8);
			json.put("extinfo", "");
			tmpjson.put("txt",info.txt);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			tmpjson.put("GroupName", info.groupName);
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	private String getWebData(String nubeNumber,String txt,WebDataInfo info)
	{
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
	    JSONObject secJson = new JSONObject();
	    JSONArray tmpArr = new JSONArray();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type", 20);
			json.put("extinfo", "");
			tmpjson.put("txt",txt);
			secJson.put("footStr", info.footStr);
			secJson.put("imgUrl", info.imageUrl);
			secJson.put("htmlStr", info.htmlStr);
			secJson.put("headStr", info.headStr);
			secJson.put("titleStr", info.titleStr);
			tmpArr.put(0, secJson);
			tmpjson.put("webData",tmpArr);
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
	}
	
	private String getArticleData(String nubeNumber,DataBodyInfo info){
		
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type",30);
			json.put("extinfo", "");
			tmpjson.put("officialAccountId", info.officialAccountId);
			tmpjson.put("name", info.name);
			tmpjson.put("ArticleId", info.ArticleId);
			tmpjson.put("title", info.title);
			tmpjson.put("previewUrl", info.previewUrl);
			tmpjson.put("offAccLogoUrl", info.offAccLogoUrl);
			tmpjson.put("createTime", info.createTime);
			tmpjson.put("introduction",info.introduction);
			tmpjson.put("articleType", info.articleType);
			tmpjson.put("isforwarded",info.isforwarded);
			tmpjson.put("ForwarderNube", info.ForwarderNube);
			tmpjson.put("ForwarderName", info.ForwarderName);
			tmpjson.put("ForwarderHeaderUrl", info.ForwarderHeaderUrl);
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
		
	}
private String getCombineData(String nubeNumber,DataBodyInfo info){
		
		JSONObject json = new JSONObject();
		JSONArray arr = new JSONArray();
		JSONObject tmpjson = new JSONObject();
		try {
			
			json.put("operatorNube", nubeNumber);
			json.put("type",31);
			json.put("extinfo", "");
			tmpjson.put("combineHeadUrl", info.combineHeadUrl);
			tmpjson.put("combineName", info.combineName);
			if (info.combineInfoList.size()>0) {
				List<JSONObject> tmplist = new ArrayList<JSONObject>();
				for (int i = 0; i < info.combineInfoList.size(); i++) {
					DataBodyInfo tmpInfo = new DataBodyInfo();
					tmpInfo = info.combineInfoList.get(i);
					JSONObject tmpjson1 = new JSONObject();
					if(tmpInfo.type == 2){
					  
					  tmpjson1.put("type", tmpInfo.type);
					  tmpjson1.put("localUrl",tmpInfo.localUrl);
					  tmpjson1.put("remoteUrl", tmpInfo.remoteUrl);
					  tmpjson1.put("thumbnailRemoteUrl", tmpInfo.thumbnailRemoteUrl);
					  tmpjson1.put("photoHeight", tmpInfo.photoHeight);
					  tmpjson1.put("photoWidth", tmpInfo.photoWidh);
					  tmpjson1.put("size", tmpInfo.size);
					  tmpjson1.put("ForwarderHeaderUrl", tmpInfo.ForwarderHeaderUrl);
					  tmpjson1.put("ForwarderName", tmpInfo.ForwarderName);
					  tmpjson1.put("messageTime", tmpInfo.messageTime);
						
					}
					if (tmpInfo.type == 3) {
				      
						  tmpjson1.put("type", tmpInfo.type);
						  tmpjson1.put("localUrl",tmpInfo.localUrl);
						  tmpjson1.put("remoteUrl", tmpInfo.remoteUrl);
						  tmpjson1.put("thumbnailRemoteUrl", tmpInfo.thumbnailRemoteUrl);
						  tmpjson1.put("duration", tmpInfo.duration);
						  tmpjson1.put("size", tmpInfo.size);
						  tmpjson1.put("ForwarderHeaderUrl", tmpInfo.ForwarderHeaderUrl);
						  tmpjson1.put("ForwarderName", tmpInfo.ForwarderName);
						  tmpjson1.put("messageTime", tmpInfo.messageTime);
						
					}
				  if (tmpInfo.type == 7) {
					  
					  tmpjson1.put("type", tmpInfo.type);
					  tmpjson1.put("localUrl",tmpInfo.localUrl);
					  tmpjson1.put("remoteUrl", tmpInfo.remoteUrl);
					  tmpjson1.put("duration", tmpInfo.duration);
					  tmpjson1.put("size", tmpInfo.size);
					  tmpjson1.put("ForwarderHeaderUrl", tmpInfo.ForwarderHeaderUrl);
					  tmpjson1.put("ForwarderName", tmpInfo.ForwarderName);
					  tmpjson1.put("messageTime", tmpInfo.messageTime);
					   
				}
				  if (tmpInfo.type == 8) {
					  tmpjson1.put("type", tmpInfo.type);
					  tmpjson1.put("txt",tmpInfo.txt);
					  tmpjson1.put("ForwarderHeaderUrl", tmpInfo.ForwarderHeaderUrl);
					  tmpjson1.put("ForwarderName", tmpInfo.ForwarderName);
					  tmpjson1.put("messageTime", tmpInfo.messageTime);
					
				}
				  if (tmpInfo.type == 30) {
					 tmpjson1.put("type",tmpInfo.type);
					 tmpjson1.put("officialAccountId", tmpInfo.officialAccountId);
					 tmpjson1.put("name", tmpInfo.name);
					 tmpjson1.put("ArticleId", tmpInfo.ArticleId);
					 tmpjson1.put("title", tmpInfo.title);
					 tmpjson1.put("previewUrl", tmpInfo.previewUrl);
					 tmpjson.put("articleType", info.articleType);
					 tmpjson1.put("offAccLogoUrl", tmpInfo.offAccLogoUrl);
					 tmpjson1.put("createTime", tmpInfo.createTime);
					 tmpjson1.put("isforwarded", tmpInfo.isforwarded);
					 tmpjson1.put("ForwarderNube", tmpInfo.ForwarderNube);
					 tmpjson1.put("ForwarderHeaderUrl", tmpInfo.ForwarderHeaderUrl);
					 tmpjson1.put("ForwarderName", tmpInfo.ForwarderName);
					 tmpjson1.put("messageTime", tmpInfo.messageTime);  
				}
				tmplist.add(tmpjson1);
				}	
				tmpjson.put("combineInfoList", tmplist);
			}
			arr.put(0, tmpjson);
			json.put("body", arr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		return json.toString();
		
	}

}
