package cn.redcdn.datacenter.collectcenter;


import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.array;
import android.R.integer;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;


public abstract class GetCollectItems extends AbstractBusinessData<List<CollectionInfo>>{
  
	
	public int getCollectionItem(String nubeNumber,String token,long startTime){
		
		
		String urlStr = "?service=getItems&nubeNumber="+nubeNumber+"&token="+token+"&startTime"+startTime;
		
		return exec(ConstConfig.getFavoriteItemUrl()+urlStr, "");
		
	}
	
	protected List<CollectionInfo> parseContentBody(JSONObject jo){

		List<CollectionInfo> collectionList = new ArrayList<CollectionInfo>();
		try {
			JSONArray userInfo = jo.getJSONArray("userInfo");
			if (userInfo!= null) {
				CollectionInfo info = null;
				DataBodyInfo bodyInfo = null;
				for (int i = 0; i < userInfo.length(); i++) {
					JSONObject json = userInfo.optJSONObject(i);
					//todo 2018-1-11 PC端收藏数据为空 造成的不往下解析
					if (json.optString("data").isEmpty()){
						continue;
					}
					JSONObject firJson = new JSONObject(json.optString("data"));
					if (firJson != null) {
						    info = new CollectionInfo();
							info.operatorNube = firJson.optString("operatorNube");
							info.type = firJson.optInt("type");
							info.time = json.optString("time");
							info.extinfo = firJson.optString("extinfo");
							JSONArray bodyArr = firJson.optJSONArray("body");
							if (bodyArr!=null) {
								JSONObject secJson = new JSONObject();
								for (int j = 0; j < bodyArr.length(); j++) {
									secJson = bodyArr.optJSONObject(j);
									bodyInfo = new DataBodyInfo();
									bodyInfo.collecTime = json.optString("time");
									bodyInfo.collectionId = json.optString("id");
									if (info.type == 2) {
										//图片
										bodyInfo.localUrl = secJson.optString("localUrl");
										bodyInfo.remoteUrl = secJson.optString("remoteUrl");
										bodyInfo.thumbnailRemoteUrl = secJson.optString("thumbnailRemoteUrl"); 
										bodyInfo.photoHeight = secJson.optInt("photoHeight");
										bodyInfo.photoWidh = secJson.optInt("photoWidth");
										bodyInfo.size = secJson.optLong("size");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.getString("operatorNube");
										}
										bodyInfo.groupName = secJson.optString("GroupName");
										
												
									}
									if (info.type == 3) {
										//视频
										bodyInfo.duration = secJson.optInt("duration");
										bodyInfo.localUrl = secJson.optString("localUrl");
										bodyInfo.remoteUrl = secJson.optString("remoteUrl");
										bodyInfo.photoHeight = secJson.optInt("photoHeight");
										bodyInfo.photoWidh = secJson.optInt("photoWidth");
										bodyInfo.thumbnailRemoteUrl = secJson.optString("thumbnailRemoteUrl"); 
										bodyInfo.size = secJson.optLong("size");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.optString("operatorNube");
										}
										bodyInfo.groupName = secJson.optString("GroupName");
									}
									if (info.type == 7) {
										//音频
										bodyInfo.duration = secJson.optInt("duration");
										bodyInfo.localUrl = secJson.optString("localUrl");
										bodyInfo.remoteUrl = secJson.optString("remoteUrl"); 
										bodyInfo.size = secJson.optLong("size");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.optString("operatorNube");
										}
										bodyInfo.groupName = secJson.optString("GroupName");
									}
									if (info.type == 8) {
										//文字
										bodyInfo.txt = secJson.optString("txt");
										if(secJson.has("ForwarderHeaderUrl")){
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										}
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.optString("operatorNube");
										}
										bodyInfo.groupName = secJson.optString("GroupName");
									}
									if (info.type == 16) {
										// 文件类型
										bodyInfo.localUrl = secJson.optString("localUrl");
										bodyInfo.fileName = secJson.optString("fileName");
										bodyInfo.size = secJson.optLong("fileSize");
										bodyInfo.remoteUrl = secJson.optString("remoteUrl");
										bodyInfo.ForwarderNube = secJson.optString("operatorNube");
										bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										bodyInfo.groupName = secJson.optString("GroupName");
									}
									if (info.type == 21) {
										//文件
										bodyInfo.duration = secJson.optInt("duration");
										bodyInfo.fileType = secJson.optString("fileType");
										bodyInfo.fileName = secJson.optString("fileName");
										bodyInfo.localUrl = secJson.optString("localUrl");
										bodyInfo.remoteUrl = secJson.optString("remoteUrl"); 
										bodyInfo.size = secJson.optLong("size");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.optString("operatorNube");
										}
									}
									if (info.type == 30) {
										//文章
										bodyInfo.officialAccountId = secJson.optString("officialAccountId");
										bodyInfo.name = secJson.optString("name");
										bodyInfo.ArticleId = secJson.optString("ArticleId");
										bodyInfo.title = secJson.optString("title");
										bodyInfo.introduction = secJson.optString("introduction");
										bodyInfo.previewUrl = secJson.optString("previewUrl");
										bodyInfo.offAccLogoUrl = secJson.optString("offAccLogoUrl");
									    bodyInfo.articleType = secJson.optInt("articleType");
										bodyInfo.createTime = secJson.optString("createTime");
										bodyInfo.isforwarded = secJson.optInt("isforwarded");
										bodyInfo.ForwarderNube = secJson.optString("ForwarderNube");
										bodyInfo.ForwarderHeaderUrl = secJson.optString("ForwarderHeaderUrl");
										if (secJson.has("ForwarderName")) {
											bodyInfo.ForwarderName = secJson.optString("ForwarderName");
										}else {
											bodyInfo.ForwarderName = firJson.optString("operatorNube");
										}
									}
									if (info.type == 31) {
										//合并聊天记录
										bodyInfo.text = secJson.optString("text");
										bodyInfo.combineHeadUrl = secJson.optString("ForwarderHeaderUrl");
										bodyInfo.combineName = secJson.optString("ForwarderName");
										JSONArray arr = secJson.optJSONArray("chatrecordInfo");
										if(arr.length()>0)
										{
											for (int k = 0; k < arr.length(); k++) {
												JSONObject tmpjson = arr.getJSONObject(k);
												int type = tmpjson.optInt("type");
												System.out.println(type);
												DataBodyInfo tmpinfo = new DataBodyInfo();
												if (type == 2) {
													tmpinfo.type = tmpjson.optInt("type");
													tmpinfo.localUrl = tmpjson.optString("localUrl");
													tmpinfo.remoteUrl = tmpjson.optString("remoteUrl");
													tmpinfo.thumbnailRemoteUrl = tmpjson.optString("thumbnail");
													tmpinfo.ForwarderHeaderUrl = tmpjson.optString("userheadUrl");
													tmpinfo.ForwarderName = tmpjson.optString("username");
													tmpinfo.photoHeight = tmpjson.optInt("height");
													tmpinfo.photoWidh = tmpjson.optInt("width");
													tmpinfo.messageTime = tmpjson.optString("createtime");
//													tmpinfo.photoWidh = Integer.parseInt(tmpjson.optString("width"));
//													tmpinfo.photoHeight = Integer.parseInt(tmpjson.optString("height"));
//													tmpinfo.messageTime = String.valueOf(tmpjson.optLong("createtime"));
												}
												if (type == 3) {
													tmpinfo.type = tmpjson.optInt("type");
													tmpinfo.localUrl = tmpjson.optString("localUrl");
													tmpinfo.remoteUrl = tmpjson.optString("remoteUrl");
													tmpinfo.thumbnailRemoteUrl = tmpjson.optString("thumbnail");
												    tmpinfo.ForwarderHeaderUrl = tmpjson.optString("userheadUrl");
												    tmpinfo.ForwarderName = tmpjson.optString("username");
												    tmpinfo.photoHeight = tmpjson.optInt("height");
													tmpinfo.photoWidh = tmpjson.optInt("width");
												    tmpinfo.duration = tmpjson.optInt("duration");
												    tmpinfo.messageTime = tmpjson.optString("createtime");
//												    tmpinfo.duration = Integer.parseInt(tmpjson.optString("duration"));
//												    tmpinfo.messageTime = String.valueOf(tmpjson.optLong("createtime"));
												}                                            
                                                if (type == 8) {
                                                	tmpinfo.type = tmpjson.optInt("type");
                                                	if (tmpjson.has("txt")) {
														tmpinfo.txt = tmpjson.optString("txt");
													}else if (tmpjson.has("text")) {
														tmpinfo.txt = tmpjson.optString("text");
													}                                                	
//                                            		tmpinfo.txt = tmpjson.optString("text");
                                            		tmpinfo.ForwarderHeaderUrl = tmpjson.optString("userheadUrl");
                                            	    tmpinfo.ForwarderName = tmpjson.optString("username");
                                            	    tmpinfo.messageTime = tmpjson.optString("createtime");
//                                            	    tmpinfo.messageTime = String.valueOf(tmpjson.optLong("createtime"));
                                                 }
                                                if (type == 30) {
	                                                tmpinfo.type = tmpjson.optInt("type");
	                                                tmpinfo.name = tmpjson.optString("officeName");
	                                                tmpinfo.title = tmpjson.optString("title");
	                                                tmpinfo.isforwarded = tmpjson.optInt("isforwarded");
	                                                tmpinfo.introduction = tmpjson.optString("introduction");
	                                                tmpinfo.articleType = tmpjson.optInt("articleType");
	                                                tmpinfo.previewUrl = tmpjson.optString("previewUrl");
	                                                tmpinfo.ArticleId = tmpjson.optString("articleId");
	                                                tmpinfo.ForwarderHeaderUrl = tmpjson.optString("userheadUrl");
	                                                tmpinfo.ForwarderName = tmpjson.optString("username");
	                                                tmpinfo.messageTime = tmpjson.optString("createtime");
//	                                                tmpinfo.messageTime = String.valueOf(tmpjson.optLong("createtime"));
	                                                
                                                }
                                                if (type == 4) {
													tmpinfo.type = tmpjson.optInt("type");
													tmpinfo.ForwarderHeaderUrl = tmpjson.optString("userheadUrl");
													tmpinfo.ForwarderName = tmpjson.optString("username");
													tmpinfo.cardCode = tmpjson.optString("cardCode");
													tmpinfo.cardname = tmpjson.optString("cardname");
													tmpinfo.cardUrl = tmpjson.optString("cardUrl");
													tmpinfo.messageTime = tmpjson.optString("createtime");
//													tmpinfo.messageTime = String.valueOf(tmpjson.optLong("createtime"));
													
												}
                                                bodyInfo.combineInfoList.add(tmpinfo);
											}									
//											
										}
									 
									}
									if (info.type == 20) {
										//文字链接
										bodyInfo.txt = secJson.optString("txt");
										JSONArray webarr = secJson.optJSONArray("webData");
										if (webarr != null) {
											for (int k = 0; k < webarr.length(); k++) {
												JSONObject webjson = webarr.optJSONObject(k);
											    WebDataInfo webData = new WebDataInfo();
											    webData.footStr = webjson.optString("footStr");
											    webData.imageUrl = webjson.optString("imgUrl");
											    webData.htmlStr = webjson.optString("htmlStr");
											    webData.headStr = webjson.optString("headStr");
											    webData.titleStr = webjson.optString("titleStr");
											    bodyInfo.webdatalist.add(webData);
											}
										}
									}
									info.dataList.add(bodyInfo);
								}
							
							}	
					}
					collectionList.add(info);	
				}
			}
			
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		for (int i = 0; i < collectionList.size(); i++) {
			CollectionInfo collectionInfo = collectionList.get(i);
			if (!(collectionInfo.type == 2||collectionInfo.type == 3||collectionInfo.type == 7||collectionInfo.type == 8||collectionInfo.type == 30||collectionInfo.type == 31 || collectionInfo.type == 16)) {
				collectionList.remove(i--);
			}
		}
		
		Collections.sort(collectionList, new Comparator<CollectionInfo>() {

			@Override
			public int compare(CollectionInfo arg0, CollectionInfo arg1) {
				 int a = Integer.parseInt(arg0.dataList.get(0).collecTime);
				 int b = Integer.parseInt(arg1.dataList.get(0).collecTime);
				 if (a<b) {
					return 1;
				}
				 if (a == b) {
					return 0;
				}
				return -1;
			}
		});
		
		return collectionList;
	}
	protected Parser getParser(){
		return new CollectionParser();
	}
	
	
}
