package cn.redcdn.datacenter.enterprisecenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.meetingmanage.data.ResponseEmpty;
import cn.redcdn.log.CustomLog;

public abstract class SetAccountAttr extends
		AbstractBusinessData<ResponseEmpty> {
	private String tag = SetAccountAttr.class.getName();

	/**
	 * 修改参会名称接口。返回结果码 对应《企业中心接口文档》1.4.8
	 * 
	 * @param nickName
	 *            参会名称
	 * @param accessToken
	 *            有效的token
	 * @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常； -4 ：输入为空
	 */
	public int setAccountAttr(String nickName, String accessToken) {
		CustomLog.i(tag, "SetAccountAttr");
		if(nickName == null){
		  return -4;
		}
		
		JSONObject json = new JSONObject();
		try {
			json.put("nickName", nickName);
			json.put("accessToken", accessToken);
		} catch (Exception e) {
			return -3;
		}
		  //转义特殊字符   % --> %25
	    String JsonString = json.toString().replace("%", "%25");
	    String jsonString = java.net.URLEncoder.encode(JsonString);
		return exec(ConstConfig.getSetAccountAttr(),
		ConstConfig.PARAM_MODIFYATTENDMEETINGNAME + jsonString);		
	}

	protected Parser getParser() {
		return new EnterpriseCenterParser();
	}

}
