package cn.redcdn.datacenter.enterprisecenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.meetingmanage.data.ResponseEmpty;
import cn.redcdn.log.CustomLog;

public abstract class SetAccountImg extends
AbstractBusinessData<ResponseEmpty> {
private String tag = SetAccountImg.class.getName();

/**
* 修改帐号头像接口。
* 
* @param headUrl
*            头像的url
* @param accessToken
*            有效的token
* @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常； -4： 输入为空
*/
public int setAccountImg(String headUrl, String accessToken) {
CustomLog.i(tag, "setAccountImg");
if(headUrl == null){
  return -4;
}

try {
  JSONObject json = new JSONObject();
  json.put("headUrl", headUrl);
  json.put("accessToken", accessToken);
  //转义特殊字符   % --> %25
  String jsonString = java.net.URLEncoder.encode(json.toString());
  return exec(ConstConfig.getSetAccountAttr(),
      ConstConfig.PARAM_MODIFYATTENDMEETINGNAME + jsonString);

} catch (Exception e) {
  CustomLog.e(tag, e.getMessage());
}
return -3;
}

protected Parser getParser() {
return new EnterpriseCenterParser();
}

}
