package cn.redcdn.datacenter.friendValidation;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.friendValidation.data.friendInfo;
import cn.redcdn.datacenter.friendValidation.data.friends;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;

public abstract class SyncFriend extends AbstractBusinessData<friends>{

	/**
	 * 同步好友接口
	 * 
	 * @param token    鉴权token
	 * 
	 * @param nube     视讯号
	 * 
	 * @param synchronousTime 上次同步时间
	 * 
	 * @return  
	 */
	public friends syscfriend(String token,String nube,String synchronousTime){
		
		String tmpStr = "token="+token+"&nube="+nube+"&synchronousTime="+synchronousTime;
		return execSync(ConstConfig.getFriendMangerUrl()+ConstConfig.FRIEND_SYNC,tmpStr);
	}
	
	protected friends parseContentBody(JSONObject jo){
		friends tmpFriends = new friends();
		if (jo!=null) {
			tmpFriends.code = jo.optString("code");
			tmpFriends.msg = jo.optString("msg");	
		}
		JSONObject json = jo.optJSONObject("data");
		if (json!=null) {
			tmpFriends.synchronousTime = json.optString("synchronousTime");
			JSONArray array = json.optJSONArray("friendSet");
			if (array.length()>0) {
				for (int i = 0; i < array.length(); i++) {
					JSONObject tmpjson = array.optJSONObject(i);
				    friendInfo info = new friendInfo();
				    info.nube = tmpjson.optString("nube");
				    info.nickName = tmpjson.optString("nickName");
				    info.status = tmpjson.optInt("status");
				    tmpFriends.friendList.add(info);
				}
				
			}
		}
		
		return tmpFriends;
	}
 
    protected Parser getParser(){return new MedicalParser();}
}
