package cn.redcdn.datacenter.hpucenter;

import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLEncoder;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.TFCommonInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/1/2.
 */

public class HPUCreateSubscribeTfCsl extends MDSAbstractBusinessData<JSONObject> {

    /**
     * 创建预约转诊
     * @param token      鉴权token
     * @param unionOrgId 机构id
     * @param deptId      科室id
     * @param transferSchedulId 排班id
     * @param expertId     排班医生id
     * @param patientName  患者姓名
     * @param patientMobile 患者手机
     * @param age   年龄
     * @param sex   性别
     * @param height  身高
     * @param weight 体重
     * @param chief  主诉
     * @param physical 查体
     * @param assCheckUrl 辅助检查
     * @param problem 待解决问题
     */
    public void createSubscribeTf(String token,String unionOrgId,String deptId,String transferSchedulId,String expertId,String patientName,String patientMobile,String age,String sex,String height,String weight,String chief,String physical,String assCheckUrl,String problem,String expertName){

        String encodeChief = URLEncoder.encode(chief);
        String encodePhysical = URLEncoder.encode(physical);
        String encodeProblem = URLEncoder.encode(problem);
        JSONObject json = new JSONObject();
        try{
            json.put("token",token);
            json.put("unionOrgId",unionOrgId);
            json.put("deptId",deptId);
            json.put("transferSchedulId",transferSchedulId);
            json.put("expertId",expertId);
            json.put("patientName",patientName);
            json.put("patientMobile",patientMobile);
            json.put("age",age);
            json.put("sex",sex);
            json.put("height",height);
            json.put("weight",weight);
            json.put("chief",encodeChief);
            json.put("physical",encodePhysical);
            json.put("assCheckUrl",assCheckUrl);
            json.put("problem",encodeProblem);
            json.put("expertName",expertName);
        }catch (JSONException e){

        }
        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TF_CREATE_SUBSCRIBE,json.toString());
    }
    //重新提交创建预约转诊申请

    /**
     *新增参数id  转诊号
     * @param token
     * @param id
     * @param unionOrgId
     * @param deptId
     * @param transferSchedulId
     * @param expertId
     * @param patientName
     * @param patientMobile
     * @param age
     * @param sex
     * @param height
     * @param weight
     * @param chief
     * @param physical
     * @param assCheckUrl
     * @param problem
     */
    public void reCreateSubscribeTf(String token,String id,String unionOrgId,String deptId,String transferSchedulId,String expertId,String patientName,String patientMobile,String age,String sex,String height,String weight,String chief,String physical,String assCheckUrl,String problem,String expertName){

        String encodeChief = URLEncoder.encode(chief);
        String encodePhysical = URLEncoder.encode(physical);
        String encodeProblem = URLEncoder.encode(problem);
        JSONObject json = new JSONObject();
        try{
            json.put("token",token);
            json.put("id",id);
            json.put("unionOrgId",unionOrgId);
            json.put("deptId",deptId);
            json.put("transferSchedulId",transferSchedulId);
            json.put("expertId",expertId);
            json.put("patientName",patientName);
            json.put("patientMobile",patientMobile);
            json.put("age",age);
            json.put("sex",sex);
            json.put("height",height);
            json.put("weight",weight);
            json.put("chief",encodeChief);
            json.put("physical",encodePhysical);
            json.put("assCheckUrl",assCheckUrl);
            json.put("problem",encodeProblem);
            json.put("expertName",expertName);
        }catch (JSONException e){

        }
        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TF_RECREATE_SUBSCRIBE,json.toString());
    }

    protected JSONObject parseContentBody(JSONObject jo){
        return jo;
    }


    protected Parser getParser(){return new HpuParser();}

}
