package cn.redcdn.datacenter.hpucenter;

import java.util.List;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CurInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.medicalcenter.data.MDSFanTypes;

public class HPUCreateUionDT extends MDSAbstractBusinessData<CurInfo>{
	
	private String TAG = HPUCreateUionDT.class.getName();
	
	/**
	 * 创建联合诊疗
	 * @param token
	 * @param deptId        科室id
	 * @param schedulId     排班id
	 * @param patientName   患者姓名
	 * @param cardType      证件类型
	 * @param patientCard   患者证件号
	 * @param patientMobile 患者手机号
	 * @param guardName     监护人姓名
	 * @param guardCard     监护人身份证号
	 * @param guardMobile   监护人手机号
	 */
	
	
	public void createUionDT(String token,String deptId,String schedulId,String patientName,String cardType,String patientCard,String patientMobile,String guardName,String guardCard,String guardMobile,String dtId){
		
		JSONObject json = new JSONObject();
		
		try {
			json.put("token", token);
			json.put("unionOrgId", dtId);
			json.put("deptId", deptId);
			json.put("schedulId", schedulId);
			json.put("patientName", patientName);
			json.put("cardType", cardType);
			json.put("patientCard", patientCard);
			json.put("patientMobile", patientMobile);
			json.put("guardCard", guardCard);
			json.put("guardMobile", guardMobile);
			json.put("guardName", guardName);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_CREATE_DT, json.toString());	
	}
	public void createUionDT(String token,String deptId,String schedulId,String patientName,String cardType,String patientCard,String patientMobile,String guardName,String guardCard,String guardMobile,String dtId,int sendMsgFlg){

		JSONObject json = new JSONObject();

		try {
			json.put("token", token);
			json.put("unionOrgId", dtId);
			json.put("deptId", deptId);
			json.put("schedulId", schedulId);
			json.put("patientName", patientName);
			json.put("cardType", cardType);
			json.put("patientCard", patientCard);
			json.put("patientMobile", patientMobile);
			json.put("guardCard", guardCard);
			json.put("guardMobile", guardMobile);
			json.put("guardName", guardName);
			json.put("sendMsgFlg", sendMsgFlg);

		} catch (JSONException e) {
			// TODO: handle exception
		}
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_CREATE_DT, json.toString());
	}
	protected CurInfo parseContentBody(JSONObject jo){
		CurInfo info = new CurInfo();
		JSONObject jsonObject = jo.optJSONObject("data");
		if (jsonObject!=null) {
			info.id = jsonObject.optString("id");
			info.curNum = jsonObject.optString("curNum");
			info.schedulDate = jsonObject.optString("schedulDate");
			
		}
		
		return info;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}

}
