package cn.redcdn.datacenter.hpucenter;

import java.net.URLDecoder;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CSLRoomDetailInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetCslRoomDetail extends MDSAbstractBusinessData<CSLRoomDetailInfo>{
	
	private String TAG = HPUGetCslRoomDetail.class.getName();
	
	/**
	 * 获取诊疗室详情
	 * @param token
	 * @param id
	 */
	
	public void getcslroomdetail(String token,String id){
		
		JSONObject json = new JSONObject();
		
		try {
			
			json.put("token", token);
			json.put("id", id);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_CSLINFO, json.toString());
		
	}
	
	protected CSLRoomDetailInfo parseContentBody(JSONObject jo){
		
		JSONObject json = jo.optJSONObject("data");
		CSLRoomDetailInfo info = new CSLRoomDetailInfo();
		if (json!=null) {
			
			info.patientId = json.optString("patientId");
			info.guardId = json.optString("guardId");
			info.state = json.optString("state");
			info.curNum = json.optString("curNum");
			info.patientName = json.optString("patientName");
			info.patientCard = json.optString("patientCard");
			info.cardType = json.optString("cardType");;
			info.patientMobile = json.optString("patientMobile");
			info.patientAge = json.optString("patientAge");
			info.patientSex= json.optString("patientSex");
			info.height = json.optString("height");
			info.weight = json.optString("weight");
			info.chief =  URLDecoder.decode(json.optString("chief")) ;
			info.physical = URLDecoder.decode(json.optString("physical")) ;
			info.assCheckUrl = json.optString("assCheckUrl");
			info.problem = URLDecoder.decode(json.optString("problem"));
			info.guardCard = json.optString("guardCard");
			info.guardId = json.optString("guardId");
			info.guardMobile = json.optString("guardMobile");
			info.guardSex = json.optString("guardSex");
			info.requestName = json.optString("requestName");
			info.requestDep = json.optString("requestDep");
			info.requestHosp = json.optString("requestHosp");
			info.requestNubeNumber = json.optString("requestNubeNumber");
			info.responseNubeNumber = json.optString("responseNubeNumber");
			info.responseName = json.optString("responseName");
			info.responseHosp = json.optString("responseHosp");
			info.responseDep = json.optString("responseDep");
			info.advice = URLDecoder.decode(json.optString("advice"));
			info.requestHeadThumUrl = json.optString("requestHeadThumUrl");
			info.responseHeadThumUrl = json.optString("responseHeadThumUrl");
			info.schedulDate = json.optString("schedulDate");
			info.requestProfessional = json.optString("requestProfessional");
			info.responseProfessional = json.optString("responseProfessional");
			info.requestScore = json.optString("requestScore");
			info.requestReview = URLDecoder.decode(json.optString("requestReview"));
			info.responseReview = URLDecoder.decode(json.optString("responseReview"));
			info.responseScore = json.optString("responseScore");
			info.meetingNo = json.optString("meetingNo");
			info.groupId = json.optString("groupId");
			info.rangeNumber = json.optString("rangeNumber");
			info.guardName = json.optString("guardName");
			info.transferFlg = json.optString("transferFlg");
			info.transferId = json.optString("transferId");
			info.transferAdvice = URLDecoder.decode(json.optString("transferAdvice"));
			info.transferHosp = json.optString("transferHosp");
			info.transferDept = json.optString("transferDept");
			info.sectionType = json.optString("sectionType");
			info.expertName = json.optString("expertName");
			info.transferSchedulDate = json.optString("transferSchedulDate");
			info.transferRangeFlg = json.optString("transferRangeFlg");
			info.logoUrL = json.optString("logoUrL");
			info.sectionName = json.optString("sectionName");
			info.printTransferUrl = json.optString("printTransferUrl");

			
			
		}
		
		return info;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	

}
