package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.ContactInfo;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetDTlist extends MDSAbstractBusinessData<List<DTInfo>>{

	
	private String TAG = HPUGetDTlist.class.getName();
	
	
	/**
	 *获取通讯录医联体列表
	 * @param token
	 */
	
	public void getdtlist(String token){
		JSONObject json = new JSONObject();
		
		try {
			
			json.put("token", token);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_LISTDTS,json.toString());
		
	}
	
	protected List<DTInfo> parseContentBody(JSONObject jo){
		List<DTInfo> mList = new ArrayList<DTInfo>();
		if (jo != null){
			JSONArray array = jo.optJSONArray("data");
			if (array!=null) {
				if (array.length()>0) {
					for (int i = 0; i < array.length(); i++) {
						DTInfo info = new DTInfo();
						JSONObject jsonObject = array.optJSONObject(i);
						if (jsonObject!=null) {
							info.id = jsonObject.optString("id");
							info.name = jsonObject.optString("name");
							mList.add(info);
						}
					}
				}
			}
		}
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
}
