package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DepartmentInfo;
import cn.redcdn.datacenter.hpucenter.data.InstitutionInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetDepartments extends MDSAbstractBusinessData<List<DepartmentInfo>> {

	
	/**
	 * 获取机构下科室列表
	 * @param token
	 * @param id   机构id
	 */
	
	public void getdepartments(String token,String id){
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("id", id);
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_LISTDEPTS, json.toString());
	}
	
protected List<DepartmentInfo> parseContentBody(JSONObject jo){
		
		JSONArray array = jo.optJSONArray("data");
		List<DepartmentInfo> mList = new ArrayList<DepartmentInfo>();
		if (array!=null) {
			if (array.length()>0) {
				for (int i = 0; i < array.length(); i++) {
					DepartmentInfo info = new DepartmentInfo();
					JSONObject jsonObject = array.optJSONObject(i);
					if (jsonObject!=null) {
						
						info.id = jsonObject.optString("id");
						info.name = jsonObject.optString("name");
						
						mList.add(info);
						
					}
				}			
			}
			
		}
		
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
	
}
