package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.InstitutionInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetInstitutions extends MDSAbstractBusinessData<List<InstitutionInfo>>{
	
	/**
	 * 获取医联体下机构列表
	 * @param token
	 * @param id
	 */
	
	public void getinstitution(String token,String id){
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("id", id);
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_ORGLIST, json.toString());
		
	}
	
protected List<InstitutionInfo> parseContentBody(JSONObject jo){
		
		JSONArray array = jo.optJSONArray("data");
		List<InstitutionInfo> mList = new ArrayList<InstitutionInfo>();
		if (array!=null) {
			if (array.length()>0) {
				for (int i = 0; i < array.length(); i++) {
					InstitutionInfo info = new InstitutionInfo();
					JSONObject jsonObject = array.optJSONObject(i);
					if (jsonObject!=null) {
						
						info.id = jsonObject.optString("id");
						info.name = jsonObject.optString("name");
						
						mList.add(info);
						
					}
				}
				
				
			}
			
		}
		
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
	

}
