package cn.redcdn.datacenter.hpucenter;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.integer;

import cn.redcdn.datacenter.CommonCode;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CSLInfo;
import cn.redcdn.datacenter.hpucenter.data.CslRangeInfo;
import cn.redcdn.datacenter.hpucenter.data.DepCslInfo;
import cn.redcdn.datacenter.hpucenter.data.DeptCslInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetListcslsBydate extends MDSAbstractBusinessData<List<DepCslInfo>>{

	private String TAG = HPUGetListcslsBydate.class.getName();
	
	private static int dtcount = 0;
	
	/**
	 * 获取某科室某日的接诊列表
	 * @param token       //鉴权token
	 * @param schedulDate //排班日期
	 */
	
	public void getcsllist(String token,String schedulDate,String dtId){
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("schedulDate", schedulDate);
			json.put("dtId",dtId);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_RESPONSEDT_BYWEEK, json.toString());
		
	}
	
	protected List<DepCslInfo> parseContentBody(JSONObject jo){
		
		List<DepCslInfo> depList = new ArrayList<DepCslInfo>();
//		List<CSLInfo> mList = new ArrayList<CSLInfo>();
		JSONObject tmparr = jo.optJSONObject("data");
		if (tmparr!=null) {
				DepCslInfo depInfo = new DepCslInfo();
				depInfo.dtName = tmparr.optString("dtName");
				depInfo.dtId = tmparr.optString("dtId");
				JSONArray tmpArr = tmparr.optJSONArray("deptList");
				if (tmpArr != null){
					for (int i1 =0;i1<tmpArr.length();i1++){
						JSONObject jsonObject1 = tmpArr.optJSONObject(i1);
						DeptCslInfo tmpInfo = new DeptCslInfo();
						tmpInfo.deptId = jsonObject1.optString("deptId");
						tmpInfo.deptName = jsonObject1.optString("deptName");
						JSONArray cslRangeArr = jsonObject1.optJSONArray("cslDeptRangeList");
						if (cslRangeArr != null){
							for (int i2 = 0;i2<cslRangeArr.length();i2++){
								JSONObject jsonObject2 = cslRangeArr.optJSONObject(i2);
								CslRangeInfo rangeInfo = new CslRangeInfo();
								rangeInfo.rangeNumber = jsonObject2.optString("rangeNumber");
								JSONArray cslArray = jsonObject2.optJSONArray("cslList");
								if (cslArray != null) {
									for (int j = 0; j < cslArray.length(); j++) {
										JSONObject json = cslArray.optJSONObject(j);
										CSLInfo info = new CSLInfo();
										if (json!=null) {
											info.id    = json.optString("id");
											info.state = json.optInt("state");
											info.schedulDate = json.optString("schedulDate");
											info.curNum = json.optString("curNum");
											info.cslStartTime = json.optLong("cslStartTime");
											info.cslEndTime = json.optLong("cslEndTime");
											info.curSystemTime = json.optLong("curSystemTime");
											info.requestNubeNumber = json.optString("requestNubeNumber");
											info.requestHosp = json.optString("requestHosp");
											info.requestDep = json.optString("requestDep");
											info.requestName = json.optString("requestName");
											info.responseNubeNumber = json.optString("responseNubeNumber");
											info.responseName = json.optString("responseName");
											info.responseDep  = json.optString("responseDep");
											info.responseHosp = json.optString("responseHosp");
											info.patientName = json.optString("patientName");
											info.chief = URLDecoder.decode(json.optString("chief"));
											info.meetingNo = json.optString("meetingNo");
											info.groupId = json.optString("groupId");
											rangeInfo.cslInfos.add(info);
										}
									}
								}
                           tmpInfo.rangeInfos.add(rangeInfo);
							}
						}
						depInfo.deptInfos.add(tmpInfo);
					}
				}
				depList.add(depInfo);

		}
		return depList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	 
	 
//	 //将列表按照时间段分组
//	 private List<DepCslInfo> sort(List<CSLInfo> tmpList){
//		 
//		 List<DepCslInfo> depinfos = new ArrayList<DepCslInfo>();
// 		 for (int i = 4*(dtcount-1); i < 4*dtcount; i++) {
// 			DepCslInfo info = new DepCslInfo();
// 			info.Num = i;
// 			if (tmpList.size()>0) {
//				info.dtName = tmpList.get(0).dtName;
//			}
// 			depinfos.add(info);
//		}
//		 if (tmpList.size()>0) {
//			 
//			 for (int i = 0; i < tmpList.size(); i++) {
//				if (tmpList.get(i).range.equals(CommonCode.RANGE_ONE)) {
//				    depinfos.get(0).cslInfos.add(tmpList.get(i));	
//				}else if (tmpList.get(i).range.equals(CommonCode.RANGE_TWO)) {
//				    depinfos.get(1).cslInfos.add(tmpList.get(i));	
//				}else if (tmpList.get(i).range.equals(CommonCode.RANGE_THREE)) {
//				    depinfos.get(2).cslInfos.add(tmpList.get(i));	
//				}else if (tmpList.get(i).range.equals(CommonCode.RANGE_FOUR)) {
//				    depinfos.get(3).cslInfos.add(tmpList.get(i));	
//				}	
//			}	
//		}	 
//	 return depinfos; 
//	 }
	 
	
}


