package cn.redcdn.datacenter.hpucenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.integer;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.HPUHomeListInfo;
import cn.redcdn.datacenter.hpucenter.data.MainBannerInfo;
import cn.redcdn.datacenter.hpucenter.data.MainOfficalInfo;
import cn.redcdn.datacenter.hpucenter.data.MainPageInfo;
import cn.redcdn.datacenter.hpucenter.data.ModuleInfo;
import cn.redcdn.datacenter.hpucenter.data.SubModuleInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomeCustomInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomelistInfo;

public class HPUGetMainPageInfo extends MDSAbstractBusinessData<HPUHomeListInfo> {


    /**
     * 获取医联体主页信息
     *
     * @param token
     * @param id         医联体id  不传查询所有医联体
     * @param updateTime 更新时间 不传则全部返回
     * @param num        医联体数量 默认 0
     */
    public void getmainInfo(String token, String id, String updateTime, int num) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);
            json.put("updateTime", updateTime);
            json.put("num", num);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_HOMELIST, json.toString());
    }

    public void getmainInfo(String token, String id, String updateTime, int num, String versionNo) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);
            json.put("updateTime", updateTime);
            json.put("num", num);
            json.put("versionNo", versionNo);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_HOMELIST, json.toString());
    }

    public void getmainInfo(String token, String id, String updateTime, int num, String versionNo, String clientType) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);
            json.put("updateTime", updateTime);
            json.put("num", num);
            json.put("versionNo", versionNo);
            json.put("clientType", clientType);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_HOMELIST, json.toString());
    }

    protected HPUHomeListInfo parseContentBody(JSONObject jo) {

        HPUHomeListInfo homeInfo = new HPUHomeListInfo();
        homeInfo.mainJson = jo;
        JSONObject json = jo.optJSONObject("data");
        if (json != null) {
            homeInfo.updateTime = json.optLong("updateTime");
            homeInfo.dtFlag = Integer.parseInt(json.optString("dtFlg"));
            JSONArray mainArray = json.optJSONArray("mainList");
            if (mainArray != null && mainArray.length() > 0) {
                for (int i = 0; i < mainArray.length(); i++) {
                    MainPageInfo mainInfo = new MainPageInfo();
                    DTInfo dtInfo = new DTInfo();
                    JSONObject mainJson = mainArray.optJSONObject(i);
                    if (mainJson != null) {
                        mainInfo.dtId = mainJson.optString("dtId");
                        mainInfo.dtName = mainJson.optString("dtName");

                        dtInfo.id = mainJson.optString("dtId");
                        dtInfo.name = mainJson.optString("dtName");
                        dtInfo.mainLogoUrl = mainJson.optString("mainLogoUrl");
                        dtInfo.logoUrl = mainJson.optString("logoUrl");
                        dtInfo.qrCodeUrl = mainJson.optString("qrCodeUrl");
                        dtInfo.infoOffId = mainJson.optString("infoOffId");
                        dtInfo.intOffId = mainJson.optString("intrOffId");
                        dtInfo.intrOffName = mainJson.optString("intrOffName");
                        dtInfo.infoOffName = mainJson.optString("infoOffName");

                        JSONArray moudleArr = mainJson.optJSONArray("module");
                        if (moudleArr != null) {
                            for (int k = 0; k < moudleArr.length(); k++) {
                                JSONObject jsonObject = moudleArr.optJSONObject(k);
                                ModuleInfo moduleInfo = new ModuleInfo();
                                moduleInfo.showName = jsonObject.optString("showName");
                                moduleInfo.perInfo = jsonObject.optString("operInfo");
                                moduleInfo.id = jsonObject.optString("id");

                                JSONArray subMoudleArr = jsonObject.optJSONArray("subModules");
                                if (subMoudleArr != null) {
                                    for (int sub = 0; sub < subMoudleArr.length(); sub++) {
                                        JSONObject subMoudleObj = subMoudleArr.optJSONObject(sub);
                                        SubModuleInfo subModuleInfo = new SubModuleInfo();
                                        subModuleInfo.id = subMoudleObj.optString("id");
                                        subModuleInfo.showName = subMoudleObj.optString("showName");
                                        subModuleInfo.showIcon = subMoudleObj.optString("showIcon");
                                        subModuleInfo.operInfo = subMoudleObj.optString("operInfo");
                                        subModuleInfo.subType = subMoudleObj.optString("subType");

                                        subModuleInfo.privilegeFlg = subMoudleObj.optInt("privilegeFlg");
                                        subModuleInfo.privilegeTip  = subMoudleObj.optString("privilegeTip");

                                        moduleInfo.subModuleInfoList.add(subModuleInfo);
                                    }
                                }

                                dtInfo.moduleList.add(moduleInfo);
                            }
                        }
                        homeInfo.dtInfos.add(dtInfo);

                        JSONArray bannerArray = mainJson.optJSONArray("mainNavigation");
                        if (bannerArray != null) {
                            if (bannerArray.length() > 0) {
                                for (int j = 0; j < bannerArray.length(); j++) {

                                    MDSHomelistInfo homelistInfo = new MDSHomelistInfo();
                                    JSONObject bannerJson = bannerArray.optJSONObject(j);
                                    if (bannerJson != null) {


                                        homelistInfo.id = bannerJson.optString("articleId");
                                        homelistInfo.name = bannerJson.optString("name");
                                        homelistInfo.articleType = bannerJson.optInt("articleType");
                                        homelistInfo.showName = bannerJson.optString("showName");
                                        homelistInfo.sort = bannerJson.optString("sort");
                                        homelistInfo.showPic = bannerJson.optString("showPic");
                                        homelistInfo.showPicType = 2;

                                        mainInfo.homeRecommendList.add(homelistInfo);

                                    }

                                }
                            }
                        }
                        JSONArray offaccArray = mainJson.optJSONArray("mainAccOffList");
                        if (offaccArray != null) {
                            if (offaccArray.length() > 0) {
                                for (int k = 0; k < offaccArray.length(); k++) {

                                    MDSHomeCustomInfo customInfo = new MDSHomeCustomInfo();
                                    JSONObject officalJson = offaccArray.optJSONObject(k);
                                    if (officalJson != null) {

                                        customInfo.customName = officalJson.optString("offaccName");
                                        customInfo.showMode = 1;
                                        customInfo.officalId = officalJson.optString("offaccId");
                                        JSONArray articleArray = officalJson.optJSONArray("articleList");
                                        if (articleArray != null) {
                                            if (articleArray.length() > 0) {
                                                for (int m = 0; m < articleArray.length(); m++) {

                                                    MDSHomelistInfo homelistInfo = new MDSHomelistInfo();
                                                    JSONObject articleJson = articleArray.optJSONObject(m);
                                                    if (articleJson != null) {

                                                        homelistInfo.id = articleJson.optString("articleId");
                                                        homelistInfo.name = articleJson.optString("name");
                                                        homelistInfo.articleType = articleJson.optInt("articleType");
                                                        homelistInfo.showName = articleJson.optString("showName");
                                                        homelistInfo.sort = articleJson.optString("sort");
                                                        homelistInfo.showPic = articleJson.optString("showPic");
                                                        homelistInfo.showPicType = 2;

                                                        customInfo.articleList.add(homelistInfo);

                                                    }
                                                }

                                            }

                                        }
                                        mainInfo.homeCustomList.add(customInfo);
                                    }
                                }
                            }
                        }
                        homeInfo.pageInfos.add(mainInfo);
                    }
                }
            }
            JSONObject homeJson = json.optJSONObject("hosMedia");
            if (homeJson != null) {
                JSONArray recommendArr = homeJson.optJSONArray("homeRecommendList");
                if (recommendArr != null) {
                    for (int i = 0; i < recommendArr.length(); i++) {

                        JSONObject recommendTmp = recommendArr.optJSONObject(i);
                        MDSHomelistInfo info = new MDSHomelistInfo();
                        if (recommendTmp != null) {
                            info.id = recommendTmp.optString("id");
                            info.name = recommendTmp.optString("name");
                            info.articleType = recommendTmp.optInt("articleType");
                            info.showName = recommendTmp.optString("showName");
                            info.showPic = recommendTmp.optString("showPic");
                        }
                        homeInfo.homeRecommendList.add(info);

                    }

                }

                JSONArray officalArr = homeJson.optJSONArray("homeOfficialAccountList");
                if (officalArr != null) {
                    for (int i = 0; i < officalArr.length(); i++) {
                        JSONObject officalTmp = officalArr.optJSONObject(i);
                        MDSHomelistInfo info = new MDSHomelistInfo();
                        if (officalTmp != null) {
                            info.id = officalTmp.optString("id");
                            info.name = officalTmp.optString("name");
                            info.showName = officalTmp.optString("showName");
                            info.showPic = officalTmp.optString("showPic");
                        }
                        homeInfo.homeOfficialAccountList.add(info);
                    }
                }


                JSONArray customArr = homeJson.optJSONArray("homeCustomList");
                if (customArr != null) {
                    for (int i = 0; i < customArr.length(); i++) {
                        JSONObject customJson = customArr.optJSONObject(i);
                        MDSHomeCustomInfo info = new MDSHomeCustomInfo();
                        if (customJson != null) {
                            info.customName = customJson.optString("customName");
                            info.showMode = customJson.optInt("showMode");
                            JSONArray articleArr = customJson.optJSONArray("articleList");
                            if (articleArr != null) {
                                for (int j = 0; j < articleArr.length(); j++) {
                                    JSONObject articleJson = articleArr.optJSONObject(j);
                                    MDSHomelistInfo tmpInfo = new MDSHomelistInfo();
                                    if (articleJson != null) {
                                        tmpInfo.id = articleJson.optString("id");
                                        tmpInfo.name = articleJson.optString("name");
                                        tmpInfo.articleType = articleJson.optInt("articleType");
                                        tmpInfo.showName = articleJson.optString("showName");
                                        tmpInfo.showPic = articleJson.optString("showPic");
                                        tmpInfo.showPicType = articleJson.optInt("showPicType");
                                    }
                                    info.articleList.add(tmpInfo);
                                }
                            }
                        }
                        homeInfo.homeCustomList.add(info);
                    }
                }

            }
        }
        return homeInfo;
    }


    protected Parser getParser() {
        return new HpuParser();
    }


}
