package cn.redcdn.datacenter.hpucenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.ModuleInfo;
import cn.redcdn.datacenter.hpucenter.data.SubModuleInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by caizx on 2018/2/26.
 */

public class HPUGetMoudleList extends MDSAbstractBusinessData<List<DTInfo>> {

    public void getMoudleList(String token, String id) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);

        } catch (JSONException e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_MODULE_LIST, json.toString());
    }

    public void getMoudleList(String token, String id, String versionNo) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);
            json.put("versionNo", versionNo);
        } catch (JSONException e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_MODULE_LIST, json.toString());
    }

    public void getMoudleList(String token, String id, String versionNo, String clientType) {
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("id", id);
            json.put("versionNo", versionNo);
            json.put("clientType", clientType);
        } catch (JSONException e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_MODULE_LIST, json.toString());
    }

    protected List<DTInfo> parseContentBody(JSONObject jo) {

        List<DTInfo> mList = new ArrayList<>();
        JSONArray array = jo.optJSONArray("data");
        if (array != null) {
            if (array.length() > 0) {
                for (int i = 0; i < array.length(); i++) {
                    JSONObject tmpjson = array.optJSONObject(i);
                    List<ModuleInfo> moduleInfos = new ArrayList<>();
                    DTInfo info = new DTInfo();
                    if (tmpjson != null) {
                        info.name = tmpjson.optString("dtName");
                        info.id = tmpjson.optString("dtId");
                        info.logoUrl = tmpjson.optString("logoUrl");
                        JSONArray mArray = tmpjson.optJSONArray("module");
                        if (mArray != null) {
                            for (int j = 0; j < mArray.length(); j++) {
                                JSONObject mjson = mArray.optJSONObject(j);
                                if (mjson != null) {
                                    ModuleInfo moduleInfo = new ModuleInfo();
                                    moduleInfo.id = mjson.optString("id");
                                    moduleInfo.name = mjson.optString("name");
                                    moduleInfo.showName = mjson.optString("showName");
                                    moduleInfo.status = mjson.optInt("status");
                                    moduleInfo.perInfo = mjson.optString("operInfo");

                                    JSONArray subMoudleArr = mjson.optJSONArray("subModules");
                                    if (subMoudleArr != null) {
                                        for (int sub = 0; sub < subMoudleArr.length(); sub++) {
                                            JSONObject subMoudleObj = subMoudleArr.optJSONObject(sub);
                                            SubModuleInfo subModuleInfo = new SubModuleInfo();
                                            subModuleInfo.id = subMoudleObj.optString("id");
                                            subModuleInfo.showName = subMoudleObj.optString("showName");
                                            subModuleInfo.showIcon = subMoudleObj.optString("showIcon");
                                            subModuleInfo.operInfo = subMoudleObj.optString("operInfo");
                                            subModuleInfo.subType = subMoudleObj.optString("subType");

                                            subModuleInfo.privilegeFlg = subMoudleObj.optInt("privilegeFlg");
                                            subModuleInfo.privilegeTip  = subMoudleObj.optString("privilegeTip");

                                            moduleInfo.subModuleInfoList.add(subModuleInfo);
                                        }
                                    }

                                    moduleInfos.add(moduleInfo);
                                }
                            }
                        }
                        info.moduleList = moduleInfos;
                    }
                    mList.add(info);
                }
            }
        }
        return mList;
    }

    protected Parser getParser() {
        return new HpuParser();
    }

}
