package cn.redcdn.datacenter.hpucenter;

import java.net.URLDecoder;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CSLInfo;
import cn.redcdn.datacenter.hpucenter.data.MyAllCslListInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetMyAllListByDate extends MDSAbstractBusinessData<MyAllCslListInfo>{
	
	private String TAG = HPUGetMyAllListByDate.class.getName();
	
	/**
	 * 获取某日我的所有诊疗列表
	 * @param token       //鉴权token
	 * @param schedulDate //排班时间（不设定默认今日）
	 */
	
	public void getallList(String token,String schedulDate,String dtId){
		
		JSONObject json = new JSONObject();
		try {
			
			json.put("token", token);
			json.put("schedulDate", schedulDate);
			json.put("dtId",dtId);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_ALL_DT,json.toString());
		
	}
	
	protected MyAllCslListInfo parseContentBody(JSONObject jo){
		MyAllCslListInfo info = new MyAllCslListInfo();
		JSONObject json = jo.optJSONObject("data");
		if (json!=null) {
			
			JSONArray seekArray = json.optJSONArray("seekList");
			
			if (seekArray!=null) {
				if(seekArray.length()>0)
					for (int i = 0; i < seekArray.length(); i++) {
						CSLInfo seekinfo = new CSLInfo();
						JSONObject seekJson = seekArray.optJSONObject(i);
						if (seekJson!=null) {
							seekinfo.range = seekJson.optString("rangeNumber");
							seekinfo.id    = seekJson.optString("id");
							seekinfo.state = seekJson.optInt("state");
							seekinfo.schedulDate = seekJson.optString("schedulDate");
							seekinfo.curNum = seekJson.optString("curNum");
							seekinfo.dtId = seekJson.optString("dtId");
							seekinfo.dtName = seekJson.optString("dtName");
							seekinfo.cslStartTime = seekJson.optLong("cslStartTime");
							seekinfo.cslEndTime = seekJson.optLong("cslEndTime");
							seekinfo.curSystemTime = seekJson.optLong("curSystemTime");
							seekinfo.requestNubeNumber = seekJson.optString("requestNubeNumber");
							seekinfo.requestHosp = seekJson.optString("requestHosp");
							seekinfo.requestDep = seekJson.optString("requestDep");
							seekinfo.requestName = seekJson.optString("requestName");
							seekinfo.responseNubeNumber = seekJson.optString("responseNubeNumber");
							seekinfo.responseName = seekJson.optString("responseName");
							seekinfo.responseDep  = seekJson.optString("responseDep");
							seekinfo.requestHosp = seekJson.optString("responseHosp");
							seekinfo.patientName = seekJson.optString("patientName");
							seekinfo.chief = URLDecoder.decode(seekJson.optString("chief"));
							seekinfo.meetingNo = seekJson.optString("meetingNo");
							seekinfo.groupId = seekJson.optString("groupId");
							info.seekInfos.add(seekinfo);
						}
					}
			}
			
			JSONArray cslArray = json.optJSONArray("cslList");
			
			if (cslArray!=null) {
				if(cslArray.length()>0)
					for (int j = 0; j < cslArray.length(); j++) {
						CSLInfo cslinfo = new CSLInfo();
						JSONObject cslJson = cslArray.optJSONObject(j);
						if (cslJson!=null) {
							cslinfo.range = cslJson.optString("rangeNumber");
							cslinfo.id    = cslJson.optString("id");
							cslinfo.state = cslJson.optInt("state");
							cslinfo.schedulDate = cslJson.optString("schedulDate");
							cslinfo.curNum = cslJson.optString("curNum");
							cslinfo.dtId = cslJson.optString("dtId");
							cslinfo.dtName = cslJson.optString("dtName");
							cslinfo.cslStartTime = cslJson.optLong("cslStartTime");
							cslinfo.cslEndTime = cslJson.optLong("cslEndTime");
							cslinfo.curSystemTime = cslJson.optLong("curSystemTime");
							cslinfo.requestNubeNumber = cslJson.optString("requestNubeNumber");
							cslinfo.requestHosp = cslJson.optString("requestHosp");
							cslinfo.requestDep = cslJson.optString("requestDep");
							cslinfo.requestName = cslJson.optString("requestName");
							cslinfo.responseNubeNumber = cslJson.optString("responseNubeNumber");
							cslinfo.responseName = cslJson.optString("responseName");
							cslinfo.responseDep  = cslJson.optString("responseDep");
							cslinfo.responseHosp = cslJson.optString("responseHosp");
							cslinfo.patientName = cslJson.optString("patientName");
							cslinfo.chief = cslJson.optString("chief");
							cslinfo.meetingNo = cslJson.optString("meetingNo");
							cslinfo.groupId = cslJson.optString("groupId");
							info.cslInfos.add(cslinfo);
					}
			}
			}
		}
		return info;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	

}
