package cn.redcdn.datacenter.hpucenter;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CSLInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetMyRequestList extends MDSAbstractBusinessData<List<CSLInfo>>{
	
	private String TAG = HPUGetMyRequestList.class.getName();
	
	/**
	 * 获取我的求诊列表
	 * @param token
	 */
	
	public void getmyseekslist(String token,String dtid){
		
		JSONObject json = new JSONObject();
		
		try {
			
			json.put("token", token);
			json.put("dtId",dtid);
//			json.put("versionNo","3.4.0");

			
		} catch (JSONException e) {
			// TODO: handle exception
		}
	   
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_MYREQUEST_CSL, json.toString());
	
	}

	//重载 添加版本号
	public void getmyseekslist(String token,String dtid,String version){

		JSONObject json = new JSONObject();

		try {

			json.put("token", token);
			json.put("dtId",dtid);
			json.put("versionNo",version);
		} catch (JSONException e) {
			// TODO: handle exception
		}

		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_MYREQUEST_CSL, json.toString());

	}
	
	protected List<CSLInfo> parseContentBody(JSONObject jo){
		
		List<CSLInfo> mList = new ArrayList<CSLInfo>();
		JSONArray tmparr = jo.optJSONArray("data");
		if (tmparr!=null && tmparr.length() > 0) {
			for (int i = 0; i < tmparr.length(); i++) {
				JSONObject jsonObject = tmparr.optJSONObject(i);
				CSLInfo info = new CSLInfo();
				
				info.range = jsonObject.optString("rangeNumber");
				info.id    = jsonObject.optString("id");
				info.state = jsonObject.optInt("state");
				info.schedulDate = jsonObject.optString("schedulDate");
				info.curNum = jsonObject.optString("curNum");
				info.dtId = jsonObject.optString("dtId");
				info.dtName = jsonObject.optString("dtName");
				info.cslStartTime = jsonObject.optLong("cslStartTime");
				info.cslEndTime = jsonObject.optLong("cslEndTime");
				info.curSystemTime = jsonObject.optLong("curSystemTime");
				info.requestNubeNumber = jsonObject.optString("requestNubeNumber");
				info.requestHosp = jsonObject.optString("requestHosp");
				info.requestDep = jsonObject.optString("requestDep");
				info.requestName = jsonObject.optString("requestName");
				info.responseNubeNumber = jsonObject.optString("responseNubeNumber");
				info.responseName = jsonObject.optString("responseName");
				info.responseDep  = jsonObject.optString("responseDep");
				info.responseHosp = jsonObject.optString("responseHosp");
				info.patientName = jsonObject.optString("patientName");
				info.chief = URLDecoder.decode(jsonObject.optString("chief"));
				info.meetingNo = jsonObject.optString("meetingNo");
				info.groupId = jsonObject.optString("groupId");
				
				mList.add(info);
				
			}
		}
		
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	

}
