package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.TFCommonInfo;
import cn.redcdn.datacenter.hpucenter.data.TFInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetMyallTfList extends MDSAbstractBusinessData<List<TFInfo>>{
	
	/**
	 * 获取我的转诊列表
	 * @param token
	 */
	
	public void getList(String token,String dtId){
		
		JSONObject json = new JSONObject();
		try {
			
			json.put("token", token);
			json.put("version","1.0.5");
			json.put("dtId",dtId);
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TF_GETMINE,json.toString());
		
	}

	 protected List<TFInfo> parseContentBody(JSONObject jo){
			
			JSONArray array = jo.optJSONArray("data");
			List<TFInfo> mList = new ArrayList<TFInfo>();
			
			if (array!=null) {
				for (int i = 0; i < array.length(); i++) {
					JSONObject  tfJson = array.optJSONObject(i);
					TFInfo info = new TFInfo();
					if (tfJson!=null) {
						info.id = tfJson.optString("id");
						info.patientName = tfJson.optString("patientName");
						info.state = tfJson.optString("state");
						info.transferHosp = tfJson.optString("transferHosp");
						info.transferDept = tfJson.optString("transferDept");
						info.expertName = tfJson.optString("expertName");
						info.transferSchedulDate = tfJson.optString("schedulDate");
						info.transferRangeFlg = tfJson.optString("transferRangeFlg");
						info.sectionType = tfJson.optString("sectionType");
						info.sectionName = tfJson.optString("sectionName");
						info.confirmDate = tfJson.optString("confirmDate");
						info.printTransferUrl = tfJson.optString("printTransferUrl");
						info.auditState = tfJson.optString("auditState");
						info.reason = tfJson.optString("reason");
						info.requestName = tfJson.optString("appointName");
						info.requestDept = tfJson.optString("appointDept");
						info.requestHospital = tfJson.optString("appointHosp");
						mList.add(info);	
					}	
				}	
			}
			return mList;
		}
		
		
		 protected Parser getParser(){return new HpuParser();}

}
