package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.SchedulInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetSchedulBydate extends MDSAbstractBusinessData<List<SchedulInfo>>{

	private String TAG = HPUGetSchedulBydate.class.getName();
	
	/**
	 * 获取某科室某日的排班信息
	 * @param token
	 * @param deptId      科室id
	 * @param schedulDate 查询日期(YYYYMMDD)
	 */
	
	public void getschedulBydate(String token,String deptId,String schedulDate){
		
		JSONObject json = new JSONObject();
		try {
			
			json.put("token", token);
			json.put("deptId", deptId);
			json.put("schedulDate", schedulDate);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_SCHED_BYDATE, json.toString());
			
	}
	
	protected List<SchedulInfo> parseContentBody(JSONObject jo){
		
		List<SchedulInfo> mList = new ArrayList<SchedulInfo>();
		if (jo.optJSONArray("data")!=null) {
		JSONArray tmarArray = jo.optJSONArray("data");
		 if (tmarArray.length()>0) {
			for (int i = 0; i < tmarArray.length(); i++) {
			  JSONObject tmpJson = tmarArray.optJSONObject(i);
			  if (tmpJson!=null) {
				 SchedulInfo info = new SchedulInfo();
				 info.schedulId = tmpJson.optString("id");
				 info.range = tmpJson.optString("rangeNumber");
				 info.num = tmpJson.optString("num");
				 info.curNum = tmpJson.optString("curNum");
				 info.status = tmpJson.optString("status");
				 info.userNames = tmpJson.optString("userNames");
				 info.enableFLg = tmpJson.optString("enableFLg");
				 mList.add(info);
			}
			}
		}	
		}
		return mList;
	}
	
	 protected Parser getParser(){return new HpuParser();}
	
}
