package cn.redcdn.datacenter.hpucenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.InstitutionInfo;
import cn.redcdn.datacenter.hpucenter.data.SchedulInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by caizx on 2018/2/26.
 */

public class HPUGetSchedulListOrgs extends MDSAbstractBusinessData<List<InstitutionInfo>> {

    /**
     *
     * @param token
     * @param id  医联体id
     * @param type
     */
    public void getSchedulList(String token,String id,int type){

        JSONObject jsonObject = new JSONObject();

        try {
            jsonObject.put("token",token);
            jsonObject.put("id",id);
            jsonObject.put("moduleType",type);

        }catch (JSONException e){

        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_SCHEDULORGS,jsonObject.toString());
    }

    protected List<InstitutionInfo> parseContentBody(JSONObject jo){

        List<InstitutionInfo> mList = new ArrayList<>();
        JSONArray array = jo.optJSONArray("data");
        if (array!=null){
            if (array.length()>0){
                for (int i = 0;i<array.length();i++){
                    JSONObject tmpjson = array.optJSONObject(i);
                    if (tmpjson!=null){
                        InstitutionInfo info = new InstitutionInfo();
                        info.name = tmpjson.optString("name");
                        info.id = tmpjson.optString("id");
                        mList.add(info);
                    }
                }
            }
        }
        return mList;
    }

    protected Parser getParser(){return new HpuParser();}


}
