package cn.redcdn.datacenter.hpucenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.integer;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.ContactInfo;
import cn.redcdn.datacenter.hpucenter.data.ShareContactInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetShareContactList extends MDSAbstractBusinessData<ShareContactInfo>{

	private String TAG = HPUGetShareContactList.class.getName();
	
	/**
	 * 获取所有医联体通讯录列表
	 * @param token
	 * @param updateTime
	 * @return
	 */
	 //同步接口
	public ShareContactInfo getlist(String token,long updateTime,int num){
		
		JSONObject json = new JSONObject();
		try {
			
			json.put("token", token);
			json.put("updateTime", updateTime);
			json.put("num", num);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
	  return	execSync(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_ALLDTCONTACT,json.toString());
		
	}
	protected ShareContactInfo parseContentBody(JSONObject jo){
		
		ShareContactInfo info = new ShareContactInfo();
		if (jo!=null) {
			info.code = jo.optInt("code");
			info.msg = jo.optString("msg");
		}
		JSONObject json = jo.optJSONObject("data");
		if (json!=null) {
			info.updateTime = json.optLong("updateTime");
			info.dtFlag = Integer.parseInt(json.optString("dtFlg"));
			JSONArray array = json.optJSONArray("contactList");
			if (array!=null&&array.length()>0) {
				
				for (int i = 0; i < array.length(); i++) {
					ContactInfo tmpInfo = new ContactInfo();
					JSONObject tmJson = array.optJSONObject(i);
					if (tmJson!=null) {
						
						tmpInfo.dtId = tmJson.optString("id");
						tmpInfo.dtName = tmJson.optString("dtName");
						tmpInfo.nube = tmJson.optString("nube");
						tmpInfo.nickName = tmJson.optString("nickName");
						tmpInfo.headThumUrl = tmJson.optString("headThumUrl");
						tmpInfo.workUnit = tmJson.optString("workUnit");
						tmpInfo.department = tmJson.optString("department");
						tmpInfo.updateTime = info.updateTime;
						
						info.contactInfos.add(tmpInfo);
						
					}	
				}	
			}	
		}
		return info;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
	
}
