package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.TFCommonInfo;
import cn.redcdn.datacenter.hpucenter.data.TFDoctorInfo;
import cn.redcdn.datacenter.hpucenter.data.TFInfo;
import cn.redcdn.datacenter.hpucenter.data.TFRangeType;
import cn.redcdn.datacenter.hpucenter.data.TFSchedInfo;
import cn.redcdn.datacenter.hpucenter.data.TFSectionInfo;
import cn.redcdn.datacenter.hpucenter.data.TFdepSchedulInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetTfScheduls extends MDSAbstractBusinessData<TFSchedInfo>{

	/**
	 * 获取转诊科室某日排班列表
	 * @param token
	 * @param deptId
	 * @param schedulDate
	 */
	
	public void getscheduls(String token,String deptId,String schedulDate){
		JSONObject json = new JSONObject();
		try {
			
			json.put("token", token);
			json.put("deptId", deptId);
			json.put("schedulDate", schedulDate);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TF_GETSCHEDS, json.toString());
	}
	
	protected TFSchedInfo parseContentBody(JSONObject jo){
		
		JSONArray array = jo.optJSONArray("data");
		TFSchedInfo tfInfo = new TFSchedInfo();
	    List<TFdepSchedulInfo> mList = new ArrayList<TFdepSchedulInfo>();
		if (array!=null) {
			for (int i = 0; i < array.length(); i++) {
				JSONObject json = array.optJSONObject(i);
				TFdepSchedulInfo info = new TFdepSchedulInfo();
				TFSectionInfo tmpInfo1 = new TFSectionInfo();
				if (json!=null) {
					info.id = json.optString("id");
					info.name = json.optString("name");
					tmpInfo1.id = json.optString("id");
					tmpInfo1.name = json.optString("name");
					JSONArray ranges = json.optJSONArray("rangeList");
					if(ranges!=null){
						for (int j = 0; j < ranges.length(); j++) {
							JSONObject raObject = ranges.optJSONObject(j);
							TFRangeType type = new TFRangeType();
							if (raObject!=null) {
								type.id = raObject.optString("id");
								type.rangeFlg = raObject.optString("rangeFlg");
								type.rangeName = raObject.optString("rangeName");
								type.enableFlg = raObject.optString("enableFlg");
								JSONArray docArray = raObject.optJSONArray("expertList");
								if (docArray!= null) {
									for (int k = 0; k < docArray.length(); k++) {
										
										JSONObject docObject = docArray.optJSONObject(k);
										TFDoctorInfo doctorInfo = new TFDoctorInfo();
										
										if (docObject!=null) {
											doctorInfo.id = docObject.optString("id");
											doctorInfo.name = docObject.optString("name");
											type.docs.add(doctorInfo);
											
										}
									}
									if (docArray.length() != 0) {
										info.types.add(type);	
									}else {
										if (info.id.equals("1")) {
											TFDoctorInfo tmpInfo = new TFDoctorInfo();
											tmpInfo.id = "";
											tmpInfo.name = info.name;
											type.docs.add(tmpInfo);
											info.types.add(type);
										}else if(info.id.equals("2")) {
											TFDoctorInfo tmpInfo = new TFDoctorInfo();
											tmpInfo.id = "";
											tmpInfo.name = info.name;
											type.docs.add(tmpInfo);
											info.types.add(type);
										}
										
									}		
								}
								
							}
						}
						if (ranges.length() != 0&&info.types.size()!=0) {	
							mList.add(info);
							tfInfo.sectionInfos.add(tmpInfo1);
						}
					}
					
				}
					
			}
			
		}
		
		//数据封装
		tfInfo.setmList(mList);
		
		return tfInfo;
		
	}
	
	
	
	
	 protected Parser getParser(){return new HpuParser();}
	
}
