package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.TFdepInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetTransferDeps extends MDSAbstractBusinessData<List<TFdepInfo>>{

	/**
	 * 获取转诊科室
	 * @param token
	 * @param cslid  //诊疗室id
	 */
	
	public void getdeps(String token,String cslid){
		
		JSONObject json = new JSONObject();
         try {
			
			json.put("token", token);
			json.put("id", cslid);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
         exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TF_GETDEPS, json.toString());
		
	}
	
  protected List<TFdepInfo> parseContentBody(JSONObject jo){
		
		JSONArray array = jo.optJSONArray("data");
		List<TFdepInfo> mList = new ArrayList<TFdepInfo>();
		if (array!=null) {
			if (array.length()>0) {
				for (int i = 0; i < array.length(); i++) {
					TFdepInfo info = new TFdepInfo();
					JSONObject jsonObject = array.optJSONObject(i);
					if (jsonObject!=null) {
						
						info.id = jsonObject.optString("id");
						info.name = jsonObject.optString("name");
						
						mList.add(info);
						
					}
				}
								
			}
			
		}
		
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
}
