package cn.redcdn.datacenter.hpucenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CertypeInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUGetlisrcards extends MDSAbstractBusinessData<List<CertypeInfo>>{

	private String TAG = HPUGetlisrcards.class.getName();
	/**
	 * 获取支持的证件类型
	 */
	public void getlistcards(){
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_CERCARD,"");
		
	}
	
	protected List<CertypeInfo> parseContentBody(JSONObject jo){
		
		List<CertypeInfo> mList = new ArrayList<CertypeInfo>();
		if (jo.optJSONArray("data")!=null) {
			JSONArray listInfos = jo.optJSONArray("data");
			if (listInfos.length()>0) {
			 for (int i = 0; i < listInfos.length(); i++) {
				JSONObject tmpjson = listInfos.optJSONObject(i);
				if (tmpjson!=null) {
					CertypeInfo info = new CertypeInfo();
					info.cerType = tmpjson.optString("type");
					info.cerName = tmpjson.optString("name");
					mList.add(info);
				}
			}
			}
		}
		return mList;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
	
}
