package cn.redcdn.datacenter.hpucenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.SearchableInfo;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.ContactInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUSearchContactInfo extends MDSAbstractBusinessData<ContactInfo>{
	
	/**
	 * 获取联系人详情
	 * @param token
	 * @param nube
	 */

	public void search(String token,String nube){
		
		JSONObject json = new JSONObject();
		
		try {
			
			json.put("token", token);
			json.put("nube", nube);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_SEARCH_DTCONTACT_INFO, json.toString());
		
	}
	
	protected ContactInfo parseContentBody(JSONObject jo){
		JSONObject jsonObject = jo.optJSONObject("data");
		ContactInfo info = new ContactInfo();
		if (jsonObject!=null) {
			info.uid = jsonObject.optString("uid");
			info.nube = jsonObject.optString("nube");
			info.nickName = jsonObject.optString("nickName");
			info.mobile = jsonObject.optString("mobile");
			info.mail = jsonObject.optString("mail");
			info.workUnit = jsonObject.optString("workUnit");
			info.workUnitType = jsonObject.optInt("workUnitType");
			info.department = jsonObject.optString("department");
			info.officeTel = jsonObject.optString("officeTel");
			info.professional = jsonObject.optString("professional");
			info.headThumUrl = jsonObject.optString("headThumUrl");
		    
		}
		return null;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
}
