package cn.redcdn.datacenter.hpucenter;

import java.net.URLEncoder;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUSubmitAdvice extends MDSAbstractBusinessData<JSONObject>{
	
	private String TAG = HPUSubmitAdvice.class.getName();
	
	/**
	 * 提交诊疗意见
	 * @param token
	 * @param id
	 * @param advice
	 */
	
	public void submit(String token,String id,String advice){
		
		JSONObject json = new JSONObject();
		String encodeAdvice = URLEncoder.encode(advice);
		try {
			
			json.put("token", token);
			json.put("id", id);
			json.put("advice", encodeAdvice);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_SUBMIT_DTOP,json.toString());
		
	}
	
	
	
	protected JSONObject parseContentBody(JSONObject jo){
		return jo;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}

}
