package cn.redcdn.datacenter.hpucenter;

import java.net.URLEncoder;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.CurInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

public class HPUUpdatePatient extends MDSAbstractBusinessData<CurInfo>{

	private String TAG = HPUUpdatePatient.class.getName();
	
	/**
	 * 
	 * @param token      鉴权token
	 * @param DTid       诊疗号
	 * @param name       名称
	 * @param cardType   证件类型
	 * @param card       证件号
	 * @param mobile     手机
	 * @param sex        性别
	 * @param height     身高
	 * @param weight     体重
	 * @param chief      主诉
	 * @param physical   查体
	 * @param assCheckUrl辅助检查
	 * @param problem    自带解决问题
	 */
	
	public void updatePatient(String token,String DTid,String name,String cardType,String age,String card,String mobile,String sex,String height,String weight,String chief,String physical,String assCheckUrl,String problem){
		
		String encodeChief = URLEncoder.encode(chief);
		String encodePhysical = URLEncoder.encode(physical);
		String encodeProblem = URLEncoder.encode(problem);
		JSONObject json = new  JSONObject();
		try {
			
			json.put("token", token);
			json.put("id", DTid);
			json.put("name", name);
			json.put("cardType", cardType);
			json.put("card", card);
			json.put("mobile",mobile);
			json.put("sex", sex);
			json.put("height", height);
			json.put("weight", weight);
			json.put("chief", encodeChief);
			json.put("physical", encodePhysical);
			json.put("assCheckUrl", assCheckUrl);
			json.put("problem", encodeProblem);
			json.put("age", age);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_UPDATE_PATIENT, json.toString());
		
	}
	protected CurInfo parseContentBody(JSONObject jo){
		
		JSONObject json = jo.optJSONObject("data");
		CurInfo info = new CurInfo();
		if (json!=null) {
			
			info.curNum = json.optString("curNum");
			info.schedulDate = json.optString("schedulDate");
	
		}
		return info;
	}
	
	
	 protected Parser getParser(){return new HpuParser();}
	
	
}
