package cn.redcdn.datacenter.hpucenter.data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.medicalcenter.data.MDSHomeCustomInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomeInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomelistInfo;

public class HPUHomeListInfo implements Serializable{
	
	public long updateTime; //最后一条更新时间单位 s
	public int dtFlag; //是否有从属的医联体
	public List<MainPageInfo> pageInfos; //医联体主页列表
	public List<MDSHomelistInfo> homeRecommendList; //推荐列表
	public List<MDSHomelistInfo> homeOfficialAccountList; //公众号列表
	public List<MDSHomeCustomInfo>  homeCustomList;  //自定义列表

	public List<DTInfo> dtInfos; //医联体账号列表

	public JSONObject mainJson;
	
	public HPUHomeListInfo(){
		updateTime = 0;
		dtFlag = 0;
		pageInfos = new ArrayList<MainPageInfo>();
		homeRecommendList = new ArrayList<MDSHomelistInfo>();
		homeOfficialAccountList = new ArrayList<MDSHomelistInfo>();
		homeCustomList = new ArrayList<MDSHomeCustomInfo>();
		dtInfos = new ArrayList<>();
		
	}
	
	public HPUHomeListInfo(HPUHomeListInfo info){
		
		this.updateTime = info.updateTime;
		this.pageInfos = info.pageInfos;
		this.homeRecommendList = info.homeRecommendList;
		this.homeOfficialAccountList = info.homeOfficialAccountList;
		this.homeCustomList = info.homeCustomList;
		this.dtFlag = info.dtFlag;
		this.dtInfos = info.dtInfos;
			
	}

	public List<DTInfo> getDtInfos() {
		return dtInfos;
	}

	public void setDtInfos(List<DTInfo> dtInfos) {
		this.dtInfos = dtInfos;
	}

	public JSONObject getMainJson() {
		return mainJson;
	}

	public void setMainJson(JSONObject mainJson) {
		this.mainJson = mainJson;
	}

	public int getDtFlag() {
		return dtFlag;
	}

	public void setDtFlag(int dtFlag) {
		this.dtFlag = dtFlag;
	}

	public List<MDSHomelistInfo> getHomeRecommendList() {
		return homeRecommendList;
	}

	public void setHomeRecommendList(List<MDSHomelistInfo> homeRecommendList) {
		this.homeRecommendList = homeRecommendList;
	}

	public List<MDSHomelistInfo> getHomeOfficialAccountList() {
		return homeOfficialAccountList;
	}

	public void setHomeOfficialAccountList(
			List<MDSHomelistInfo> homeOfficialAccountList) {
		this.homeOfficialAccountList = homeOfficialAccountList;
	}

	public List<MDSHomeCustomInfo> getHomeCustomList() {
		return homeCustomList;
	}

	public void setHomeCustomList(List<MDSHomeCustomInfo> homeCustomList) {
		this.homeCustomList = homeCustomList;
	}

	public long getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(long updateTime) {
		this.updateTime = updateTime;
	}

	public List<MainPageInfo> getPageInfos() {
		return pageInfos;
	}

	public void setPageInfos(List<MainPageInfo> pageInfos) {
		this.pageInfos = pageInfos;
	}
	
	public static HPUHomeListInfo analyseInfo(JSONObject jsonObject){
		
		HPUHomeListInfo homeInfo = new HPUHomeListInfo();
  	  JSONObject json = jsonObject.optJSONObject("data");
  	  if (json!=null) {
			 homeInfo.updateTime = json.optLong("updateTime");
			 homeInfo.dtFlag = Integer.parseInt(json.optString("dtFlg"));
			 JSONArray mainArray = json.optJSONArray("mainList");
			 if (mainArray!=null && mainArray.length()>0) {
				for (int i = 0; i < mainArray.length(); i++) {
					 MainPageInfo mainInfo = new MainPageInfo();
					 DTInfo dtInfo = new DTInfo();
					 JSONObject mainJson = mainArray.optJSONObject(i);
					 if (mainJson!=null) {
						 mainInfo.dtId = mainJson.optString("dtId");
						 mainInfo.dtName = mainJson.optString("dtName");


						 dtInfo.id = mainJson.optString("dtId");
						 dtInfo.name = mainJson.optString("dtName");
						 dtInfo.mainLogoUrl= mainJson.optString("mainLogoUrl");
						 dtInfo.logoUrl = mainJson.optString("logoUrl");
						 dtInfo.qrCodeUrl = mainJson.optString("qrCodeUrl");
						 dtInfo.infoOffId = mainJson.optString("infoOffId");
						 dtInfo.intOffId = mainJson.optString("intrOffId");
						 dtInfo.intrOffName = mainJson.optString("intrOffName");
						 dtInfo.infoOffName = mainJson.optString("infoOffName");

						 JSONArray moudleArr = mainJson.optJSONArray("module");
						 if(moudleArr!=null){
							 for (int k = 0;k<moudleArr.length();k++){
								 JSONObject jsonObject1 = moudleArr.optJSONObject(k);
								 ModuleInfo moduleInfo = new ModuleInfo();
								 moduleInfo.showName = jsonObject1.optString("showName");
								 moduleInfo.perInfo = jsonObject1.optString("operInfo");
								 moduleInfo.id = jsonObject1.optString("id");
							 }
						 }
						 homeInfo.dtInfos.add(dtInfo);

						 JSONArray bannerArray = mainJson.optJSONArray("mainNavigation");
						 if (bannerArray!=null) {
							 if (bannerArray.length()>0) {
								for (int j = 0; j < bannerArray.length(); j++) {
									
									MDSHomelistInfo homelistInfo = new MDSHomelistInfo();
									JSONObject bannerJson = bannerArray.optJSONObject(j);
									if (bannerJson!=null) {
										
										
										homelistInfo.id =  bannerJson.optString("articleId");
										homelistInfo.name = bannerJson.optString("name");
										homelistInfo.articleType = bannerJson.optInt("articleType");
										homelistInfo.showName = bannerJson.optString("showName");
										homelistInfo.sort = bannerJson.optString("sort");
										homelistInfo.showPic = bannerJson.optString("showPic");
										homelistInfo.showPicType = 2;
										
										mainInfo.homeRecommendList.add(homelistInfo);
										
									}
									
								}
							}
						}
						 JSONArray offaccArray = mainJson.optJSONArray("mainAccOffList");
						 if (offaccArray!=null) {
							if(offaccArray.length()>0){
								   for (int k = 0; k < offaccArray.length(); k++) {
									
									MDSHomeCustomInfo customInfo = new MDSHomeCustomInfo();
									JSONObject officalJson = offaccArray.optJSONObject(k);
									if (officalJson!=null) {
									
										customInfo.customName =  officalJson.optString("offaccName");
										customInfo.showMode = 1;
										JSONArray articleArray = officalJson.optJSONArray("articleList");
										if (articleArray!=null) {
											if(articleArray.length()>0){
												for (int m = 0; m < articleArray.length(); m++) {
												
													MDSHomelistInfo homelistInfo = new MDSHomelistInfo();
													JSONObject articleJson = articleArray.optJSONObject(m);
													if (articleJson!=null) {
														
														homelistInfo.id = articleJson.optString("articleId");
														homelistInfo.name = articleJson.optString("name");
														homelistInfo.articleType = articleJson.optInt("articleType");
														homelistInfo.showName = articleJson.optString("showName");
														homelistInfo.sort = articleJson.optString("sort");
														homelistInfo.showPic = articleJson.optString("showPic");
														homelistInfo.showPicType = 2;
														
														customInfo.articleList.add(homelistInfo);
														
													}
												}
												
											}
											
										}
										mainInfo.homeCustomList.add(customInfo);	
									}
								}
							}
						}
						homeInfo.pageInfos.add(mainInfo);
					}
				} 	
			}
			JSONObject homeJson = json.optJSONObject("hosMedia");
			if (homeJson!=null) {
				JSONArray recommendArr = homeJson.optJSONArray("homeRecommendList");
				if (recommendArr!=null) {
					for (int i = 0; i < recommendArr.length(); i++) {
					
							JSONObject recommendTmp = recommendArr.optJSONObject(i);
							MDSHomelistInfo info = new MDSHomelistInfo();
							if (recommendTmp!=null) {
								info.id = recommendTmp.optString("id");
								info.name = recommendTmp.optString("name");
								info.articleType = recommendTmp.optInt("articleType");
								info.showName = recommendTmp.optString("showName");
								info.showPic = recommendTmp.optString("showPic");
							}
							homeInfo.homeRecommendList.add(info);
						
					}
					
				}
				
				JSONArray officalArr = homeJson.optJSONArray("homeOfficialAccountList");
				if (officalArr!=null) {
					for (int i = 0; i < officalArr.length(); i++) {
						JSONObject officalTmp = officalArr.optJSONObject(i);
						MDSHomelistInfo info = new MDSHomelistInfo();
						if (officalTmp!=null) {
							info.id = officalTmp.optString("id");
							info.name = officalTmp.optString("name");
							info.showName = officalTmp.optString("showName");
							info.showPic = officalTmp.optString("showPic");
						}
						homeInfo.homeOfficialAccountList.add(info);
					}
				}
				
				
				JSONArray customArr = homeJson.optJSONArray("homeCustomList");
				if (customArr!=null) {
					for (int i = 0; i < customArr.length(); i++) {
						JSONObject customJson = customArr.optJSONObject(i);
						MDSHomeCustomInfo info = new MDSHomeCustomInfo();
						if (customJson!=null) {
							info.customName = customJson.optString("customName");
							info.showMode = customJson.optInt("showMode");
							JSONArray articleArr = customJson.optJSONArray("articleList");
							if (articleArr!=null) {
								for (int j = 0; j < articleArr.length(); j++) {
									JSONObject articleJson = articleArr.optJSONObject(j);
									MDSHomelistInfo tmpInfo = new MDSHomelistInfo();
									if (articleJson!=null) {
										tmpInfo.id = articleJson.optString("id");
										tmpInfo.name = articleJson.optString("name");
										tmpInfo.articleType = articleJson.optInt("articleType");
										tmpInfo.showName = articleJson.optString("showName");
										tmpInfo.showPic = articleJson.optString("showPic");
										tmpInfo.showPicType = articleJson.optInt("showPicType"); 
									}
									info.articleList.add(tmpInfo);
								}
							}		
						}
						homeInfo.homeCustomList.add(info);
					}
				}
				
			}
		}
  	  return homeInfo;
		
	}	
	

}
