package cn.redcdn.datacenter.hpucenter.data;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.log.CustomLog;

public class TFSchedInfo {

	public  List<TFdepSchedulInfo> mList;
    
	public List<TFSectionInfo> sectionInfos; //门诊列表 
	
    public TFSchedInfo(){
    	mList = new ArrayList<TFdepSchedulInfo>();
    	sectionInfos = new ArrayList<TFSectionInfo>();
    }
    
    
    /**
     * 根据门诊ID 获得门诊下面的排班信息
     * @param id
     * @return
     */
    
    public  List<TFRangeType> getRangeTypesById(String id){
    	
    	List<TFRangeType> types = new ArrayList<TFRangeType>();
    	if (mList.size()>0) {
			for (int i = 0; i < mList.size(); i++) {
				TFdepSchedulInfo info = mList.get(i);
				if (info.id.equals(id)) {
					types = info.getTypes();
				}
			}
    		
		}
    	return types;  
    }
    
    /**
     * 根据排班id 获取医生列表
     * @param id
     * @return
     */
    
    public  List<TFDoctorInfo> getDoctorInfosById(String id){
    	
    	List<TFDoctorInfo> doctorInfos = new ArrayList<TFDoctorInfo>();
    	
    	if (mList.size()>0) {
    		for (int i = 0; i < mList.size(); i++) {
				TFdepSchedulInfo info = mList.get(i);
				if (info.types.size()>0) {
					for (int j = 0; j < info.types.size(); j++) {
						TFRangeType type = info.types.get(j);
						if (type.id.equals(id)) {
							doctorInfos = type.docs;
						}
					}
					
				}
			}	
		}
    	return doctorInfos;
    }

    public TFSchedInfo getSchedInfoByRangeFlag(String rangFlg){

    	TFSchedInfo schedInfo = new TFSchedInfo();
    	List<TFdepSchedulInfo> infos = new ArrayList<>();

    	if (mList.size()>0){
    		for (int i = 0;i<mList.size();i++){
    			TFdepSchedulInfo info = mList.get(i);
    			if(info.getTypes().size()>0){
    				for (int j = 0;j<info.getTypes().size();j++){
    					if (info.getTypes().get(j).rangeFlg.equals(rangFlg)){
    						TFdepSchedulInfo newinfo = new TFdepSchedulInfo();
    						newinfo.id = info.id;
    						newinfo.name = info.name;
    						List<TFRangeType> newlist = new ArrayList<>();
    						newlist.add(info.getTypes().get(j));
    						newinfo.setTypes(newlist);
    						infos.add(newinfo);
						}
					}
				}
			}
		}
		schedInfo.setmList(infos);
		return schedInfo;
	}

	public List<TFDoctorInfo> getDoctorsByRangeFlag(String rangFlg,String id){

		List<TFRangeType> types = new ArrayList<TFRangeType>();
		List<TFDoctorInfo> doctorInfos = new ArrayList<TFDoctorInfo>();
		if (mList.size()>0) {
			for (int i = 0; i < mList.size(); i++) {
				TFdepSchedulInfo info = mList.get(i);
				if (info.id.equals(id)) {
					types = info.getTypes();
				}
			}
		}
		if (types.size()>0) {
			for (int j = 0; j < types.size(); j++) {
				TFRangeType type = types.get(j);
				if (type.rangeFlg.equals(rangFlg)) {
					doctorInfos = type.docs;
						}
					}
				}
		return doctorInfos;
	}




	public List<TFSectionInfo> getSectionInfos() {
		return sectionInfos;
	}


	public void setSectionInfos(List<TFSectionInfo> sectionInfos) {
		this.sectionInfos = sectionInfos;
	}


	public List<TFdepSchedulInfo> getmList() {
		return mList;
	}


	public void setmList(List<TFdepSchedulInfo> mList) {
		this.mList = mList;
	}


	
    
	
	
	
}
