package cn.redcdn.datacenter.hpucenter.instant;

import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLEncoder;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.instant.data.CreateInstantResultInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by gexy on 2018\9\17 0017.
 */

public class HPUCreateInstant extends MDSAbstractBusinessData<CreateInstantResultInfo> {

    /**
     * 创建即时会诊
     */
    public void createInstant(String token, String unionOrgId, String deptId, String doctorIds, String name, String mobile, String comment) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("unionOrgId", unionOrgId);
            json.put("deptId", deptId);
            json.put("doctorIds", doctorIds);
            json.put("name", name);
            json.put("mobile", mobile);
            json.put("comment", comment);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_CREATE_INSTANT, json.toString());

    }

    protected CreateInstantResultInfo parseContentBody(JSONObject jo) {

        JSONObject json = jo.optJSONObject("data");
        CreateInstantResultInfo info = new CreateInstantResultInfo();
        if (json != null) {
            info.instantId = json.optString("id");
        }

        return info;
    }

    protected Parser getParser() {
        return new HpuParser();
    }
}
