package cn.redcdn.datacenter.hpucenter.instant;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.instant.data.DeptDoctorInfo;
import cn.redcdn.datacenter.hpucenter.instant.data.DeptDoctorList;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by gexy on 2018\9\17 0017.
 */

public class HPUGetDeptDoctorList extends MDSAbstractBusinessData<DeptDoctorList>{

    /**
     * 获取科室下医生列表
     */
    public void getDeptDoctorList(String token, String deptId) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("deptId", deptId);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_DEPTDOCTORLIST, json.toString());
    }

    protected DeptDoctorList parseContentBody(JSONObject jo) {

        JSONObject json = jo.optJSONObject("data");
        DeptDoctorList info = new DeptDoctorList();
        if (json != null) {
            JSONArray doclist = json.optJSONArray("doctorList");
            if (doclist != null) {
                List<DeptDoctorInfo> infoList = new ArrayList<>();
                for (int i = 0;i<doclist.length();i++) {
                    JSONObject jsonObject = doclist.optJSONObject(i);
                    if (jsonObject != null) {
                        DeptDoctorInfo doctorInfo = new DeptDoctorInfo();
                        doctorInfo.id = jsonObject.optString("id");
                        doctorInfo.name = jsonObject.optString("name");
                        doctorInfo.headThumUrl = jsonObject.optString("headThumUrl");
                        doctorInfo.nube = jsonObject.optString("nube");
                        infoList.add(doctorInfo);
                    }
                }
                info.deptDoctorInfoList = infoList;
            }
        }

        return info;
    }

    protected Parser getParser() {
        return new HpuParser();
    }
}
