package cn.redcdn.datacenter.hpucenter.instant;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.instant.data.InstantInfo;
import cn.redcdn.datacenter.hpucenter.instant.data.InstantsData;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2018\9\18 0018.
 */

public class HPUGetInstantList extends MDSAbstractBusinessData<List<InstantsData>> {

    /**
     * 获取即时会诊列表
     */
    public void getInstantList(String token, String instantDate, String dtId) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("instantDate", instantDate);
            json.put("dtId", dtId);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_INSTANT_LIST, json.toString());
    }

    protected List<InstantsData> parseContentBody(JSONObject jo) {

        List<InstantsData> instantsDataList = new ArrayList<>();
        JSONArray json = jo.optJSONArray("data");
        if (json != null) {
            for (int i = 0; i < json.length(); i++) {
                InstantsData instantList = new InstantsData();

//                CustomLog.d("HPUGetInstantList","data i="+i);
                JSONObject object = json.optJSONObject(i);
                if (object != null) {
                    instantList.rangeNumber = object.optString("rangeNumber");

                    JSONArray jsonArray = object.optJSONArray("instants");
                    if (jsonArray != null) {
                        List<InstantInfo> instantInfoList = new ArrayList<>();
                        for (int j = 0; j < jsonArray.length(); j++) {
//                            CustomLog.d("HPUGetInstantList","rangeNumber="+instantList.rangeNumber+" instants j="+j);
                            JSONObject info = jsonArray.optJSONObject(j);
                            if (info != null) {
                                InstantInfo instantInfo = new InstantInfo();
                                instantInfo.id = info.optString("id");
                                instantInfo.requestName = info.optString("requestName");
                                instantInfo.requestHosp = info.optString("requestHosp");
                                instantInfo.requestDep = info.optString("requestDep");
                                instantInfo.responseName = info.optString("responseName");
                                instantInfo.patientName = info.optString("patientName");
                                instantInfo.chief = URLDecoder.decode(info.optString("chief"));
                                instantInfo.state = info.optString("state");

                                instantInfoList.add(instantInfo);
                            }
                        }
                        instantList.instants = instantInfoList;
                    }
                }
//                CustomLog.d("HPUGetInstantList","instantsDataList add InstantInfo.size="+instantList.instants.size());
                instantsDataList.add(instantList);
            }

        }
        CustomLog.d("HPUGetInstantList","instantsDataList size="+instantsDataList.size());
        return instantsDataList;
    }

    protected Parser getParser() {
        return new HpuParser();
    }
}
