package cn.redcdn.datacenter.hpucenter.instant;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;

/**
 * Created by gexy on 2018\9\18 0018.
 */

public class HPUGetInstantListDate extends MDSAbstractBusinessData<List<String>> {

    /**
     * 获取即时会诊接诊日期列表
     */
    public void getInstantListDate(String token, String dtId, String month) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("dtId", dtId);
            json.put("month", month);
        } catch (JSONException e) {
            // TODO: handle exception
        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.HPU_GET_INSTANT_LISTDATE, json.toString());
    }

    protected List<String> parseContentBody(JSONObject jo) {

        List<String> date = new ArrayList<>();
        JSONArray jsonArray = jo.optJSONArray("data");
        for (int i=0;i<jsonArray.length();i++) {
            date.add(jsonArray.optString(i));
        }

        return date;
    }

    protected Parser getParser() {
        return new HpuParser();
    }
}
