package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLEncoder;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/5/4.
 */

public class HPUCreateTriage extends MDSAbstractBusinessData<String> {

    String TAG = HPUCreateTriage.class.getName();
    /**
     *创建分诊
     * @param token
     * @param expectUnionOrgId   预期机构Id
     * @param expectDeptId       预期科室id
     * @param expectDate        预期预约时间YYYYMMDD
     * @param expectRange       预期预约时间段标识
     * @param name               患者姓名
     * @param phone              手机
     * @param sendMsgFlg         是否发送短信通知
     * @param comment            备注
     */



    //重新提交 把旧的诊疗单id 带上
    public void create(String token,String dtId,String expectUnionOrgId,String expectDeptId,String expectDate,String expectRange,String name,String phone,int sendMsgFlg,String comment,String id){

        JSONObject jsonObject = new JSONObject();

        try{
            jsonObject.put("token",token);
            jsonObject.put("dtId",dtId);
            jsonObject.put("expectUnionOrgId",expectUnionOrgId);
            jsonObject.put("expectDeptId",expectDeptId);
            jsonObject.put("expectDate",expectDate);
            jsonObject.put("expectRange",expectRange);
            jsonObject.put("name",name);
            jsonObject.put("phone",phone);
            jsonObject.put("sendMsgFlg",sendMsgFlg);
            jsonObject.put("comment", URLEncoder.encode(comment));
            jsonObject.put("id",id);
        }catch (JSONException e){
            CustomLog.e(TAG,e.getMessage());
        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TRIAGE_CREATE,jsonObject.toString());
    }

    protected String parseContentBody(JSONObject jo){
         if (jo!=null){
             JSONObject jsonObject = jo.optJSONObject("data");
             if(jsonObject!=null){
                 return jsonObject.optString("id");
             }
         }
         return "";
    }


    protected Parser getParser(){return new HpuParser();}


}
