package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLEncoder;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.data.TriageExpectInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by Administrator on 2018\11\21 0021.
 */

public class HPUCreateTriageMulti extends MDSAbstractBusinessData<String> {

    /**
     *创建分诊(跨医院)
     * @param token
     * @param expect         期望接诊的医院，科室医生
     * @param expectTime     预期预约时间(YYYYMMDDHHmm)
     * @param name           患者姓名
     * @param phone          手机
     * @param sendMsgFlg     是否发送短信通知（否）
     * @param dtId           医联体Id
     * @param comment        备注（否）
     * @param id             诊疗单id（否）
     */
    public void createMulti(String token, List<TriageExpectInfo> expect, String expectTime, String name, String phone,
                            String sendMsgFlg, String dtId, String comment, String id) {
        JSONObject jsonObject = new JSONObject();

        JSONArray expectArr = new JSONArray();

        try{
            jsonObject.put("token",token);
            if (expect != null) {
                for (int i = 0; i < expect.size(); i++) {
                    TriageExpectInfo expectInfo = expect.get(i);
                    JSONObject tmpJson = new JSONObject();
                    tmpJson.put("expectUnionOrgId",expectInfo.expectUnionOrgId);
                    tmpJson.put("expectDeptId",expectInfo.expectDeptId);
                    tmpJson.put("expectDoctorIds",expectInfo.expectDoctorId);
                    expectArr.put(tmpJson);
                }
            }
            jsonObject.put("expect",expectArr);
            jsonObject.put("expectTime",expectTime);
            jsonObject.put("name",name);
            jsonObject.put("phone",phone);
            jsonObject.put("sendMsgFlg",sendMsgFlg);
            jsonObject.put("dtId",dtId);
            jsonObject.put("comment", URLEncoder.encode(comment));
            jsonObject.put("id",id);
        }catch (JSONException e){
            CustomLog.e("HPUCreateTriageMulti",e.getMessage());
        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_CREATE_MUL,jsonObject.toString());

    }

    //返回诊疗单ID
    protected String parseContentBody(JSONObject jo){
        if (jo!=null){
            JSONObject jsonObject = jo.optJSONObject("data");
            if(jsonObject!=null){
                return jsonObject.optString("id");
            }
        }
        return "";
    }

    protected Parser getParser(){return new HpuParser();}
}
