package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.data.TriageDoctorInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by Administrator on 2018\11\21 0021.
 */

public class HPUGetTriageDoctorList extends MDSAbstractBusinessData<List<TriageDoctorInfo>> {

    /**
     *获取科室的医生列表
     * @param token          鉴权token
     * @param deptId         科室id
     */
    public void getDoctorList(String token, String deptId) {
        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("deptId",deptId);
        }catch (JSONException e){
            CustomLog.e("HPUGetTriageDoctorList",e.getMessage());
        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_GET_DOCTOR_LIST,jsonObject.toString());
    }

    //返回诊疗单ID
    protected List<TriageDoctorInfo> parseContentBody(JSONObject jo){
        List<TriageDoctorInfo> doctorInfos = new ArrayList<>();
        if (jo!=null){
            JSONArray jsonArray = jo.optJSONArray("data");
            if(jsonArray != null){
                for (int i = 0;i < jsonArray.length();i++) {
                    TriageDoctorInfo info = new TriageDoctorInfo();
                    JSONObject tmp = jsonArray.optJSONObject(i);
                    info.id = tmp.optString("id");
                    info.name = tmp.optString("name");
                    doctorInfos.add(info);
                }
            }
        }
        return doctorInfos;
    }

    protected Parser getParser(){return new HpuParser();}
}
