package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.data.RequestInfo;
import cn.redcdn.datacenter.hpucenter.data.TriageListInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/5/4.
 */

public class HPUGetTriageList extends MDSAbstractBusinessData<List<TriageListInfo>> {

    String TAG = HPUGetTriageList.class.getName();

    /**
     *  获取疑难分诊列表
     * @param token
     * @param triageDate  分诊日期 YYYYMMDD
     * @param dtId  医联体id
     */

    public void getList(String token,String triageDate,String dtId){

        JSONObject jsonObject = new JSONObject();

        try {
            jsonObject.put("token",token);
            jsonObject.put("triageDate",triageDate);
            jsonObject.put("dtId",dtId);
        }catch (JSONException e){
            CustomLog.e(TAG,e.getMessage());
        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TRIAGE_LIST,jsonObject.toString());
    }

    protected List<TriageListInfo> parseContentBody(JSONObject jo){

       List<TriageListInfo> mList = new ArrayList<>();

        JSONArray dataArr = jo.optJSONArray("data");
        if (dataArr!=null){
            for (int i = 0;i<dataArr.length();i++) {
                TriageListInfo info = new TriageListInfo();
                JSONObject tmp = dataArr.optJSONObject(i);
                info.rangeNumber = tmp.optString("rangeNumber");
                JSONArray requestArr = tmp.optJSONArray("triages");
                if(requestArr!=null){
                    for (int j = 0;j<requestArr.length();j++){
                        RequestInfo requestInfo = new RequestInfo();
                        JSONObject tmp1 = requestArr.optJSONObject(j);
                        requestInfo.state = tmp1.optInt("state");
                        requestInfo.id = tmp1.optString("id");
                        requestInfo.requestName = tmp1.optString("requestName");
                        requestInfo.requestHosp = tmp1.optString("requestHosp");
                        requestInfo.requestDep = tmp1.optString("requestDep");
                        requestInfo.responseNames = tmp1.optString("responseNames");
                        requestInfo.patientName = tmp1.optString("patientName");
                        requestInfo.rangeNumber = tmp1.optString("rangeNumber");
                       info.requestInfos.add(requestInfo);
                    }
                }
                mList.add(info);
            }
        }
       return mList;
    }


    protected Parser getParser(){return new HpuParser();}

}
