package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/5/4.
 */

public class HPUQueryEstimateResult extends MDSAbstractBusinessData<Integer> {

    String TAG = HPUQueryEstimateResult.class.getName();

    /**
     *1 查询会诊建议提交情况
     * @param token
     * @param id    诊疗单id
     */
    public void query(String token,String id){

        JSONObject jsonObject = new JSONObject();

        try{
            jsonObject.put("token",token);
            jsonObject.put("id",id);
        }catch (JSONException e){
            CustomLog.e(TAG,e.getMessage());
        }

        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TRIAGE_QUERY_ESTIMATE,jsonObject.toString());
    }

    protected Integer parseContentBody(JSONObject jo){
        return jo.optInt("data");
    }

    protected Parser getParser(){return new HpuParser();}
}
