package cn.redcdn.datacenter.hpucenter.triage;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.net.URLEncoder;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.HpuParser;
import cn.redcdn.datacenter.hpucenter.data.Evaluation;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/5/4.
 */

public class HPUSubmitEstimate extends MDSAbstractBusinessData<JSONObject> {

    String TAG = HPUSubmitEstimate.class.getName();

    /**
     * 提交评价
     * @param token
     * @param id     诊疗单id
     * @param mList
     */
    public void submit(String token, String id, List<Evaluation> mList) {

        JSONObject jsonObject = new JSONObject();
        JSONArray scopeList = new JSONArray();
        try{
            jsonObject.put("token",token);
            jsonObject.put("id",id);
            if (mList!=null){
                    for (int i = 0;i<mList.size();i++){
                        Evaluation info = mList.get(i);
                        JSONObject object = new JSONObject();
                        object.put("destUserId",info.destUserId);
                        object.put("review",URLEncoder.encode(info.review));
                        object.put("score",info.score);
                        object.put("advice", URLEncoder.encode(info.advice));
                        scopeList.put(i,object);
                    }
            }
            jsonObject.put("evaluations",scopeList);
        }catch (JSONException e){
            CustomLog.e(TAG,e.getMessage());
        }

       exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.HPU_TRIAGE_SUBMITESTIMATE,jsonObject.toString());
    }


    protected JSONObject parseContentBody(JSONObject jo){
        return jo;
    }


    protected Parser getParser(){return new HpuParser();}
}
