package cn.redcdn.datacenter.jhycenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.JsonReader;



import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.medicalcenter.data.MDSDetailInfo;
import cn.redcdn.log.CustomLog;


public class JHYappJISearchUsers extends MDSAbstractBusinessData<List<MDSDetailInfo>>{

	
	public void appJISearchUsers(String token,int searchType,String[] strArr){
		
		JSONObject json = new JSONObject();
		JSONArray  settingArr = new JSONArray();
		if (strArr.length>0) {
			for (int i = 0; i < strArr.length; i++) {
				settingArr.put(strArr[i]);
			}
		}
		
		try {
			json.put("token", token);
			json.put("searchType", searchType);
			json.put("content", settingArr);
			
		} catch (JSONException e) {
			// TODO: handle exception
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.JHY_SEARCH_URSER, json.toString());
		
	}
	
	 public List<MDSDetailInfo> appSearchUsersSync(String token,int searchType,String[] content)	{
			
			
			CustomLog.d("JHYappJISearchUsers:", "MDSJHYsearchusers token = "+token+"searchType = "+searchType+
					"content ="+content);
			JSONArray jArray = new JSONArray();
			for (int i = 0; i < content.length; i++) {
				jArray.put(content[i]);
			}
			JSONObject json = new JSONObject();
			try {
				json.put("token",token);
				json.put("searchType",searchType);
				json.put("content", jArray);
				
			} catch (JSONException e) {
				// TODO: handle exception
				
			}
			return execSync(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_SEARCH_USERS,json.toString());
		}
	
	
	protected List<MDSDetailInfo> parseContentBody(JSONObject jo){ 
		
		   List<MDSDetailInfo> detailList = new ArrayList<MDSDetailInfo>();
		   if (jo!=null) {
			   JSONArray userArr = jo.optJSONArray("data");
				MDSDetailInfo info = null;
				if (userArr != null) {
					for (int i = 0; i < userArr.length(); i++) {
						JSONObject userInfo;
						try {
							if(userArr.length()>0){
								userInfo = userArr.getJSONObject(i);
								info = new MDSDetailInfo();
								info.uid = userInfo.optString("id");
								info.nickName = userInfo.optString("nickName");
								info.userType = userInfo.optInt("userType");
								info.nubeNumber = userInfo.optString("nube");
								info.mail = userInfo.optString("mail");
								info.mobile = userInfo.optString("mobile");
								info.expiryDate = userInfo.optString("expiryDate");
								info.headUrl = userInfo.optString("headUrl");
								detailList.add(info);
							}
							
						} catch (JSONException e) {
							e.printStackTrace();
						}
						
					}
				}
		    }
			
		
			return detailList;
		
	}	
	protected Parser getParser(){
		
		return new MedicalParser();
		
	}
	
	
}
