package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSCityInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAPPBindGroupCsl extends MDSAbstractBusinessData<JSONObject>{

	private String TAG = MDSAPPBindGroupCsl.class.getName();
	
	/**
	 * 绑定群会诊
	 * @param token   鉴权token
	 * @param groupId 群组id
	 * @param cslRoomNo 会诊室号
	 * @param cslSubject 群视频会诊主题 
	 * @param cslPassword MD5加密密码 
	 */
	
	public void bindGroupCsl(String token,String groupId,String cslRoomNo,String cslSubject,String cslPassword){
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("groupId", groupId);
			json.put("cslRoomNo", cslRoomNo);
			json.put("cslSubject", cslSubject);
			json.put("cslPassword",cslPassword);
			
		} catch (JSONException e) {
			
		}
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_BIND_GROUPCSL,json.toString());	
	}
	
	protected JSONObject parseContentBody(JSONObject jo) 
	{
		return jo;
	}
    protected Parser getParser(){return new MedicalParser();}
	
}
