package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSRemoteVideoInfo;

/**
 * Created by gexy on 2019\8\6 0006.
 */

public class MDSAddRemoteVideo extends MDSAbstractBusinessData<List<String>> {

    /**
     * 添加远程视频设备
     *
     * @param token               登录鉴权token
     * @param remoteVideoInfoList 需要添加的远程视频设备列表
     */
    public void addRemoteVideo(String token, List<MDSRemoteVideoInfo> remoteVideoInfoList) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            JSONArray remoteVideoInfoArray = new JSONArray();
            for (int i = 0; i < remoteVideoInfoList.size(); i++) {
                JSONObject remoteVideoInfo = new JSONObject();
                remoteVideoInfo.put("account", remoteVideoInfoList.get(i).account);
                remoteVideoInfo.put("hospital", remoteVideoInfoList.get(i).hospital);
                remoteVideoInfo.put("department", remoteVideoInfoList.get(i).department);
                remoteVideoInfo.put("roomName", remoteVideoInfoList.get(i).roomName);

                remoteVideoInfoArray.put(remoteVideoInfo);
            }
            jsonObject.put("remotevedios", remoteVideoInfoArray);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_ADD_REMOTE_VIDEO, jsonObject.toString());
    }

    protected List<String> parseContentBody(JSONObject jo) {
        List<String> accountId = new ArrayList<>();
        JSONObject jsonObject = jo.optJSONObject("data");
        if (jsonObject != null) {
            JSONArray accountIdArray = jsonObject.optJSONArray("accounts");
            if (accountIdArray != null) {
                for (int i = 0; i < accountIdArray.length(); i++) {
                    accountId.add(accountIdArray.optString(i));
                }
            }
        }
        return accountId;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
