package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSCityInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetCitys extends MDSAbstractBusinessData<List<MDSCityInfo>>{
private String tag = MDSAppGetCitys.class.getName();
	/*
	 * 获取市信息
	 * @param token 登录鉴权token
	 * 
	 * @param provinceId 省Id
	 * 
	 * @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常
	 */
	public int appGetCitys(String token,String provinceId){
	
		CustomLog.d(tag, "MDSAppGetCitys token="+token+"provinceID = "+provinceId);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("provinceId", provinceId);
			
		} catch (Exception e) {
			// TODO: handle exception
			return -3;
		}
		
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_CITYS,json.toString());
	}
	protected List<MDSCityInfo> parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "MDSGetCitysinfo jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			List<MDSCityInfo> cityInfoList = new ArrayList<MDSCityInfo>();
			JSONArray arr = jo.optJSONArray("data");
			MDSCityInfo info = null;
			if (arr != null) {
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmpJson = arr.getJSONObject(i);
					info = new MDSCityInfo();
					info.cityId= tmpJson.getString("id");
					info.cityName = tmpJson.getString("name");
					cityInfoList.add(info);
				} 
			}
			return  cityInfoList;
		} catch (JSONException e) {
			CustomLog.e(tag, " MDSGetCitysInfo invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
    protected Parser getParser(){return new MedicalParser();}
}
