package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSDepartmentInfoA;
import cn.redcdn.datacenter.medicalcenter.data.MDSDepartmentInfoB;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetDepartments extends MDSAbstractBusinessData<List<MDSDepartmentInfoA>>{
	
private String tag = MDSAppGetDepartments.class.getName();
	/**
	 * 获取科室信息
	 *  	
	 * @param token 登录鉴权token
	 * 
	 * @param hospitalId  医院Id
	 * 
	 * @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常
	 */

	public int appGetDepartment(String token,String hospitalId)
			{
			
				CustomLog.d(tag, "MDSAppGetDepartments token="+token+"hospitalId = "+hospitalId);
				
				JSONObject json = new JSONObject();
				try {
					json.put("token", token);
					json.put("hospitalId", hospitalId);
					
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_DEPARTMENTS,json.toString());
			}
	protected List<MDSDepartmentInfoA> parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "MDSGetDepartmentInfo jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			List<MDSDepartmentInfoA> departmentInfoList = new ArrayList<MDSDepartmentInfoA>();
			JSONArray arr = jo.optJSONArray("data");
			MDSDepartmentInfoA info = null;
			MDSDepartmentInfoB info_b = null;
			if (arr != null) {
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmpJson = arr.getJSONObject(i);
					info = new MDSDepartmentInfoA();
					info.class_a_departmentId = tmpJson.getString("id");
					info.class_a_departmentName = tmpJson.getString("name");
					JSONArray arr_b =  new JSONArray(tmpJson.getString("child"));
					if (arr_b != null) {
						for (int j = 0; j <arr_b.length(); j++) {
							JSONObject tmpjson_b = arr_b.getJSONObject(j);
							info_b = new MDSDepartmentInfoB();
							info_b.departmentId = tmpjson_b.getString("id");
							info_b.departmentName = tmpjson_b.getString("name");
							info.infoBlist.add(info_b);
							System.out.println(info.infoBlist.size());
						}
					}
					departmentInfoList.add(info);
				} 
			}
			return  departmentInfoList;
		} catch (JSONException e) {
			CustomLog.e(tag, " MDSGetDepartmentInfo invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
		    protected Parser getParser(){return new MedicalParser();}
	
}
