package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONObject;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;



public abstract class MDSAppGetGroupQrCode extends MDSAbstractBusinessData<JSONObject> {

	private String tag = MDSAppGetGroupQrCode.class.getName();
	
	/*
	 * 获取群二维码
	 * 
	 * @param token 登录用户鉴权
	 * 
	 * @param groupId 群id
	 * 
	 * @param qrCodeType 二维码类型
	 * 
	 */
	
	public int appGetGroupQrCode(String token,String groupId) {
		
		CustomLog.d(tag, "appGetGroupQrCode token="+token+"groupId = "+groupId);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("groupId", groupId);
			
		} catch (Exception e) {
			// TODO: handle exception
			
			return -3;
		}

		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_QR_CODE, json.toString());
	}
	
    protected JSONObject parseContentBody(JSONObject jo){
    	if (jo == null) {
			CustomLog.e(tag, "appGetGroupQrCode jo == null");
		}
		return jo;
	}
	protected Parser getParser(){
		return new MedicalParser();
	}
	
}
