package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomeCustomInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomeInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSHomelistInfo;



public abstract class MDSAppGetHomeList extends MDSAbstractBusinessData<MDSHomeInfo>{
  
	/**
	 * 
	 * @param token  鉴权token 可以是登录之后的token 也可以是游客token
	 */
	public void getHomeList(String token){
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			
		} catch (Exception e) {
			
		}
		
		exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_HOME_lIST,json.toString());
		
	}
	
	protected MDSHomeInfo parseContentBody(JSONObject jo)
	{
				JSONObject json = jo.optJSONObject("data");
				MDSHomeInfo homeInfo = new MDSHomeInfo();
				if (json != null) {
					JSONArray recommendArr = json.optJSONArray("homeRecommendList");
					if (recommendArr.length()>0) {
						for (int i = 0; i < recommendArr.length(); i++) {
						
								JSONObject recommendTmp = recommendArr.optJSONObject(i);
								MDSHomelistInfo info = new MDSHomelistInfo();
								if (recommendTmp!=null) {
									info.id = recommendTmp.optString("id");
									info.name = recommendTmp.optString("name");
									info.articleType = recommendTmp.optInt("articleType");
									info.showName = recommendTmp.optString("showName");
									info.showPic = recommendTmp.optString("showPic");
								}
								homeInfo.homeRecommendList.add(info);
							
						}
						
					}
					
					JSONArray officalArr = json.optJSONArray("homeOfficialAccountList");
					if (officalArr.length()>0) {
						for (int i = 0; i < officalArr.length(); i++) {
							JSONObject officalTmp = officalArr.optJSONObject(i);
							MDSHomelistInfo info = new MDSHomelistInfo();
							if (officalTmp!=null) {
								info.id = officalTmp.optString("id");
								info.name = officalTmp.optString("name");
								info.showName = officalTmp.optString("showName");
								info.showPic = officalTmp.optString("showPic");
							}
							homeInfo.homeOfficialAccountList.add(info);
						}
					}
					
					
					JSONArray customArr = json.optJSONArray("homeCustomList");
					if (customArr.length()>0) {
						for (int i = 0; i < customArr.length(); i++) {
							JSONObject customJson = customArr.optJSONObject(i);
							MDSHomeCustomInfo info = new MDSHomeCustomInfo();
							if (customJson!=null) {
								info.customName = customJson.optString("customName");
								info.showMode = customJson.optInt("showMode");
								JSONArray articleArr = customJson.optJSONArray("articleList");
								if (articleArr.length()>0) {
									for (int j = 0; j < articleArr.length(); j++) {
										JSONObject articleJson = articleArr.optJSONObject(j);
										MDSHomelistInfo tmpInfo = new MDSHomelistInfo();
										if (articleJson!=null) {
											tmpInfo.id = articleJson.optString("id");
											tmpInfo.name = articleJson.optString("name");
											tmpInfo.articleType = articleJson.optInt("articleType");
											tmpInfo.showName = articleJson.optString("showName");
											tmpInfo.showPic = articleJson.optString("showPic");
											tmpInfo.showPicType = articleJson.optInt("showPicType"); 
										}
										info.articleList.add(tmpInfo);
									}
								}		
							}
							homeInfo.homeCustomList.add(info);
						}
					}								
				}
				return homeInfo;
				
	}
			
	protected Parser getParser(){return new MedicalParser();}
	
}
