package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSHospitalInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetHospitals extends MDSAbstractBusinessData<List<MDSHospitalInfo>>{
	private String tag = MDSAppGetHospitals.class.getName();
	
	public int appGetHospitals(String token,String cityId)
			{
			
				CustomLog.d(tag, "MDSAppGetHospitals token="+token+"cityId = "+cityId);
				
				JSONObject json = new JSONObject();
				try {
					json.put("token", token);
					json.put("cityId", cityId);
					
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_HOSPITALS,json.toString());
			}
	protected List<MDSHospitalInfo> parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "MDSGetHospitalinfo jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			List<MDSHospitalInfo> hospitalInfoList = new ArrayList<MDSHospitalInfo>();
			JSONArray arr = jo.optJSONArray("data");
			MDSHospitalInfo info = null;
			if (arr != null) {
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmpJson = arr.getJSONObject(i);
					info = new MDSHospitalInfo();
					info.hospitalId = tmpJson.getString("id");
					info.hospitalName = tmpJson.getString("name");
					hospitalInfoList.add(info);
				} 
			}
			return  hospitalInfoList;
		} catch (JSONException e) {
			CustomLog.e(tag, " MDSGetHospitalinfo invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
		    protected Parser getParser(){return new MedicalParser();}
}
