package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSProviceInfo;
import cn.redcdn.log.CustomLog;


public abstract class MDSAppGetProvinces extends MDSAbstractBusinessData<List<MDSProviceInfo>>{ 
	private String tag = MDSAppGetProvinces.class.getName();
	
	public int appGetProvinces(String token)
	{
	
		CustomLog.d(tag, "MDSAppGetProvinces token="+token);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			
		} catch (Exception e) {
			// TODO: handle exception
			return -3;
		}
		
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_PROVINCES,json.toString());
		
	}
	protected List<MDSProviceInfo> parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "MDSGetProvinceInfo jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			List<MDSProviceInfo> proviceInfoList = new ArrayList<MDSProviceInfo>();
			JSONArray arr = jo.optJSONArray("data");
			MDSProviceInfo info = null;
			if (arr != null) {
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmpJson = arr.getJSONObject(i);
					info = new MDSProviceInfo();
					info.proviceId = tmpJson.getString("id");
					info.proviceName = tmpJson.getString("name");
					proviceInfoList.add(info);
				} 
			}
			return  proviceInfoList;
		} catch (JSONException e) {
			CustomLog.e(tag, " MDSGetProvinceInfo invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
    protected Parser getParser(){return new MedicalParser();}
}
