package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSUserInfo;
import cn.redcdn.log.CustomLog;

/**
 * Created by gexy on 2019\1\30 0030.
 */

public class MDSAppGetUserInfo extends MDSAbstractBusinessData<MDSUserInfo> {
    private String TAG = "MDSAppGetUserInfo";

    public int getUserInfo(String token) {
        CustomLog.d(TAG, "MDSAppGetUserInfo getUserInfo token=" + token);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }
        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_APPUSERINFO, json.toString());
    }

    protected MDSUserInfo parseContentBody(JSONObject jo)
            throws InvalidateResponseException {
        try {
            if (jo == null) {
                CustomLog.e(TAG, "MDSAppGetUserInfo invalidate reponse");
                throw new InvalidateResponseException();
            }

            JSONObject userInfo = jo.getJSONObject("data");

            MDSUserInfo info = new MDSUserInfo();
            info.nube = userInfo.optString("nube");
            info.nickName = userInfo.optString("nickName");
            info.mobile = userInfo.optString("mobile");
            info.mail = userInfo.optString("mail");
            info.accountType = userInfo.optInt("accountType");
            info.workUnit = userInfo.optString("workUnit");
            info.workUnitType = userInfo.optInt("workUnitType");
            info.department = userInfo.optString("department");
            info.officeTel = userInfo.optString("officeTel");
            info.professional = userInfo.optString("professional");
            info.headThumUrl = userInfo.optString("headThumUrl");
            info.headPreviewUrl = userInfo.optString("headPreviewUrl");
            info.certificateThumUrl = userInfo.optString("certificateThumUrl");
            info.certificatePreviewUrl = userInfo.optString("certificatePreviewUrl");
            info.qrCodeUrl = userInfo.optString("qrCodeUrl");
            info.state = userInfo.optInt("state");
            info.reason = userInfo.optString("reason");
            info.doctubeState = userInfo.optInt("doctubeState");
            info.doctubeReason = userInfo.optString("doctubeReason");
            info.licenseThumUrl = userInfo.optString("licenseThumUrl");
            info.licensePreviewUrl = userInfo.optString("licensePreviewUrl");
            info.creator = userInfo.optString("creator");
            info.remarks = userInfo.optString("remarks");
            info.createTime = userInfo.optString("createTime");
            info.updateTime = userInfo.optString("updateTime");

            return info;
        } catch (JSONException e) {
            CustomLog.e(TAG, "enterprise MDSAppGetUserInfo invalidate reponse");
            throw new InvalidateResponseException();
        }
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
