package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.integer;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSHospitalInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppSearchHospitals extends MDSAbstractBusinessData<List<MDSHospitalInfo>>{

	private String tag = MDSAppSearchHospitals.class.getName();
	
	public int appSearchHospitals(String token,String content)
			{
			
				CustomLog.d(tag, "MDSAppsearchHospitals token="+token+"content ="+content);
				
				JSONObject json = new JSONObject();
				try {
					json.put("token", token);
					json.put("content", content);
					
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_SEARCH_HOSPITALS,json.toString());
	 }

	public int appSearchHospitals(String content)
	{

		CustomLog.d(tag, "MDSAppsearchHospitals content ="+content);

		JSONObject json = new JSONObject();
		try {
			json.put("content", content);
		} catch (Exception e) {
			// TODO: handle exception
			return -3;
		}

		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_SEARCH_HOSPITALS,json.toString());
	}
	
	//紫光重载接口
	/**]
	 * 
	 * @param token
	 * @param content
	 * @param parentId
	 * @param contentId 1.分公司 2.风机场 默认2
	 * @return
	 */
	
	public int appSearch(String token,String content,String parentId,int contentId)
	{
	
		CustomLog.d(tag, "MDSAppsearchHospitals token="+token+"content ="+content);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("content", content);
			json.put("parentId", parentId);
			json.put("contentId",contentId);
			
		} catch (Exception e) {
			// TODO: handle exception
			return -3;
		}
		
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_SEARCH_HOSPITALS,json.toString());
		
	}
	
	protected List<MDSHospitalInfo> parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "MDSearchHospitals jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			List<MDSHospitalInfo> hospitalInfoList = new ArrayList<MDSHospitalInfo>();
			JSONArray arr = jo.optJSONArray("data");
			MDSHospitalInfo info = null;
			if (arr!=null) {
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmpJson = arr.getJSONObject(i);
					info = new MDSHospitalInfo();
					info.hospitalId = tmpJson.getString("id");
					info.hospitalName = tmpJson.getString("name");
					hospitalInfoList.add(info);
				} 
			}
			return  hospitalInfoList;
		} catch (JSONException e) {
			CustomLog.e(tag, " MDSSearchHospitals invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
      protected Parser getParser(){return new MedicalParser();}
	
}
