package cn.redcdn.datacenter.medicalcenter;

import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSDetailInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppSearchUsers extends MDSAbstractBusinessData<List<MDSDetailInfo>> {

    private String tag = MDSAppSearchUsers.class.getName();

    public int appSearchUsers(String token, int searchType, String[] content) {

        CustomLog.d(tag, "MDSAppSearchUsers token = " + token + "searchType = " + searchType +
                "content =" + content);
        JSONArray jArray = new JSONArray();
        for (int i = 0; i < content.length; i++) {
            jArray.put(content[i]);
        }
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("searchType", searchType);
            json.put("content", jArray);
            json.put("versionNo", ConstConfig.MDS_SERVICE_VERSIONNO);

        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SEARCH_USERS, json.toString());

    }

    public int appSearchUsers(String token, int searchType, String[] content,String versionNo,String regOrgin) {

        CustomLog.d(tag, "MDSAppSearchUsers token = " + token + "searchType = " + searchType +
                "content =" + content + " versionNo=" + versionNo + " regOrgin=" + regOrgin);
        JSONArray jArray = new JSONArray();
        for (int i = 0; i < content.length; i++) {
            jArray.put(content[i]);
        }
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("searchType", searchType);
            json.put("content", jArray);
            json.put("versionNo", versionNo);
            json.put("regOrgin", regOrgin);

        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SEARCH_USERS, json.toString());

    }

    public List<MDSDetailInfo> appSearchUsersSync(String token, int searchType, String[] content) {


        CustomLog.d(tag, "MDSAppSearchUsers token = " + token + "searchType = " + searchType +
                "content =" + content);
        JSONArray jArray = new JSONArray();
        for (int i = 0; i < content.length; i++) {
            jArray.put(content[i]);
        }
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("searchType", searchType);
            json.put("content", jArray);

        } catch (JSONException e) {
            // TODO: handle exception

        }
        return execSync(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SEARCH_USERS, json.toString());
    }

    protected List<MDSDetailInfo> parseContentBody(JSONObject jo)
            throws InvalidateResponseException {
        try {
            if (jo == null) {
                CustomLog.e(tag, " appSearchUsers jo = null");
                throw new InvalidateResponseException();
            }
            List<MDSDetailInfo> detailList = new ArrayList<MDSDetailInfo>();
            JSONArray userArr = jo.optJSONArray("data");
            MDSDetailInfo info = null;
            if (userArr != null) {
                for (int i = 0; i < userArr.length(); i++) {
                    JSONObject userInfo = userArr.getJSONObject(i);
                    info = new MDSDetailInfo();
                    info.uid = userInfo.optString("id");
                    info.headThumUrl = userInfo.optString("headThumUrl");
                    info.headPreviewUrl = userInfo.optString("headPreviewUrl");
                    info.nickName = userInfo.optString("nickName");
                    info.account = userInfo.optString("account");
                    info.accountType = userInfo.optString("accountType");
                    info.nubeNumber = userInfo.optString("nube");
                    info.qrCodeUrl = userInfo.optString("qrCodeUrl");
                    info.workUnit = userInfo.optString("workUnit");
                    info.workUnitType = userInfo.optString("workUnitType");
                    info.department = userInfo.optString("department");
                    info.professional = userInfo.optString("professional");
                    info.officTel = userInfo.optString("officeTel");
                    info.mail = userInfo.optString("mail");
                    info.mobile = userInfo.optString("mobile");
                    info.remarks = userInfo.optString("remarks");

                    info.model = userInfo.optString("model");
                    info.remarks2 = userInfo.optString("remarks2");
                    info.remarks3 = userInfo.optString("remarks3");

                    info.state = userInfo.optInt("state");
                    info.doctubeState = userInfo.optInt("doctubeState");
                    info.certificateThumUrl = userInfo.optString("certificateThumUrl");
                    info.certificatePreviewUrl = userInfo.optString("certificatePreviewUrl");
                    info.versionNo = userInfo.optString("versionNo");
                    info.createTime = userInfo.optString("createTime");
                    info.updateTime = userInfo.optString("updateTime");

                    detailList.add(info);
                }
            }

            return detailList;
        } catch (JSONException e) {
            CustomLog.e(tag, "appSearchUsers invalidate reponse");
            throw new InvalidateResponseException();
        }
    }

    protected Parser getParser() {
        return new MedicalParser();
    }


}
