package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppSubmitUserInf extends MDSAbstractBusinessData<JSONObject> {
    private String tag = MDSAppSubmitUserInf.class.getName();
    /**
     * @param token  登录鉴权token
     * @param headThumUrl  头像缩略图 
     * @param headPreviewUrl  头像预览图
     * @param nickName  昵称
     * @param mobile  手机号
     * @param mail  邮箱号
     * @param accountType  账号类型1.手机 2.邮箱
     * @param nube  视讯号
     * @param workUnit  公司/医院
     * @param workUnitType  单位类型 1.医院 2.公司
     * @param department  科室/部门
     * @param professional  职称/职位
     * @param officeTel  科室电话/公司电话
     * @param certificateThumUrl  认证照片缩略图
     * @param certificatePreviewUrl 认证照片预览图
     **/
    /**
     * 账号类型手机
     * <p/>
     */
    public static final int ACCOUNT_TYPE_MOBILE = 1;

    /**
     * 账号类型邮箱
     */
    public static final int ACCOUNT_TYPE_MAIL = 2;

    /**
     * 单位类型医院
     */
    public static final int WORKUNIT_TYPE_HOSPITAL = 1;

    /**
     * 单位类型公司
     */
    public static final int WORKUNIT_TYPE_COMMPANY = 2;

    public int appSubmitUserInfo(String token, String headThumUrl, String headPreviewUrl, String nickName, String mobile, String mail, int accountType, String nube,
                                 String workUnit, int workUnitType, String department, String professional, String officeTel, String cerThumUrl, String cerPreviewUrl) {
        CustomLog.d(tag, "appSubmitUserInfo token=" + token + "headThuml =" + headThumUrl + "headPreviewUrl =" + headPreviewUrl + "nickName =" + nickName + "mobile =" + mobile
                + "mail =" + mail + "accountType =" + accountType + "nube =" + nube + "workUnit =" + workUnit + "workUnitType =" + workUnitType + "department=" + department + "professional=" +
                professional + "officetel =" + officeTel + "cerThumUrl=" + cerThumUrl + "cerPreview=" + cerPreviewUrl);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("headThumUrl", headThumUrl);
            json.put("headPreviewUrl", headPreviewUrl);
            json.put("nickName", nickName);
            json.put("mobile", mobile);
            json.put("mail", mail);
            json.put("accountType", accountType);
            json.put("nube", nube);
            json.put("workUnit", workUnit);
            json.put("workUnitType", workUnitType);
            json.put("department", department);
            json.put("professional", professional);
            json.put("officeTel", officeTel);
            json.put("certificateThumUrl", cerThumUrl);
            json.put("certificatePreviewUrl", cerPreviewUrl);
            json.put("versionNo", ConstConfig.MDS_SERVICE_VERSIONNO);
        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SUBMIT_INFO, json.toString());

    }


    /**
     * 2017-07-27
     *
     * @param remarks 新增 备注属性
     * @return
     */

    public int newappSubmitUserInfo(String token, String headThumUrl, String headPreviewUrl, String nickName, String mobile, String mail, int accountType, String nube,
                                    String workUnit, int workUnitType, String department, String professional, String officeTel, String cerThumUrl, String cerPreviewUrl, String remarks) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("headThumUrl", headThumUrl);
            json.put("headPreviewUrl", headPreviewUrl);
            json.put("nickName", nickName);
            json.put("mobile", mobile);
            json.put("mail", mail);
            json.put("accountType", accountType);
            json.put("nube", nube);
            json.put("workUnit", workUnit);
            json.put("workUnitType", workUnitType);
            json.put("department", department);
            json.put("professional", professional);
            json.put("officeTel", officeTel);
            json.put("certificateThumUrl", cerThumUrl);
            json.put("certificatePreviewUrl", cerPreviewUrl);
            json.put("versionNo", ConstConfig.MDS_SERVICE_VERSIONNO);
            json.put("remarks", remarks);
        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SUBMIT_INFO, json.toString());

    }

    /**
     * @param token
     * @param headThumUrl
     * @param headPreviewUrl
     * @param nickName
     * @param mobile
     * @param mail
     * @param accountType
     * @param nube
     * @param workUnit       //公司
     * @param workUnitType
     * @param department     //分公司
     * @param professional   //风场
     * @param model          //型号（专业）
     * @param officeTel      //风场电话
     * @param cerThumUrl
     * @param cerPreviewUrl
     * @param remarks
     * @param remarks2       //备注2
     * @param remarks3       //备注3
     * @return
     */

    public int zgappSubmitUserInfo(String token, String headThumUrl, String headPreviewUrl, String nickName, String mobile, String mail, int accountType, String nube,
                                   String workUnit, int workUnitType, String department, String professional, String model, String officeTel, String cerThumUrl, String cerPreviewUrl, String remarks, String remarks2, String remarks3) {

        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("headThumUrl", headThumUrl);
            json.put("headPreviewUrl", headPreviewUrl);
            json.put("nickName", nickName);
            json.put("mobile", mobile);
            json.put("mail", mail);
            json.put("accountType", accountType);
            json.put("nube", nube);
            json.put("workUnit", workUnit);
            json.put("workUnitType", workUnitType);
            json.put("department", department);
            json.put("professional", professional);
            json.put("model", model);
            json.put("officeTel", officeTel);
            json.put("certificateThumUrl", cerThumUrl);
            json.put("certificatePreviewUrl", cerPreviewUrl);
            json.put("versionNo", ConstConfig.MDS_SERVICE_VERSIONNO);
            json.put("remarks", remarks);
            json.put("remarks2", remarks2);
            json.put("remarks3", remarks3);

        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SUBMIT_INFO, json.toString());

    }

    /**
     * @param token                 登录鉴权token
     * @param headThumUrl           头像缩略图
     * @param headPreviewUrl        头像预览图
     * @param nickName              昵称
     * @param mobile                手机号
     * @param mail                  邮箱号
     * @param accountType           账号类型1.手机 2.邮箱
     * @param nube                  视讯号
     * @param workUnit              医院/公司/学校
     * @param workUnitType          身份类型
     * @param department            科室/部门/专业
     * @param professional          职称/职位/学历
     * @param officeTel             科室电话/入学年份
     * @param certificateThumUrl    资格认证照片缩略图
     * @param certificatePreviewUrl 资格认证照片预览图
     * @param versionNo             版本号
     * @param remarks               备注
     * @param licenseThumUrl        执业证认证照片缩略图
     * @param licensePreviewUrl     执业证认证照片预览图
     * @param regOrgin              数据来源（详见5.35数据来源）
     **/
    public int appSubmitUserInfo(String token, String headThumUrl, String headPreviewUrl, String nickName, String mobile, String mail, int accountType, String nube,
                                 String workUnit, int workUnitType, String department, String professional, String officeTel, String certificateThumUrl, String certificatePreviewUrl, String versionNo, String remarks,
                                 String licenseThumUrl, String licensePreviewUrl, String regOrgin) {
        CustomLog.d(tag, "appSubmitUserInfo token=" + token + "headThuml =" + headThumUrl + "headPreviewUrl =" + headPreviewUrl + "nickName =" + nickName + "mobile =" + mobile
                + "mail =" + mail + "accountType =" + accountType + "nube =" + nube + "workUnit =" + workUnit + "workUnitType =" + workUnitType + "department=" + department + "professional=" +
                professional + "officetel =" + officeTel + "cerThumUrl=" + certificateThumUrl + "cerPreview=" + certificatePreviewUrl + " versionNo=" + versionNo + " remarks=" + remarks + " licenseThumUrl=" + licenseThumUrl
                + " licensePreviewUrl=" + licensePreviewUrl + " regOrgin=" + regOrgin);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("headThumUrl", headThumUrl);
            json.put("headPreviewUrl", headPreviewUrl);
            json.put("nickName", nickName);
            json.put("mobile", mobile);
            json.put("mail", mail);
            json.put("accountType", accountType);
            json.put("nube", nube);
            json.put("workUnit", workUnit);
            json.put("workUnitType", workUnitType);
            json.put("department", department);
            json.put("professional", professional);
            json.put("officeTel", officeTel);
            json.put("certificateThumUrl", certificateThumUrl);
            json.put("certificatePreviewUrl", certificatePreviewUrl);
            json.put("versionNo", versionNo);
            json.put("remarks", remarks);
            json.put("licenseThumUrl", licenseThumUrl);
            json.put("licensePreviewUrl", licensePreviewUrl);
            json.put("regOrgin", regOrgin);
        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SUBMIT_INFO, json.toString());

    }

    public int appSubmitUserInfo(String token, String headThumUrl, String headPreviewUrl, String nickName, String mobile, String mail, int accountType, String nube,
                                 String workUnit, int workUnitType, String department, String professional, String officeTel, String certificateThumUrl, String certificatePreviewUrl, String versionNo, String remarks,
                                 String licenseThumUrl, String licensePreviewUrl, String regOrgin, String remarksReview) {
        CustomLog.d(tag, "appSubmitUserInfo token=" + token + "headThuml =" + headThumUrl + "headPreviewUrl =" + headPreviewUrl + "nickName =" + nickName + "mobile =" + mobile
                + "mail =" + mail + "accountType =" + accountType + "nube =" + nube + "workUnit =" + workUnit + "workUnitType =" + workUnitType + "department=" + department + "professional=" +
                professional + "officetel =" + officeTel + "cerThumUrl=" + certificateThumUrl + "cerPreview=" + certificatePreviewUrl + " versionNo=" + versionNo + " remarks=" + remarks + " licenseThumUrl=" + licenseThumUrl
                + " licensePreviewUrl=" + licensePreviewUrl + " regOrgin=" + regOrgin + " remarksReview=" + remarksReview);
        JSONObject json = new JSONObject();
        try {
            json.put("token", token);
            json.put("headThumUrl", headThumUrl);
            json.put("headPreviewUrl", headPreviewUrl);
            json.put("nickName", nickName);
            json.put("mobile", mobile);
            json.put("mail", mail);
            json.put("accountType", accountType);
            json.put("nube", nube);
            json.put("workUnit", workUnit);
            json.put("workUnitType", workUnitType);
            json.put("department", department);
            json.put("professional", professional);
            json.put("officeTel", officeTel);
            json.put("certificateThumUrl", certificateThumUrl);
            json.put("certificatePreviewUrl", certificatePreviewUrl);
            json.put("versionNo", versionNo);
            json.put("remarks", remarks);
            json.put("licenseThumUrl", licenseThumUrl);
            json.put("licensePreviewUrl", licensePreviewUrl);
            json.put("regOrgin", regOrgin);
            json.put("remarksReview", remarksReview);
        } catch (JSONException e) {
            // TODO: handle exception
            return -3;
        }

        return exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_SUBMIT_INFO, json.toString());

    }

    protected Parser getParser() {
        return new MedicalParser();
    }


}
