package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSRemoteVideoInfo;

/**
 * Created by gexy on 2019\8\7 0007.
 */

public class MDSDelRemoteVideo extends MDSAbstractBusinessData<String> {

    /**
     * 删除远程视频设备
     *
     * @param token               登录鉴权token
     * @param accountIdList 需要删除的远程视频设备列表
     */
    public void delRemoteVideo(String token, List<String> accountIdList) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            JSONArray accountIdListArray = new JSONArray();
            for (int i = 0; i < accountIdList.size(); i++) {
                accountIdListArray.put(accountIdList.get(i));
            }
            jsonObject.put("accounts", accountIdListArray);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_DEL_REMOTE_VIDEO, jsonObject.toString());
    }

    protected String parseContentBody(JSONObject jo) {

        return "";
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
