package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSFileInfo;

/**
 * Created by gexy on 2018\12\13 0013.
 */

public class MDSGetDownLoadList extends MDSAbstractBusinessData<List<MDSFileInfo>> {

    /**
     * 获取子模块下下载列表
     *
     * @param token 登录鉴权token
     * @param id    子模块ID
     */
    public void getDownLoadList(String token, String id) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("id",id);
        }catch (Exception e){

        }
        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_DOWNLOAD_LIST,jsonObject.toString());
    }

    protected List<MDSFileInfo> parseContentBody(JSONObject jo) {
        JSONArray jsonArray = jo.optJSONArray("data");
        List<MDSFileInfo> fileInfoList = new ArrayList<>();
        if (jsonArray != null) {
            for (int i = 0;i < jsonArray.length();i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                if (jsonObject != null) {
                    MDSFileInfo fileInfo = new MDSFileInfo();
                    fileInfo.id = jsonObject.optString("id");
                    fileInfo.fileName = jsonObject.optString("fileName");
                    fileInfo.fileSize = jsonObject.optString("fileSize");
                    fileInfo.url = jsonObject.optString("url");
                    fileInfo.createTime = jsonObject.optString("createTime");

                    fileInfoList.add(fileInfo);
                }
            }
        }
        return fileInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
