package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSLinkInfo;

/**
 * Created by gexy on 2018\12\13 0013.
 */

public class MDSGetLinkList extends MDSAbstractBusinessData<List<MDSLinkInfo>> {
    /**
     * 获取子模块下快链列表
     *
     * @param token 登录鉴权token
     * @param id    子模块ID
     */
    public void getLinkList(String token, String id) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("id",id);
        }catch (Exception e){

        }
        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_LINK_LIST,jsonObject.toString());
    }

    protected List<MDSLinkInfo> parseContentBody(JSONObject jo) {
        JSONArray jsonArray = jo.optJSONArray("data");
        List<MDSLinkInfo> linkInfoList = new ArrayList<>();
        if (jsonArray != null) {
            for (int i = 0;i < jsonArray.length();i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                if (jsonObject != null) {
                    MDSLinkInfo linkInfo = new MDSLinkInfo();
                    linkInfo.name = jsonObject.optString("name");
                    linkInfo.subName = jsonObject.optString("subName");
                    linkInfo.url = jsonObject.optString("url");
                    linkInfo.createTime = jsonObject.optString("createTime");
                    linkInfo.privilegeFlg = jsonObject.optString("privilegeFlg");
                    linkInfo.privilegeTip = jsonObject.optString("privilegeTip");
                    linkInfo.privilegeNube = jsonObject.optString("privilegeNube");
                    linkInfo.showIcon = jsonObject.optString("showIcon");
                    linkInfo.refuseFlg = jsonObject.optString("refuseFlg");

                    linkInfoList.add(linkInfo);
                }
            }
        }
        return linkInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
