package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSLiveStatus;
import cn.redcdn.datacenter.medicalcenter.data.UploadVideoInfo;

/**
 * Created by gexy on 2019\7\3 0003.
 */

public class MDSGetLiveStatus extends MDSAbstractBusinessData<MDSLiveStatus> {

    /**
     * 根据内容ID 查询直播状态
     */
    public void getLiveStatus(String token, String contentID, String articleID) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            jsonObject.put("contentID", contentID);
            jsonObject.put("articleID", articleID);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_LIVE_STATUS, jsonObject.toString());
    }

    protected MDSLiveStatus parseContentBody(JSONObject jo) {
        MDSLiveStatus liveStatus = new MDSLiveStatus();
        if (jo != null) {
            JSONObject jsonObject = jo.optJSONObject("data");
            if (jsonObject != null) {
                liveStatus.status = jsonObject.optInt("status");
                liveStatus.stillurl = jsonObject.optString("stillurl");
                liveStatus.playurl = jsonObject.optString("playurl");
            }
        }
        return liveStatus;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
