package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSPlayListInfo;

/**
 * Created by gexy on 2018\12\5 0005.
 */

public class MDSGetPlayList extends MDSAbstractBusinessData<List<MDSPlayListInfo>> {

    /**
     * 获取观看记录列表
     * @param token
     */
    public void getPlayList(String token) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
        }catch (Exception e){

        }
        exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_PLAY_LIST,jsonObject.toString());
    }

    protected List<MDSPlayListInfo> parseContentBody(JSONObject jo) {
        JSONArray jsonArray = jo.optJSONArray("data");
        List<MDSPlayListInfo> playListInfos = new ArrayList<>();
        if (jsonArray != null) {
            for (int i = 0;i < jsonArray.length();i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                if (jsonObject != null) {
                    MDSPlayListInfo playListInfo = new MDSPlayListInfo();
                    playListInfo.id = jsonObject.optString("id");
                    playListInfo.name = jsonObject.optString("name");
                    playListInfo.progress = jsonObject.optString("progress");
                    playListInfo.previewUrl = jsonObject.optString("previewUrl");
                    playListInfo.showFlg = jsonObject.optString("showFlg");
                    playListInfos.add(playListInfo);
                }
            }
        }
        return playListInfos;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
