package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSRemoteVideoInfo;

/**
 * Created by gexy on 2019\8\7 0007.
 */

public class MDSGetRemoteVideo extends MDSAbstractBusinessData<List<MDSRemoteVideoInfo>> {

    /**
     * 获取远程视频设备
     *
     * @param token 登录鉴权token
     */
    public void getRemoteVideo(String token) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_REMOTE_VIDEO, jsonObject.toString());
    }

    protected List<MDSRemoteVideoInfo> parseContentBody(JSONObject jo) {
        List<MDSRemoteVideoInfo> remoteVideoInfoList = new ArrayList<>();
        JSONArray jsonArray = jo.optJSONArray("data");
        if (jsonArray != null) {
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                MDSRemoteVideoInfo remoteVideoInfo = new MDSRemoteVideoInfo();
                remoteVideoInfo.account = jsonObject.optString("account");
                remoteVideoInfo.hospital = jsonObject.optString("hospital");
                remoteVideoInfo.department = jsonObject.optString("department");
                remoteVideoInfo.roomName = jsonObject.optString("roomName");
                remoteVideoInfo.id = jsonObject.optString("id");

                remoteVideoInfoList.add(remoteVideoInfo);
            }
        }
        return remoteVideoInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
