package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.MDSSchoolInfo;

/**
 * Created by Administrator on 2019\1\23 0023.
 */

public class MDSGetSchoolList extends MDSAbstractBusinessData<List<MDSSchoolInfo>> {

    public void getSchoolList() {
        JSONObject jsonObject = new JSONObject();
        try {
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_SCHOOL_LIST, jsonObject.toString());
    }

    protected List<MDSSchoolInfo> parseContentBody(JSONObject jo) {
        List<MDSSchoolInfo> schoolInfoList = new ArrayList<>();
        if (jo != null) {
            JSONArray schoolArray = jo.optJSONArray("data");
            if (schoolArray != null) {
                for (int i = 0; i < schoolArray.length(); i++) {
                    JSONObject schoolObj = schoolArray.optJSONObject(i);
                    if (schoolObj != null) {
                        MDSSchoolInfo schoolInfo = new MDSSchoolInfo();
                        schoolInfo.id = schoolObj.optString("id");
                        schoolInfo.name = schoolObj.optString("name");
                        schoolInfo.district = schoolObj.optString("district");

                        schoolInfoList.add(schoolInfo);
                    }
                }
            }

        }
        return schoolInfoList;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }

}
