package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.UploadVideoInfo;

/**
 * Created by gexy on 2019\7\3 0003.
 */

public class MDSGetUploadVideoInfo extends MDSAbstractBusinessData<UploadVideoInfo> {

    /**
     * 查询视频文件是否转码并入库成功
     */
    public void getVideoInfo(String token, String fileID) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            jsonObject.put("fileID", fileID);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_UPLOAD_VIDEO_INFO, jsonObject.toString());
    }

    protected UploadVideoInfo parseContentBody(JSONObject jo) {
        UploadVideoInfo videoInfo = new UploadVideoInfo();
        if (jo != null) {
            JSONObject jsonObject = jo.optJSONObject("data");
            if (jsonObject != null) {
                videoInfo.status = jsonObject.optString("status");
                videoInfo.filesize = jsonObject.optInt("filesize");
                videoInfo.filename = jsonObject.optString("filename");
                videoInfo.createDate = jsonObject.optLong("createDate");
                videoInfo.fileUrl = jsonObject.optString("fileUrl");
            }
        }
        return videoInfo;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }
}
