package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.hpucenter.data.ModuleInfo;
import cn.redcdn.datacenter.hpucenter.data.SubModuleInfo;
import cn.redcdn.datacenter.medicalcenter.data.MDSAccountInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTBaseInfo;

/**
 * Created by caizx on 2018/7/24.
 */

public class MDSGetUserInfo extends MDSAbstractBusinessData<MDSAccountInfo> {

    /**
     * 获取用户配置信息 接口（返回医联体信息 以及 专培相关信息）
     *
     * @param token
     */
    public void getUserInfo(String token) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_USETINFO, jsonObject.toString());
    }

    public void getUserInfo(String token, String versionNo) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            jsonObject.put("versionNo", versionNo);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_USETINFO, jsonObject.toString());
    }

    public void getUserInfo(String token, String versionNo, String clientType) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token", token);
            jsonObject.put("versionNo", versionNo);
            jsonObject.put("clientType", clientType);
        } catch (Exception e) {

        }
        exec(ConstConfig.getMedicalCenterUrl() + ConstConfig.MDS_GET_USETINFO, jsonObject.toString());
    }

    protected MDSAccountInfo parseContentBody(JSONObject jo) {
        MDSAccountInfo info = new MDSAccountInfo();

        if (jo != null) {
            JSONObject userInfo = jo.optJSONObject("data");
            List<DTInfo> mList = new ArrayList<>();
            JSONArray array = userInfo.optJSONArray("dtList");
            if (array != null) {
                if (array.length() > 0) {
                    for (int i = 0; i < array.length(); i++) {
                        JSONObject tmpjson = array.optJSONObject(i);
                        List<ModuleInfo> moduleInfos = new ArrayList<>();
                        DTInfo info1 = new DTInfo();
                        if (tmpjson != null) {
                            info1.name = tmpjson.optString("dtName");
                            info1.id = tmpjson.optString("dtId");
                            info1.logoUrl = tmpjson.optString("logoUrl");
                            info1.mainLogoUrl = tmpjson.optString("mainLogoUrl");
                            info1.logoUrl = tmpjson.optString("logoUrl");
                            info1.qrCodeUrl = tmpjson.optString("qrCodeUrl");
                            info1.infoOffId = tmpjson.optString("infoOffId");
                            info1.intOffId = tmpjson.optString("intrOffId");
                            info1.intrOffName = tmpjson.optString("intrOffName");
                            info1.infoOffName = tmpjson.optString("infoOffName");
                            JSONArray mArray = tmpjson.optJSONArray("module");
                            if (mArray != null) {
                                for (int j = 0; j < mArray.length(); j++) {
                                    JSONObject mjson = mArray.optJSONObject(j);
                                    if (mjson != null) {
                                        ModuleInfo moduleInfo = new ModuleInfo();
                                        moduleInfo.id = mjson.optString("id");
                                        moduleInfo.showName = mjson.optString("showName");
                                        moduleInfo.perInfo = mjson.optString("operInfo");

                                        JSONArray subMoudleArr = mjson.optJSONArray("subModules");
                                        if (subMoudleArr != null) {
                                            for (int sub = 0; sub < subMoudleArr.length(); sub++) {
                                                JSONObject subMoudleObj = subMoudleArr.optJSONObject(sub);
                                                SubModuleInfo subModuleInfo = new SubModuleInfo();
                                                subModuleInfo.id = subMoudleObj.optString("id");
                                                subModuleInfo.showName = subMoudleObj.optString("showName");
                                                subModuleInfo.showIcon = subMoudleObj.optString("showIcon");
                                                subModuleInfo.operInfo = subMoudleObj.optString("operInfo");
                                                subModuleInfo.subType = subMoudleObj.optString("subType");

                                                subModuleInfo.privilegeFlg = subMoudleObj.optInt("privilegeFlg");
                                                subModuleInfo.privilegeTip  = subMoudleObj.optString("privilegeTip");

                                                moduleInfo.subModuleInfoList.add(subModuleInfo);
                                            }
                                        }



                                        moduleInfos.add(moduleInfo);
                                    }
                                }
                            }
                            info1.moduleList = moduleInfos;
                        }
                        mList.add(info1);
                    }
                }
            }
            info.dtList = mList;

            JSONObject sptJson = userInfo.optJSONObject("profestraining");
            if (sptJson != null) {
                info.sptInfos.roleBid = sptJson.optString("roleBid");
                info.sptInfos.roleName = sptJson.optString("roleName");
                info.sptInfos.baseName = sptJson.optString("base");
                info.sptInfos.studentNo = sptJson.optString("num");
                info.sptInfos.trainTime = sptJson.optString("trainDate");
                info.sptInfos.professionBid = sptJson.optString("profession");
                JSONArray baseArr = sptJson.optJSONArray("bases");
                if (baseArr != null) {
                    for (int m = 0; m < baseArr.length(); m++) {
                        JSONObject baseJson = baseArr.optJSONObject(m);
                        SPTBaseInfo baseInfo = new SPTBaseInfo();
                        if (baseJson != null) {
                            baseInfo.baseId = baseJson.optString("id");
                            baseInfo.baseName = baseJson.optString("name");
                            baseInfo.showName = baseJson.optString("showName");
                            baseInfo.associationName = baseJson.optString("associationName");
                            baseInfo.associationId = baseJson.optString("association_id");
                        }
                        info.sptInfos.baseInfos.add(baseInfo);
                    }
                }
            }
        }
        return info;
    }

    protected Parser getParser() {
        return new MedicalParser();
    }


}
