package cn.redcdn.datacenter.medicalcenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.data.NoticeInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSUserGetGrougNotice extends MDSAbstractBusinessData<NoticeInfo>{
	
private String tag = MDSUserGetGrougNotice.class.getName();
	
	/*
	 * 获取群公告
	 * 
	 * @param token 登录用户鉴权
	 * 
	 * @param groupId 群id
	 *
	 */
	
	public int appGetGroupNotice(String token,String groupId){
		
		CustomLog.d(tag, "appGetGroupQrCode token="+token+"groupId = "+groupId);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token", token);
			json.put("groupId", groupId);
			
		} catch (Exception e) {
			// TODO: handle exception
			return -3;
		}
		
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_GROUP_NOTICE, json.toString());
	}
	
    protected NoticeInfo parseContentBody(JSONObject jo){
		     
    	NoticeInfo info = new NoticeInfo();
    	if (jo.optJSONObject("data")!=null){
			
    		JSONObject json;
			try {
				json = jo.getJSONObject("data");
				info.noticeContent = java.net.URLDecoder.decode(json.optString("noticeContent"));
	       		info.createTime = json.optLong("createTime");
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
		}
    	
		return info;
	}
	protected Parser getParser(){
		return new MedicalParser();
	}
	
	

}
