package cn.redcdn.datacenter.medicalcenter.data;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.hpucenter.data.DTInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTInfo;

public class MDSAccountInfo {
    public String uid;             //用户id
    public String headThumUrl;     //头像缩略图
    public String headPreviewUrl;  //头像预览图
    public String nickName;        //昵称
    public String mobile;          //手机号
    public String mail;            //邮箱号
    public String accountType;     //账号类型（1：手机号、2：邮箱号）
    public String nube;            //视讯号
    public String qrCodeUrl;       //二维码url地址
    public String workUnit;        //医院/公司/学校
    public String workUnitType;    //身份类型（详见5.2 ）
    public String department;      //科室/部门/专业
    public String professional;    //职称/职位/学历
    public String creatTime;       //提交审核资料时间
    public String officTel;        //科室电话/入学年份
    public String certificateThum; //认证照片缩略图
    public String certificatePreview;//认证照片预览图
    public int state;    //注册审核状态（详见5.33）(1：待注册审核、2：已通过注册审核、3：已拒绝注册审核)
    public String reason;//注册未通过原因
    public int doctubeState; //认证审核状态（详见5.34） (1：未提交认证资料、2：待认证审核、3：已通过认证审核 4:已拒绝认证审核)
    public String doctubeReason; //认证未通过原因
    public String licenseThumUrl; //执业证认证照片缩略图
    public String licensePreviewUrl; //执业证认证照片预览图
    public String stateDes;//审核状态描述
    public String accessToken;
    public String remarks; //备注

    //红云紫光 新增
    public String model; //型号 专业
    public String remarks2; //备注2
    public String remarks3; //备注3

    public String token; //登录鉴权token
    public String id;   //用户id
    public String name; //参会名称
    public int userType; //用户类型 1.vip 2.试用 3.普通会员
    public String headUrl; //用户头像
    public String createTime; //注册时间
    public String registerTime; //登记时间
    public String expiryDate; //服务期有效时间
    public String serviceTime;
    public long day;
    public String phone; // 客服电话
    public String payIntroUrl; //会员中心地址

    public List<DTInfo> dtList; //医联体列表

    public SPTInfo sptInfos; //专培列表


    public MDSAccountInfo() {
        uid = "";
        headThumUrl = "";
        headPreviewUrl = "";
        nickName = "";
        mobile = "";
        mail = "";
        accountType = "";
        nube = "";
        qrCodeUrl = "";
        workUnit = "";
        workUnitType = "";
        department = "";
        professional = "";
        creatTime = "";
        officTel = "";
        certificateThum = "";
        certificatePreview = "";
        state = 0;
        reason = "";
        stateDes = "";//审核状态描述
        accessToken = "";
        remarks = "";

        model = "";
        remarks2 = "";
        remarks3 = "";

        token = "";
        id = "";
        name = "";
        userType = 0;
        headUrl = ""; //用户头像
        createTime = ""; //注册时间
        registerTime = ""; //登记时间
        expiryDate = ""; //服务期有效时间
        serviceTime = "";
        day = 0;
        phone = "";
        payIntroUrl = "";

        dtList = new ArrayList<>();
        sptInfos = new SPTInfo();

        doctubeState = 0;
        doctubeReason = "";
        licenseThumUrl = "";
        licensePreviewUrl = "";
    }

    public MDSAccountInfo(MDSAccountInfo info) {
        this.uid = info.uid;
        this.headThumUrl = info.headThumUrl;
        this.headPreviewUrl = info.headPreviewUrl;
        this.nickName = info.nickName;
        this.mobile = info.mobile;
        this.mail = info.mail;
        this.accountType = info.accountType;
        this.nube = info.nube;
        this.qrCodeUrl = info.qrCodeUrl;
        this.workUnit = info.workUnit;
        this.workUnitType = info.workUnitType;
        this.department = info.department;
        this.professional = info.professional;
        this.creatTime = info.creatTime;
        this.officTel = info.officTel;
        this.certificateThum = info.certificateThum;
        this.certificatePreview = info.certificatePreview;
        this.state = info.state;
        this.reason = info.reason;
        this.stateDes = info.stateDes;
        this.accessToken = info.accessToken;
        this.remarks = info.remarks;

        this.model = info.model;
        this.remarks2 = info.remarks2;
        this.remarks3 = info.remarks3;

        this.token = info.token;
        this.id = info.id;
        this.name = info.name;
        this.userType = info.userType;
        this.headUrl = info.headUrl; //用户头像
        this.createTime = info.createTime; //注册时间
        this.registerTime = info.registerTime; //登记时间
        this.expiryDate = info.expiryDate; //服务期有效时间
        this.serviceTime = info.serviceTime;
        this.day = info.day;
        this.phone = info.phone;
        this.payIntroUrl = info.payIntroUrl;

        this.dtList = info.dtList;
        this.sptInfos = info.sptInfos;

        this.doctubeState = info.doctubeState;
        this.doctubeReason = info.doctubeReason;
        this.licenseThumUrl = info.licenseThumUrl;
        this.licensePreviewUrl = info.licensePreviewUrl;
    }

    public SPTInfo getSptInfos() {
        return sptInfos;
    }

    public void setSptInfos(SPTInfo sptInfos) {
        this.sptInfos = sptInfos;
    }

    public String getPayIntroUrl() {
        return payIntroUrl;
    }

    public void setPayIntroUrl(String payIntroUrl) {
        this.payIntroUrl = payIntroUrl;
    }

    public long getDay() {
        return day;
    }

    public void setDay(long day) {
        this.day = day;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getUserType() {
        return userType;
    }

    public void setUserType(int userType) {
        this.userType = userType;
    }

    public String getHeadUrl() {
        return headUrl;
    }

    public void setHeadUrl(String headUrl) {
        this.headUrl = headUrl;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getRegisterTime() {
        return registerTime;
    }

    public void setRegisterTime(String registerTime) {
        this.registerTime = registerTime;
    }

    public String getExpiryDate() {
        return expiryDate;
    }

    public void setExpiryDate(String expiryDate) {
        this.expiryDate = expiryDate;
    }

    public String getServiceTime() {
        return serviceTime;
    }

    public void setServiceTime(String serviceTime) {
        this.serviceTime = serviceTime;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getRemarks2() {
        return remarks2;
    }

    public void setRemarks2(String remarks2) {
        this.remarks2 = remarks2;
    }

    public String getRemarks3() {
        return remarks3;
    }

    public void setRemarks3(String remarks3) {
        this.remarks3 = remarks3;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getUid() {
        return uid;
    }

    public void setUid(String uid) {
        this.uid = uid;
    }

    public String getHeadThumUrl() {
        return headThumUrl;
    }

    public void setHeadThumUrl(String headThumUrl) {
        this.headThumUrl = headThumUrl;
    }

    public String getHeadPreviewUrl() {
        return headPreviewUrl;
    }

    public void setHeadPreviewUrl(String headPreviewUrl) {
        this.headPreviewUrl = headPreviewUrl;
    }

    public String getNickName() {
        return nickName;
    }

    public void setNickName(String nickName) {
        this.nickName = nickName;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getMail() {
        return mail;
    }

    public void setMail(String mail) {
        this.mail = mail;
    }

    public String getAccountType() {
        return accountType;
    }

    public void setAccountType(String accountType) {
        this.accountType = accountType;
    }

    public String getNube() {
        return nube;
    }

    public void setNube(String nube) {
        this.nube = nube;
    }

    public String getQrCodeUrl() {
        return qrCodeUrl;
    }

    public void setQrCodeUrl(String qrCodeUrl) {
        this.qrCodeUrl = qrCodeUrl;
    }

    public String getWorkUnit() {
        return workUnit;
    }

    public void setWorkUnit(String workUnit) {
        this.workUnit = workUnit;
    }

    public String getWorkUnitType() {
        return workUnitType;
    }

    public void setWorkUnitType(String workUnitType) {
        this.workUnitType = workUnitType;
    }

    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    public String getProfessional() {
        return professional;
    }

    public void setProfessional(String professional) {
        this.professional = professional;
    }

    public String getCreatTime() {
        return creatTime;
    }

    public void setCreatTime(String creatTime) {
        this.creatTime = creatTime;
    }

    public String getOfficTel() {
        return officTel;
    }

    public void setOfficTel(String officTel) {
        this.officTel = officTel;
    }

    public String getCertificateThum() {
        return certificateThum;
    }

    public void setCertificateThum(String certificateThum) {
        this.certificateThum = certificateThum;
    }

    public String getCertificatePreview() {
        return certificatePreview;
    }

    public void setCertificatePreview(String certificatePreview) {
        this.certificatePreview = certificatePreview;
    }

    public int getState() {
        return state;
    }

    public void setState(int state) {
        this.state = state;
    }

    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public String getStateDes() {
        return stateDes;
    }

    public void setStateDes(String stateDes) {
        this.stateDes = stateDes;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public List<DTInfo> getDtList() {
        return dtList;
    }

    public void setDtList(List<DTInfo> dtList) {
        this.dtList = dtList;
    }

    public int getDoctubeState() {
        return doctubeState;
    }

    public void setDoctubeState(int doctubeState) {
        this.doctubeState = doctubeState;
    }

    public String getDoctubeReason() {
        return doctubeReason;
    }

    public void setDoctubeReason(String doctubeReason) {
        this.doctubeReason = doctubeReason;
    }

    public String getLicenseThumUrl() {
        return licenseThumUrl;
    }

    public void setLicenseThumUrl(String licenseThumUrl) {
        this.licenseThumUrl = licenseThumUrl;
    }

    public String getLicensePreviewUrl() {
        return licensePreviewUrl;
    }

    public void setLicensePreviewUrl(String licensePreviewUrl) {
        this.licensePreviewUrl = licensePreviewUrl;
    }
}
