package cn.redcdn.datacenter.meetingmanage;

import cn.redcdn.datacenter.AbstractBusinessDataSub;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.meetingmanage.data.ResponseEmpty;
import cn.redcdn.log.CustomLog;

public abstract class ClientReportInfo extends
AbstractBusinessDataSub<ResponseEmpty> {
  private String tag = ClientReportInfo.class.getName();
/**
 * 
 * @param jsonString
 * @return
 *  -1: 表示无效的操作，当前操作正在执行
 *  -2: 表示无效的编码
 *  -3: 表示json操作异常
 *  -4: 接口服务器地址不合法
 */
  public int submitInfo(String jsonString) {
    CustomLog.d(tag, "ClientReportInfo:" + jsonString);
    
    if( ConstConfig.getBindOnAccountUrl() == null ||ConstConfig.getBindOnAccountUrl().equals("")){
      CustomLog.e(tag, "请求服务器地址为空");
      return -4;
    }
    
    try {
  	  //转义特殊字符   % --> %25
    	String JsonString = java.net.URLEncoder.encode(jsonString);
      return exec(ConstConfig.getBindOnAccountUrl(),
          ConstConfig.PARAM_CLIENTREPORT + JsonString);
    } catch (Exception e) {
      CustomLog.e(tag, e.getMessage());
    }
    return -3;
  }

  protected Parser getParser() {
    return new MeetingManageParser();
  }



}
