package cn.redcdn.datacenter.meetingmanage;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.AbstractBusinessDataSub;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.meetingmanage.data.ResponseEmpty;
import cn.redcdn.log.CustomLog;

public abstract class FeedBack extends AbstractBusinessDataSub<ResponseEmpty> {
  private String tag = FeedBack.class.getName();

  /**
   * 文字信息反馈接口。将反馈的文字信息保存到数据库中。 仅返回返回码。
   * 
   * @param feedbackText
   *          文字信息反馈
   * 
   * @return 
   *  -1: 表示无效的操作，当前操作正在执行
   *  -2: 表示无效的编码
   *  -3: 表示json操作异常
   *  -4: 接口服务器地址不合法
   */
  public int StoreFeedbackText(String feedbackText) {
    CustomLog.i(tag, "StoreFeedbackText, feedbackText:" + feedbackText);
    
    if(ConstConfig.getSuggestionUrl() == null ||ConstConfig.getSuggestionUrl().equals("")){
      CustomLog.e(tag, "请求服务器地址为空");
      return -4;
    }
    JSONObject json = new JSONObject();
    try {
      json.put("feedbackText", feedbackText);
    } catch (JSONException e) {
      return -3;
    }
	  //转义特殊字符   % --> %25
	String jsonString = java.net.URLEncoder.encode(json.toString());
    return exec(ConstConfig.getSuggestionUrl(),
        ConstConfig.PARAM_MEETINGMANAGE_STOREFEEDBACKTEXT + jsonString);
  }

  protected Parser getParser() {
    return new MeetingManageParser();
  }


}
