package cn.redcdn.datacenter.meetingmanage;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public abstract class GetMeetings extends AbstractBusinessData<Map<String, Object>>{
  private String TAG = GetMeetings.class.getName();
/**
 * 
 * @param token
 * @param userContact
 * @return
   *  -1: 表示无效的操作，当前操作正在执行
   *  -2: 表示无效的编码
   *  -3: 表示json操作异常
   *  -4: 接口服务器地址不合法
   *  -5: 输入参数不合法
 */
  public int getMeetings(String token,String userContact) {
    CustomLog.d(TAG, "call getMeetings .token = " + token + " userContact = "+ userContact);
    if(token.equals("")|| token == null){
      CustomLog.e(TAG, "token不合法");
      return -5;
    }
    if(ConstConfig.getGetMeetingsUrl() == null||ConstConfig.getGetMeetingsUrl().equals("")){
      CustomLog.e(TAG, "请求服务器地址为空");
      return -4;
    }
    try {
      JSONObject json = new JSONObject();
      json.put(ConstConfig.PARAM_TOKEN, token);
      json.put(ConstConfig.PARAM_USERCONTACT, userContact);
      CustomLog.d(TAG, "getMeetings success");
	  //转义特殊字符   % --> %25
	String jsonString = java.net.URLEncoder.encode(json.toString());
      return exec(ConstConfig.getGetMeetingsUrl(), ConstConfig.PARAM_GETMEETINGS+jsonString);
    } catch (Exception e) {
      CustomLog.e(TAG, e.getMessage());
    }
    return -3;
  }
  
  protected Map<String, Object>  parseContentBody(JSONObject bodyObject)
      throws InvalidateResponseException {
    Iterator<String> keys = bodyObject.keys();
    Map<String, Object> map = null;
    if (keys != null && keys.hasNext()) {
      map = new HashMap<String, Object>();
      String key = null;
      try {
        do {
          key = keys.next();
          map.put(key, bodyObject.get(key));
          CustomLog.e("key",key);
          CustomLog.e("bodyObject",bodyObject.get(key).toString());
        } while (keys.hasNext());
      } catch (JSONException e) {
        CustomLog.e(TAG, e.getMessage());
      }
    }
    CustomLog.e(TAG, "map: "+ map);
    return map;
    
    
  }
  protected Parser getParser() {
    return new MeetingManageParser();
  }

}
