package cn.redcdn.datacenter.meetingmanage;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public abstract class GetTimeNow extends AbstractBusinessData<String>{
  private static final String TAG = GetTimeNow.class.getName();
  
  /**
   * 
   * @return
   *  -1: 表示无效的操作，当前操作正在执行
   *  -2: 表示无效的编码
   *  -3: 表示json操作异常
   *  -4: 接口服务器地址不合法 
   */
  public int getTime() {
    CustomLog.d(TAG, "Call GetTimeNow ");
    if(ConstConfig.getGetTimeNowUrl() == null||ConstConfig.getGetTimeNowUrl().equals("") ){
      CustomLog.e(TAG, "请求服务器地址为空");
      return -4;
    }
    try {
      JSONObject json = new JSONObject();
	  //转义特殊字符   % --> %25
	String jsonString = java.net.URLEncoder.encode(json.toString());
      return exec(ConstConfig.getGetTimeNowUrl(), ConstConfig.PARAM_GETTIMENOW + jsonString);
    } catch (Exception e) {
      CustomLog.e(TAG, e.getMessage());
      return -3;
    }
  
  }
  

  protected String parseContentBody(JSONObject jo)
      throws InvalidateResponseException {
    
    try {
      if (jo == null) {
        CustomLog.e(TAG, "GetTimeNow JSONObject == null");
        throw new InvalidateResponseException();
      }
      return jo.getString("datetime");
    } catch (JSONException e) {
      CustomLog.e(TAG, "GetTimeNow JSONException");
      throw new InvalidateResponseException();
    }
  }
  protected Parser getParser() {
    return new MeetingManageParser();
  }
  
}
