package cn.redcdn.datacenter.meetingmanage;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessDataSub;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public abstract class GetZBForwardURL extends AbstractBusinessDataSub<String> {
  private String tag = GetZBForwardURL.class.getName();
  
  /**
   * 获取直播跳转地址
   * @param urlFlg
   * @return   
   *  -3: 表示json操作异常
   *  -4: 会议接口服务器地址不合法
   */
  public int  getZBForwardUrl(String urlFlg){
    
    if(ConstConfig.getCreateMeetingUrl() == null ||ConstConfig.getCreateMeetingUrl().equals("")){
      CustomLog.e(tag, "请求服务器地址为空");
      return -4;
    }
    
    JSONObject json = new JSONObject();
    try {
      json.put(ConstConfig.URLFLAG,urlFlg);
	  //转义特殊字符   % --> %25
	String jsonString = java.net.URLEncoder.encode(json.toString());
      return exec(ConstConfig.getCreateMeetingUrl(),
          ConstConfig.PARAM_GETFORWARDURL + jsonString);
    } catch (JSONException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
      return -3;
    }
    
  }
  
  
  protected String parseContentBody(JSONObject jo)
      throws InvalidateResponseException{
    if (jo == null) {
      CustomLog.e(tag, "GetZBForwardURL JSONObject == null");
      throw new InvalidateResponseException();
    }
    String  forwardURL = jo.optString("forwardURL");
    return forwardURL;
  }
  
  
  protected Parser getParser() {
    return new MeetingManageParser();
  }
  
}
