package cn.redcdn.datacenter.meetingmanage;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.AbstractBusinessDataSub;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;

public class SendSMS extends AbstractBusinessDataSub<ResponseEmpty>{
  private String tag = SendSMS.class.getName();
  
  /**
   * 发送短信
   * @param token
   *            token 
   * @param phoneNumber
   *            手机号
   * @param message
   *            邀请内容
   * @return
   *  -1: 表示无效的操作，当前操作正在执行
   *  -2: 表示无效的编码
   *  -3: 表示json操作异常
   *  -4: 接口服务器地址不合法
   *  -5: 输入参数不合法  
   */

  public int sendSMS(String token ,String phoneNumber, String msg){
    CustomLog.i(tag,"Call sendSMS,phoneNumber="+phoneNumber+ " msg ="+msg);
    
    if((token == null || token.equals("")) || (phoneNumber == null || phoneNumber.equals("")) || (msg == null || msg.equals(""))){
      CustomLog.e(tag,"sendSMS ,参数不合法");
      return -5;
    }
    if(ConstConfig.getCreateMeetingUrl() == null||ConstConfig.getCreateMeetingUrl().equals("")){
      CustomLog.e(tag, "请求服务器地址为空");
      return -4;
    }
    JSONObject json = new JSONObject();
    try {
      json.put(ConstConfig.PARAM_TOKEN, token);
      json.put(ConstConfig.PARAM_PHONENUMBER,phoneNumber);
      json.put(ConstConfig.PARAM_MESSAGE, msg);
	  //转义特殊字符   % --> %25
	String jsonString = java.net.URLEncoder.encode(json.toString());
      return exec(ConstConfig.getCreateMeetingUrl(),
          ConstConfig.PARAM_SENDSMS + jsonString);
    } catch (JSONException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
      return -2;
    }
    
  }
  
  protected Parser getParser() {
    return new MeetingManageParser();
  }
  
}
