package cn.redcdn.datacenter.meetingmanage.data;

/**
 * expectStarttime 周林后台将预约开始时间统一设置成0时，不方便客户端处理，故增加字段yyBeginTime
 * yyBeginTime 预约开始时间与1970-1-1相差的秒数（UTC时区）
 */
public class MeetingInfomation {

  /**
   * meetingId（类型：int | 说明：会议号）
   */
  public int meetingId;
  
  /**
   * enterpriseId（类型：String | 说明：企业Id）
   */
  public String enterpriseId;
  
  /**
   * terminalAccount（类型：String | 说明：会议创建者的终端账号）
   */
  public String terminalAccount;
  
  /**
   * terminalAccountName（类型：String | 说明：会议创建者的终端账号昵称）
   */
  public String terminalAccountName;
  
  /**
   * expectStarttime（类型：String | 说明：会议预计开始时间）
   */
  public String expectStarttime;
  
  /**
   * expectEndtime（类型：String | 说明：会议预计结束时间）
   */
  public String expectEndtime;
  
  /**
   * realStarttime（类型：String | 说明：会议实际开始时间）
   */
  public String realStarttime;
  
  /**
   * realEndtime（类型：String | 说明：会议实际开始时间）
   */
  public String realEndtime;
  
  /**
   * numberOfsquares（类型：int | 说明：会议所属企业的方数）
   */
  public int numberOfsquares;
  
  /**
   * meetingName（类型：String | 说明：会议名称）
   */
  public String meetingName;
  
  /**
   * meetingStatus（类型：int | 说明：会议状态，"1：未开始  2：进行中   3：结束"）
   */
  public int meetingStatus;
  
  /**
   * meetingType（类型：int | 说明：会议类型，"1：即时会议   2：预约会议"）
   */
  public int meetingType;
  
  /**
   * topic（类型：String | 说明：主题）
   */
  public String topic;
  
  /**
   * yyBeginTime（类型：String | 说明：预约开始时间与1970-1-1相差的秒数 ，UTC时区）
   */
  public String yyBeginTime;
  
  /**
   * hasMeetingPwd（类型：int | 说明：是否有会议密码，"0：无   1：有"）
   */
  public int hasMeetingPwd;
  
  /**
   * meetingHost（类型：String | 说明：会议主持人，当前即会议创建者）
   */
  public String meetingHost;
  
  public MeetingInfomation(){
    meetingId = 0;
    enterpriseId = "";
    terminalAccount = "";
    terminalAccountName = "";
    expectStarttime = "";
    expectEndtime = "";
    realStarttime = "";
    realEndtime = "";
    numberOfsquares = 0;
    meetingName = "";
    meetingStatus = 0;
    meetingType = 0;
    topic = "";
    yyBeginTime = "";
    hasMeetingPwd = 1;
    meetingHost = "";
    		
  }
  
  public MeetingInfomation(MeetingInfomation info) {
    if (info == null) {
      return;
    }
    this.meetingId = info.meetingId;
    this.enterpriseId = info.enterpriseId;
    this.terminalAccount = info.terminalAccount;
    this.terminalAccountName = info.terminalAccountName;
    this.expectStarttime = info.expectStarttime;
    this.expectEndtime = info.expectEndtime;
    this.realStarttime = info.realStarttime;
    this.realEndtime = info.realEndtime;
    this.numberOfsquares = info.numberOfsquares;
    this.meetingName = info.meetingName;
    this.meetingStatus = info.meetingStatus;
    this.meetingType = info.meetingType;
    this.topic = info.topic;
    this.yyBeginTime = info.yyBeginTime;
    this.hasMeetingPwd = info.hasMeetingPwd;
    this.meetingHost = info.meetingHost;
  } 
  
}
