package cn.redcdn.datacenter.offaccscenter;



import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.text.TextUtils;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.offaccscenter.data.OffAccContentDetailInfo;

import cn.redcdn.datacenter.offaccscenter.data.VideoInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetArticleInfo extends MDSAbstractBusinessData<VideoInfo> {
	private String tag = MDSAppGetArticleInfo.class.getName();
	
	/**  获取内容详细信息
	 * 
	 * @param token 登录鉴权token
	 *
	 * 
	 * @return 
	 * 
	 */
	public int appGetArticleInfo(String token,String id,String versionNo)
	{
		CustomLog.d(tag, "appGetArticleInfo token ="+token+"id = "+id);
				
				JSONObject json = new JSONObject();
				 
				try {
				     json.put("token", token);
				     json.put("articleId", id);
				     json.put("versionNo", versionNo);
				} catch (JSONException e) {
					// TODO: handle exception
					return -3;
				}
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_ART_INFO, json.toString());
		
		
	}
	
	protected VideoInfo parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		if (jo == null) {
			CustomLog.e(tag, "appGetArticleInfo jo == null");
			throw new InvalidateResponseException();
		}
		VideoInfo info = new VideoInfo();
		JSONObject json = jo.optJSONObject("data");
		if (json != null) {
			info.contentType = json.optInt("contentType");
			info.channelId = json.optString("contentId");
			info.name = json.optString("name");
			info.accessType = json.optInt("accessType");
			info.accessPassword = json.optString("accessPassword");
			info.webViewUrl = json.optString("webViewUrl");
			info.pcViewUrl = json.optString("pcViewUrl");
			info.enrollFlag = json.optInt("enrollFlag");
			info.activityUrl = json.optString("activityUrl");
			info.signUpType = json.optString("signUpType");
			info.activityPic = json.optString("activityPicUrl");
			info.privilegeFlg = json.optString("privilegeFlg");
			info.privilegeTip = json.optString("privilegeTip");
			info.refuseFlg = json.optString("refuseFlg");
		}
		return  info;
	}
		    protected Parser getParser(){return new MedicalParser();}
	
}
