package cn.redcdn.datacenter.offaccscenter;



import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.offaccscenter.data.MDSFocusPageInfo;
import cn.redcdn.datacenter.offaccscenter.data.MDSfocusOffAccArtcleInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetArticlesByOffAcc extends MDSAbstractBusinessData<MDSFocusPageInfo>{

	private String tag = MDSAppGetFocusOffAccArticles.class.getName();
	/**
	 * 获取某公众号内容列表
	 * @param token 登录鉴权token
	 * 
	 * @param id 公众号id
	 * 
	 * @param pageNo 当前请求页码
	 * 
	 * @param pageSize 每页请求的数据量
	 * 
	 * @return MDSFocusPageInfo
	 * 
	 */
	public int appGetArticlesByOffAcc(String token,String id,int pageNo,int pageSize)
	{
		
		CustomLog.d(tag, "AppGetArticlesByOffAcc token ="+token+"pageNo ="+pageNo+"pageSize ="+
		pageSize);
		
		JSONObject json = new JSONObject();
		 
		try {
		     json.put("token", token);
		     json.put("officialAccountId", id);
		     json.put("pageNo", pageNo);
		     json.put("pageSize", pageSize);
		} catch (JSONException e) {
			// TODO: handle exception
			return -3;
		}
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_ART_OFFACC, json.toString());
		
	}
	protected MDSFocusPageInfo parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "AppGetArticlesByOffAcc jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			MDSFocusPageInfo info = new MDSFocusPageInfo();
			info.dataJson = jo;
			JSONObject json = jo.optJSONObject("data");
			if (json != null) {
				JSONArray arr = json.optJSONArray("articles");
				MDSfocusOffAccArtcleInfo tmpinfo = null;
				if (arr != null) {
					info.totalSize = json.optInt("totalSize");
					for (int i = 0; i < arr.length(); i++) {
						JSONObject tmp = arr.getJSONObject(i);
						tmpinfo = new MDSfocusOffAccArtcleInfo();
						tmpinfo.offaccId = tmp.optString("id");
						tmpinfo.offaccLoginUrl = tmp.optString("logoUrl");
						tmpinfo.offaccName = tmp.optString("officialAccountName");
						tmpinfo.articleId = tmp.optString("articleId");
						tmpinfo.articleTitle = tmp.optString("name");
						tmpinfo.showImgUrl = tmp.optString("previewUrl");
						tmpinfo.commentNumber = tmp.optInt("commentNumber");
						tmpinfo.instroduction = java.net.URLDecoder.decode(tmp.optString("description"));
						tmpinfo.praiseNumber = tmp.optInt("praiseNumber");
						tmpinfo.publishTime = tmp.optString("publishTime");
						tmpinfo.isEncipher = tmp.optInt("accessType");
						tmpinfo.encipherPwd = tmp.optString("accessPassword");
						tmpinfo.playCount = tmp.optInt("playCount");
						tmpinfo.articleType = tmp.optInt("articleType");
						info.focusList.add(tmpinfo);
					}
				}
			}
			
			
			return  info;
		} catch (JSONException e) {
			CustomLog.e(tag, " AppGetArticlesByOffAcc invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
		    protected Parser getParser(){return new MedicalParser();}
	
	
	
}
