package cn.redcdn.datacenter.offaccscenter;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.offaccscenter.data.ArticleDetailInfo;
import cn.redcdn.datacenter.offaccscenter.data.ArticleDetailInfoCts;
import cn.redcdn.datacenter.offaccscenter.data.ArticleDetailInfoSds;
import cn.redcdn.datacenter.offaccscenter.data.ArticleDetailInfoVideos;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetDetailArticleInfo extends MDSAbstractBusinessData<ArticleDetailInfo>{

	private String tag = MDSAppGetDetailArticleInfo.class.getName();
	
	public int getDetailArticleInfo(String id,String token){
		
		CustomLog.d(tag, "MDSAppGetDetailArticleInfo token="+token+"id="+id);
		
		JSONObject json = new JSONObject();
		try {
			json.put("token",token);
			json.put("id",id);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_DETAIL_ARTICLE,json.toString());	
	}
	
	protected ArticleDetailInfo parseContentBody(JSONObject jo){
		
		
		ArticleDetailInfo info = new ArticleDetailInfo();
		ArticleDetailInfoSds  sdsinfo = null;
		ArticleDetailInfoCts ctsinfo = null;
		ArticleDetailInfoVideos videoinfo = null;
		try {
			info.name = jo.optString("name");
			info.introduction = jo.optString("introduction");
			info.label = jo.optString("label");
			info.previewUrl = jo.optString("previewUrl");
			info.accessPassword = jo.optString("accessPassword");
			info.commentType = jo.optString("commentType");
			info.description = jo.optString("description");
			info.creator = jo.optString("creator");
			JSONArray sdsarr = jo.optJSONArray("schedules");
			JSONArray ctsarr = jo.optJSONArray("customizedContents");
			JSONArray videos = jo.optJSONArray("videos");
			if (sdsarr != null) {
				for (int i = 0; i < sdsarr.length(); i++) {
					JSONObject scsjson = sdsarr.getJSONObject(i);
					 sdsinfo = new ArticleDetailInfoSds();
					 sdsinfo.showType = scsjson.optString("showType");
					 sdsinfo.schedueDate = scsjson.optString("schedueDate");
					 sdsinfo.content = scsjson.optString("content");
					 info.schedules.add(sdsinfo);
				}
			}
			if (ctsarr != null) {
				for (int j = 0; j < ctsarr.length(); j++) {
					JSONObject ctsjson = ctsarr.getJSONObject(j);
					ctsinfo = new ArticleDetailInfoCts();
					ctsinfo.title = ctsjson.optString("title");
					ctsinfo.content = ctsjson.optString("content");
					info.customizedContents.add(ctsinfo);
				}
			}
			
			if (videos != null) {
				for (int k = 0; k < videos.length(); k++) {
					
					JSONObject videojson = videos.getJSONObject(k);
					videoinfo = new ArticleDetailInfoVideos();
					videoinfo.fileName = videojson.optString("fileName");
					videoinfo.updated = videojson.optString("updated");
					videoinfo.creator = videojson.optString("creator");
					videoinfo.cotentType = videojson.optString("cotentType");
					videoinfo.sort = videojson.optString("sort");
					videoinfo.introduction = videojson.optString("introduction");
					info.videos.add(videoinfo);
				}
			}
			
			
 		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return info;
	}
	
	 protected Parser getParser(){return new OffAccParser();}
		
}
