package cn.redcdn.datacenter.offaccscenter;


import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;

import cn.redcdn.datacenter.offaccscenter.data.OffAccdetailInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetOffAccInfo extends MDSAbstractBusinessData<OffAccdetailInfo>{

	private String tag = MDSAppGetOffAccInfo.class.getName();
	
	/*  获取某公众号详细信息
	 * 
	 * @param token 登录鉴权token
	 * 
	 * @param id    公众号id
	 * 
	 * @return 
	 * 
	 */
	
	public int appGetOffAccInfo(String token,String offaccid)
			{
			
				CustomLog.d(tag, "MDSAppGetOffAccInfo token="+token+"offaccid = "+offaccid);
				
				JSONObject json = new JSONObject();
				try {
					json.put("token", token);
					json.put("officialAccountId", offaccid);
					
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_OFFACC_DETAIL,json.toString());
			}
	protected OffAccdetailInfo parseContentBody(JSONObject jo)
			throws InvalidateResponseException{
				try {
					if (jo == null) {
						CustomLog.e(tag, "MDSAppGetOffAccInfo invalidate reponse");
						throw new InvalidateResponseException();
					}

					JSONObject json = jo.getJSONObject("data");
					OffAccdetailInfo info = new OffAccdetailInfo();
					if (json != null) {
						info.id = json.optString("id");
						info.name = json.optString("name");
						info.logoUrl = json.optString("logoUrl");
						info.functionIntroduction = java.net.URLDecoder.decode(json.optString("introduction"));
						info.serviceTel= json.optString("customerPhone");
				        info.businessScope = java.net.URLDecoder.decode(json.optString("scope"));
						info.enterpriseIntroduction = java.net.URLDecoder.decode(json.optString("entIntroduction"));
						info.themeBackgroundUrl= json.optString("themeBackgroundUrl");
						info.introduction = java.net.URLDecoder.decode(json.optString("homeIntroduction"));
						info.subscribeNumber= json.optString("subscribeNumber");
						info.isSubscribe = json.optInt("isSubscribe");
						info.entName = json.optString("entName");
						info.articleIntro = java.net.URLDecoder.decode(json.optString("articleIntro"));
						info.articlePreviewUrl = json.optString("articlePreviewUrl");
						info.qrcodeUrl = json.optString("qrCodeUrl");
					}
					return info;
				} catch (JSONException e) {
					CustomLog.e(tag, "MDSAppGetOffAccInfo invalidate reponse");
					throw new InvalidateResponseException();
				}
			}
			
			protected Parser getParser(){
				return new MedicalParser();
			}
	
	
	
}
