package cn.redcdn.datacenter.offaccscenter;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.util.Base64;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.offaccscenter.data.MDSRecommedOffaccInfo;
import cn.redcdn.datacenter.offaccscenter.data.ArtcleInfo;
import cn.redcdn.datacenter.offaccscenter.data.RecommedPageInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetRecommendOffAccs extends MDSAbstractBusinessData<RecommedPageInfo> {
  
	private String tag = MDSAppGetRecommendOffAccs.class.getName();
	/*
	 * 获取推荐公众号列表接口  
	 * @param token 登录鉴权token
	 * 
	 * @param pageNo 当前请求页码
	 * 
	 * @param pageSize 每页请求的数据量
	 * 
	 * @return 推荐公众号列表
	 * 
	 */
	public int appGetRecommedOffAccs(String token,int pageNo,int pageSize)
	{
		
		CustomLog.d(tag, "appGetRecommedOffAccs token ="+token+"pageNo ="+pageNo+"pageSize ="+
		pageSize);
		
		JSONObject json = new JSONObject();
		 
		try {
		     json.put("token", token);
		     json.put("pageNo", pageNo);
		     json.put("pageSize", pageSize);
		} catch (JSONException e) {
			// TODO: handle exception
			return -3;
		}
		return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_RE_OFFACC, json.toString());
		
	}
	protected RecommedPageInfo parseContentBody(JSONObject jo) 
			throws InvalidateResponseException{
		try {
			if (jo == null) {
				CustomLog.e(tag, "appGetRecommedOffAccs jo == null");
				throw new InvalidateResponseException();
			}
			CustomLog.d(tag, jo.toString());
			RecommedPageInfo recomInfo = new RecommedPageInfo();
			JSONObject json = jo.optJSONObject("data");
			if (json!=null) {
				JSONArray arr = json.optJSONArray("officialAccounts");
				MDSRecommedOffaccInfo info = null;
				ArtcleInfo info_b = null;
				if (arr != null) {
					recomInfo.totalSize = json.optInt("totalSize");
					for (int i = 0; i < arr.length(); i++) {
						JSONObject tmpJson = arr.getJSONObject(i);
						info = new MDSRecommedOffaccInfo();
						info.offaccid = tmpJson.optString("offAccId");
						info.logoUrl = tmpJson.optString("logoUrl");
						info.name = tmpJson.optString("name");
//						info.introduction = tmpJson.optString("introduction");
						info.introduction = java.net.URLDecoder.decode(tmpJson.optString("introduction"));
						info.subscribe = tmpJson.optInt("subscribe");
						JSONArray arr_b = tmpJson.optJSONArray("articles");
						 if (arr_b != null) {
							 for (int j = 0; j <arr_b.length(); j++) {
									JSONObject tmpjson_b = arr_b.optJSONObject(j);
									info_b = new ArtcleInfo();
									info_b.articleId = tmpjson_b.optString("articleId");
									info_b.title = tmpjson_b.optString("name");
									info_b.publishTime = tmpjson_b.optString("published");
									info_b.playCount = tmpjson_b.optInt("playCount");
									info_b.isEncipher = tmpjson_b.optInt("accessType");
									info_b.encipherPwd = tmpjson_b.optString("accessPassword");
									info_b.articleType = tmpjson_b.optInt("articleType");
									info_b.previewUrl = tmpjson_b.optString("previewUrl");
									info.artcleList.add(info_b);
								}
						}	
						recomInfo.recommedList.add(info);
					} 
				}
			}
			return  recomInfo;
		} catch (JSONException e) {
			CustomLog.e(tag, " appGetRecommedOffAccs invalidate reponse");
			throw new InvalidateResponseException();
		}
	}
		    protected Parser getParser(){return new MedicalParser();}
	
}
