package cn.redcdn.datacenter.offaccscenter;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import net.sourceforge.pinyin4j.PinyinHelper;
import net.sourceforge.pinyin4j.format.HanyuPinyinCaseType;
import net.sourceforge.pinyin4j.format.HanyuPinyinOutputFormat;
import net.sourceforge.pinyin4j.format.HanyuPinyinToneType;
import net.sourceforge.pinyin4j.format.HanyuPinyinVCharType;
import net.sourceforge.pinyin4j.format.exception.BadHanyuPinyinOutputFormatCombination;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.R.array;
import android.R.integer;



import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.collectcenter.CollectionInfo;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.offaccscenter.data.OffAccdetailInfo;
import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetSubscribeOffAccs extends MDSAbstractBusinessData<List<OffAccdetailInfo>> {

private String tag = MDSAppGetSubscribeOffAccs.class.getName();
/*
 * 获取已关注公众号列表
 * @param token 登录鉴权token
 * 
 * @return 已关注公众号列表
 * 
 */	

	public int appGetSubscribeOffAccs(String token)
			{
			
				CustomLog.d(tag, "appGetSubscribeOffAccs token="+token);
				
				JSONObject json = new JSONObject();
				try {
					json.put("token", token);
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_SUB_OFFACC,json.toString());
			}
	protected List<OffAccdetailInfo> parseContentBody(JSONObject jo)
			throws InvalidateResponseException{
		       List<OffAccdetailInfo> offList = new ArrayList<OffAccdetailInfo>();
				try {
					if (jo == null) {
						CustomLog.e(tag, "appGetSubscribeOffAccs jo = null");
						throw new InvalidateResponseException();
					}
//                    List<OffAccdetailInfo> offList = new ArrayList<OffAccdetailInfo>();
					JSONArray json = jo.optJSONArray("data");
					OffAccdetailInfo info = null;
					if (json != null) {
						for (int i = 0; i < json.length(); i++) {
							JSONObject tmpjson = json.getJSONObject(i);
							info = new OffAccdetailInfo();
							info.id = tmpjson.optString("id");
							info.name = tmpjson.optString("name");
							info.logoUrl = tmpjson.optString("logoUrl");
							info.functionIntroduction = java.net.URLDecoder.decode(tmpjson.optString("introduction"));
							info.serviceTel= tmpjson.optString("customerPhone");
							info.businessScope = java.net.URLDecoder.decode(tmpjson.optString("scope"));
							info.enterpriseIntroduction = java.net.URLDecoder.decode(tmpjson.optString("entIntroduction"));
							info.themeBackgroundUrl= tmpjson.optString("themeBackgroundUrl");
							info.introduction = java.net.URLDecoder.decode(tmpjson.optString("homeIntroduction"));
							info.subscribeNumber= tmpjson.optString("subscribeNumber");	
							info.entName = tmpjson.optString("entName");
							info.articleIntro = java.net.URLDecoder.decode(tmpjson.optString("articleIntro"));
							info.articlePreviewUrl = tmpjson.optString("articlePreviewUrl");
							info.nameInitial = getPingYin(info.name);
							info.nameSpell = info.nameInitial.substring(0, 1).toUpperCase();
							offList.add(info);
						}
					}
					
					
				} catch (JSONException e) {
					CustomLog.e(tag, "appGetSubscribeOffAccs invalidate reponse");
					throw new InvalidateResponseException();
				}
				
				if (!ConstConfig.APP_TYPE.equals("jhy")) {
					Collections.sort(offList, new Comparator<OffAccdetailInfo>() {

						@Override
						public int compare(OffAccdetailInfo arg0,
								OffAccdetailInfo arg1) {
							char c1 =  arg0.nameInitial.charAt(0);  
				            char c2 = arg1.nameInitial.charAt(0);  
						    int a = getAscii(c1);
							int b = getAscii(c2);
							
							if(a > b){
								return 1;
							}else
	                        if(a == b){
	                        	int length = 0;
	                        	if (arg0.nameInitial.length()>=arg1.nameInitial.length()) {
									length = arg1.nameInitial.length();
								}else {
									length = arg0.nameInitial.length();
								}
	                        	for (int i = 0; i < length; i++) {
	                        		char c3 =  arg0.nameInitial.charAt(i);  
	        			            char c4 = arg1.nameInitial.charAt(i);  
	        			
	        					    int c = getAscii(c3);
	        						int d = getAscii(c4);
	        						
	        						if (c==d) {
										continue;
									}else if(c>d){
										return 1;
									}else {
										return -1;
									}
								}
								return 0;
								
							}else 
								
							return -1;		
						}	 
					});
				}
				
				return offList;
			}
			
			protected Parser getParser(){
				return new MedicalParser();
			}
	        
			
			// 将汉字转换为全拼  
		    public static String getPingYin(String src) {  
		        char[] t1 = null;  
		        t1 = src.toCharArray();  
		        String[] t2 = new String[t1.length];  
		        HanyuPinyinOutputFormat t3 = new HanyuPinyinOutputFormat();  
		          
		        t3.setCaseType(HanyuPinyinCaseType.LOWERCASE);  
		        t3.setToneType(HanyuPinyinToneType.WITHOUT_TONE);  
		        t3.setVCharType(HanyuPinyinVCharType.WITH_V);  
		        String t4 = "";  
		        int t0 = t1.length;  
		        try {  
		            for (int i = 0; i < t0; i++) {  
		                // 判断是否为汉字字符  
		                if (java.lang.Character.toString(t1[i]).matches(  
		                        "[\\u4E00-\\u9FA5]+")) {  
		                    t2 = PinyinHelper.toHanyuPinyinStringArray(t1[i], t3);  
		                    t4 += t2[0];  
		                } else  {
		                    t4 += java.lang.Character.toString(t1[i]);  
		                	}
		            }   
//		             System.out.println(t4); 
		            return t4.toLowerCase();  
		        } catch (BadHanyuPinyinOutputFormatCombination e1) {  
		            e1.printStackTrace();  
		        }  
		        return t4.toLowerCase();  
		    }  
		  
		    // 将字符串转移为ASCII码  
			public static int getAscii(char cn){
			      byte[] bytes = (String.valueOf(cn)).getBytes();
			      if(bytes.length == 1){ //单字节字符
			        return bytes[0];
			      }else if(bytes.length == 2){ //双字节字符
			       int hightByte = 256 + bytes[0];
			        int lowByte = 256 + bytes[1];
			        int ascii = (256 * hightByte + lowByte) - 256 * 256;
			        return ascii;
			      }else{
			       return 0; //错误
			      }
			    }
		
}