package cn.redcdn.datacenter.offaccscenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.offaccscenter.data.PlayerInfo;

import cn.redcdn.log.CustomLog;

public abstract class MDSAppGetVideoInfo extends MDSAbstractBusinessData<PlayerInfo>{

private String tag = MDSAppGetVideoInfo.class.getName();
	/*
	 * 根据频道id获取频道详细信息
	 * @param token 登录鉴权token
	 * 
	 * @param urlId 频道ID
	 * 
	 * @return 频道详细信息
	 * 
	 */

	private int type;

	public int appGetVideoInfo(String token,String contentId,int contentType)
			{
			
				CustomLog.d(tag, "appGetVideoInfo token="+token+"urlId = "+contentId+"contentType ="+contentType);
				
				JSONObject json = new JSONObject();
				try {
					type = contentType;
					json.put("token", token);
					json.put("contentId", contentId);
					json.put("contentType", contentType);
					
				} catch (Exception e) {
					// TODO: handle exception
					return -3;
				}
				
				return exec(ConstConfig.getMedicalCenterUrl()+ConstConfig.MDS_GET_VIDEO_INFO,json.toString());
			}
	protected PlayerInfo parseContentBody(JSONObject jo)
			throws InvalidateResponseException{
				try {
					if (jo == null) {
						CustomLog.e(tag, "appGetVideoInfo invalidate reponse");
						throw new InvalidateResponseException();
					}

					JSONObject json = jo.getJSONObject("data");
					PlayerInfo info = new PlayerInfo();
					if (json != null) {

						info.previewType= json.optInt("previewType");
						if(type == 2){
							info.url = json.optString("flvUrl");
						}else{
							info.url = json.optString("url");
						}
						info.poster= json.optString("poster");


					}
					return info;
				} catch (JSONException e) {
					CustomLog.e(tag, "appGetVideoInfo invalidate reponse");
					throw new InvalidateResponseException();
				}
			}
			
			protected Parser getParser(){
				return new MedicalParser();
			}
	
	
}
