package cn.redcdn.datacenter.offaccscenter.data;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class MDSFocusPageInfo {

	
	public int totalSize;
	public List<MDSfocusOffAccArtcleInfo> focusList;

	public JSONObject dataJson; //缓存json
	
	public MDSFocusPageInfo(){
	
		totalSize = 0;
		focusList = new ArrayList<MDSfocusOffAccArtcleInfo>();
		dataJson  = new JSONObject();
		
	}
	
	public MDSFocusPageInfo(MDSFocusPageInfo info){
		
		
		this.totalSize = info.totalSize;
		this.focusList = info.focusList;
		this.dataJson = info.dataJson;
		
	}

	public JSONObject getDataJson() {
		return dataJson;
	}

	public void setDataJson(JSONObject dataJson) {
		this.dataJson = dataJson;
	}

	public int getTotalSize() {
		return totalSize;
	}

	public void setTotalSize(int totalSize) {
		this.totalSize = totalSize;
	}

	public List<MDSfocusOffAccArtcleInfo> getFocusList() {
		return focusList;
	}

	public void setFocusList(List<MDSfocusOffAccArtcleInfo> focusList) {
		this.focusList = focusList;
	}
	

	public static MDSFocusPageInfo analyze(JSONObject jo){
		MDSFocusPageInfo info = new MDSFocusPageInfo();
		JSONObject json = jo.optJSONObject("data");
		if (json != null) {
			JSONArray arr = json.optJSONArray("articles");
			MDSfocusOffAccArtcleInfo tmpinfo = null;
			if (arr != null) {
				info.totalSize = json.optInt("totalSize");
				for (int i = 0; i < arr.length(); i++) {
					JSONObject tmp = arr.optJSONObject(i);
					tmpinfo = new MDSfocusOffAccArtcleInfo();
					tmpinfo.offaccId = tmp.optString("id");
					tmpinfo.offaccLoginUrl = tmp.optString("logoUrl");
					tmpinfo.offaccName = tmp.optString("officialAccountName");
					tmpinfo.articleId = tmp.optString("articleId");
					tmpinfo.articleTitle = tmp.optString("name");
					tmpinfo.showImgUrl = tmp.optString("previewUrl");
					tmpinfo.commentNumber = tmp.optInt("commentNumber");
					tmpinfo.instroduction = java.net.URLDecoder.decode(tmp.optString("description"));
					tmpinfo.praiseNumber = tmp.optInt("praiseNumber");
					tmpinfo.publishTime = tmp.optString("publishTime");
					tmpinfo.isEncipher = tmp.optInt("accessType");
					tmpinfo.encipherPwd = tmp.optString("accessPassword");
					tmpinfo.playCount = tmp.optInt("playCount");
					tmpinfo.articleType = tmp.optInt("articleType");
					info.focusList.add(tmpinfo);
				}
			}
		}

		return  info;
	}

}
