package cn.redcdn.datacenter.otherinterface;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.otherinterface.data.OtherContact;
import cn.redcdn.datacenter.otherinterface.data.OtherContactInfo;

/**
 * Created by gexy on 2018\8\22 0022.
 */

public class GetOtherContacts extends MDSAbstractBusinessData<OtherContact> {

    public void getOtherContacts(String fromSystem,String nube){
//        String param = "["+"FROMSYSTEM="+fromSystem+",NUBENUMBER="+nube+"]";
        String param = "FROMSYSTEM="+fromSystem+"&NUBENUMBER="+nube;
        execOther(ConstConfig.getOtherContactUrl()+ConstConfig.getGetOtherContact(),param);
    }

    protected OtherContact parseContentBody(JSONObject jo) {
        OtherContact otherContact = new OtherContact();
        if (jo != null) {
            JSONObject data = jo.optJSONObject("DATA");
            if (data != null) {
                JSONArray users = data.optJSONArray("LIST");
                if (users != null) {
                    for (int i=0;i<users.length();i++) {
                        OtherContactInfo contactInfo = new OtherContactInfo();
                        JSONObject user = users.optJSONObject(i);
                        if (user != null) {
                            contactInfo.nube = user.optString("NUBENUMBER");
                            contactInfo.name = user.optString("NAME");
                            contactInfo.headUrl = user.optString("HEADURL");
                        }
                        otherContact.contactInfos.add(contactInfo);
                    }
                }
            }
        }
        return otherContact;
    }

    protected Parser getParser(){
        return new OtherInterfaceParser();
    }
}
