package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseAuditProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetAllCourseAuditProcessList extends MDSAbstractBusinessData<List<SPTCourseAuditProcessInfo>> {

    //获取老师所有学科下面已审核进度列表
    public void getProcessList(String baseId,String token,String logType){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("baseId",baseId);
            jsonObject.put("token",token);
            jsonObject.put("logTypeId",logType);
        }catch (Exception e){

        }
     exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_TEACHER_AUDIT_LIST,jsonObject.toString());
    }

    protected List<SPTCourseAuditProcessInfo> parseContentBody(JSONObject jo){
      List<SPTCourseAuditProcessInfo> infos = new ArrayList<>();
      if (jo != null){
          JSONArray array = jo.optJSONArray("data");
          if (array != null){
              for (int i = 0;i<array.length();i++){
                  JSONObject tmpJson = array.optJSONObject(i);
                  SPTCourseAuditProcessInfo info = new SPTCourseAuditProcessInfo();
                  if (tmpJson!=null){
                      info.courseid = tmpJson.optString("subjectId");
                      info.courseName = tmpJson.optString("subjectName");
                      info.finishedCount = tmpJson.optString("finishedAudit");
                  }
                  infos.add(info);
              }
          }
      }
      return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}

