package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetAllCourseProcessList extends MDSAbstractBusinessData<List<SPTCourseProcessInfo>>{

    //获取学生所有学科下的学习进度
    //SPTCourseProcessInfo
    public void getCourseProcessList(String baseId,String token,String logType){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("baseId",baseId);
            jsonObject.put("token",token);
            jsonObject.put("logTypeId",logType);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_STUDENT_PROCESSS_ALLSUBJECT,jsonObject.toString());

    }

    protected List<SPTCourseProcessInfo> parseContentBody(JSONObject jo){
        List<SPTCourseProcessInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray array = jo.optJSONArray("data");
            if (array!=null){
                for (int i = 0;i<array.length();i++){
                    JSONObject tmpJson = array.optJSONObject(i);
                    SPTCourseProcessInfo info = new SPTCourseProcessInfo();
                    if (tmpJson!=null){
                        info.courseid = tmpJson.optString("subjectId");
                        info.courseName = tmpJson.optString("subjectName");
                        info.finishedCount = tmpJson.optString("finishedLogs");
                        info.totalNeedCount = tmpJson.optString("needLogs");
                    }
                    infos.add(info);
                }
            }
        }
        return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}
