package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetAllCourses extends MDSAbstractBusinessData<List<SPTCourseInfo>> {

    //获取协会下所有学科
    public void getAllCourses(String token,String baseId){

        JSONObject jsonObject = new JSONObject();

        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
        }catch (Exception e){

        }


        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_ALL_SUBJECT_LIST,jsonObject.toString());

    }

    protected List<SPTCourseInfo> parseContentBody(JSONObject jo){
          List<SPTCourseInfo> infos = new ArrayList<>();
          if (jo!=null){
              JSONArray array = jo.optJSONArray("data");
              if (array!=null){
                  for (int i= 0;i<array.length();i++){
                      JSONObject tmpJson = array.optJSONObject(i);
                      SPTCourseInfo info = new SPTCourseInfo();
                      if (tmpJson!=null){
                          info.courseId = tmpJson.optString("subjectId");
                          info.courseName = tmpJson.optString("subjectName");
                      }
                      infos.add(info);
                  }
              }
          }
          return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
