package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTAnyCourseProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetAnyCourseProcess extends MDSAbstractBusinessData<SPTAnyCourseProcessInfo> {

    //某学科下的病种/临床操作学习进度
     public void getAnyCourseProcess(String subjectId,String baseId,String token){

         JSONObject jsonObject = new JSONObject();

         try {
             jsonObject.put("token",token);
             jsonObject.put("baseId",baseId);
             jsonObject.put("subjectId",subjectId);
         }catch (Exception e){

         }
         exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_ANY_PROCESS,jsonObject.toString());
     }

    protected SPTAnyCourseProcessInfo parseContentBody(JSONObject jo){
        SPTAnyCourseProcessInfo infos = new SPTAnyCourseProcessInfo();
        if (jo!=null){
            JSONObject data = jo.optJSONObject("data");
            if (data!=null){
                infos.totalCount = data.optString("allFinish");
                infos.finishedCount = data.optString("needFinish");
                JSONArray array = data.optJSONArray("detail");
                if (array!=null){
                    for (int i = 0;i<array.length();i++){
                        JSONObject tmpJson = array.optJSONObject(i);
                        SPTCourseProcessInfo info = new SPTCourseProcessInfo();
                        if (tmpJson!=null){
                            info.courseid = tmpJson.optString("logNormId");
                            info.courseName = tmpJson.optString("logNormName");
                            info.finishedCount = tmpJson.optString("allFinish");
                            info.totalNeedCount = tmpJson.optString("needFinish");
                        }
                        infos.courseProcessInfos.add(info);
                    }
                }
            }

        }
        return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
