package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTBaseInfo;

/**
 * Created by caizx on 2018/7/17.
 */

public class SPTGetBaseList extends MDSAbstractBusinessData<List<SPTBaseInfo>> {

   //获取基地列表

    public void getBaseList(String token){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_BASE_LIST,jsonObject.toString());
    }

    protected List<SPTBaseInfo> parseContentBody(JSONObject jo){

        List<SPTBaseInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray datas = jo.optJSONArray("data");
            if (datas!=null){
                for (int i = 0;i<datas.length();i++){
                    JSONObject tmpJson = datas.optJSONObject(i);
                    SPTBaseInfo info = new SPTBaseInfo();
                    if (tmpJson!=null){
                        info.baseId = tmpJson.optString("baseId");
                        info.baseName = tmpJson.optString("baseName");
                        info.showName = tmpJson.optString("showName");
                    }
                }
            }
        }
     return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
