package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlLogListInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTClinicalListInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetClinicalAuditLogList extends MDSAbstractBusinessData<SPTNoramlLogListInfo>{

    //获取已审核临床日志列表
    public void getClinicalAuditLogList(String baseId,String token,String subjectId,String nube){
        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("nube",nube);
            jsonObject.put("subjectId",subjectId);

        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_AUDIT_GET_CLINICALLIST,jsonObject.toString());
    }

    protected SPTNoramlLogListInfo parseContentBody(JSONObject jo){

        SPTNoramlLogListInfo infos = new SPTNoramlLogListInfo();
        if (jo!=null){
            JSONObject tmpJson = jo.optJSONObject("data");
            if (tmpJson!=null){

                infos.courseProcessInfo.courseid = tmpJson.optString("subjectId");
                infos.courseProcessInfo.courseName = tmpJson.optString("subjectName");
                infos.courseProcessInfo.finishedCount = tmpJson.optString("auditNum");
//                infos.courseProcessInfo.finishedCount = tmpJson.optString("auditNum");

                JSONArray logs = tmpJson.optJSONArray("logs");
                if (logs!=null){
                    for (int i = 0;i<logs.length();i++){
                        JSONObject jsonObject = logs.optJSONObject(i);
                        SPTNoramlInfo info = new SPTNoramlInfo();
                        if (jsonObject!=null){
                            info.logId = jsonObject.optString("id");
                            info.diseaseName = jsonObject.optString("logName");
                            info.patientName = jsonObject.optString("patient");
                            info.courseName = jsonObject.optString("subjectName");
                            info.studentName = jsonObject.optString("name");
                            info.roleName = jsonObject.optString("nowAudit");
                            info.logStaus = jsonObject.optString("state");
                            info.auditTime = jsonObject.optString("lastTime");
                        }
                        infos.noramlInfos.add(info);
                    }
                }
            }
        }
        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
