package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.template.SPTClinicalInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTClinicalListInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTDiseaseInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTDiseaseListInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetClinicalList extends MDSAbstractBusinessData<List<SPTClinicalListInfo>> {

    //获取临床操作列表

public void getClinicalList(String baseId,String token){
    JSONObject jsonObject = new JSONObject();

    try {
        jsonObject.put("baseId",baseId);
        jsonObject.put("token",token);

    }catch (Exception e){

    }

    exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_CLONOCAL_LIST,jsonObject.toString());

}

    protected List<SPTClinicalListInfo> parseContentBody(JSONObject jo){
        List<SPTClinicalListInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray jsonArray = jo.optJSONArray("data");
            if (jsonArray != null){
                for (int i = 0;i<jsonArray.length();i++){
                    JSONObject jsonObject = jsonArray.optJSONObject(i);
                    SPTClinicalListInfo info = new SPTClinicalListInfo();
                    if (jsonObject!=null){
                        info.courseName = jsonObject.optString("subjectName");
                        info.courseId = jsonObject.optString("subjectId");
                        JSONArray array = jsonObject.optJSONArray("logs");
                        if (array!=null){
                            for(int j = 0;j<array.length();j++){
                                JSONObject jsonObject1 = array.optJSONObject(j);
                                SPTClinicalInfo diseaseInfo = new SPTClinicalInfo();
                                if (jsonObject1!=null){
                                    diseaseInfo.clinicalName = jsonObject1.optString("logStandardName");
                                    diseaseInfo.clinicalId = jsonObject1.optString("logStandardId");
                                }
                                info.clinicalInfos.add(diseaseInfo);
                            }
                        }
                    }
                    infos.add(info);
                }
            }
        }

        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
