package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTDetailProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetDetailProcess extends MDSAbstractBusinessData<List<SPTProcessInfo>>{

    //获取详细的进度列表
    public void getDetailProcess(String baseId,String token){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
        }catch (Exception e){

        }
       exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_STUDENT_DETAIL_PROCESS,jsonObject.toString());
    }

    protected List<SPTProcessInfo> parseContentBody(JSONObject jo){
        List<SPTProcessInfo> infos = new ArrayList<>();
        if (jo != null){
            JSONArray data = jo.optJSONArray("data");
            if (data != null){
                for (int i = 0;i<data.length();i++){
                    JSONObject tmpJson = data.optJSONObject(i);
                    SPTProcessInfo processInfo = new SPTProcessInfo();
                    if (tmpJson!=null){
                        processInfo.trainStart = tmpJson.optString("trainStart");
                        processInfo.trainEnd = tmpJson.optString("trainEnd");
                        processInfo.timeEvent = tmpJson.optString("logDesc");
                        processInfo.processStaus = tmpJson.optString("state");
                        JSONArray array = tmpJson.optJSONArray("logDetail");
                        if (array !=null){
                            for (int j = 0;j<array.length();j++){
                                JSONObject detailJson = array.optJSONObject(j);
                                SPTDetailProcessInfo detail = new SPTDetailProcessInfo();
                                if (detailJson!=null){
                                   detail.detailDesc = detailJson.optString("detail");
                                }
                                processInfo.detailProcessInfos.add(detail);
                            }
                        }
                    }
                    infos.add(processInfo);
                }
            }
        }
        return infos;
    }

    protected Parser getParser(){
        return new MedicalParser();
    }


}
