package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.template.SPTDiseaseInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTDiseaseListInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetDiseaselist extends MDSAbstractBusinessData<List<SPTDiseaseListInfo>>{

    //获取病种记录列表
    public void getDiseaseList(String baseId,String token){
        JSONObject jsonObject = new JSONObject();

        try {
            jsonObject.put("baseId",baseId);
            jsonObject.put("token",token);
        }catch (Exception e){

        }

     exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_DISEASE_LIST,jsonObject.toString());

    }

    protected List<SPTDiseaseListInfo> parseContentBody(JSONObject jo){
        List<SPTDiseaseListInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray jsonArray = jo.optJSONArray("data");
            if (jsonArray != null){
                for (int i = 0;i<jsonArray.length();i++){
                    JSONObject jsonObject = jsonArray.optJSONObject(i);
                    SPTDiseaseListInfo info = new SPTDiseaseListInfo();
                    if (jsonObject!=null){
                        info.courseName = jsonObject.optString("subjectName");
                        info.courseId = jsonObject.optString("subjectId");
                        JSONArray array = jsonObject.optJSONArray("logs");
                        if (array!=null){
                            for(int j = 0;j<array.length();j++){
                                JSONObject jsonObject1 = array.optJSONObject(j);
                                SPTDiseaseInfo diseaseInfo = new SPTDiseaseInfo();
                                if (jsonObject1!=null){
                                    diseaseInfo.diseaseName = jsonObject1.optString("logStandardName");
                                    diseaseInfo.diseaseId = jsonObject1.optString("logStandardId");
                                }
                                info.diseaseInfos.add(diseaseInfo);
                            }
                        }
                    }
                    infos.add(info);
                }
            }
        }

        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
