package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateAuditInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateWaitAuditInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetLogAuditTemplate extends MDSAbstractBusinessData<SPTTemplateWaitAuditInfo>{
    //获取日志的待审核模板

    public void getLogAuditTemplate(String token,String logId){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("logId",logId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_AUDIT_GET_TEMPLATE,jsonObject.toString());
    }

    //获取批量审核模板
    public void getBatchLogAuditTemplate(String token,String logId,String isBatch){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("logId",logId);
            jsonObject.put("isBatch",isBatch);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_AUDIT_GET_TEMPLATES,jsonObject.toString());
    }

    protected SPTTemplateWaitAuditInfo parseContentBody(JSONObject jo){
           SPTTemplateWaitAuditInfo info = new SPTTemplateWaitAuditInfo();
           if (jo!=null){
               JSONObject data = jo.optJSONObject("data");
               if (data!=null){
                   info.auditTempId = data.optString("auditTempId");
                   JSONArray array = data.optJSONArray("detail"); //todo:待确定
                   if(array!=null){
                       for (int i = 0;i<array.length();i++){
                           JSONObject tmpJson = array.optJSONObject(i);
                           SPTTemplateAuditInfo tmpInfo = new SPTTemplateAuditInfo();
                           if(tmpJson!=null){
                               tmpInfo.templateAuditId = tmpJson.optString("tempKeyId");
                               tmpInfo.templateAuditType = tmpJson.optString("tempKeyType");
                               tmpInfo.templateAuditName = tmpJson.optString("tempKeyName");
                               tmpInfo.templateAuditDefaultValue = tmpJson.optString("defaultValue");
                               tmpInfo.showName = tmpJson.optString("showName");
                               tmpInfo.tempKeyTip = tmpJson.optString("tempKeyTip");
//                               if (tmpJson.has("tempKeyContent")) {
//                                   tmpInfo.templateAuditContent = tmpJson.optString("tempKeyContent");
//                               }
                               tmpInfo.temlateAuditValue  = tmpJson.optString("tempKeyValue");
                           }
                           info.auditInfos.add(tmpInfo);
                       }
                   }
               }
           }
           return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }




}
