package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.friendValidation.ImportFriend;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTAuditDetailInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTLogDetailInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateAuditInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateBaseInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateOptionalInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateStaus;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetLogDetail extends MDSAbstractBusinessData<SPTLogDetailInfo> {

    //获取日志详情

    public void getLogDetail(String token,String logId){

        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("logId",logId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_LOG_DETAIL,jsonObject.toString());
    }

    public  SPTLogDetailInfo getLogDetailSyn(String token,String logId) {
        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("logId",logId);
        }catch (Exception e){

        }
        return execSync(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_LOG_DETAIL,jsonObject.toString());
    }

    protected SPTLogDetailInfo parseContentBody(JSONObject jo){

        SPTLogDetailInfo  info = new SPTLogDetailInfo();

        if (jo!=null){
            JSONObject data = jo.optJSONObject("data");
            if (data != null){
                info.logType = data.optString("logType");
                info.totalStatus = data.optString("finalState");
                info.crossFlg = data.optString("crossFlg");
                JSONArray auditState = data.optJSONArray("auditState");
                if (auditState!=null){
                    for (int i = 0;i<auditState.length();i++){
                        JSONObject tmpJson = auditState.optJSONObject(i);
                        SPTTemplateStaus staus = new SPTTemplateStaus();
                        if (tmpJson!=null){
                            staus.roleName = tmpJson.optString("roleName");
                            staus.auditStaus = tmpJson.optString("state");
                            staus.isMyTask = tmpJson.optString("isMyTask");
//                            staus.crossFlg = tmpJson.optString("crossFlg");
                        }
                        info.staus.add(staus);
                    }
                }
                //todo:基本信息类型需要重新定义
                JSONArray logBase = data.optJSONArray("baseInfo");
                if (logBase!=null){
                    for (int i= 0;i<logBase.length();i++){
                        JSONObject tmpJson = logBase.optJSONObject(i);
                        SPTTemplateBaseInfo base = new SPTTemplateBaseInfo();
                        if (tmpJson!=null){
                            base.nube = tmpJson.optString("nube");
                            base.templateType = tmpJson.optString("tempKeyType");
                            base.templateId = tmpJson.optString("tempKeyId");
                            base.templateName = tmpJson.optString("tempKeyName");
                            base.defaultValue = tmpJson.optString("defaultValue");
                            base.showName =tmpJson.optString("showName");
                            base.tempKeyTip = tmpJson.optString("tip");
                            base.templateValue = tmpJson.optString("tempKeyValue");
                        }
                        info.baseInfos.add(base);
                    }
                }

                JSONArray logDetail = data.optJSONArray("logContent");

                if (logDetail !=null ){
                    for (int i = 0;i<logDetail.length();i++){
                        JSONObject tmpJson = logDetail.optJSONObject(i);
                        SPTTemplateBaseInfo detail = new SPTTemplateBaseInfo();
                        if (tmpJson!=null){
                            detail.templateType = tmpJson.optString("tempKeyType");
                            detail.templateId = tmpJson.optString("tempKeyId");
                            detail.templateName = tmpJson.optString("tempKeyName");
                            detail.defaultValue = tmpJson.optString("defaultValue");
                            detail.showName = tmpJson.optString("showName");
                            detail.tempKeyTip = tmpJson.optString("tip");
                            detail.templateValue = tmpJson.optString("tempKeyValue");
                        }
                        info.patientInfos.add(detail);
                    }
                }


                JSONArray auditDetail = data.optJSONArray("audits");

                if (auditDetail !=null ){
                    for (int i = 0;i<auditDetail.length();i++){
                        JSONObject tmpJson = auditDetail.optJSONObject(i);
                        SPTAuditDetailInfo auditInfo = new SPTAuditDetailInfo();
                        if (tmpJson!=null){
                            auditInfo.auditRoleId = tmpJson.optString("roleId");
                            auditInfo.nube = tmpJson.optString("nube");
                            auditInfo.templateAuditId = tmpJson.optString("tempKeyId");
                            auditInfo.templateAuditType = tmpJson.optString("tempKeyType");
                            auditInfo.templateAuditName = tmpJson.optString("tempKeyName");
                            auditInfo.templateAuditDefaultValue = tmpJson.optString("defaultValue");
                            auditInfo.tempKeyTip = tmpJson.optString("tip");
                            auditInfo.showName = tmpJson.optString("showName");

                            JSONArray userArr = tmpJson.optJSONArray("selectUser");
                            if (userArr !=null){
                                for (int m = 0;m<userArr.length();m++){
                                    JSONObject userJson = userArr.optJSONObject(m);
                                    SPTTemplateOptionalInfo optionalInfo = new SPTTemplateOptionalInfo();
                                    if (userJson!=null){
                                        optionalInfo.optionalId = userJson.optString("userId");
                                        optionalInfo.optialName = userJson.optString("userName");
                                        optionalInfo.optionalDepart = userJson.optString("dept");
                                    }
                                    auditInfo.optionalInfos.add(optionalInfo);
                                }
                            }

                            JSONArray optails = tmpJson.optJSONArray("auditContent");
                            if (optails!=null){
                                for (int j = 0;j<optails.length();j++){
                                    JSONObject jsonObject = optails.optJSONObject(j);
                                    SPTTemplateAuditInfo info1 = new SPTTemplateAuditInfo();
                                    if (jsonObject !=null){
                                        info1.templateAuditType = jsonObject.optString("tempKeyType");
                                        info1.templateAuditId = jsonObject.optString("tempKeyId");
                                        info1.templateAuditName = jsonObject.optString("tempKeyName");
                                        info1.valid  = jsonObject.optString("valid");

                                        info1.templateAuditDefaultValue = jsonObject.optString("defaultValue");
                                        info1.tempKeyTip = jsonObject.optString("tip");
                                        info1.showName = jsonObject.optString("showName");

                                    }
                                    auditInfo.auditInfos.add(info1);
                                }
                            }
                        }
                        info.auditInfos.add(auditInfo);
                    }
                }
            }
        }
           return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
