package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateAuditInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateBaseInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateOptionalInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetLogTemplate extends MDSAbstractBusinessData<SPTTemplateInfo>{
    //获取日志模板

    public void getLogTemplate(String token,String logType,String baseId,String logId,String deptId){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("logTypeId",logType);
            jsonObject.put("logStandardId",logId);
            jsonObject.put("baseId",baseId);
            jsonObject.put("deptId",deptId);
        }catch (Exception e){
        }
      exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_LOGTEMPLATE,jsonObject.toString());
    }

    protected SPTTemplateInfo parseContentBody(JSONObject jo){
       SPTTemplateInfo info = new SPTTemplateInfo();
       if (jo !=null){
           JSONObject jsonObject = jo.optJSONObject("data");
           if (jsonObject != null){
               JSONArray temps = jsonObject.optJSONArray("temps");
               if(temps!=null){
                   for (int i = 0;i<temps.length();i++){
                       JSONObject tmpJson = temps.optJSONObject(i);
                       SPTTemplateBaseInfo baseInfo = new SPTTemplateBaseInfo();
                       if (tmpJson!=null){
                           baseInfo.templateId = tmpJson.optString("tempKeyId");
                           baseInfo.templateType = tmpJson.optString("tempKeyType");
                           baseInfo.templateName = tmpJson.optString("tempKeyName");
                           baseInfo.defaultValue = tmpJson.optString("defaultValue");
                           baseInfo.tempKeyTip = tmpJson.optString("tip");
                           baseInfo.templateValue = tmpJson.optString("tempKeyValue");
                           info.baseInfos.add(baseInfo);
                       }
                   }
               }
               JSONArray audits = jsonObject.optJSONArray("audits");


               if (audits!=null){
                   for (int i = 0;i<audits.length();i++){
                       JSONObject auditJson = audits.optJSONObject(i);
                       SPTTemplateAuditInfo auditInfo = new SPTTemplateAuditInfo();
                       if (auditJson!=null){
                           //待确定解析内容
                           auditInfo.roleBussinessId = auditJson.optString("roleBid");
                           auditInfo.templateAuditId = auditJson.optString("tempKeyId");
                           auditInfo.templateAuditType=auditJson.optString("tempKeyType");
                           auditInfo.templateAuditName = auditJson.optString("tempKeyName");
                           auditInfo.defaultId= auditJson.optString("defaultValue");
                           auditInfo.tempKeyTip = auditJson.optString("tip");

                           JSONArray selects = auditJson.optJSONArray("selectUser");
                           if (selects!=null){
                               for (int j = 0;j<selects.length();j++){
                                   JSONObject tmpJson = selects.optJSONObject(j);
                                   SPTTemplateOptionalInfo info1 = new SPTTemplateOptionalInfo();
                                   if(tmpJson !=null){
                                       info1.optionalId = tmpJson.optString("userId");
                                       info1.optialName = tmpJson.optString("userName");
                                       info1.optionalDepart = tmpJson.optString("dept");
                                   }
                                auditInfo.optionalInfos.add(info1);
                               }
                           }
                       }
                       info.auditInfos.add(auditInfo);
                   }
               }
           }
       }
       return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }
}
