package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.security.PublicKey;
import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTNotificationInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetNotficationList extends MDSAbstractBusinessData<List<SPTNotificationInfo>> {

    //获取通知列表
   public void  getNotficationList(String token,String baseId){
       JSONObject jsonObject = new JSONObject();

       try {
           jsonObject.put("token",token);
           jsonObject.put("baseId",baseId);
       }catch (Exception e){

       }
       exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_NOTIFICATION_LIST,jsonObject.toString());
   }

    protected List<SPTNotificationInfo> parseContentBody(JSONObject jo){
        List<SPTNotificationInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray array = jo.optJSONArray("data");
            if (array!=null){
                for (int i = 0;i<array.length();i++){
                    JSONObject jsonObject = array.optJSONObject(i);
                    SPTNotificationInfo info = new SPTNotificationInfo();
                    if (jsonObject!=null){
                        info.notifId = jsonObject.optString("id");
                        info.notifTitle = jsonObject.optString("title");
                        info.notifContent = jsonObject.optString("content");
                        info.notifIntr = jsonObject.optString("descp");
                        info.notifPublisher = jsonObject.optString("publisher");
                        info.notifFlg = jsonObject.optString("noticeFlg");
                        info.publishTime = jsonObject.optString("publishTime");
                    }
                    infos.add(info);
                }
            }
        }
        return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}
