package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.net.URLDecoder;
import java.security.PublicKey;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.hpucenter.data.TFPdfInfo;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTNotificationInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetNotificationDetail extends MDSAbstractBusinessData<SPTNotificationInfo>{

    //根据通知id 获取通知内容

    /**
     *
     * @param token
     * @param noticeId
     */
     public void getNotificationDetail(String token,String noticeId,String noticeFlg){
         JSONObject jsonObject = new JSONObject();
         try {
             jsonObject.put("token",token);
             jsonObject.put("id",noticeId);
             jsonObject.put("noticeFlg",noticeFlg);
         }catch (Exception e){

         }
      exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_NOTIFICATION_DETAIL,jsonObject.toString());
     }

    protected SPTNotificationInfo parseContentBody(JSONObject jo){
         SPTNotificationInfo info = new SPTNotificationInfo();
        if (jo!=null){
            JSONObject jsonObject = jo.optJSONObject("data");
            if (jsonObject!=null){
                info.notifId = jsonObject.optString("id");
                info.notifTitle = jsonObject.optString("title");
                info.notifContent = URLDecoder.decode(jsonObject.optString("content"));
                info.notifIntr = jsonObject.optString("descp");
                info.notifPublisher = jsonObject.optString("publisher");
                info.publishTime = jsonObject.optString("publishTime");
                JSONArray pathArr  =  jsonObject.optJSONArray("attachPaths");
                if (pathArr!=null){
                    for (int i = 0;i<pathArr.length();i++){
                        JSONObject tmpJson = pathArr.optJSONObject(i);
                        TFPdfInfo tmpInfo = new TFPdfInfo();
                        if (tmpJson!=null){
                            tmpInfo.pdfName = tmpJson.optString("name");
                            tmpInfo.pdfUrl = tmpJson.optString("url");
                        }
                        info.attachmentPaths.add(tmpInfo);
                    }
                }
            }
        }
        return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
