package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlLogListInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTTaskProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetOtherTaskAuditLogList extends MDSAbstractBusinessData<SPTNoramlLogListInfo> {

    //获取其他任务已审核进度列表
    public void getOtherTakAuditLogList(String token,String baseId,String logTypeId,String nube){

        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("nube",nube);
            jsonObject.put("logTypeId",logTypeId);

        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_AUDIT_GET_OTHERLIST,jsonObject.toString());

    }

    protected SPTNoramlLogListInfo parseContentBody(JSONObject jo){

        SPTNoramlLogListInfo infos = new SPTNoramlLogListInfo();
        if (jo!=null){
            JSONObject tmpJson = jo.optJSONObject("data");
            if (tmpJson!=null){

                infos.taskProcessInfo.taskType = tmpJson.optString("logTypeId");
                infos.taskProcessInfo.taskName = tmpJson.optString("logTypeName");
//                infos.taskProcessInfo.totalCount = tmpJson.optString("needLog");
                infos.taskProcessInfo.finishedCount = tmpJson.optString("auditNum");

                JSONArray logs = tmpJson.optJSONArray("logs");
                if (logs!=null){
                    for (int i = 0;i<logs.length();i++){
                        JSONObject jsonObject = logs.optJSONObject(i);
                        SPTNoramlInfo info = new SPTNoramlInfo();
                        if (jsonObject!=null){
                            info.logId = jsonObject.optString("id");
                            info.diseaseName = jsonObject.optString("logName");
                            info.studentName = jsonObject.optString("name");
                            info.roleName = jsonObject.optString("nowAudit");
                            info.auditTime = jsonObject.optString("lastTime");
                            info.logStaus = jsonObject.optString("state");

//                            info.courseName = jsonObject.optString("subject");
//                            info.title = jsonObject.optString("logName");
//                            info.taskType = jsonObject.optString("logTypeId");
                        }
                        infos.noramlInfos.add(info);
                    }
                }

            }
        }
        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
