package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTTaskAuditProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTTaskProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetOtherTaskAuditProcessList extends MDSAbstractBusinessData<List<SPTTaskAuditProcessInfo>> {

     //获取其他任务老师已审核进度列表
     public void getOtherAuditProcessList(String token,String baseId){

         JSONObject jsonObject = new JSONObject();
         try{
             jsonObject.put("token",token);
             jsonObject.put("baseId",baseId);
         }catch (Exception e){

         }
         exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_OTHER_AUDIT_PROCESS,jsonObject.toString());

     }
    protected List<SPTTaskAuditProcessInfo> parseContentBody(JSONObject jo){
        List<SPTTaskAuditProcessInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray array = jo.optJSONArray("data");
            if (array!=null){
                for (int i = 0;i<array.length();i++){
                    JSONObject tmpJson = array.optJSONObject(i);
                    SPTTaskAuditProcessInfo info = new SPTTaskAuditProcessInfo();
                    if (tmpJson!=null){
                        info.taskType = tmpJson.optString("logTypeId");
                        info.taskName = tmpJson.optString("logTypeName");
                        info.totalCount = tmpJson.optString("finishedAudit");
                    }
                    infos.add(info);
                }
            }
        }
        return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
