package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlLogListInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTTaskProcessInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetOtherTaskLogList extends MDSAbstractBusinessData<SPTNoramlLogListInfo>{

    //获取其他日志列表

    public void getOtherTaskLogList(String token,String baseId,String logType,String nube,String subjectId){

        JSONObject jsonObject = new JSONObject();
        try{
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("logTypeId",logType);
            jsonObject.put("nube",nube);
            jsonObject.put("subjectId",subjectId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_OTHER_LOGLIST,jsonObject.toString());

    }

    protected SPTNoramlLogListInfo parseContentBody(JSONObject jo){

        SPTNoramlLogListInfo infos = new SPTNoramlLogListInfo();
        if (jo!=null){
            JSONObject tmpJson = jo.optJSONObject("data");
            if (tmpJson!=null){
                infos.taskProcessInfo.taskType = tmpJson.optString("logTypeId");
                infos.taskProcessInfo.taskName = tmpJson.optString("logTypeName");
                infos.taskProcessInfo.finishedCount = tmpJson.optString("finishedLogs");
                infos.taskProcessInfo.totalNeedCount = tmpJson.optString("needLogs");
                JSONArray logs = tmpJson.optJSONArray("logs");
                if (logs!=null){
                    for (int i = 0;i<logs.length();i++){
                        JSONObject jsonObject = logs.optJSONObject(i);
                        SPTNoramlInfo info = new SPTNoramlInfo();
                        if (jsonObject!=null){
                            info.logId = jsonObject.optString("logId");
                            info.diseaseName = jsonObject.optString("logName");
                            info.logStaus = jsonObject.optString("state");
                            info.courseName = jsonObject.optString("subjectName");
                            info.roleName = jsonObject.optString("nowAudit");
                            info.auditTime = jsonObject.optString("lastTime");

//                            info.title = jsonObject.optString("title");
//                            info.taskType = jsonObject.optString("type");
                        }
                        infos.noramlInfos.add(info);
                    }
                }
            }
        }
        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }
}
