package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTOutDepartInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTRdepartInfo;

/**
 * Created by caizx on 2018/7/18.
 */

public class SPTGetOutDepartList extends MDSAbstractBusinessData<List<SPTOutDepartInfo>>{

    //获取出科科室列表

    public void  getOutDepartList(String token,String baseId){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_OUTDEPART_LIST,jsonObject.toString());
    }

    protected List<SPTOutDepartInfo> parseContentBody(JSONObject jo){
        List<SPTOutDepartInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray jsonArray = jo.optJSONArray("data");
            if (jsonArray != null){
                for (int i = 0;i<jsonArray.length();i++){
                    JSONObject jsonObject = jsonArray.optJSONObject(i);
                    SPTOutDepartInfo info = new SPTOutDepartInfo();
                    if (jsonObject!=null){
                        info.subjectId = jsonObject.optString("subjectId");
                        info.subjectName = jsonObject.optString("subjectName");
                        JSONArray array = jsonObject.optJSONArray("depts");
                        if (array!=null){
                            for(int j = 0;j<array.length();j++){
                                JSONObject jsonObject1 = array.optJSONObject(j);
                                SPTRdepartInfo diseaseInfo = new SPTRdepartInfo();
                                if (jsonObject1!=null){
                                    diseaseInfo.deptId = jsonObject1.optString("deptId");
                                    diseaseInfo.deptName = jsonObject1.optString("deptName");
                                }
                                info.departs.add(diseaseInfo);
                            }
                        }
                    }
                    infos.add(info);
                }
            }
        }
        return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}
