package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTRdepartInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetRotaryDeparts extends MDSAbstractBusinessData<List<SPTCourseInfo>> {

    //获取基地下面轮转科室列表

   public void getRotaryDeparts(String token,String baseId){
       JSONObject jsonObject = new JSONObject();
       try {
          jsonObject.put("token",token);
          jsonObject.put("baseId",baseId);
       }catch (Exception e){

       }
       exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_DEPARTS_LIST,jsonObject.toString());
   }
    protected List<SPTCourseInfo> parseContentBody(JSONObject jo){
       List<SPTCourseInfo> infos = new ArrayList<>();
       if (jo!=null){
           JSONArray array = jo.optJSONArray("data");
           if (array!=null){
               for (int i = 0;i<array.length();i++){
                   JSONObject jsonObject = array.optJSONObject(i);
                   SPTCourseInfo info = new SPTCourseInfo();
                   if (jsonObject!=null){
                       info.courseId = jsonObject.optString("subjectId");
                       info.courseName = jsonObject.optString("subjectName");
                       JSONArray departs = jsonObject.optJSONArray("depts");
                       if (departs!=null){
                           for (int j = 0;j<departs.length();j++){
                               JSONObject departJson = departs.optJSONObject(j);
                               SPTRdepartInfo departInfo = new SPTRdepartInfo();
                               if (departJson!=null){
                                   departInfo.deptId = departJson.optString("deptId");
                                   departInfo.deptName = departJson.optString("deptName");
                               }
                               info.departs.add(departInfo);
                           }
                       }
                   }
                   infos.add(info);
               }
           }
       }
       return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }
}
