package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTContact;
import cn.redcdn.datacenter.sptcenter.data.SPTContactInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTContactUserInfo;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetSptContacts extends MDSAbstractBusinessData<SPTContact>{

    //获取专培基地通讯录

    /**
     *
     * @param token
     * @param updateTime  更新时间
     */

    public void getSptContacts(String token,String updateTime){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("updateTime",updateTime);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_BASE_CONTACTS,jsonObject.toString());
    }

    public SPTContact getSptContactSync(String token,long updateTime){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("updateTime",updateTime);
        }catch (Exception e){

        }
     return  execSync(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_BASE_CONTACTS,jsonObject.toString());
    }

    protected SPTContact parseContentBody(JSONObject jo){
        SPTContact sptContact = new SPTContact();
        if(jo!=null){
            JSONObject data = jo.optJSONObject("data");
            if (data != null) {
                sptContact.updateTime = data.optString("updateTime");
                JSONArray results = data.optJSONArray("results");
                if (results != null) {
                    for (int i=0;i<results.length();i++) {
                        JSONObject result = results.optJSONObject(i);
                        SPTContactInfo contactInfo = new SPTContactInfo();
                        if (result != null) {
                            contactInfo.baseId = result.optString("baseId");
                            contactInfo.baseName = result.optString("baseName");
                            contactInfo.associationName = result.optString("associationName");

                            JSONArray users = result.optJSONArray("users");
                            if (users != null) {
                                for (int j=0;j<users.length();j++) {
                                    JSONObject user = users.optJSONObject(j);
                                    SPTContactUserInfo contactUserInfo = new SPTContactUserInfo();
                                    if (user != null) {
                                        contactUserInfo.name = user.optString("name");
                                        contactUserInfo.role = user.optString("role");
                                        contactUserInfo.headUrl = user.optString("head_url");
                                        contactUserInfo.nube = user.optString("nube");
                                        contactUserInfo.id = user.optString("id");
                                        contactUserInfo.hospName = user.optString("hosp_name");
                                        contactUserInfo.department = user.optString("department");
                                        contactUserInfo.professional = user.optString("professional");
                                        contactUserInfo.mobile = user.optString("mobile");
                                        contactUserInfo.mail = user.optString("mail");
                                        contactUserInfo.phone = user.optString("phone");
                                        contactUserInfo.roleBid = user.optString("role_bid");
                                    }
                                    contactInfo.userInfos.add(contactUserInfo);
                                }
                            }
                        }
                        sptContact.contactInfos.add(contactInfo);
                    }
                }
            }
        }

     return sptContact;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
