package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTSrInfo;

/**
 * Created by caizx on 2018/7/18.
 */

public class SPTGetSrList extends MDSAbstractBusinessData<List<SPTSrInfo>> {

    //获取科研类型列表

    public void getSrList(String token,String baseId){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_SR_LIST,jsonObject.toString());
    }

    protected List<SPTSrInfo> parseContentBody(JSONObject jo){
       List<SPTSrInfo> infos = new ArrayList<>();
       if(jo!=null){
           JSONArray arr = jo.optJSONArray("data");
           if (arr!=null){
               for (int i = 0;i<arr.length();i++){
                   JSONObject tmpJson = arr.optJSONObject(i);
                   SPTSrInfo info = new SPTSrInfo();
                  if (tmpJson!=null){
                       info.researchId = tmpJson.optString("researchId");
                       info.researchName = tmpJson.optString("researchName");
                       info.hasTemp = tmpJson.optString("hasTemp");
                   }
                  infos.add(info);
               }
           }
       }
       return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
