package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTDetailProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTSrInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTStandarInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTStandardLog;

/**
 * Created by caizx on 2018/7/21.
 */

public class SPTGetStandarList extends MDSAbstractBusinessData<List<SPTStandarInfo>> {

    //获取日志规范列表
    public void getStandarList(String token,String baseId,String logTypeId){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("logTypeId",logTypeId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_STANDAR_LIST,jsonObject.toString());
    }

    protected List<SPTStandarInfo> parseContentBody(JSONObject jo){
        List<SPTStandarInfo> infos = new ArrayList<>();
        if (jo != null){
            JSONArray data = jo.optJSONArray("data");
            if (data != null){
                for (int i = 0;i<data.length();i++){
                    JSONObject tmpJson = data.optJSONObject(i);
                    SPTStandarInfo standarInfo = new SPTStandarInfo();
                    if (tmpJson!=null){
                        standarInfo.subjectId = tmpJson.optString("subjectid");
                        standarInfo.subjectName = tmpJson.optString("subjectName");
                        JSONArray array = tmpJson.optJSONArray("logs");
                        if (array !=null){
                            for (int j = 0;j<array.length();j++){
                                JSONObject logs = array.optJSONObject(j);
                                SPTStandardLog standardLog = new SPTStandardLog();
                                if (logs!=null){
                                    standardLog.logStandardId = logs.optString("logStandardId");
                                    standardLog.logStandardName = logs.optString("logStandardName");
                                    standardLog.hasTemp = logs.optString("hasTemp");
                                }
                                standarInfo.standardLogs.add(standardLog);
                            }
                        }
                    }
                    infos.add(standarInfo);
                }
            }
        }

        return infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
