package cn.redcdn.datacenter.sptcenter;

import android.content.Context;

import org.json.JSONArray;
import org.json.JSONObject;

import java.security.PublicKey;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTCourseInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTProcessInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTStudentInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTTeacherInfo;
import cn.redcdn.datacenter.sptcenter.data.TeacherInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetStudentDetail extends MDSAbstractBusinessData<SPTStudentInfo> {
    //获取学生专培信息
    //
    /**
     *
     * @param baseId
     * @param token
     * @param nube
     */

    public void getStudentDetail(String baseId,String token,String nube){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("nube",nube);
        }catch (Exception e){

        }

      exec(ConstConfig.getSptCenterUrl()+ ConstConfig.SPT_STUDENT_DETAIL,jsonObject.toString());

    }
    protected SPTStudentInfo parseContentBody(JSONObject jo){
        SPTStudentInfo studentInfo = new SPTStudentInfo();
        studentInfo.dataJson = jo;
        if (jo !=null){
            JSONObject data = jo.optJSONObject("data");
            if(data != null){
                studentInfo.logFinishedRate = data.optString("rate");
                studentInfo.totaldays = data.optString("planTrainDate");
                studentInfo.finishedDays = data.optString("trainedDate");
                studentInfo.diseaseRecord = data.optString("diseases");
                studentInfo.clinicalRecord = data.optString("clinicals");
                studentInfo.otherRecord = data.optString("others");
                studentInfo.name = data.optString("name");
                studentInfo.serialNumber = data.optString("student_no");
                studentInfo.teacherName = data.optString("teacher");
                studentInfo.trainingBase = data.optString("hosp_name");
                studentInfo.sptTime = data.optString("trainDate");
                studentInfo.sptProfessional = data.optString("profession_name");
                studentInfo.nube = data.optString("nube");
                studentInfo.headUrl = data.optString("head_url");
                studentInfo.state = data.optString("state");
                studentInfo.sex = data.optString("sex");
                studentInfo.proTrainName = data.optString("proTrainName");
                JSONArray depts = data.optJSONArray("subjects");
                if (depts!=null){
                    for (int i = 0;i<depts.length();i++){
                        JSONObject tmpJson = depts.optJSONObject(i);
                        SPTCourseInfo courseInfo = new SPTCourseInfo();
                        if (tmpJson!=null){
                            courseInfo.courseId = tmpJson.optString("bid");
                            courseInfo.courseName = tmpJson.optString("name");
                            courseInfo.learnGoals = tmpJson.optString("purpose");
                            courseInfo.finishedDR = tmpJson.optString("finishDisease");
                            courseInfo.totalDR = tmpJson.optString("allDisease");
                            courseInfo.finishedCR = tmpJson.optString("finishClinical");
                            courseInfo.totalCR = tmpJson.optString("allClinical");
                            courseInfo.finisedOR = tmpJson.optString("finishOther");
                            courseInfo.totalOR = tmpJson.optString("allOther");
                            courseInfo.isTraining = tmpJson.optString("isTraining");
                        }
                     studentInfo.courseInfos.add(courseInfo);
                    }
                }
                JSONArray schedules = data.optJSONArray("depts");
                if (schedules !=null){
                 for (int i = 0;i<schedules.length();i++){
                     JSONObject tmpJson = schedules.optJSONObject(i);
                     SPTProcessInfo processInfo = new SPTProcessInfo();
                     if (tmpJson!=null){
                         processInfo.courseName = tmpJson.optString("department_name");
                         processInfo.sptTime = tmpJson.optString("trainDatePeriod");
                         processInfo.lsgivenTime = tmpJson.optString("outDate");
                         processInfo.isGivened = tmpJson.optString("isOut");
                         processInfo.processStaus = tmpJson.optString("trainState");
                     }
                     studentInfo.processInfos.add(processInfo);
                 }
                }
                JSONArray teachers = data.optJSONArray("teachers");
                if (teachers !=null){
                    for (int i = 0;i<teachers.length();i++){
                        JSONObject tmpJson = teachers.optJSONObject(i);
                        TeacherInfo teacherInfo = new TeacherInfo();
                        if (tmpJson!=null){
                            teacherInfo.headUrl = tmpJson.optString("head_url");
                            teacherInfo.name = tmpJson.optString("name");
                            teacherInfo.role = tmpJson.optString("role");
                            teacherInfo.nube = tmpJson.optString("nube");
                            teacherInfo.courseName = tmpJson.optString("dept");
                            teacherInfo.baseId = tmpJson.optString("baseId");
                        }
                        studentInfo.teacherInfos.add(teacherInfo);
                    }
                }
            }
        }
       return studentInfo;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
