package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTTeacherInfo;
import cn.redcdn.datacenter.sptcenter.data.StudentInfo;
import cn.redcdn.datacenter.sptcenter.data.TeacherInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetTeacherDetail extends MDSAbstractBusinessData<SPTTeacherInfo>{
    //获取老师专培信息

    public void getTeacherDetail(String token,String nube,String baseId){
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("nube",nube);
        }catch (Exception e){

        }

        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_TEACHER_DETAIL,jsonObject.toString());

    }

    protected SPTTeacherInfo parseContentBody(JSONObject jo){
       SPTTeacherInfo info = new SPTTeacherInfo();
       info.dataJson = jo;
       if (jo!=null){
           JSONObject data = jo.optJSONObject("data");
           if (data!=null){
               info.auditingNum = data.optString("auditingNum");
               info.auditedNum = data.optString("auditedNum");
               info.diseases = data.optString("diseases");
               info.clinicals = data.optString("clinicals");
               info.others = data.optString("others");
               info.name = data.optString("name");
               info.sex = data.optString("sex");
               info.role = data.optString("role");
               info.trainBase = data.optString("trainBase");
               info.trainMajor = data.optString("tainMajor");
               info.nube = data.optString("nube");
               info.headUrl = data.optString("headurl");
               JSONArray students = data.optJSONArray("students");
               if (students!=null){
                   for (int i = 0;i<students.length();i++){
                       JSONObject tmpJson = students.optJSONObject(i);
                       StudentInfo student = new StudentInfo();
                       if (tmpJson!=null){
                           student.headUrl = tmpJson.optString("headUrl");
                           student.name = tmpJson.optString("name");
                           student.dept = tmpJson.optString("dept");
                           student.logRate = tmpJson.optString("logRate");
                           student.nube = tmpJson.optString("nube");
                           student.baseId = tmpJson.optString("baseId");
                       }
                       info.students.add(student);
                   }
               }
           }
       }
       return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
