package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTBaseInfo;
import cn.redcdn.datacenter.sptcenter.data.SPTUserInfo;

/**
 * Created by caizx on 2018/7/17.
 */

public class SPTGetUserInfo extends MDSAbstractBusinessData<SPTUserInfo> {

    //获取用户信息
    public void getUserInfo(String token,String nube){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("nube",nube);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_USER_INFO,jsonObject.toString());
    }

    protected SPTUserInfo parseContentBody(JSONObject jo){
        SPTUserInfo info = new SPTUserInfo();
        if (jo!=null){
            JSONObject data = jo.optJSONObject("data");
            if (data!=null){
                info.num = data.optString("num");
                info.trainDate = data.optString("trainDate");
                JSONArray arr = data.optJSONArray("bases");
                if (arr!=null){
                   for (int i = 0;i<arr.length();i++){
                       JSONObject baseJson = arr.optJSONObject(i);
                       SPTBaseInfo baseInfo = new SPTBaseInfo();
                       if (baseJson!=null){
                           baseInfo.baseName = baseJson.optString("baseName");
                           baseInfo.baseId = baseJson.optString("baseId");
                       }
                   }
                }
            }
        }
        return info;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}
