package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTNoramlInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTGetWaittingAuditLogList extends MDSAbstractBusinessData<List<SPTNoramlInfo>> {

    //获取待审核列表

    public void getWaitingAuditLogList(String token,String baseId){

        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
        }catch (Exception e){

        }
        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_GET_WAITTING_LIST,jsonObject.toString());
    }

    protected List<SPTNoramlInfo> parseContentBody(JSONObject jo){

        List<SPTNoramlInfo> infos = new ArrayList<>();
        if (jo!=null){
            JSONArray array = jo.optJSONArray("data");
            if (array!=null){
                for (int i = 0;i<array.length();i++){
                    JSONObject jsonObject = array.optJSONObject(i);
                    SPTNoramlInfo info = new SPTNoramlInfo();
                    if (jsonObject!=null){
                        info.isChecked = jsonObject.optString("auditState");
                        info.nowAudit = jsonObject.optString("nowAudit");
                        info.patientName = jsonObject.optString("patient");
                        info.diseaseName = jsonObject.optString("logName");
                        info.studentName = jsonObject.optString("student");
                        info.auditTime = jsonObject.optString("taskTime");
                        info.logId = jsonObject.optString("logId");
                        info.taskType = jsonObject.optString("logTypeId");
                        info.departName = jsonObject.optString("rotateSubject");

                    }
                    infos.add(info);
                }
            }
        }
     return  infos;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }


}
