package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateAuditInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateWaitAuditInfo;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTSubmitAudit extends MDSAbstractBusinessData<JSONObject>{

    //提交审核结果（非批量）

    public void submitAudit(String token, SPTTemplateWaitAuditInfo auditInfos){

        JSONObject jsonObject = new JSONObject();

        JSONArray auditDetail = new JSONArray();

        JSONObject data = new JSONObject();

        try {
            jsonObject.put("token",token);
            if (auditInfos!=null){
                        data.put("logId",auditInfos.logId);
                        data.put("auditTempId",auditInfos.auditTempId);
                        for (int j = 0;j<auditInfos.auditInfos.size();j++){
                            SPTTemplateAuditInfo auditInfo = auditInfos.auditInfos.get(j);
                            JSONObject tmpJson1 = new JSONObject();
                            if (auditInfo != null){
                                tmpJson1.put("tempKeyType",auditInfo.templateAuditType);
                                tmpJson1.put("tempKeyId",auditInfo.templateAuditId);
                                tmpJson1.put("tempKeyName",auditInfo.templateAuditName);
                                tmpJson1.put("defaultValue",auditInfo.templateAuditDefaultValue);
                                tmpJson1.put("showName",auditInfo.showName);
                                tmpJson1.put("tip",auditInfo.tempKeyTip);
                                tmpJson1.put("tempKeyValue",auditInfo.temlateAuditValue);
                            }
                            auditDetail.put(tmpJson1);
                    }
                data.put("auditDetail",auditDetail);
            }
            jsonObject.put("data",data);

        }catch (Exception e){

        }

        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_SUBMIT_AUDIT,jsonObject.toString());
    }

    //提交批量审核结果
    public void submitBatchAudit(String token, SPTTemplateWaitAuditInfo auditInfos){

        JSONObject jsonObject = new JSONObject();

        JSONArray auditDetail = new JSONArray();

        JSONObject data = new JSONObject();

        try {
            jsonObject.put("token",token);
            if (auditInfos!=null){
                data.put("logIds",auditInfos.logId);
                data.put("auditTempId",auditInfos.auditTempId);
                for (int j = 0;j<auditInfos.auditInfos.size();j++){
                    SPTTemplateAuditInfo auditInfo = auditInfos.auditInfos.get(j);
                    JSONObject tmpJson1 = new JSONObject();
                    if (auditInfo != null){
                        tmpJson1.put("tempKeyType",auditInfo.templateAuditType);
                        tmpJson1.put("tempKeyId",auditInfo.templateAuditId);
                        tmpJson1.put("tempKeyName",auditInfo.templateAuditName);
                        tmpJson1.put("defaultValue",auditInfo.templateAuditDefaultValue);
                        tmpJson1.put("showName",auditInfo.showName);
                        tmpJson1.put("tip",auditInfo.tempKeyTip);
                        tmpJson1.put("tempKeyValue",auditInfo.temlateAuditValue);
                    }
                    auditDetail.put(tmpJson1);
                }
                data.put("auditDetail",auditDetail);
            }
            jsonObject.put("data",data);

        }catch (Exception e){

        }

        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_SUBMIT_BATCH_AUDIT,jsonObject.toString());
    }





    protected JSONObject parseContentBody(JSONObject jo){
        return jo;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
