package cn.redcdn.datacenter.sptcenter;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.medicalcenter.MDSAbstractBusinessData;
import cn.redcdn.datacenter.medicalcenter.MedicalParser;
import cn.redcdn.datacenter.sptcenter.data.SPTSubmitReturnInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateAuditInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateBaseInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateInfo;
import cn.redcdn.datacenter.sptcenter.data.template.SPTTemplateOptionalInfo;
import cn.redcdn.log.CustomLog;

/**
 * Created by caizx on 2018/7/11.
 */

public class SPTSubmitLog extends MDSAbstractBusinessData<List<SPTSubmitReturnInfo>>{
    private String TAG = getClass().getName();

    //提交日志接口
    public void submit(String token,String baseId,String logType,String logId,List<SPTTemplateBaseInfo> bases, List<SPTTemplateInfo> infos){

        JSONObject jsonObject = new JSONObject();

        JSONArray logs = new JSONArray();

         JSONArray baseArr = new JSONArray();
        try{
            jsonObject.put("token",token);
            jsonObject.put("baseId",baseId);
            jsonObject.put("logTypeId",logType);
            if (bases!=null){
                for (int i= 0;i<bases.size();i++){
                    SPTTemplateBaseInfo info = bases.get(i);
                    JSONObject tmpJson = new JSONObject();
                    tmpJson.put("tempKeyType",info.templateType);
                    tmpJson.put("tempKeyId",info.templateId);
                    tmpJson.put("tempKeyName",info.templateName);
                    tmpJson.put("defaultValue",info.defaultValue);
                    tmpJson.put("showName",info.showName);
                    tmpJson.put("tip",info.tempKeyTip);
                    tmpJson.put("tempKeyValue",info.templateValue);
                    baseArr.put(tmpJson);
                }
                jsonObject.put("baseInfo",baseArr);
            }


            if (infos!=null){
                for(int i= 0;i<infos.size();i++){
                    SPTTemplateInfo info = infos.get(i);
                    JSONObject tmpJson = new JSONObject();
                    tmpJson.put("logStandardId",info.logNormalId);
                    tmpJson.put("logStandardName",info.logNormalName);
                    tmpJson.put("logId",logId);
                    JSONArray baseExtraArr = new JSONArray();
                    for (int n = 0;n<info.baseExtraInfos.size();n++){

                        JSONObject jsonObject1 = new JSONObject();
                        SPTTemplateBaseInfo baseInfo1 = info.baseExtraInfos.get(n);
                        jsonObject1.put("tempKeyId",baseInfo1.templateId);
                        jsonObject1.put("tempKeyType",baseInfo1.templateType);
                        jsonObject1.put("tempKeyName",baseInfo1.templateName);
                        jsonObject1.put("defaultValue",baseInfo1.defaultValue);
                        jsonObject1.put("showName",baseInfo1.showName);
                        jsonObject1.put("tip",baseInfo1.tempKeyTip);
                        jsonObject1.put("tempKeyValue",baseInfo1.templateValue);
                        baseExtraArr.put(jsonObject1);

                    }
                       tmpJson.put("baseinfoExtra",baseExtraArr);

                    JSONArray logContent = new JSONArray();
                    for (int j = 0;j<info.baseInfos.size();j++){
                        SPTTemplateBaseInfo baseInfo = info.baseInfos.get(j);
                        JSONObject baseJson = new JSONObject();
                        if (baseInfo!=null){
                            baseJson.put("tempKeyId",baseInfo.templateId);
                            baseJson.put("tempKeyType",baseInfo.templateType);
                            baseJson.put("tempKeyName",baseInfo.templateName);
                            baseJson.put("defaultValue",baseInfo.defaultValue);
                            baseJson.put("showName",baseInfo.showName);
                            baseJson.put("tip",baseInfo.tempKeyTip);
                            baseJson.put("tempKeyValue",baseInfo.templateValue);
                        }
                        logContent.put(baseJson);
                    }
                    tmpJson.put("logContent",logContent);
                    JSONArray audits = new JSONArray();
                    for (int m = 0;m<info.auditInfos.size();m++){
                        SPTTemplateAuditInfo auditInfo = info.auditInfos.get(m);
                        JSONObject auditJson = new JSONObject();
                        if (auditInfo != null){
                            auditJson.put("roleId",auditInfo.roleBussinessId);
                            auditJson.put("tempKeyId",auditInfo.templateAuditId);
                            auditJson.put("tempKeyType",auditInfo.templateAuditType);
                            auditJson.put("tempKeyName",auditInfo.templateAuditName);
                            auditJson.put("defaultValue",auditInfo.defaultId);
                            auditJson.put("tip",auditInfo.tempKeyTip);
                            auditJson.put("showName",auditInfo.showName);
                            JSONArray userArr = new JSONArray();
                            for (int j = 0;j<auditInfo.optionalInfos.size();j++){
                                JSONObject userJson = new JSONObject();
                                SPTTemplateOptionalInfo optionalInfo = auditInfo.getOptionalInfos().get(j);
                                userJson.put("userId",optionalInfo.getOptionalId());
                                userJson.put("userName",optionalInfo.getOptialName());
                                userJson.put("dept",optionalInfo.getOptionalDepart());
                                userArr.put(userJson);
                            }
                            auditJson.put("selectUser",userArr);
                        }
                        audits.put(auditJson);
                    }
                    tmpJson.put("audits",audits);
                    logs.put(tmpJson);
                }
            }
            jsonObject.put("data",logs);
        }catch (Exception e){

        }

        exec(ConstConfig.getSptCenterUrl()+ConstConfig.SPT_SUBMIT_LOG,jsonObject.toString());

    }

    protected List<SPTSubmitReturnInfo> parseContentBody(JSONObject jo){
        List<SPTSubmitReturnInfo> returnInfoList = new ArrayList<>();
        if (jo!=null){
            CustomLog.d(TAG,"parseContentBody begin");
            JSONArray data = jo.optJSONArray("data");
            if (data!=null){
                for (int m = 0;m<data.length();m++){
                    SPTSubmitReturnInfo info = new SPTSubmitReturnInfo();

                    JSONObject userJson = data.optJSONObject(m);
                    info.logId = userJson.optString("logId");
                    info.logNormId = userJson.optString("logStandardId");

                    returnInfoList.add(info);
                }
            }
            CustomLog.d(TAG,"parseContentBody end");
        }
        return returnInfoList;
    }
    protected Parser getParser(){
        return new MedicalParser();
    }

}
