package cn.redcdn.datacenter.sptcenter.data;

import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by caizx on 2018/7/11.
 */
 //返回原始数据

public class SPTStudentInfo {
    public  String totaldays;     //培训总天数
    public  String finishedDays;  //已完成培训天数
    public  String diseaseRecord; //病种记录
    public  String clinicalRecord;//临床操作记录
    public  String otherRecord; //其他记录
    public  String name; //学员名称
    public  String serialNumber;//学员编号
    public  String teacherName; //指导老师
    public  String trainingBase;//培训基地
    public  String sptTime;//专培时间
    public  String sptProfessional; //专培专业
    public  String nube; //视讯号
    public  String headUrl;//头像地址
    public  String logFinishedRate; //日志完成率
    public String state;//学员状态
    public String sex;//性别
    public String proTrainName;//专培计划

    public List<SPTCourseInfo> courseInfos; //专培科室列表
    public List<SPTProcessInfo> processInfos; //学习进度列表
    public List<TeacherInfo> teacherInfos;//指导老师列表

    //缓存json
    public JSONObject dataJson;
    public SPTStudentInfo(){
        logFinishedRate = "";
        totaldays = "";
        finishedDays = "";
        diseaseRecord = "";
        clinicalRecord = "";
        otherRecord = "";
        name = "";
        serialNumber = "";//学员编号
        teacherName = ""; //指导老师
        trainingBase = "";//培训基地
        sptTime = "";//专培时间
        sptProfessional = ""; //专培专业
        nube = ""; //视讯号
        headUrl = "";//头像地址

        state="";//学员状态
        sex="";//性别
        proTrainName="";//专培计划

        courseInfos = new ArrayList<>(); //专培科室列表
        processInfos = new ArrayList<>(); //学习进度列表
        teacherInfos = new ArrayList<>();//指导老师列表
        dataJson = new JSONObject();
    }


    public JSONObject getDataJson() {
        return dataJson;
    }

    public void setDataJson(JSONObject dataJson) {
        this.dataJson = dataJson;
    }

    public String getLogFinishedRate() {
        return logFinishedRate;
    }

    public void setLogFinishedRate(String logFinishedRate) {
        this.logFinishedRate = logFinishedRate;
    }

    public String getTotaldays() {
        return totaldays;
    }

    public void setTotaldays(String totaldays) {
        this.totaldays = totaldays;
    }

    public String getFinishedDays() {
        return finishedDays;
    }

    public void setFinishedDays(String finishedDays) {
        this.finishedDays = finishedDays;
    }

    public String getDiseaseRecord() {
        return diseaseRecord;
    }

    public void setDiseaseRecord(String diseaseRecord) {
        this.diseaseRecord = diseaseRecord;
    }

    public String getClinicalRecord() {
        return clinicalRecord;
    }

    public void setClinicalRecord(String clinicalRecord) {
        this.clinicalRecord = clinicalRecord;
    }

    public String getOtherRecord() {
        return otherRecord;
    }

    public void setOtherRecord(String otherRecord) {
        this.otherRecord = otherRecord;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSerialNumber() {
        return serialNumber;
    }

    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public String getTrainingBase() {
        return trainingBase;
    }

    public void setTrainingBase(String trainingBase) {
        this.trainingBase = trainingBase;
    }

    public String getSptTime() {
        return sptTime;
    }

    public void setSptTime(String sptTime) {
        this.sptTime = sptTime;
    }

    public String getSptProfessional() {
        return sptProfessional;
    }

    public void setSptProfessional(String sptProfessional) {
        this.sptProfessional = sptProfessional;
    }

    public String getNube() {
        return nube;
    }

    public void setNube(String nube) {
        this.nube = nube;
    }

    public String getHeadUrl() {
        return headUrl;
    }

    public void setHeadUrl(String headUrl) {
        this.headUrl = headUrl;
    }

    public List<SPTCourseInfo> getCourseInfos() {
        return courseInfos;
    }

    public void setCourseInfos(List<SPTCourseInfo> courseInfos) {
        this.courseInfos = courseInfos;
    }

    public List<SPTProcessInfo> getProcessInfos() {
        return processInfos;
    }

    public void setProcessInfos(List<SPTProcessInfo> processInfos) {
        this.processInfos = processInfos;
    }

    public List<TeacherInfo> getTeacherInfos() {
        return teacherInfos;
    }

    public void setTeacherInfos(List<TeacherInfo> teacherInfos) {
        this.teacherInfos = teacherInfos;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    public String getProTrainName() {
        return proTrainName;
    }

    public void setProTrainName(String proTrainName) {
        this.proTrainName = proTrainName;
    }

    //提供解析Json 的方法
    public static SPTStudentInfo analyze(JSONObject jo){

        SPTStudentInfo studentInfo = new SPTStudentInfo();
        if (jo !=null){
            JSONObject data = jo.optJSONObject("data");
            if(data != null){
                studentInfo.logFinishedRate = data.optString("");
                studentInfo.totaldays = data.optString("planTrainDate");
                studentInfo.finishedDays = data.optString("trainedDate");
                studentInfo.diseaseRecord = data.optString("diseases");
                studentInfo.clinicalRecord = data.optString("clinicals");
                studentInfo.otherRecord = data.optString("others");
                studentInfo.name = data.optString("name");
                studentInfo.serialNumber = data.optString("no");
                studentInfo.teacherName = data.optString("teacher");
                studentInfo.trainingBase = data.optString("trainBase");
                studentInfo.sptProfessional = data.optString("tainMajor");
                studentInfo.sptTime = data.optString("trainDate");
                studentInfo.nube = data.optString("nube");
                studentInfo.headUrl = data.optString("headurl");
                JSONArray depts = data.optJSONArray("depts");
                if (depts!=null){
                    for (int i = 0;i<depts.length();i++){
                        JSONObject tmpJson = depts.optJSONObject(i);
                        SPTCourseInfo courseInfo = new SPTCourseInfo();
                        if (tmpJson!=null){
                            courseInfo.courseId = tmpJson.optString("subjectid");
                            courseInfo.courseName = tmpJson.optString("subjectname");
                            courseInfo.totalCR = tmpJson.optString("allClinical");
                            courseInfo.totalDR = tmpJson.optString("allDisease");
                            courseInfo.totalOR = tmpJson.optString("allOther");
                            courseInfo.finisedOR = tmpJson.optString("finishOther");
                            courseInfo.finishedCR = tmpJson.optString("finishClinical");
                            courseInfo.finishedDR = tmpJson.optString("finishDisease");
                            courseInfo.isTraining = tmpJson.optString("isTraining");
                            courseInfo.learnGoals = tmpJson.optString("purpose");
                        }
                        studentInfo.courseInfos.add(courseInfo);
                    }
                }
                JSONArray schedules = data.optJSONArray("schedules");
                if (schedules !=null){
                    for (int i = 0;i<schedules.length();i++){
                        JSONObject tmpJson = schedules.optJSONObject(i);
                        SPTProcessInfo processInfo = new SPTProcessInfo();
                        if (tmpJson!=null){
                            processInfo.courseName = tmpJson.optString("deptname");
                            processInfo.sptTime = tmpJson.optString("trainDatePeriod");
                            processInfo.isGivened = tmpJson.optString("isOut");
                            processInfo.processStaus = tmpJson.optString("trainState");
                            processInfo.lsgivenTime = tmpJson.optString("outDate");
                        }
                        studentInfo.processInfos.add(processInfo);
                    }
                }
                JSONArray teachers = data.optJSONArray("teachers");
                if (teachers !=null){
                    for (int i = 0;i<teachers.length();i++){
                        JSONObject tmpJson = teachers.optJSONObject(i);
                        TeacherInfo teacherInfo = new TeacherInfo();
                        if (tmpJson!=null){
                            teacherInfo.courseName = tmpJson.optString("subject");
                            teacherInfo.headUrl = tmpJson.optString("headUrl");
                            teacherInfo.name = tmpJson.optString("name");
                            teacherInfo.nube = tmpJson.optString("nube");
                            teacherInfo.role = tmpJson.optString("role");
                        }
                        studentInfo.teacherInfos.add(teacherInfo);
                    }
                }
            }
        }
        return studentInfo;
    }


}
