package cn.redcdn.datacenter.usercenter;

import org.json.JSONException;
import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.datacenter.meetingmanage.data.ResponseEmpty;
import cn.redcdn.log.CustomLog;

public abstract class SendCodeForResetPwd extends
		AbstractBusinessData<ResponseEmpty> {
	private String tag = SendCodeForResetPwd.class.getName();
  /**
   * ProductType_SPSY: 视频兽医
   */
  public static final String ProductType_SPSY = "spsy";
  /**
   * ProductType_HVS: 红云医疗
   */
  public static final String ProductType_HVS = "hvs";
  /**
	 * ProductType_JHY: 极会议
	 * 
	 */
	public static final String  ProductType_JHY = "JHY_MOBILE";
	/**
	 * ProductType_ZGHY:紫光红云 
	 */
	public static final String  ProductType_ZGHY = "zghy";
  
  
  
	/**
	 * 发送重置密码验证码接口。返回结果码。对应《个人用户中心接口文档》1.6.8
	 * 
	 * @param account
	 *            帐号
	 * @param productId
	 *            "prod002"
	 * 
	 * @return -1 : 表示无效的操作，当前操作正在执行; -2: 表示无效的编码; -3: 表示json操作异常
	 */
	public int sendCodeForResetPwd(String account, String productId) {
		CustomLog.i(tag, "usercenter SendCodeForResetPwd, account:" + account
				+ "productId:" + productId);

		JSONObject json = new JSONObject();
		try {
			json.put(ConstConfig.ACCOUNT, account);
			json.put(ConstConfig.PRODUCTID, productId);
		} catch (JSONException e) {
			return -3;
		}
		  //转义特殊字符   % --> %25
		String jsonString = java.net.URLEncoder.encode(json.toString());
		return exec(
				ConstConfig.getSendCodeForResetPwd(),
				ConstConfig.PARAM_USERCNTER_SENDCODEFORRESETPWD
						+ jsonString);
	}

	/**
	 * 增加productType参数，提供给手机版hvs 项目
	 * @param account
	 * @param productId
	 * @param productType
	 * @return
	 */
	 public int sendCodeForResetPwd(String account, String productId,String productType) {
	    CustomLog.i(tag, "usercenter SendCodeForResetPwd, account:" + account
	        + "productId:" + productId);

	    JSONObject json = new JSONObject();
	    try {
	    	if (ConstConfig.getNeedtoaddAppkey()) {
				json.put(ConstConfig.ACCOUNT,ConstConfig.getAccount(account, ConstConfig.getAppkey()));
			}else {
				json.put(ConstConfig.ACCOUNT, account);
			}
	      json.put(ConstConfig.PRODUCTID, productId);
	      json.put(ConstConfig.PARAM_PRODUCTYPE, productType);
	    } catch (JSONException e) {
	      return -3;
	    }
		  //转义特殊字符   % --> %25
		String jsonString = java.net.URLEncoder.encode(json.toString());
	    return exec(
	        ConstConfig.getSendCodeForResetPwd(),
	        ConstConfig.PARAM_USERCNTER_SENDCODEFORRESETPWD
	            + jsonString);
	  }

	public int sendCodeForResetPwdUser(String account, String productId,String productType) {
		CustomLog.i(tag, "usercenter sendCodeForResetPwdUser, account:" + account
				+ "productId:" + productId);

		JSONObject json = new JSONObject();
		try {
			if (ConstConfig.getNeedtoaddAppkey()) {
				json.put(ConstConfig.ACCOUNT,ConstConfig.getAccount(account, ConstConfig.getAppkey()));
			}else {
				json.put(ConstConfig.ACCOUNT, account);
			}
			json.put(ConstConfig.PRODUCTID, productId);
			json.put(ConstConfig.PARAM_PRODUCTYPE, productType);
		} catch (JSONException e) {
			return -3;
		}
		//转义特殊字符   % --> %25
		String jsonString = java.net.URLEncoder.encode(json.toString());
		return exec(
				ConstConfig.getSendCodeForResetPwd(),
				ConstConfig.PARAM_USERCNTER_SENDCODEFORRESETPWDUSER
						+ jsonString);
	}
	 /**
	  * 
	  * 
	  */
	 
	 
	 
	protected Parser getParser() {
		return new UserCenterParse();
	}
}
