package cn.redcdn.datacenter.usercenter;

import android.text.TextUtils;

import org.json.JSONObject;

import cn.redcdn.datacenter.AbstractBusinessData;
import cn.redcdn.datacenter.BaseClass.AbstractBusinessDataBothSeq;
import cn.redcdn.datacenter.InvalidateResponseException;
import cn.redcdn.datacenter.Parser;
import cn.redcdn.datacenter.config.ConstConfig;
import cn.redcdn.log.CustomLog;


public abstract class VerifyToken extends AbstractBusinessDataBothSeq<Boolean> {
    private String tag = VerifyToken.class.getName();

    public Boolean verifyTokenSync(String accessToken) {
        CustomLog.i(tag, "usercenter verifyTokenSync");
        if (accessToken == null || accessToken.equals("")) {
            CustomLog.e(tag, " accessToken不能为空");
        }
        if (TextUtils.isEmpty(ConstConfig.slavePersonalUserCenterWebDomain)) {
            return execSyncEncode(ConstConfig.getVerifyTokenUrl(), "",
                    ConstConfig.PARAM_VERIFYTOKEN + accessToken);
        }
        return execSyncEncode(ConstConfig.getVerifyTokenUrl(), ConstConfig.getSlaveVerifyTokenUrl(),
                ConstConfig.PARAM_VERIFYTOKEN + accessToken);
    }

    protected Boolean parseContentBody(JSONObject jo)
            throws InvalidateResponseException {

        if (jo == null) {
            CustomLog.e(tag, "usercenter verifyTokenSync invalidate reponse");
            throw new InvalidateResponseException();
        }
        CustomLog.d(tag, jo.toString());

        if (jo.optString("status").equals("0")) {
            CustomLog.d(tag, "usercenter verifyTokenSync,Token有效");
            return jo.optBoolean("isValid");
        } else if (jo.optString("status").equals("-201")) {
            CustomLog.e(tag, "usercenter verifyTokenSync,Token无效, Return = " + jo.optBoolean("isValid"));
            return jo.optBoolean("isValid");
        } else {
            CustomLog.e(tag, "usercenter verifyTokenSync,接口调用异常, Return =" + jo.optBoolean("isValid"));
            return jo.optBoolean("isValid");
        }

    }


    protected Parser getParser() {
        return new UserCenterParse();
    }

}