package cn.redcdn.datacenter.versionupdate;

import org.json.JSONException;
import org.json.JSONObject;
import cn.redcdn.datacenter.Parser;

public class CheckAppInstallParser implements Parser {

  protected int rc;
  protected String rd;
  protected JSONObject body;

  @Override
  public int getHeaderValue() {
    return rc;
  }

  @Override
  public String getHeaderText() {
    return rd;
  }

  @Override
  public JSONObject getBody() {
    return body;
  }

  @Override
  public void parse(String content) {
    try {
      JSONObject joContent = new JSONObject(content);
      JSONObject resultObject = joContent.getJSONObject("result");
      rc = resultObject.getInt("rc");
      rd = resultObject.getString("rd");
      body = joContent.getJSONObject("response");
    } catch (JSONException e) {
      rc = -1;
      rd = "数据异常,请重试!";
    }
  }

  @Override
  public boolean isOk() {
    return (rc == 1 || rc == 0);
  }
}
