package cn.redcdn.dep;

public class MeetingHostAgentJNI {

	public static native void LoadBreakpad();

	public static native void LoadBreakpad2(String dumpDir);

	public static native int Start(String accounted, String localip,
			int localport, String localCmdIp, int localCmdPort, String UICmdIp,
			int UICmdPort, String rcAddr, String logConfPath, String logOutPath);

	/**
	 * 
	 * @param accounted
	 *            ： 视讯号
	 * @param localip
	 *            ： 本机ip地址
	 * @param localport
	 *            ： agent与服务器通信的端口地址
	 * @param localCmdIp
	 *            ： agent接收UI命令的地址： 127.0.0.1
	 * @param localCmdPort
	 *            ： agent接收UI命令的端口，该端口实际上由agent返回，用于UI向这个端口发送UDP命令
	 * @param UICmdIp
	 *            ： UI接收agent命令的地址：127.0.0.1
	 * @param UICmdPort
	 *            ： UI接收agent命令的端口，UI保持对这个端口的监听，用于agent向这个端口发送UDP命令
	 * @param rcAddr
	 *            ： rc地址
	 * @param logConfPath
	 *            ： 配置文件地址
	 * @param logOutPath
	 *            ： 日志输出地址
	 * @param token
	 * @return
	 */
	public static native int Start2(String accounted, String localip,
			int localport, String localCmdIp, int localCmdPort, String UICmdIp,
			int UICmdPort, String rcAddr, String logConfPath,
			String logOutPath, String token);

	public static native String getRecommendMsgAbstract(String contactlistid);

	public static native String getRecommendMsgDetail(String contactlistid);

	public static native int deleteRecommendMsg(String contactlistid);

	public static native int deleteRecommendMsgRecord(String contactlistid);

	public static native int Stop();

	/*
	 * 初始化P2PConn对象 (在start返回成功之后调用)
	 * 
	 * @param accountId: 本地视讯号
	 * 
	 * @param cb: 回调对象
	 */
	public static native int initP2PConn(String accountId, P2PConnCBInterface cb);

	/*
	 * 释放P2PConn对象 (在stop之前调用)
	 * 
	 * @param accountId: 本地视讯号
	 */
	public static native int unInitP2PConn(String accountId);

	/*
	 * 发送P2P透传数据 (initP2PConn之后调用)
	 * 
	 * @param accountId: 本地视讯号
	 * 
	 * @param destAccountId: 目标视讯号
	 * 
	 * @param data: 数据内容
	 * 
	 * @param context: 上下文参数
	 */
	public static native int sendP2PConnData(String accountId,
			String destAccountId, String data, long context);

	/*
	 * IP映射接口
	 * 
	 * @param IPPortmap :json格式字符串
	 * "{"ip:port":"ip2:port2","ip3:port3":"ip4:port4"}"
	 */
	public static native int UpdateIPPortMap(String IPPortmap);

	static {
		System.loadLibrary("litezip");
//		System.loadLibrary("breakpad");
		System.loadLibrary("logwriter");
		System.loadLibrary("mhostclient");
	}
}
