package cn.redcdn.log;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Timer;

import org.json.JSONObject;

import cn.redcdn.datacenter.logMonitor.GetUuid;
import cn.redcdn.datacenter.logMonitor.SubmitLog;


import android.R.integer;
import android.R.string;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Build;
import android.os.Environment;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;

/**
 * 
 * 带日志文件输入的，又可控开关的日志调试
 * 
 * 
 */

@SuppressLint("DefaultLocale")
public class CustomLog{

  private static char LOG_TYPE = 'v'; // 输入日志类型，w代表只输出告警信息等，v代表输出所有信息

  private static Boolean LOG_SWITCH = true; // 日志文件总开关

  private static SimpleDateFormat LogSdf = new SimpleDateFormat(
	      "yyyy-MM-dd HH:mm:ss.SSSZ"); 
  
  @SuppressLint("SimpleDateFormat")
  private static SimpleDateFormat logfile = new SimpleDateFormat("yyyy-MM-dd"); // 日志文件格式

  // warning info.
  // [V]：详细(Verbose)信息

  // [D]：调试(Debug)信息

  // [I]：通告(Info)信息

  // [W]：警告(Warn)信息

  // [E]：错误(Error)信息
  public static void w(String tag, String text) {

    if (LOG_TYPE == 'w' || LOG_TYPE == 'v') {
      log(tag, text, 'w');
    }

  }

  // error info.
  public static  void e(final String tag, final String text) {

    if (LOG_TYPE == 'e' || LOG_TYPE == 'v') {
      log(tag, text, 'e');
    }
  }
   
  // info info.
  public static void i(String tag, String text) {
    if (LOG_TYPE == 'i' || LOG_TYPE == 'v') {
      log(tag, text, 'i');
    }
  }

  // debug info
  public static void d( String tag, String text) {

    if (LOG_TYPE == 'd' || LOG_TYPE == 'v') {
      log(tag, text, 'd');
    }
  }

  // 详细 信息
  public static void v(String tag, String text) {

    log(tag, text, 'v');

  }

  /**
   * 
   * 根据tag, msg和等级，输出日志
   * 
   * 
   * 
   * @param tag
   * 
   * @param msg
   * 
   * @param level
   * 
   * @return void
   * 
   */

  @SuppressLint("DefaultLocale")
  private static void log(String tag, String msg, char level) {
    if (msg == null) {
      return;
    }
    if (LOG_SWITCH) {

      if ('i' == level) {

        Log.i(tag, msg);
        writeLogToCache(String.valueOf(level).toUpperCase(), tag, msg);

      } else if ('e' == level) {

        Log.e(tag, msg);
        writeLogToCache(String.valueOf(level).toUpperCase(), tag, msg);

      } else if ('w' == level) {

        Log.w(tag, msg);
        writeLogToCache(String.valueOf(level).toUpperCase(), tag, msg);

      } else if ('d' == level) {

        Log.d(tag, msg);
        if (BuildConfig.DEBUG) {
          writeLogToCache(String.valueOf(level).toUpperCase(), tag, msg);
        }
      } else {

        Log.v(tag, msg);
        writeLogToCache(String.valueOf(level).toUpperCase(), tag, msg);

      }
    }
  }

  /**
   * 
   * 打开日志文件并写入日志
   * 
   * 
   * 
   * @return
   * 
   * **/
  public static void writeLogToCache(String mylogtype, String tag,
      String content) {
   
    if (content != null && !content.equalsIgnoreCase("")) {
    	Date nowtime = new Date();
      String needWriteMessage = LogSdf.format(nowtime)+" "+mylogtype + " "
          + tag + " " + content;
      LogcatFileManager.getInstance().setMessage(needWriteMessage);
      if (mylogtype.equals("E")) {
          LogMonitor.getInstance().setMessage(needWriteMessage);
   	  }
    }

  }
  
}
