package cn.redcdn.log;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Timer;
import org.json.JSONObject;
import cn.redcdn.datacenter.logMonitor.GetUuid;
import cn.redcdn.datacenter.logMonitor.SubmitLog;
import android.os.Build;
import android.os.Environment;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Message;
import android.text.TextUtils;

public class LogMonitor {

	  private static String TAG = "LogMonitor";
	
	  private static LogMonitor INSTANCE = null;
	
	  private   String account = ""; //视讯号
	
	  private   String appkey =  ""; //appkey
	
	  private   String logurl =  ""; //上传日志的地址
	
	  private  String uuid;
	  
	  private  List<String> strList = new ArrayList<String>(); //缓冲List
	  
	  private  int count = 5; //一次上传信息条数
	  
	  private  Timer timer = new Timer();
	  
	  private  boolean isFirstError = true; //是不是第一次调用.e
	  
	  private  boolean isStopSubmit = false; //是否是退出调用
	  
	  private  String fileNube = "";
	  
	  private   HandlerThread thread;
	  
	  private  Handler mHandler;
	  
	  private  final int LIST_ADD_MSG = 1;
	  
	  private  final int LIST_DELETE_MSG = 2;
	  
	  private  final int LIST_DELETE_ALL = 3;
	  
	  private  final int MSG_ADD_LIST_CFG = 4;
	  
	  private  final int DELAY_SEND_MESSAGE = 5;
	  
	  private  String DEFAULT_FILE_NAME = "Log_uuid.txt";
	  
	  private  String NUBE_FILE_NAME = "Log_nube.txt";
	  
	  private  String DEFAULT_FILE_PATH = "/cn.redcdn.hvs/main/config/"; 
	  
	  private  final int TOTAL_LIST_COUNT = 100;
	  
	  private  boolean beInitialized = false;
	  
	  
 //创建LogMonitor单例
	  
public synchronized static LogMonitor getInstance() {
	
    if (INSTANCE == null) {
      INSTANCE = new LogMonitor();
    }
    return INSTANCE;
    
 }

private LogMonitor() {
		
}

//初始化日志上传模块
public void init(String key,String url){
		if(!TextUtils.isEmpty(key)&&!TextUtils.isEmpty(url)){
			setAppkey(key);
			setLogurl(url);
		}
		start();
		beInitialized = true;
}
    
//外部接口调用传入上传信息
public void setMessage(String message){
	
	//如果不初始化认为没有开启上传  不存入缓冲池
	if (thread != null&&beInitialized) {   		 
	 Message msg = new Message();
         msg.what = LIST_ADD_MSG;
         msg.obj = message;
         msg.arg1 = MSG_ADD_LIST_CFG;
         mHandler.sendMessage(msg);	        
      }  
	
}
	
	/**
	 * 处理error日志上传相关代码 放到子线程去执行
	 * 
	 * getuuid() 从服务器获取uuid
	 * 
	 * submitLog() 提交error日志到服务器
	 * 
	 * readSharedPreferences() 从缓存中读取uuid
	 * 
	 * writeSharedPreferences() 将uuid写入缓存
	 * 
	 *
	 */
	
private  boolean isStartSubmit(){
		  
	 if (!TextUtils.isEmpty(appkey)&&!TextUtils.isEmpty(logurl)) {
		return false;
	}
	 return true;
	 
  }
	  
	  //定时器任务 提交信息到服务器 一次提交count条 以拼接方式
 class ReadAndSubmitTask extends java.util.TimerTask{      
     public void run(){     
    	  String tmpStr = "";
    	  //每次提交count条信息 以 换行符 分割
    	    if (strList.size()>=count) {
    			//遍历 拼接
    	    	for (int i = 0; i < count; i++) {
    				//分隔符  
    	    	    if(i == 0){
    	    	    	tmpStr = strList.get(i);	
    	    	    }else {
    					tmpStr = tmpStr +"_-_"+strList.get(i);
    				}
    			}
    	    	readFile();
        	    if (TextUtils.isEmpty(uuid)) {
        			getuuid(tmpStr);
        		}else {
        			submitLog(tmpStr);
        		}
    		}else{
    			 Message msg = new Message();
		    	 msg.what = DELAY_SEND_MESSAGE;
		         mHandler.sendMessage(msg);
    		}    
      }     
  }   

	 
private   void getuuid(final String txt){
	  
	    //获取uuid
	    GetUuid getuid = new GetUuid() {
	    	@Override
	    	protected void onSuccess(String responseContent) {
	    		//获取uuid成功  将uuid存到缓存 提交errorLog
	    		uuid = responseContent;
	    		writeFile();
	    		submitLog(txt);
	    	}
	    	
	    	@Override
	    	protected void onFail(int statusCode, String statusInfo) {
	    	   //获取uuid失败
	    	CustomLog.d("CustomLog", "获取uuid失败stausCode="+statusCode+"stausInfo"+statusInfo);
	    		 Message msg = new Message();
		    	 msg.what = DELAY_SEND_MESSAGE;
		    	 mHandler.sendMessageDelayed(msg,180000);
	    	}
		};
		String deivce =	Build.MODEL;
		String os = Build.VERSION.RELEASE;
		getuid.getUUid(appkey,deivce,os,logurl);
  }
	  
private  void submitLog(String text){
		  
	     //提交日志信息
		SubmitLog submitLog = new SubmitLog() {
			@Override
			protected void onSuccess(JSONObject responseContent) {
				//提交日志信息到服务器成功
				CustomLog.d("CustomLog", "提交error日志到服务器成功!");
				//提交成功后清空前count条信息
				 if (!isStopSubmit) {
					 Message msg = new Message();
			         msg.what = LIST_DELETE_MSG;
			         mHandler.sendMessage(msg);
				}else{
					Message msg = new Message();
			         msg.what = LIST_DELETE_ALL;
			         mHandler.sendMessage(msg);
				}	 
			}
			
			@Override
			protected void onFail(int statusCode, String statusInfo) {
				//提交日志信息到服务器失败
				CustomLog.d("CustomLog", "提交error日志到服务器失败stausCode="+statusCode+"stausInfo="+statusInfo);
				//提交失败后暂停一段时间在开启上传				
				 Message msg1 = new Message();
		    	 msg1.what = DELAY_SEND_MESSAGE;
		         mHandler.sendMessageDelayed(msg1,180000);
			}
			
		};
		readNube();
		String tmpstr = account;
		if (account!=""&&tmpstr!=fileNube) {
			writeNube();
		}
		if (TextUtils.isEmpty(fileNube)) {
			fileNube = Build.MODEL;
		}
		submitLog.submitLog(appkey,uuid,fileNube,text,logurl);  
  }
	    
/*
 * start()方法
 */  
private  void start(){
	 if (thread == null) {
 		thread = new HandlerThread("Log");
 	   	 thread.start();
 	   	 mHandler = new Handler(thread.getLooper()){
 	   		 @Override
 	   		 public void handleMessage(Message msg) {
 	   			   switch (msg.what) {
 				case LIST_ADD_MSG:
 					if (strList.size()<TOTAL_LIST_COUNT) {
 						strList.add((String) msg.obj);
					} else{
						strList.remove(0);
						strList.add((String) msg.obj);
					}					
 	                if (isFirstError&&!isStartSubmit()) {
 	                	Message msg1 = new Message();
 				         msg1.what = DELAY_SEND_MESSAGE;
 				         mHandler.sendMessage(msg1); 	                
 	                	isFirstError = false;
 	            	}	 
 					break;
 			    case LIST_DELETE_MSG:
 			    	for (int i = count-1; i>=0; i--) {
 			    		strList.remove(i);
					}
 			    	 Message msg1 = new Message();
 			    	 msg1.what = DELAY_SEND_MESSAGE;
			         mHandler.sendMessage(msg1);
 			    	CustomLog.d("CustomLog", "size="+strList.size());
 			    break;
 			   case LIST_DELETE_ALL:
 				   strList.clear();
			    break;
 			   case DELAY_SEND_MESSAGE:
 				  timer.schedule(new ReadAndSubmitTask(), 3000);
 			   break;
 				default:
 					break;
 				}    
 	   		} 
 	   	 };	
		}
 }
	  
/*
 * stop()方法
 */
public void release(){
	 isStopSubmit = true;
	 String tmpStr = null;
	 if (strList.size()>0) {
   	    	for (int i = 0; i < strList.size(); i++) {
   	    	    if(i == 0){
   	    	    	tmpStr = strList.get(i);	
   	    	    }else {
   					tmpStr = tmpStr +"_-_"+strList.get(i);
   				}
   			}
   	    	readFile();
   	   	    if (TextUtils.isEmpty(uuid)) {
   	   			getuuid(tmpStr);
   	   		}else {
   	   			submitLog(tmpStr);
   	   		} 
   		}
   	    
 }
	  
	 //获取当前时间时间戳（秒）
	 
//private  String getCurrentTime_Today() {  
//    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");  
//    return sdf.format(new java.util.Date());  
//} 
	  	  
/**
  * uuid和account读写缓存
  */
	  
private  void readFile(){
    try {  
        File file = new File(Environment.getExternalStorageDirectory()+DEFAULT_FILE_PATH,  
        DEFAULT_FILE_NAME);  
            FileInputStream is = new FileInputStream(file);  
            byte[] b = new byte[is.available()];  
            is.read(b);  
            uuid = new String(b);
            is.close();
        } catch (Exception e) {  
            e.printStackTrace();  
        }  
}  
private  void writeFile(){
	 try {  
	        File file = new File(Environment.getExternalStorageDirectory()+DEFAULT_FILE_PATH,  
	                DEFAULT_FILE_NAME);  
	            FileOutputStream fos = new FileOutputStream(file);  
	            String info = uuid;  
	               fos.write(info.getBytes());  
	               fos.close();   
	    } catch (Exception e) {  
	        e.printStackTrace();  
	    }  
}
	 
private  void readNube(){
    try {  
        File file = new File(Environment.getExternalStorageDirectory()+DEFAULT_FILE_PATH,  
        NUBE_FILE_NAME);  
            FileInputStream is = new FileInputStream(file);  
            byte[] b = new byte[is.available()];  
            is.read(b);  
            fileNube = new String(b);
            is.close();
        } catch (Exception e) {  
            e.printStackTrace();  
        }  
}  
private  void writeNube(){
	 try {  
	        File file = new File(Environment.getExternalStorageDirectory()+DEFAULT_FILE_PATH,  
	                NUBE_FILE_NAME);  
	            FileOutputStream fos = new FileOutputStream(file);  
	            String info = account;  
	               fos.write(info.getBytes());  
	               fos.close();   
	    } catch (Exception e) {  
	        e.printStackTrace();  
	    }  
}

public void setAccount(String account) {
	this.account = account;
}

private void setAppkey(String appkey) {
	this.appkey = appkey;
}

private void setLogurl(String logurl) {
	this.logurl = logurl;
}
    
	
	
	
	
	
	
}
