package cn.redcdn.meeting;

public class MeetingCtrlAgent {

	/**
	 * 启动服务
	 * 
	 * @param routeURL
	 *            路由服务器地址字符串，格式为：ip:port|ip:port
	 * @param localIP
	 *            本地ip，约定为127.0.0.1，
	 * @param localPort
	 *            本地port
	 * @param targetIP
	 *            调用者使用的udp ip
	 * @param targetPort
	 *            调用者使用的udp port
	 * @param remoteCommIP
	 *            目前版本没有使用该ip，是模块自己获取的(含义为，本地与远程通信的网卡ip)
	 * @param remoteCommPort
	 *            目前版本没有使用该port
	 * 
	 * @return >0-返回stpAgent使用的udp port 其他-失败
	 */
	public final static native int Start(String routeURL, String localIP,
			int localPort, String targetIP, int targetPort,
			String remoteCommIP, int remotePort);

	/**
	 * 停止服务
	 */
	public final static native void Stop();

	/**
	 * 加载breakpad模块
	 */
	public final static native void LoadBreakpad();

	/**
	 * 设置初始化参数
	 * 
	 * @param logConfigPath
	 *            日志配置文件名（带全路径,绝对路径）
	 * @param logOutPath
	 *            日志文件保存目录（带全路径,绝对路径）
	 * @return 0-成功 其他-失败 在Start之前调用
	 */
	public static native int SetInitParam(String logcfgpath,
			String logfileoutpath);

	/**
	 * 启动插话通道
	 * 
	 * @param ChipInIP
	 *            调用者使用的udp socket ip
	 * @param ChipInPort
	 *            调用者使用的udp socket port
	 * @return 0-成功 其他-失败
	 */
	public final static native int SetChipInParam(String chipInIp,
			int chipInPort);

	/**
	 * 获取插话端口
	 * 
	 * @return >0-插话通道使用端口 其他-失败
	 */
	public final static native int GetMCAgentChipInPort();

	/**
	 * 调用者通知stpAgent摄像头为关闭状态
	 */
	public static native void CreateFFmpegProcess();

	/**
	 * 调用者通知stpAgent摄像头为打开状态
	 */
	public static native void KillFFmpegProcess();

	/**
	 * 启用轮询和推流功能
	 * 
	 * @param processName
	 *            进程名
	 * @param processAddr
	 *            ffmpeg进程所在路径，不含进程名
	 * @param pushUrl
	 *            推流地址(不含会议和用户信息)
	 */

	public static native void StartMonitorAndPushStream(String processName,
			String processAddr, String pushUrl);

	/**
	 * 启动黑盒命令通道
	 * 
	 * @param targetIP
	 *            调用者使用的udp socket ip
	 * @param targetPort
	 *            调用者使用的udp socket port
	 * 
	 * @return >0-stpAgent使用的udp socket port 其他-失败 stpAgent 使用的udp socket ip
	 *         ，是start接口传入的localIP值，从该ip和port经过的数据，则视为黑盒数据
	 */
	public static native int StartBlackPipe(String targetIP, int targetPort);

	/**
	 * 停止黑盒命令通道
	 */
	public static native void StopBlackPipe();

	/**
	 * 设置ip映射表
	 */
	public static native void UpdateIPPortMap(String IPMapStr);

	static {
		// System.loadLibrary("iconv");

//		System.loadLibrary("breakpad");

		System.loadLibrary("logwriter");
		System.loadLibrary("meetingctrlagent");
	}
}