package cn.redcdn.network.httprequest;

import java.io.UnsupportedEncodingException;

import org.apache.http.HttpResponse;
import org.apache.http.util.ByteArrayBuffer;

public abstract class GetTextHttp extends AsyncHttpGet {

	private ByteArrayBuffer textBuffer;

	@Override
	protected void onStart(int totalSize) {
		if (totalSize == -1) { // chunked
			totalSize = AsyncHttp.BUFFER_SIZE;
		}

		textBuffer = new ByteArrayBuffer(totalSize);
	}

	@Override
	protected void onReadData(byte[] buffer, int len) {
		textBuffer.append(buffer, 0, len);
	}
	
	

	@Override
	protected void onReadData(String buffer) {
		// TODO Auto-generated method stub
		
	}

	@Override
	protected void onRequestFinished(HttpResponse response) {
		try {
			onRequestFinished(response.getStatusLine().getStatusCode(),
					new String(textBuffer.buffer(), getContentCharset()));
		} catch (UnsupportedEncodingException e) {
			onRequestFailed(HttpErrorCode.HTTP_RESPONSE_INVALIDATE_ENCODING);
		}
	}

	protected abstract void onRequestFailed(int statusCode);

	protected abstract void onRequestFinished(int statusCode,
			String responseContent);
}
