package cn.redcdn.network.httprequest;

public class HttpErrorCode {
	public final static int HTTP_CLIENT_PROTOCOL_ERROR = -0x10001;
	public final static int HTTP_ILLEGAL_STATE = -0x10002;
	public final static int HTTP_CONNECT_TIMEOUT = -0x10004;
	public final static int HTTP_SOCKET_ERROR = -0x10008;
	public final static int HTTP_SOCKET_RS_TIMEOUT = -0x10010;
	public final static int HTTP_IO_EXCEPTION = -0x10020;
	public final static int HTTP_ILLEGAL_ARGUMENT = -0X10040;
	public final static int HTTP_SERVER_ERROR = -0X10080;
	public final static int HTTP_RESPONSE_INVALIDATE_LENGTH = -0X10100;
	public final static int HTTP_RESPONSE_INVALIDATE_ENCODING = -0X10200;

	/**
	 * 检查错误码是否是网络错误
	 * 
	 * @param errorCode
	 *            错误码
	 * @return true 网络错误,无法连接到服务器； false 非网络错误，服务器内部返回的出错
	 */
	public static boolean checkNetworkError(int errorCode) {
		boolean flag = false;

		switch (errorCode) {
		case HTTP_CLIENT_PROTOCOL_ERROR:
		case HTTP_ILLEGAL_STATE:
		case HTTP_CONNECT_TIMEOUT:
		case HTTP_SOCKET_ERROR:
		case HTTP_SOCKET_RS_TIMEOUT:
		case HTTP_IO_EXCEPTION:
		case HTTP_SERVER_ERROR:
			flag = true;
			break;
		default:
			flag = false;
			break;
		}

		return flag;
	}
}
