package cn.redcdn.network.httprequest;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.cert.CertificateFactory;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManagerFactory;

import cn.redcdn.log.CustomLog;

public class SynHttpRequest {

	@SuppressWarnings("unused")
	public void requestSyncWithHttps(String requestUrl, InputStream in,
			String requestMethod, String contentData) {
		try {
			StringBuffer buffer = new StringBuffer();
			CustomLog.d("requestSyncWithHttps", "<<<<<<<<< 0");
			URL url = new URL(requestUrl);
			// 1.改成s
			HttpsURLConnection conn = (HttpsURLConnection) url.openConnection();
			conn.setSSLSocketFactory(getSSLSocketFactory(in));
			conn.setHostnameVerifier(ButelHostnameVerifier.INSTANCE);
			conn.setReadTimeout(5000);
			conn.setConnectTimeout(5000);
			conn.setDoOutput(true);
			conn.setDoInput(true);
			conn.setUseCaches(false);
			conn.setInstanceFollowRedirects(true);

			conn.setRequestMethod(requestMethod);
			CustomLog.d("requestSyncWithHttps", "<<<<<<<<< 1");
			// if ("GET".equalsIgnoreCase(requestMethod)){
			conn.connect();
			// }

			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			out.writeBytes(contentData);
			out.flush();
			out.close();

			int code = conn.getResponseCode();
			CustomLog.d("requestSyncWithHttps", "<<<<<<<<< 2 code=" + code);

			if (code != 200 && code != 206) {
				CustomLog.d("requestSyncWithHttps", "<<<<<<<<< 错误:" + code);
			} else {
				InputStream inputStream = conn.getInputStream();
				CustomLog.d("requestSyncWithHttps", "<<<<<<<<< 3");
				StringBuilder sb = new StringBuilder();
				int flag;
				byte[] buf = new byte[1024];
				while ((flag = inputStream.read(buf)) != -1) {
					sb.append(new String(buf, 0, flag));
				}
				if (sb != null) {
					String s = sb.toString();
					CustomLog.d("requestSyncWithHttps", "s=" + s);
				} else {
					CustomLog.d("requestSyncWithHttps", "空");
				}
				// // 释放资源
				inputStream.close();
				inputStream = null;
				conn.disconnect();
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	// private static HttpClient okHttpClient;

	/**
	 * 获取oKHttpClient certificates 证书信息 没有就传null
	 * 
	 * @return
	 */
	// public static HttpClient getOkHttpClient(Application
	// appContext,InputStream... certificates) {
	// if (okHttpClient == null) {
	// File sdcache = appContext.getExternalCacheDir();
	// int cacheSize = 10 * 1024 * 1024;
	//
	// // HttpClient.Builder builder = new OkHttpClient.Builder()
	// // .connectTimeout(20, TimeUnit.SECONDS)
	// // .writeTimeout(20, TimeUnit.SECONDS)
	// // .readTimeout(20, TimeUnit.SECONDS)
	// // .cache(new Cache(sdcache.getAbsoluteFile(), cacheSize));
	// if (certificates != null){
	// builder.sslSocketFactory(getSSLSocketFactory(certificates));
	// // builder.hostnameVerifier(new TrustAllHostnameVerifier());
	// }
	// okHttpClient = builder.build();
	// }
	// return okHttpClient;
	// }

	/**
	 * 获取SSLSocketFactory
	 * 
	 * @param certificates
	 *            证书流文件
	 * @return
	 */
	private static SSLSocketFactory getSSLSocketFactory(
			InputStream... certificates) {
		try {
			CertificateFactory certificateFactory = CertificateFactory
					.getInstance("X.509");
			KeyStore keyStore = KeyStore.getInstance(KeyStore.getDefaultType());
			keyStore.load(null);
			int index = 0;
			for (InputStream certificate : certificates) {
				String certificateAlias = Integer.toString(index++);
				keyStore.setCertificateEntry(certificateAlias,
						certificateFactory.generateCertificate(certificate));

				try {
					if (certificate != null)
						certificate.close();
				} catch (IOException e) {
					// Log.d("kwwl", "getSSLSocketFactory " + e.toString());
				}
			}

			SSLContext sslContext = SSLContext.getInstance("TLS");
			TrustManagerFactory trustManagerFactory = TrustManagerFactory
					.getInstance(TrustManagerFactory.getDefaultAlgorithm());
			trustManagerFactory.init(keyStore);
			sslContext.init(null, trustManagerFactory.getTrustManagers(),
					new SecureRandom());
			// sslContext.init(null, new TrustManager[] { new TrustAllCerts() },
			// new SecureRandom());

			return sslContext.getSocketFactory();
		} catch (Exception e) {
			CustomLog.d("kwwl", "getSSLSocketFactory " + e.toString());
			e.printStackTrace();
		}
		return null;
	}
}
