package com.channelsoft.sipsdk;

public interface SmSdkCBInterface {
	/*
     *  @param statusCode    状态码
	 *  @param description   状态码附带描述信息（没有附加信息时是空串），json格式  如  {"streamId":"123","desc":"问题描述"}
	 *  
	 *  @说明 :  
	 *    	回调的状态码为网络等级对应  json 的格式：{"Level":"网络等级宏所对应的值"};
     * 		回调的状态码为设备丢失对应的json 的格式：{"streamID":"1","description":"xxxxxxx"};
     * 		回调的状态码为音频分贝回调对应json的格式{"streamID":"1","channel":"1","left":"1.0000","right":"1.0000"}
     * 		声音DB回调函数，streamID音频流句柄，channels代表声道数，left代表左声道DB值，right代表右声道DB值
     * 		如果是单声道音频，只有left有意义。
	 * 		SM_SDK_CB_faultNotifyFinish 对应的json{"key":"1","filenameCount":"2","file_name1":"xxxxxxx","file_name2":"XXXXXXXXX"};
	 *      SM_SDK_CB_frameWork_msgCB:   //媒体模块json通知，json:{"streamID":"2",info:"xxxxx"}info内容格式自己协商存
	 *                                                        streamID: "-1"，根据info中的事件判断是否需要streamID
	 *      SM_SDK_CB_relayagnet_msgCB   //媒体传输json通知，内容格式自己协商存
	 *                                                       json:{"streamID":"2",info:"xxxxx"}info内容格式自己协商存
	 *                                                        streamID: "-1"，根据info中的事件判断是否需要streamID
	 */
	public void SMSDK_CallBack(int statusCode, byte[] description);

}